#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# anor.py

# Senast ändrad: 2011-02-06  - Uppdateras automatiskt. Ändra inte manuellt.
######################################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
######################################################################################




######################################################################################
import sys
import os
import datetime
import shutil
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from optparse import OptionParser
from gui_anor import *

from johangemensamt import allmänt

######################################################################################




######################################################################################
class Anor(QtGui.QMainWindow, gui_Anor):

    SenastÄndrad = '2011-02-06 14:30:35'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'anor_py3_'
    loggfilopen = False

    fontsize = 9
    förstagången = True

    anrutor = []
    anrutor[:] = []

    maximumgenerationer = 7 # högre värde blir onjutbart på varje aktuell bildskärm: värde=8 ger 256 rutor i sista spalten, dvs i höjdled 6 pixlar per person i högraste spalten vid Samsung 305T (2560 x 1600 px)
    minimumgenerationer = 3 # lägre värde ger kollisioner i vänsterkanten
    forvalantalgenerationer = 3
    antalgenerationer = 3


    palette_KatA       = QtGui.QPalette()
    palette_KatB       = QtGui.QPalette()
    palette_KatC       = QtGui.QPalette()
    palette_Kat1       = QtGui.QPalette()
    palette_Mera       = QtGui.QPalette()
    palette_KatPgodk   = QtGui.QPalette()
    palette_KatPsparr  = QtGui.QPalette()

    palette_Född_ref   = QtGui.QPalette()
    palette_Död_ref    = QtGui.QPalette()

    palette_Upplysning = QtGui.QPalette()
    palette_Antavla    = QtGui.QPalette()
    palette_Anruta     = QtGui.QPalette()

    databas                 = ""

    aktuelltpersonnummer    = ""
    aktuelltpersonnamn      = ""

    aktuelltföräldraparID   = ""     # parfilsnumret för föräldrarna till personen man klickat på
    aktuellaföräldraparnamn = ""     # namnen på de båda personerna i samma par

    options = {}
    args = []

    färgschema = '0'     # '0' = Standard, '1' = Master, '2' = Compare
    färgschemabakgrund = QColor()

    inifilnamn = ""
    inifiltext = ""
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    f_option = ""
    i_option = ""

######################################################################################




######################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas  person_nummer",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)

        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-f", "--färg", dest="färgschema", help="färgschema vid databasjämförelser")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize
        self.bestämbakgrundsfärg()

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder = os.path.join( os.environ['APPDATA'], 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass

        self.setupUi(self)

        self.createActions()
        self.inledning()

        self.ui_connections()
        self.mera_ui_connections()
        self.enableUi()

        self.lineEdit_Personnummer.setFocus()

######################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Anor_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




###################################################################################################
    def bestämbakgrundsfärg(self):

# --- bakgrundsfärg måste  (?) bestämmas före setupUi i Personblad.py

        self.f_option = ""
        self.färgschema = str(self.options.färgschema)
        if self.färgschema == "None":
            self.färgschema = '0'
            self.f_option = ""
            self.färgschemabakgrund = QColor(0,0,0,0) # färgschema Standard
#            self.setupFärgschema0()
        elif self.färgschema == '1':
            self.f_option = " -f 1 "
            self.färgschemabakgrund = QColor(0,255,0,16) # färgschema Master (ljusgrönt)
#            self.setupFärgschema1()
        elif self.färgschema == '2':
            self.f_option = " -f 2 "
            self.färgschemabakgrund = QColor(255,255,0,32) # färgschema Compare  (ljusgult)
#            self.setupFärgschema2()
        return
###################################################################################################




######################################################################################
# kopplingar till knappar i grafiska gränsytan
    def mera_ui_connections(self):

#       Kopplingar, signaler i gui till slots i anor.py
#       Ytterligare kopplingar, signaler i gui till slots i gui_anor.py, finns i gui_anor.py/ui_connections(self)

        self.connect(self.pushButton_RitaOm,          SIGNAL("clicked()"),       self.ritaomknapp)
        self.connect(self.lineEdit_Personnummer,      SIGNAL("returnPressed()"), self.ritaomknapp)
        self.connect(self.checkBox_VisaAllaNamn,      SIGNAL("stateChanged(int)"), self.VisaAllaNamn)

        self.connect(self.lineEdit_AntalGenerationer, SIGNAL("returnPressed()"), self.bestamantalknapp)

        self.connect(self.pushButton_Databas,         SIGNAL('clicked()'),       self.showDialogDatabas)
######################################################################################

    def VisaAllaNamn(self, value):
        self.ritaomknapp()


######################################################################################
# kopplingar till högerklicksmenyer. Statiska rubriker lämnas tomma. Anpassade rubriker skrivs vid högerklick
    def createActions(self):
        self.nyttföräldraparAct =  QtGui.QAction("", self)
        self.connect(self.nyttföräldraparAct, QtCore.SIGNAL("triggered()"), self.nyttföräldrapar)

        self.tidigareföräldraparAct =  QtGui.QAction("", self)
        self.connect(self.tidigareföräldraparAct, QtCore.SIGNAL("triggered()"), self.tidigareföräldrapar)

        self.personbladAct =  QtGui.QAction("", self)
        self.connect(self.personbladAct, QtCore.SIGNAL("triggered()"), self.personblad)

        self.parbladAct = QtGui.QAction("", self)
        self.connect(self.parbladAct, QtCore.SIGNAL("triggered()"), self.parblad)

        self.ättlinglistaAct = QtGui.QAction("", self)
        self.connect(self.ättlinglistaAct, QtCore.SIGNAL("triggered()"), self.ättlinglista)

        self.anlistaAct =  QtGui.QAction("", self)
        self.connect(self.anlistaAct, QtCore.SIGNAL("triggered()"), self.anlista)

        self.odtdokAct =  QtGui.QAction("", self)
        self.connect(self.odtdokAct, QtCore.SIGNAL("triggered()"), self.odtdok)

        self.merafolderAct =  QtGui.QAction("", self)
        self.connect(self.merafolderAct, QtCore.SIGNAL("triggered()"), self.visamerafolder)

        self.parodtdokAct =  QtGui.QAction("", self)
        self.connect(self.parodtdokAct, QtCore.SIGNAL("triggered()"), self.parodtdok)

        self.parmerafolderAct =  QtGui.QAction("", self)
        self.connect(self.parmerafolderAct, QtCore.SIGNAL("triggered()"), self.visaparmerafolder)
######################################################################################




######################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        if len(self.args) != 2 : # Jag förväntar mig exakt två argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt två argument i anropet: Databasadress, Personnummer. Jag avbryter här.\n ")
            self.avsluta(1)

        self.lineEdit_Databas.setText(self.args[0])
        self.lineEdit_Personnummer.setText(self.args[1])
        self.databas = self.lineEdit_Databas.text()

        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext )

        self.fontsizeset()
        self.ritaom()

        return
######################################################################################




###################################################################################################
    def showDialogDatabas(self):

        self.databas = str(QtGui.QFileDialog.getExistingDirectory(self, "Databas att exportera från", "/home", QFileDialog.ShowDirsOnly))
        self.lineEdit_Databas.setText(self.databas)

        return
###################################################################################################




###################################################################################################
    def ritaomknapp(self):
        self.bestamantal()
        self.ritaom()
###################################################################################################




######################################################################################
    def ritaom(self):

        from johanklasser import johanpersonfil

        self.databas = self.lineEdit_Databas.text()
        personnr = self.lineEdit_Personnummer.text()

        msg1 = allmänt.validera( allmänt(), self.lineEdit_Personnummer.text(),self.lineEdit_Databas.text() )
        if msg1 != True:
            annanperson = allmänt.förstaperson(allmänt(),self.lineEdit_Databas.text())
            if annanperson == "":
                msg2 = "\nTom databas?"
            else:
                msg2 = "\nFörsöker i stället med nr " + str(annanperson)
            self.lineEdit_Personnummer.setText(annanperson)
            personnr = self.lineEdit_Personnummer.text()
            QtGui.QMessageBox.information(self, "Johan - Anor" , msg1+msg2 , QtGui.QMessageBox.Ok)


        anrutanummergrans = 2**(self.antalgenerationer + 1)
#        antalrutor = anrutanummergrans - 1
#        antalspalter = self.antalgenerationer + 1
#        antalrutorisistaspalt=2**self.antalgenerationer

        self.färskantavla()
        self.sijlayout()
        self.windowlayout()
        self.windowlayout2()


        Person1 = johanpersonfil()

######  skapa fönstrets titel ----------------------------------------
        infilnamn = os.path.join(self.databas, "data", personnr[0:5], personnr + ".xml")
        if os.path.exists(infilnamn):
            allmänt.hämtapersonfil(allmänt(), infilnamn, Person1)
            self.setWindowTitle( Person1.kortnamn  + " - anor" )
######  skapade fönstrets titel ----------------------------------------

            self.hämtaperson ( self.databas, personnr, self.anrutor, 1, anrutanummergrans )

        self.lineEdit_Personnummer.setFocus()

        return

######################################################################################




######################################################################################
    def hämtaperson (self, databasktlg, personnr, anrutor, anrutanummer, anrutanummergrans):

        from johanklasser import johanpersonfil
        from johanklasser import johanparfil

        Person2 = johanpersonfil()
        infilnamn = os.path.join(databasktlg, "data", personnr[0:5], personnr + ".xml")
        if os.path.exists(infilnamn):
            allmänt.hämtapersonfil(allmänt(), infilnamn, Person2)

            if self.checkBox_VisaAllaNamn.checkState() == 0:
                anrutor[anrutanummer].label_namn.setText( Person2.kortnamn )
            else:
                anrutor[anrutanummer].label_namn.setText( Person2.allaförnamn + " " + Person2.allaefternamn )
            anrutor[anrutanummer].label_namn.setToolTip(Person2.allaförnamn + " " + Person2.allaefternamnmedant)

            föddtext= ""
            if Person2.född_år + Person2.född_månad +  Person2.född_dag != "":

                if Person2.född_år != "":
                    föddtext = " " + Person2.född_år
                else:
                    föddtext = "     "

                if Person2.född_månad != "":
                    föddtext = föddtext + '-' + Person2.född_månad
                    if Person2.född_dag != "":
                        föddtext = föddtext + '-' + Person2.född_dag
                else:
                    if Person2.född_dag != "":
                        föddtext = föddtext + '-  -' + Person2.född_dag

            if Person2.född_utrikesplats != "":
                föddplats = föddtext + ' i ' + self.summatext(Person2.född_församling, Person2.född_utrikesplats)
            else:
                föddplats =  self.summatext(Person2.född_by , Person2.född_församling)

            if föddplats != "":
                föddtext = föddtext + " i " + föddplats

            if föddtext != "":
                föddtext = "f." + föddtext

            anrutor[anrutanummer].label_född.setText( föddtext )

            if Person2.född_källa != "":
                anrutor[anrutanummer].label_född_ref.setText("Ref" )
                anrutor[anrutanummer].label_född_ref.setToolTip(Person2.född_källa  )
                anrutor[anrutanummer].label_född_ref.setPalette(self.palette_Född_ref)
                anrutor[anrutanummer].label_född_ref.setVisible(True)
            else:
                anrutor[anrutanummer].label_född_ref.setVisible(False)


            dödtext= ""
            if Person2.död_år + Person2.död_månad +  Person2.död_dag != "":

                if Person2.död_år != "":
                    dödtext = " " + Person2.död_år
                else:
                    dödtext = "     "

                if Person2.död_månad != "":
                    dödtext = dödtext + '-' + Person2.död_månad
                    if Person2.död_dag != "":
                        dödtext = dödtext + '-' + Person2.död_dag
                else:
                    if Person2.död_dag != "":
                        dödtext = dödtext + '-  -' + Person2.död_dag

            if Person2.död_utrikesplats != "":
                dödplats = dödtext + ' i ' + self.summatext(Person2.död_församling, Person2.död_utrikesplats)
            else:
                dödplats =  self.summatext(Person2.död_by , Person2.död_församling)

            if dödplats != "":
                dödtext = dödtext + " i " + dödplats

            if dödtext != "":
                dödtext = "d." + dödtext

            anrutor[anrutanummer].label_död.setText( dödtext )

            if Person2.död_källa != "":
                anrutor[anrutanummer].label_död_ref.setText("Ref" )
                anrutor[anrutanummer].label_död_ref.setToolTip(Person2.död_källa  )
                anrutor[anrutanummer].label_död_ref.setPalette(self.palette_Död_ref)
                anrutor[anrutanummer].label_död_ref.setVisible(True)
            else:
                anrutor[anrutanummer].label_död_ref.setVisible(False)


            if Person2.föräldrapar_ID != "":
                anrutor[anrutanummer].label_föräldrapar.setText("För-\näld-\nra-\npar")
                anrutor[anrutanummer].label_föräldrapar.setToolTip(Person2.föräldrapar_ID)


            anrutor[anrutanummer].label_ID.setText(personnr)
            kategoritext = Person2.person_kategori
            anrutor[anrutanummer].label_kategori.setText(  kategoritext )
            anrutor[anrutanummer].label_kategori.setPalette(self.personkategoripalett( Person2))

            merafolder = os.path.join(databasktlg, "data",  personnr[0:5], personnr)
            txtdokfilnamn = merafolder + ".txt"
            odtdokfilnamn = merafolder + ".odt"

            if os.path.exists(txtdokfilnamn) or  os.path.exists(odtdokfilnamn) or  os.path.exists(merafolder)  :
                anrutor[anrutanummer].label_mera.setText( "M" )
                anrutor[anrutanummer].label_mera.setPalette(self.palette_Mera)

            if anrutanummer < anrutanummergrans / 2:
                föräldrapar = Person2.föräldrapar_ID
                if föräldrapar != "" :
                    Par2 = johanparfil()
                    infilnamnpar =  os.path.join(databasktlg, "data", föräldrapar[0:8], föräldrapar + ".xml")
                    if os.path.exists(infilnamnpar):
                        allmänt.hämtaparfil(allmänt(), infilnamnpar, Par2)
                        self.hämtaperson ( databasktlg, Par2.person1_ID,  anrutor, anrutanummer*2, anrutanummergrans)    # rekursivt anrop för fadern
                        self.hämtaperson ( databasktlg, Par2.person2_ID,  anrutor, anrutanummer*2+1, anrutanummergrans)  # rekursivt anrop för modern

        return
######################################################################################




######################################################################################
    def personkategoripalett(self, person):

        kategori = person.person_kategori
        if kategori == "A":
            return self.palette_KatA # KatA
        elif  kategori == "1":
            return self.palette_Kat1 # Kat1
        elif allmänt.KategoriPgodk( allmänt(), person):
            if kategori == "":
                return self.palette_KatPgodk # KatPgodk
            elif kategori == "B":
                return self.palette_KatB # KatB
            elif kategori == "C":
                return self.palette_KatC # KatC
            else:
                return self.palette_KatPsparr # KatPspärr
        else:
            return self.palette_KatPsparr # KatPspärr
        return kategoriitem
######################################################################################




######################################################################################
    def summatext(self, t1, t2):
        if t1 == "":
            return t2
        elif t2 == "":
            return t1
        else:
            return t1 + ", " + t2
######################################################################################




########################################################################################
# Hit kommer man - kanske - magiskt vid högerklick
    def contextMenuEvent(self, event):

        from johanklasser import johanpersonfil
        from johanklasser import johanparfil

#        self.aktuelltpersonnummer        # personen man klickat på
#        self.aktuelltpersonnamn          # personen man klickat på

#        self.aktuelltföräldraparID       # parfilsnumret för föräldrarna till personen man klickat på
#        self.aktuellaföräldraparnamn     # namnen på de båda personerna i samma par

        inAntavlaX = event.x() - self.scrollyta.geometry().x()
        inAntavlaY = event.y() - self.scrollyta.geometry().y()

# Bestäm vilken rektangel 'frame_Person' som skulle kunna avses med högerklicket
        anrutabredd = self.anrutor[0].frame_Person.geometry().width()
        kolumn = int((inAntavlaX + self.scrollyta.horizontalScrollBar().value() )/anrutabredd)

        rutaikolumnen = int(inAntavlaY * (2**kolumn) / min(self.widget_Antavla.geometry().height(), self.scrollyta.geometry().height()))
        tmpanrutanummer = 2**kolumn + rutaikolumnen

        skapapersonmeny = False
        skapaparmeny = False

# När man klickar inom rektangeln 'frame_Person' så avses
#   vid klick i huvuddelen av rektangeln (vänster) en meny med val avseende personen
#   vid klick i en mindre del av rektangeln (intill högra kanten) en menu med val avseende personens föräldrapar
# När man klickar utanför rektangeln 'frame_Person' så ska inte skapas någon meny alls

        pos_x = event.x() + self.scrollyta.horizontalScrollBar().value()

        personruta_vanster = self.anrutor[tmpanrutanummer].frame_Person.geometry().left()
        personruta_hoger = personruta_vanster  + self.anrutor[tmpanrutanummer].ruta_Person.width()
        parruta_vanster = personruta_hoger
        parruta_hoger = self.anrutor[tmpanrutanummer].frame_Person.geometry().right()

        if self.anrutor[tmpanrutanummer].frame_Person.geometry().top() < event.y() and self.anrutor[tmpanrutanummer].frame_Person.geometry().bottom() > event.y(): # musmarkören ligger rätt i höjd

            if  personruta_vanster < pos_x and personruta_hoger > pos_x :
                skapapersonmeny = True

            elif parruta_vanster <= pos_x and parruta_hoger > pos_x :
                skapaparmeny = True



        self.aktuelltpersonnummer = str(self.anrutor[tmpanrutanummer].label_ID.text())
        merafolder = os.path.join(self.databas, "data", self.aktuelltpersonnummer[0:5], self.aktuelltpersonnummer)
        odtdokfilnamn = merafolder + ".odt"
        infilnamn =  merafolder + ".xml"

        Person3 = johanpersonfil()
        allmänt.hämtapersonfil(allmänt(), infilnamn, Person3)
        self.aktuelltpersonnamn = Person3.kortnamn
        self.aktuelltföräldraparID = Person3.föräldrapar_ID
        parmerafolder = os.path.join(self.databas, "data", self.aktuelltföräldraparID [0:8], self.aktuelltföräldraparID)
        parodtdokfilnamn = parmerafolder  + ".odt"
        infilnamn =  parmerafolder + ".xml"
        aktuelltegnapar = Person3.egna_par_ID

        Par1 = johanparfil()
        allmänt.hämtaparfil(allmänt(), infilnamn, Par1)
        makeID = Par1.person1_ID
        makaID = Par1.person2_ID

        infilnamn =  os.path.join(self.databas, "data", makeID[0:5], makeID + ".xml")

        allmänt.hämtapersonfil(allmänt(), infilnamn, Person3)
        self.aktuellaföräldraparnamn =  Person3.kortnamn
        infilnamn =  os.path.join(self.databas, "data",  makaID[0:5], makaID + ".xml")

        allmänt.hämtapersonfil(allmänt(), infilnamn, Person3)

        self.aktuellaföräldraparnamn = self.aktuellaföräldraparnamn + " och " +  Person3.kortnamn


# Skapa menyer, anpassade till förutsättningar och med anpassade texter
        if skapapersonmeny == True:
            meny = QtGui.QMenu(self)

            if aktuelltegnapar != "": # spelar ingen roll här om det finns ett eller flera egna par
                meny.addAction(self.ättlinglistaAct)
                rubriktext = "ÄTTLINGAR till " + self.aktuelltpersonnamn
                self.ättlinglistaAct.setText(rubriktext)

            if self.aktuelltföräldraparID != "":
                meny.addAction(self.anlistaAct)
                rubriktext = "ANOR till " + self.aktuelltpersonnamn
                self.anlistaAct.setText(rubriktext)

            meny.addAction(self.personbladAct)
            rubriktext = "PERSONBLAD för " + self.aktuelltpersonnamn
            self.personbladAct.setText(rubriktext)

            if os.path.exists(odtdokfilnamn):
                meny.addAction(self.odtdokAct)
                rubriktext = "Öppna ODF-dokument för "  + self.aktuelltpersonnamn
                self.odtdokAct.setText(rubriktext)
            else:
                meny.addAction(self.odtdokAct)
                rubriktext = "Skapa ODF-dokument för "  + self.aktuelltpersonnamn
                self.odtdokAct.setText(rubriktext)

            if os.path.exists(merafolder):
                meny.addAction(self.merafolderAct)
                rubriktext = "Öppna FOLDER med fler filer för " + self.aktuelltpersonnamn
                self.merafolderAct.setText(rubriktext)
            else:
                meny.addAction(self.merafolderAct)
                rubriktext = "Skapa FOLDER för fler filer för " + self.aktuelltpersonnamn
                self.merafolderAct.setText(rubriktext)

            if self.aktuelltföräldraparID == "":
                meny.addAction(self.nyttföräldraparAct)
                rubriktext = "Skapa filer för FÖRÄLDRAPAR till " + self.aktuelltpersonnamn
                self.nyttföräldraparAct.setText(rubriktext)

                meny.addAction(self.tidigareföräldraparAct)
                rubriktext = "Sammankoppla tidigare registrerat FÖRÄLDRAPAR med " + self.aktuelltpersonnamn
                self.tidigareföräldraparAct.setText(rubriktext)

            meny.exec_(event.globalPos())


        if skapaparmeny == True:
            if self.aktuelltföräldraparID != "":

                meny = QtGui.QMenu(self)
                meny.addAction(self.parbladAct)
                rubriktext = "PARBLAD för " + self.aktuellaföräldraparnamn
                self.parbladAct.setText(rubriktext)

                if os.path.exists(parodtdokfilnamn):
                    meny.addAction(self.parodtdokAct)
                    rubriktext = "Öppna ODF-dokument för paret "  + self.aktuellaföräldraparnamn
                    self.parodtdokAct.setText(rubriktext)
                else:
                    meny.addAction(self.parodtdokAct)
                    rubriktext = "Skapa ODF-dokument för paret "  + self.aktuellaföräldraparnamn
                    self.parodtdokAct.setText(rubriktext)

                if os.path.exists(parmerafolder):
                    meny.addAction(self.parmerafolderAct)
                    rubriktext = "Öppna FOLDER med fler filer för paret "  + self.aktuellaföräldraparnamn
                    self.parmerafolderAct.setText(rubriktext)
                else:
                    meny.addAction(self.parmerafolderAct)
                    rubriktext = "Skapa FOLDER för fler filer för paret "  + self.aktuellaföräldraparnamn
                    self.parmerafolderAct.setText(rubriktext)

                meny.exec_(event.globalPos())
####  slut på själva klickhanteringen ##################################################
########################################################################################




########################################################################################
##### Stöd för olika val i menyn efter högerklick  #####################################
    def visamerafolder(self):
    # Skapa vid behov, visa med krusader katalog för personens ytterligare filer
        foldernamnvänster = os.path.join(self.databas, "data", self.aktuelltpersonnummer[0:5])
        foldernamnhöger   = os.path.join(foldernamnvänster, self.aktuelltpersonnummer)

        if not os.path.exists( foldernamnhöger ):
            os.mkdir ( foldernamnhöger )

        kommando = allmänt.FILHANTERARE

        # ingemarspecifikt, linuxspecifikt anrop till filhanteraren krusader
        if kommando[-8:] == 'krusader':
            krusaderheader = '"' + self.aktuelltpersonnamn + ' - fler filer"'
            kommando = kommando + ' -caption ' + krusaderheader + '   --left ' + foldernamnvänster + '   --right ' + foldernamnhöger
        else:
            kommando = kommando +  '  ' + foldernamnhöger
        QtCore.QProcess().startDetached(kommando)
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def visaparmerafolder(self):
    # Skapa vid behov, visa med krusader katalog för föräldraparets ytterligare filer
        foldernamnvänster = os.path.join ( self.databas, "data", self.aktuelltföräldraparID[0:8] )
        foldernamnhöger   = os.path.join ( foldernamnvänster, self.aktuelltföräldraparID )

        if not os.path.exists( foldernamnhöger ):
            os.mkdir ( foldernamnhöger )

        kommando = allmänt.FILHANTERARE

        if kommando[-8:] == 'krusader':
            krusaderheader = '"' + self.aktuelltföräldraparID + ' - fler filer"'
            kommando = kommando  + ' -caption ' + krusaderheader + ' --left ' + foldernamnvänster + ' --right ' + foldernamnhöger
        else:
            kommando = kommando +  '  ' + foldernamnhöger
        QtCore.QProcess().startDetached(kommando)
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def odtdok(self):
    # Öppna odf-dokument för personen med OOo writer för editering eller läsning
        mallfilnamn = os.path.join ( self.databas, "data", "mallar", "00000000.odt")
        filnamn     = os.path.join ( self.databas, "data", self.aktuelltpersonnummer[0:5], self.aktuelltpersonnummer + ".odt")

        if not os.path.exists( filnamn ):
            shutil.copy2 ( mallfilnamn, filnamn)

        kommando = allmänt.ORDBEHANDLARE + " " + filnamn
        QtCore.QProcess().startDetached(kommando)
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def parodtdok(self):
    # Öppna odf-dokument för föräldraparet med OOo writer för editering eller läsning
        mallfilnamn = os.path.join ( self.databas, "data", "mallar", "par00000000.odt")
        filnamn     = os.path.join ( self.databas, "data", self.aktuelltföräldraparID[0:8], self.aktuelltföräldraparID + ".odt")

        if not os.path.exists( filnamn ):
            shutil.copy2 ( mallfilnamn, filnamn)

        kommando = allmänt.ORDBEHANDLARE + " " + filnamn
        QtCore.QProcess().startDetached(kommando)
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def ättlinglista(self):     # Visa ättlingar med Johan
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando)
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def anlista(self):    # Visa anor med Johan
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando)
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def personblad(self):    # Editera personblad med Johan
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando)
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def parblad(self):    # Editera parblad med Johan
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'parblad.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltföräldraparID
        QtCore.QProcess().startDetached(kommando)
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def tidigareföräldrapar(self):

        success = False

# Det är redan kontrollerat att personen inte är länkad till något föräldrapar.
# Peka ut att föräldrapar som redan finns.
# Koppla ihop personen med detta föräldrapar.

        aktuelltpersonfilnamn = os.path.join(self.databas, "data", self.aktuelltpersonnummer[0:5], self.aktuelltpersonnummer + ".xml")

        if not os.path.exists(aktuelltpersonfilnamn):
            msg = 'Jag hittar inte personfilen ' + aktuelltpersonfilnamn
            QtGui.QMessageBox.warning(self, "Johan - Anor", msg )
            success = False
        else:
            msg = 'Funktionen är inte införd'
            QtGui.QMessageBox.information(self, "Johan - Anor", msg)
            success = False

        if success == True:
            self.ritaom()

        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def nyttföräldrapar(self):

        from johanklasser import johanpersonfil
        from johanklasser import johanparfil

        success = False

# Det är redan kontrollerat att personen inte är länkad till något föräldrapar.
# Skapa ett nytt föräldrapar.
# Koppla ihop personen med detta föräldrapar.

        aktuelltpersonfilnamn = os.path.join(self.databas, "data", self.aktuelltpersonnummer[0:5], self.aktuelltpersonnummer + ".xml")
        if os.path.exists(aktuelltpersonfilnamn):

# har vi väl hittat hit är det nu att forstätta med låsteknikaliteterna:
            lockfilesenaste = os.path.join(self.databas, "locks", "senaste.lock")
            lockresponsesenaste = allmänt.johanlock(allmänt(),lockfilesenaste)
            # lås sistanummer-filerna,
            if lockresponsesenaste == "":     # så har vi låst båda filerna med senaste nummer

                # lås dessutom den aktuella personfilen.
                lockfileperson = os.path.join(self.databas, "locks", self.aktuelltpersonnummer + ".lock")
                lockresponseperson = allmänt.johanlock(allmänt(),lockfileperson)

                if lockresponseperson == "":     # så har vi också låst den aktuella personfilen



# --- ordna två personfiler ----------------------------------------------------------------------------------------
# läs sistanummer-filen för personnummer
                    senastepersonfilnamn = os.path.join(self.databas, "senaste", "senasteperson.txt")
                    senastepersonfil = open( senastepersonfilnamn, "r")
                    senasteperson=senastepersonfil.readline().strip()    # tag bort ev newline och annan whitespace
                    senastepersonfil.close()


# gör två nya sistanummer för personfiler, kolla att inte filerna redan finns
                    filnummer1 = int(senasteperson)
                    nummer1 =  str(filnummer1).zfill(8)
                    filnamn1 = os.path.join(self.databas, "data", nummer1[:5], nummer1 + ".xml")
                    while os.path.exists(filnamn1):
                        filnummer1 = filnummer1 + 1
                        nummer1 =  str(filnummer1).zfill(8)
                        filnamn1 = os.path.join(self.databas, "data", nummer1[:5], nummer1 + ".xml")
                    nyttpersonnummer1 = nummer1

# lås den nya personfilen 1 som ännu inte skrivits, den är avsedd för den nya Person1
                    lockfilenyperson1 = os.path.join(self.databas, "locks", nyttpersonnummer1 + ".lock")
                    lockresponsenyperson1 = allmänt.johanlock(allmänt(),lockfilenyperson1)

                    if lockresponsenyperson1 == "":

                        filnummer2 = filnummer1 + 1  # fortsätt med nästa nummer
                        nummer2 =  str(filnummer2).zfill(8)
                        filnamn2 = os.path.join(self.databas, "data", nummer2[:5], nummer2 + ".xml")
                        while os.path.exists(filnamn2):
                            filnummer2 = filnummer2 + 1
                            nummer2 =  str(filnummer2).zfill(8)
                            filnamn2 = os.path.join(self.databas, "data", nummer2[:5], nummer2 + ".xml")
                        nyttpersonnummer2 = nummer2

# skapa ny underkatalog vid behov
                        underkatalog = os.path.join(self.databas, "data",  nummer2[:5])
                        if not os.path.exists(underkatalog):
                            os.mkdir (underkatalog)

# lås den nya personfilen 2 som ännu inte skrivits, den är avsedd för den nya Person2
                        lockfilenyperson2 = os.path.join(self.databas, "locks", nyttpersonnummer2 + ".lock")
                        lockresponsenyperson2 = allmänt.johanlock(allmänt(),lockfilenyperson2)

                        if lockresponsenyperson2 == "":
# ------------------------------------------------------------------------------------------------------------------


# --- ordna en parfil ----------------------------------------------------------------------------------------------
# läs sistanummer-filen för parnummer
                            senasteparfilnamn = os.path.join(self.databas, "senaste", "senastepar.txt")
                            senasteparfil = open( senasteparfilnamn, "r")
                            senastepar=senasteparfil.readline().strip()    # tag bort ev newline och annan whitespace
                            senasteparfil.close()

# gör ett nytt sistanummer för parfiler, kolla att inte filen redan finns
                            filnummer = int(senastepar[3:12])
                            if filnummer == 0:
                                filnummer = 1
                            nummer = str(filnummer).zfill(8)
                            filnamn = os.path.join(self.databas, "data", "par" +  nummer[:5], "par" +  nummer + ".xml")
                            while os.path.exists(filnamn):
                                filnummer = filnummer + 1
                                nummer = str(filnummer).zfill(8)
                                filnamn = os.path.join(self.databas, "data", "par" + nummer[:5], "par" +  nummer + ".xml")
                            nyttparnummer ="par" + nummer

# skapa ny underkatalog vid behov
                            underkatalog = os.path.join(self.databas, "data", "par" +  nummer[:5])
                            if not os.path.exists(underkatalog):
                                os.mkdir( underkatalog)

# lås den nya parfilen, som ännu inte skrivits
                            lockfilenyttpar = os.path.join(self.databas, "locks", nyttparnummer + ".lock")
                            lockresponsenyttpar = allmänt.johanlock(allmänt(),lockfilenyttpar)

                            if lockresponsenyttpar == "":
# ------------------------------------------------------------------------------------------------------------------



# Skapa tomma strukturer för de tre nya filerna
                                NyttPar = johanparfil()
                                allmänt.initparfil(allmänt(), NyttPar)

                                NyPerson1 =  johanpersonfil(allmänt())
                                allmänt.initpersonfil(allmänt(), NyPerson1)

                                NyPerson2 =  johanpersonfil(allmänt())
                                allmänt.initpersonfil(allmänt(), NyPerson2)

# och en ifylld för den aktuella personen i ättlinglistan
                                TidigarePerson = johanpersonfil()
                                allmänt.hämtapersonfil(allmänt(), aktuelltpersonfilnamn , TidigarePerson)

#  koppla ihop de fyra filerna
                                NyttPar.par_ID = nyttparnummer
                                NyttPar.person1_ID = nyttpersonnummer1
                                NyttPar.person2_ID = nyttpersonnummer2
                                NyttPar.barn_ID = self.aktuelltpersonnummer

                                NyPerson1.person_ID = nyttpersonnummer1
                                NyPerson1.egna_par_ID = nyttparnummer
                                NyPerson1.person_kön = "m"

                                NyPerson2.person_ID = nyttpersonnummer2
                                NyPerson2.egna_par_ID = nyttparnummer
                                NyPerson2.person_kön = "k"

                                TidigarePerson.föräldrapar_ID = nyttparnummer

# spara de fyra filerna, detta är första skrivningen av filer för NyPerson1, NyPerson2, NyttPar
                                NyttPersonfilnamn1 = os.path.join(self.databas, "data", nyttpersonnummer1[0:5], nyttpersonnummer1 + ".xml")
                                allmänt.sparapersonfil(allmänt(),    NyttPersonfilnamn1   , NyPerson1)

                                NyttPersonfilnamn2 =  os.path.join(self.databas, "data", nyttpersonnummer2[0:5], nyttpersonnummer2 + ".xml")
                                allmänt.sparapersonfil(allmänt(),    NyttPersonfilnamn2   , NyPerson2)

                                NyttParfilnamn =  os.path.join(self.databas, "data", nyttparnummer[0:8], nyttparnummer + ".xml")
                                allmänt.sparaparfil(allmänt(),   NyttParfilnamn   , NyttPar)

                                allmänt.sparapersonfil(allmänt(),   aktuelltpersonfilnamn    , TidigarePerson)

# uppdatera senaste par&person och skriv ut

                                senastepersonfilnamn =  os.path.join(self.databas, "senaste", "senasteperson.txt")
                                senasteparfilnamn =  os.path.join(self.databas, "senaste", "senastepar.txt")

                                senastepersonfil = open( senastepersonfilnamn, "w", encoding="utf-8" )
                                senastepersonfil.write(nyttpersonnummer2)
                                senastepersonfil.close()

                                senasteparfil = open( senasteparfilnamn, "w", encoding="utf-8" )
                                senasteparfil.write(nyttparnummer)
                                senasteparfil.close()

                                success = True

                                # avsluta ned normal radering av låsfilen  lockfilenyttpar
                                os.remove(lockfilenyttpar)




                            else:
                                msg = 'Parbladet för nytt par ' + nyttparnummer + ' är LÅST\n\n'
                                msg = msg + 'DETTA SKA INTE KUNNA INTRÄFFA!\n\n'
                                msg = msg + lockresponsenyttpar
                                QtGui.QMessageBox.information(self, "Johan - Anor" , msg , QtGui.QMessageBox.Ok)
                                success = False

                            # avsluta ned normal radering av låsfilen  lockfilenyperson 2
                            os.remove(lockfilenyperson2)




                        else:
                            msg = 'Personbladet för ny person2 ' + nyttpersonnummer1 + ' är LÅST\n'
                            msg = msg + 'DETTA SKA INTE KUNNA INTRÄFFA!\n\n'
                            msg = msg + lockresponsenyperson2
                            QtGui.QMessageBox.information(self, "Johan - Anor" , msg , QtGui.QMessageBox.Ok)
                            success = False

                        # avsluta ned normal radering av låsfilen  lockfilenyperson 1
                        os.remove(lockfilenyperson1)




                    else:
                        msg = 'Personbladet för ny person1 ' + nyttpersonnummer1 + ' är LÅST\n'
                        msg = msg + 'DETTA SKA INTE KUNNA INTRÄFFA!\n\n'
                        msg = msg + lockresponsenyperson1
                        QtGui.QMessageBox.information(self, "Johan - Anor" , msg , QtGui.QMessageBox.Ok)
                        success = False

                    # avsluta ned normal radering av låsfilen  lockfileperson
                    os.remove(lockfileperson)




                else:  # lockresponseperson !=  "";  Låset för aktuell personfil är påslaget.
                    msg = 'Personbladet för person ' + self.lineEdit_Personnummer.text() + ' är LÅST\n\n'
                    msg = msg + lockresponseperson
                    QtGui.QMessageBox.information(self, "Johan - Anor" , msg , QtGui.QMessageBox.Ok)
                    success = False

                # avsluta ned normal radering av låsfilen lockfilesenaste
                os.remove(lockfilesenaste)




            else: # lockresponsesenaste != "":
                msg = 'Filerna för allokering av nya person- och parnummer är LÅSTA\n\n'
                msg = msg + lockresponsesenaste
                QtGui.QMessageBox.information(self, "Johan - Anor" , msg , QtGui.QMessageBox.Ok)
                success = False




        else:
            msg = "Jag kunde inte hitta personfilen " + aktuelltpersonfilnamn
            msg = msg + "\nKör databaskontrollen"
            QtGui.QMessageBox.information(self, "Johan - Anor" , msg , QtGui.QMessageBox.Ok)
            success = False


        if success == True:
            self.ritaom()

            # öppna nya parbladet för editering
            if nyttparnummer != "":
                self.aktuelltföräldraparID = nyttparnummer
                self.parblad()

            # öppna de båda nya personbladen för editering
            if nyttpersonnummer1 != "":
                self.aktuelltpersonnummer = nyttpersonnummer1
                self.personblad()

            if nyttpersonnummer2 != "":
                self.aktuelltpersonnummer = nyttpersonnummer2
                self.personblad()
        return

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
###################################################################################################




###################################################################################################
    def bestamantalknapp(self):
        self.bestamantal()
        self.ritaom()
###################################################################################################




###################################################################################################
    def bestamantal(self):

        meddela = False
        try:
            self.antalgenerationer = int(self.lineEdit_AntalGenerationer.text())
            if self.antalgenerationer < self.minimumgenerationer:
                meddela = True
                self.antalgenerationer = self.minimumgenerationer
            if self.antalgenerationer > self.maximumgenerationer:
                meddela = True
                self.antalgenerationer = self.maximumgenerationer
        except:
            meddela = True
            self.antalgenerationer = self.forvalantalgenerationer

        if meddela:
            msg = "Jag måste ha ett heltal mellan " + str(self.minimumgenerationer) + " och " + str(self.maximumgenerationer) + " som antal generationer ättlingar utöver probanden själv"
            QtGui.QMessageBox.information(self, "Johan - Anor" , msg , QtGui.QMessageBox.Ok)

        self.lineEdit_AntalGenerationer.setText(str(self.antalgenerationer))
###################################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn,'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Anor_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

## logga till textruta i programfönster
#        self.textEdit_logg.insertPlainText(txt )
#        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)
#
#        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Anor_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




######################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winAnor = Anor()
winAnor.show()
sys.exit(app.exec_())
######################################################################################
