#!/usr/local/bin/python3.1
# -*- coding: utf-8 -*-

# copying.py  # för Python 3

# Senast ändrad: 2011-02-22  - Uppdateras automatiskt. Ändra inte manuellt.

#############################################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

########################################################################################
import sys
import os

from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

####################################################################
class sijTextEdit(QTextEdit):

    def __init__(self, *args):
        QTextEdit.__init__(self, *args)

    def event(self, event):
        if (event.type()==QEvent.KeyPress):
            if event.modifiers() & Qt.ControlModifier:
                if event.key()==Qt.Key_Plus:
                    self.emit(SIGNAL("CtrlPlusPressed"))
                    return True
                elif event.key()==Qt.Key_Minus:
                    self.emit(SIGNAL("CtrlMinusPressed"))
                    return True

        return QTextEdit.event(self, event)
####################################################################

class Copying(QtGui.QMainWindow):
    fontsize = 10
    rutahojd = 100
    fixedsize= QtCore.QSize()

    def __init__(self, parent=None):
        QtGui.QMainWindow.__init__(self)
        self.setObjectName("Copying")
        self.setWindowTitle("Copying")
        self.centralwidget = QtGui.QWidget(self)
        self.centralwidget.setObjectName("centralwidget")
        self.setCentralWidget(self.centralwidget)

        self.textEdit_ruta = sijTextEdit(self.centralwidget)
        self.textEdit_ruta.setObjectName("textEdit_ruta")
        self.textEdit_ruta.setVerticalScrollBarPolicy ( Qt.ScrollBarAlwaysOn)

        programkatalog = os.path.split( os.path.abspath( sys.argv[0] ) )[0]
        CopyingFile = open(os.path.join(programkatalog, "copying"), "r")
        CopyingText = CopyingFile.read()
        CopyingFile.close()
        self.textEdit_ruta.insertPlainText(CopyingText)

        self.textEdit_ruta.moveCursor(QtGui.QTextCursor.Start, QtGui.QTextCursor.MoveAnchor)
        self.textEdit_ruta.setReadOnly(True)

        copyingfont = QFont()
        copyingfont.setFamily("Courier 10 Pitch")
        copyingfont.setStyleHint(QFont.TypeWriter)
        copyingfont.setFixedPitch(True)
        copyingfont.setStyle(QFont.StyleNormal)
        copyingfont.setWeight(QFont.DemiBold)
        self.textEdit_ruta.setFont(copyingfont)

        self.fontsizeset()
        self.connect(self.textEdit_ruta, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.textEdit_ruta, SIGNAL("CtrlMinusPressed"), self.fontsizedown)
        self.textEdit_ruta.setFocus()

        return

    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()
        return

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()
        return

    def fontsizeset(self):
        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        copyingfont = self.textEdit_ruta.font()
        copyingfont.setPointSize(self.fontsize)
        self.textEdit_ruta.setFont(copyingfont)

        fs =  copyingfont.pointSize()

        self.rutahojd = (int(QtGui.QDesktopWidget().screenGeometry().height()) - 50) * 0.9
        if self.rutahojd < 100:
            self.rutahojd = 100

        self.textEdit_ruta.setGeometry ( 5, 5, 70*fs, self.rutahojd )
        self.fixedsize = QtCore.QSize(10 + 70*fs, 10 + self.rutahojd )
        self.resize ( self.fixedsize )
        return

app = QtGui.QApplication(sys.argv)
winCopying = Copying()
winCopying.show()
sys.exit(app.exec_())
