#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# exportera.py

# Senast ändrad: 2011-03-03  - Uppdateras automatiskt. Ändra inte manuellt.
#######################################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
########################################################################################




########################################################################################
import sys
import os
import datetime, time
import shutil
import unicodedata

from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from optparse import OptionParser
from gui_exportera import gui_Exportera

from johangemensamt import allmänt
from johanklasser import johanpersonfil, johanparfil
########################################################################################




########################################################################################
class Exportera(QtGui.QMainWindow, gui_Exportera):

    SenastÄndrad = '2011-03-02 13:16:58'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'exportera_py3_'
    loggfilopen = False

    fontsize = 9

    användaruppgifter = {}
#    användaruppgifter = {
#        "DIS_medlemsnummer"    : DIS_medlemsnummer,
#        "disbyt_användarnamn"  : disbyt_användarnamn,
#        "disbyt_lösenord"      : disbyt_lösenord,
#        "namn"                 : namn,
#        "epost"                : epost,
#        "www"                  : www
#        }


    GedcomNyRad = b''
    GedcomKodning = "ANSEL"
    Johanversion_i_Gedcom = "PY3_2011_MAR"

    gedcomradnr = 0

    primärpersonlista = []
    primärparlista = []
    senasteperson = ""
    senastepar = ""
    datumtillägg = ""
    idag = []

    databas = ""
    nydatabas = ""
    nydatabas_auto = False

    inifilnamn = ''
    inifiltext = ''
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    options = {}
    args = []

    i_option = ""
    n_option = ""

    dictUnicodeTillAnsel= {    # För Python 3
#####################################################################################################################################################################
#    Unicode   :  Ansel   #chr#    Beskrivning                                                                 #    ingår i ...                   # ---- Ansel ---- #
#   (decimalt) :(hexadec.)#   #                                                                                #                                  #  dec  #   hex   #
#--------------------------------------------------------------------------------------------------------------------------------------------------------------------                                                                                                                          --------#---------#
    chr(    0) : b'\x00', #   #                                                                                #                                  #    0  # b'\x00' #
    chr(    1) : b'\x01', #   #                                                                                #                                  #    1  # b'\x01' #
    chr(    2) : b'\x02', #   #                                                                                #                                  #    2  # b'\x02' #
    chr(    3) : b'\x03', #   #                                                                                #                                  #    3  # b'\x03' #
    chr(    4) : b'\x04', #   #                                                                                #                                  #    4  # b'\x04' #
    chr(    5) : b'\x05', #   #                                                                                #                                  #    5  # b'\x05' #
    chr(    6) : b'\x06', #   #                                                                                #                                  #    6  # b'\x06' #
    chr(    7) : b'\x07', #   #                                                                                #                                  #    7  # b'\x07' #
    chr(    8) : b'\x08', #   #                                                                                #                                  #    8  # b'\x08' #
    chr(    9) : b'\x09', #   #                                                                                #                                  #    9  # b'\x09' #
    chr(   10) : b'\x0A', #   #                                                                                #                                  #   10  # b'\x0A' #
    chr(   11) : b'\x0B', #   #                                                                                #                                  #   11  # b'\x0B' #
    chr(   12) : b'\x0C', #   #                                                                                #                                  #   12  # b'\x0C' #
    chr(   13) : b'\x0D', #   #                                                                                #                                  #   13  # b'\x0D' #
    chr(   14) : b'\x0E', #   #                                                                                #                                  #   14  # b'\x0E' #
    chr(   15) : b'\x0F', #   #                                                                                #                                  #   15  # b'\x0F' #
    chr(   16) : b'\x10', #   #                                                                                #                                  #   16  # b'\x10' #
    chr(   17) : b'\x11', #   #                                                                                #                                  #   17  # b'\x11' #
    chr(   18) : b'\x12', #   #                                                                                #                                  #   18  # b'\x12' #
    chr(   19) : b'\x13', #   #                                                                                #                                  #   19  # b'\x13' #
    chr(   20) : b'\x14', #   #                                                                                #                                  #   20  # b'\x14' #
    chr(   21) : b'\x15', #   #                                                                                #                                  #   21  # b'\x15' #
    chr(   22) : b'\x16', #   #                                                                                #                                  #   22  # b'\x16' #
    chr(   23) : b'\x17', #   #                                                                                #                                  #   23  # b'\x17' #
    chr(   24) : b'\x18', #   #                                                                                #                                  #   24  # b'\x18' #
    chr(   25) : b'\x19', #   #                                                                                #                                  #   25  # b'\x19' #
    chr(   26) : b'\x1A', #   #                                                                                #                                  #   26  # b'\x1A' #
    chr(   27) : b'\x1B', #   #                                                                                #                                  #   27  # b'\x1B' #
    chr(   28) : b'\x1C', #   #                                                                                #                                  #   28  # b'\x1C' #
    chr(   29) : b'\x1D', #   #                                                                                #                                  #   29  # b'\x1D' #
    chr(   30) : b'\x1E', #   #                                                                                #                                  #   30  # b'\x1E' #
    chr(   31) : b'\x1F', #   #                                                                                #                                  #   31  # b'\x1F' #
    chr(   32) : b'\x20', #   #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   32  # b'\x20' #
    chr(   33) : b'\x21', # ! #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   33  # b'\x21' #
    chr(   34) : b'\x22', # " #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   34  # b'\x22' #
    chr(   35) : b'\x23', # # #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   35  # b'\x23' #
    chr(   36) : b'\x24', # $ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   36  # b'\x24' #
    chr(   37) : b'\x25', # % #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   37  # b'\x25' #
    chr(   38) : b'\x26', # & #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   38  # b'\x26' #
    chr(   39) : b'\x27', # ' #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   39  # b'\x27' #
    chr(   40) : b'\x28', # ( #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   40  # b'\x28' #
    chr(   41) : b'\x29', # ) #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   41  # b'\x29' #
    chr(   42) : b'\x2A', # * #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   42  # b'\x2A' #
    chr(   43) : b'\x2B', # + #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   43  # b'\x2B' #
    chr(   44) : b'\x2C', # , #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   44  # b'\x2C' #
    chr(   45) : b'\x2D', # - #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   45  # b'\x2D' #
    chr(   46) : b'\x2E', # . #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   46  # b'\x2E' #
    chr(   47) : b'\x2F', # / #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   47  # b'\x2F' #
    chr(   48) : b'\x30', # 0 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   48  # b'\x30' #
    chr(   49) : b'\x31', # 1 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   49  # b'\x31' #
    chr(   50) : b'\x32', # 2 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   50  # b'\x32' #
    chr(   51) : b'\x33', # 3 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   51  # b'\x33' #
    chr(   52) : b'\x34', # 4 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   52  # b'\x34' #
    chr(   53) : b'\x35', # 5 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   53  # b'\x35' #
    chr(   54) : b'\x36', # 6 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   54  # b'\x36' #
    chr(   55) : b'\x37', # 7 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   55  # b'\x37' #
    chr(   56) : b'\x38', # 8 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   56  # b'\x38' #
    chr(   57) : b'\x39', # 9 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   57  # b'\x39' #
    chr(   58) : b'\x3A', # : #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   58  # b'\x3A' #
    chr(   59) : b'\x3B', # ; #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   59  # b'\x3B' #
    chr(   60) : b'\x3C', # < #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   60  # b'\x3C' #
    chr(   61) : b'\x3D', # = #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   61  # b'\x3D' #
    chr(   62) : b'\x3E', # > #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   62  # b'\x3E' #
    chr(   63) : b'\x3F', # ? #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   63  # b'\x3F' #
    chr(   64) : b'\x40', # @ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   64  # b'\x40' #
    chr(   65) : b'\x41', # A #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   65  # b'\x41' #
    chr(   66) : b'\x42', # B #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   66  # b'\x42' #
    chr(   67) : b'\x43', # C #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   67  # b'\x43' #
    chr(   68) : b'\x44', # D #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   68  # b'\x44' #
    chr(   69) : b'\x45', # E #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   69  # b'\x45' #
    chr(   70) : b'\x46', # F #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   70  # b'\x46' #
    chr(   71) : b'\x47', # G #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   71  # b'\x47' #
    chr(   72) : b'\x48', # H #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   72  # b'\x48' #
    chr(   73) : b'\x49', # I #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   73  # b'\x49' #
    chr(   74) : b'\x4A', # J #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   74  # b'\x4A' #
    chr(   75) : b'\x4B', # K #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   75  # b'\x4B' #
    chr(   76) : b'\x4C', # L #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   76  # b'\x4C' #
    chr(   77) : b'\x4D', # M #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   77  # b'\x4D' #
    chr(   78) : b'\x4E', # N #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   78  # b'\x4E' #
    chr(   79) : b'\x4F', # O #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   79  # b'\x4F' #
    chr(   80) : b'\x50', # P #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   80  # b'\x50' #
    chr(   81) : b'\x51', # Q #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   81  # b'\x51' #
    chr(   82) : b'\x52', # R #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   82  # b'\x52' #
    chr(   83) : b'\x53', # S #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   83  # b'\x53' #
    chr(   84) : b'\x54', # T #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   84  # b'\x54' #
    chr(   85) : b'\x55', # U #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   85  # b'\x55' #
    chr(   86) : b'\x56', # V #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   86  # b'\x56' #
    chr(   87) : b'\x57', # W #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   87  # b'\x57' #
    chr(   88) : b'\x58', # X #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   88  # b'\x58' #
    chr(   89) : b'\x59', # Y #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   89  # b'\x59' #
    chr(   90) : b'\x5A', # Z #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   90  # b'\x5A' #
    chr(   91) : b'\x5B', # [ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   91  # b'\x5B' #
    chr(   92) : b'\x5C', # \ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   92  # b'\x5C' #
    chr(   93) : b'\x5D', # ] #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   93  # b'\x5D' #
    chr(   94) : b'\x5E', # ^ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   94  # b'\x5E' #
    chr(   95) : b'\x5F', # _ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   95  # b'\x5F' #
    chr(   96) : b'\x60', # ` #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   96  # b'\x60' #
    chr(   97) : b'\x61', # a #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   97  # b'\x61' #
    chr(   98) : b'\x62', # b #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   98  # b'\x62' #
    chr(   99) : b'\x63', # c #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   99  # b'\x63' #
    chr(  100) : b'\x64', # d #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  100  # b'\x64' #
    chr(  101) : b'\x65', # e #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  101  # b'\x65' #
    chr(  102) : b'\x66', # f #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  102  # b'\x66' #
    chr(  103) : b'\x67', # g #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  103  # b'\x67' #
    chr(  104) : b'\x68', # h #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  104  # b'\x68' #
    chr(  105) : b'\x69', # i #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  105  # b'\x69' #
    chr(  106) : b'\x6A', # j #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  106  # b'\x6A' #
    chr(  107) : b'\x6B', # k #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  107  # b'\x6B' #
    chr(  108) : b'\x6C', # l #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  108  # b'\x6C' #
    chr(  109) : b'\x6D', # m #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  109  # b'\x6D' #
    chr(  110) : b'\x6E', # n #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  110  # b'\x6E' #
    chr(  111) : b'\x6F', # o #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  111  # b'\x6F' #
    chr(  112) : b'\x70', # p #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  112  # b'\x70' #
    chr(  113) : b'\x71', # q #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  113  # b'\x71' #
    chr(  114) : b'\x72', # r #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  114  # b'\x72' #
    chr(  115) : b'\x73', # s #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  115  # b'\x73' #
    chr(  116) : b'\x74', # t #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  116  # b'\x74' #
    chr(  117) : b'\x75', # u #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  117  # b'\x75' #
    chr(  118) : b'\x76', # v #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  118  # b'\x76' #
    chr(  119) : b'\x77', # w #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  119  # b'\x77' #
    chr(  120) : b'\x78', # x #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  120  # b'\x78' #
    chr(  121) : b'\x79', # y #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  121  # b'\x79' #
    chr(  122) : b'\x7A', # z #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  122  # b'\x7A' #
    chr(  123) : b'\x7B', # { #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  123  # b'\x7B' #
    chr(  124) : b'\x7C', # | #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  124  # b'\x7C' #
    chr(  125) : b'\x7D', # } #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  125  # b'\x7D' #
    chr(  126) : b'\x7E', # ~ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  126  # b'\x7E' #
    chr(  127) : b'\x7F', #   #                                                                                #                                  #  127  # b'\x7F' #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    chr(  161) : b'\xC6', # ¡ #  inverted exclamation mark                                                     # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  198  # b'\xC6' #
    chr(  163) : b'\xB9', # £ #  british pound / pound sign                                                    # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  185  # b'\xB9' #
    chr(  169) : b'\xC3', # © #  copyright sign                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  195  # b'\xC3' #
    chr(  174) : b'\xAA', # ® #  patent mark / registered sign                                                 #             Gedcom 5.5.1, MARC-8 #  170  # b'\xAA' #
    chr(  176) : b'\xC0', # ° #  degree sign                                                                   #                           MARC-8 #  192  # b'\xC0' #
    chr(  177) : b'\xAB', # ± #  plus or minus / plus-minus sign                                               #             Gedcom 5.5.1, MARC-8 #  171  # b'\xAB' #
    chr(  183) : b'\xA8', # · #  middle dot                                                                    # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  168  # b'\xA8' #
    chr(  191) : b'\xC5', # ¿ #  inverted question mark                                                        # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  197  # b'\xC5' #
    chr(  198) : b'\xA5', # Æ #  uppercase digraph ae / Latin CAPITAL ligature ae                              # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  165  # b'\xA5' #
    chr(  216) : b'\xA2', # Ø #  uppercase scandinavian o / Latin CAPITAL letter o with stroke                 # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  162  # b'\xA2' #
    chr(  222) : b'\xA4', # Þ #  uppercase icelandic thorn / Latin CAPITAL letter thorn (icelandic)            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  164  # b'\xA4' #
    #chr( 223) : b'\xC7', # ß #  eszett symbol (Marc-8)                                                        #                           MARC-8 #  199  # b'\xC7' #
    chr(  223) : b'\xCF', # ß #  eszett symbol (Ansel/Gedcom)                                                  # Gedcom 5.5, Gedcom 5.5.1,        #  207  # b'\xCF' #
    chr(  230) : b'\xB5', # æ #  lowercase digraph ae / Latin small ligature ae                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  181  # b'\xB5' #
    chr(  240) : b'\xBA', # ð #  lowercase eth / Latin small letter eth (icelandic)                            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  186  # b'\xBA' #
    chr(  248) : b'\xB2', # ø #  lowercase scandinavian o / Latin small letter o with stroke                   # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  178  # b'\xB2' #
    chr(  254) : b'\xB4', # þ #  lowercase icelandic thorn / Latin small letter thorn (icelandic)              # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  180  # b'\xB4' #
    chr(  272) : b'\xA3', # Đ #  uppercase d with crossbar / Latin CAPITAL letter d with stroke                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  163  # b'\xA3' #
    chr(  273) : b'\xB3', # đ #  lowercase d with crossbar / Latin small letter d with stroke                  # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  179  # b'\xB3' #
    chr(  305) : b'\xB8', # ı #  lowercase turkish i / Latin small letter dotless i                            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  184  # b'\xB8' #
    chr(  321) : b'\xA1', # Ł #  uppercase polish l / Latin CAPITAL letter l with stroke                       # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  161  # b'\xA1' #
    chr(  322) : b'\xB1', # ł #  lowercase polish l / Latin small letter l with stroke                         # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  177  # b'\xB1' #
    chr(  338) : b'\xA6', # Œ #  uppercase digraph oe / Latin CAPITAL ligature oe                              # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  166  # b'\xA6' #
    chr(  339) : b'\xB6', # œ #  lowercase digraph oe / Latin small ligature oe                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  182  # b'\xB6' #
    chr(  416) : b'\xAC', # Ơ #  uppercase o-hook / Latin CAPITAL letter o with horn                           #                           MARC-8 #  172  # b'\xAC' #
    chr(  417) : b'\xBC', # ơ #  lowercase o-hook / Latin small letter o with horn                             #                           MARC-8 #  188  # b'\xBC' #
    chr(  431) : b'\xAD', # Ư #  uppercase u-hook / Latin CAPITAL letter u with horn                           #                           MARC-8 #  173  # b'\xAD' #
    chr(  432) : b'\xBD', # ư #  lowercase u-hook / Latin small letter u with horn                             #                           MARC-8 #  189  # b'\xBD' #
    chr(  697) : b'\xA7', # ʹ #  soft sign, prime / modifier letter prime                                      # Gedcom 5.5,               MARC-8 #  167  # b'\xA7' #
    chr(  698) : b'\xB7', # ʺ #  hard sign, double prime / modifier letter double prime                        #                           MARC-8 #  183  # b'\xB7' #
    chr(  699) : b'\xB0', # ʻ #  ayn / modifier letter turned comma                                            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  176  # b'\xB0' #
    chr(  700) : b'\xAE', # ʼ #  alif / modifier letter apostrophe                                             # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  174  # b'\xAE' #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    chr(  768) : b'\xE1', #   #  grave / combining grave accent (varia)                                        # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  225  # b'\xE1' #
    chr(  769) : b'\xE2', #   #  acute / combining acute accent (oxia)                                         # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  226  # b'\xE2' #
    chr(  770) : b'\xE3', #   #  circumflex / combining circumflex accent                                      # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  227  # b'\xE3' #
    chr(  771) : b'\xE4', #   #  tilde / combining tilde                                                       # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  228  # b'\xE4' #
    chr(  772) : b'\xE5', #   #  macron / combining macron                                                     # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  229  # b'\xE5' #
    chr(  774) : b'\xE6', #   #  breve / combining breve (vrachy)                                              # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  230  # b'\xE6' #
    chr(  775) : b'\xE7', #   #  superior dot / combining dot above                                            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  231  # b'\xE7' #
    chr(  776) : b'\xE8', #   #  umlaut, diaeresis / combining diaeresis (dialytika)                           # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  232  # b'\xE8' #
    chr(  777) : b'\xE0', #   #  pseudo question mark / combining hook above                                   #                           MARC-8 #  224  # b'\xE0' #
    chr(  778) : b'\xEA', #   #  circle above, angstrom / combining ring above                                 # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  234  # b'\xEA' #
    chr(  779) : b'\xEE', #   #  double acute / combining double acute accent                                  # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  238  # b'\xEE' #
    chr(  780) : b'\xE9', #   #  hacek / combining caron                                                       # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  233  # b'\xE9' #
    chr(  784) : b'\xEF', #   #  candrabindu / combining candrabindu                                           #                           MARC-8 #  239  # b'\xEF' #
    chr(  787) : b'\xFE', #   #  high comma, centered / combining comma above (Psili)                          # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  254  # b'\xFE' #
    chr(  789) : b'\xED', #   #  high comma, off center / combining comma above right                          # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  237  # b'\xED' #
    chr(  796) : b'\xF8', #   #  right cedilla / combining left half ring below                                #                           MARC-8 #  248  # b'\xF8' #
    chr(  803) : b'\xF2', #   #  dot below / combining dot below                                               #                           MARC-8 #  242  # b'\xF2' #
    chr(  804) : b'\xF3', #   #  double dot below / combining diaeresis below                                  #                           MARC-8 #  243  # b'\xF3' #
    chr(  805) : b'\xF4', #   #  circle below / combining ring below                                           #                           MARC-8 #  244  # b'\xF4' #
    chr(  806) : b'\xF7', #   #  left hook (comma below) / combining comma below                               # Gedcom 5.5,               MARC-8 #  247  # b'\xF7' #
    chr(  807) : b'\xF0', #   #  cedilla / combining cedilla                                                   # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  240  # b'\xF0' #
    chr(  808) : b'\xF1', #   #  right hook, ogonek / combining ogonek                                         # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  241  # b'\xF1' #
    chr(  814) : b'\xF9', #   #  upadhmaniya / combining breve below                                           #                           MARC-8 #  249  # b'\xF9' #
    chr(  818) : b'\xF6', #   #  underscore / combining low line                                               # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  246  # b'\xF6' #
    chr(  819) : b'\xF5', #   #  double underscore / combining double low line                                 #                           MARC-8 #  245  # b'\xF5' #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    chr( 8364) : b'\xC8', # € #  euro sign                                                                     #                           MARC-8 #  200  # b'\xC8' #
    chr( 8467) : b'\xC1', # ℓ #  script small l                                                                #                           MARC-8 #  193  # b'\xC1' #
    chr( 8471) : b'\xC2', # ℗ #  sound recording copyright                                                     #                           MARC-8 #  194  # b'\xC2' #
    chr( 9837) : b'\xA9', # ♭ #  music flat sign                                                               #             Gedcom 5.5.1, MARC-8 #  169  # b'\xA9' #
    chr( 9839) : b'\xC4', # ♯ #  music sharp sign                                                              #                           MARC-8 #  196  # b'\xC4' #
    }
#############################################################################################################################################################################################################################################################




########################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas  ",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-n", "--nydatabas", dest="nydatabasnamn", help="Namn för exporterad databas")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder = os.path.join( os.environ['APPDATA'], 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass

        self.setupUi(self)

        self.inledning()
        self.ui_connections()      # signaler i gui till slots i gui_exportera.py
        self.mera_ui_connections() # signaler i gui till slots i exportera.py

        self.enableUi()

        return
########################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Exportera_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




########################################################################################
# en del av grafiska gränsytan kodas här
    def mera_ui_connections(self):

        QtCore.QObject.connect(self.lineEdit_Databas,               QtCore.SIGNAL("returnPressed()"), self.uppdateranydatabas)
        QtCore.QObject.connect(self.lineEdit_Nydatabas,             QtCore.SIGNAL("returnPressed()"), self.uppdateranydatabas_2)

        QtCore.QObject.connect(self.pushButton_Startaexport,        QtCore.SIGNAL("clicked()"), self.exporteraknapp)

        QtCore.QObject.connect(self.radioButton_HelaDatabasen,      QtCore.SIGNAL("clicked()"), self.huvudvalknapp)
        QtCore.QObject.connect(self.radioButton_ExportDisbytutdrag, QtCore.SIGNAL("clicked()"), self.huvudvalknapp)
        QtCore.QObject.connect(self.radioButton_ExportWebbutdrag,   QtCore.SIGNAL("clicked()"), self.huvudvalknapp)
        QtCore.QObject.connect(self.radioButton_SärskiltUtdrag,     QtCore.SIGNAL("clicked()"), self.huvudvalknapp)
        QtCore.QObject.connect(self.radioButton_Delmängder,         QtCore.SIGNAL("clicked()"), self.huvudvalknapp)

        QtCore.QObject.connect(self.pushButton_Databas,             QtCore.SIGNAL('clicked()'), self.showDialogDatabas)
#        QtCore.QObject.connect(self.pushButton_Nydatabas,           QtCore.SIGNAL('clicked()'), self.showDialogNydatabas)

########################################################################################




########################################################################################
    def ritaom(self):
        self.sijlayout()
        return
########################################################################################




########################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        aktuelltpersonnummer = ""
        aktuelltparnummer = ""

        self.nydatabas = ""
        self.idag = datetime.datetime.today()
        self.datumtillägg = str(self.idag.year) + str(self.idag.month).zfill(2) + str(self.idag.day).zfill(2) + "_" + str(self.idag.hour).zfill(2) + str(self.idag.minute).zfill(2) + str(self.idag.second).zfill(2)

        if len(self.args) != 1 : # Jag förväntar mig exakt ett argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt ett argument i anropet: Databasadress. Jag avbryter här.\n ")
            self.avsluta(1)

        self.lineEdit_Databas.setText(self.args[0])
        self.databas = self.lineEdit_Databas.text()

        self.nydatabas = str(self.options.nydatabasnamn)
        if self.nydatabas == "None":
            self.nydatabas = ""
            self.nydatabas_auto = True
        else:
            self.nydatabas_auto = False
        self.lineEdit_Nydatabas.setText(self.nydatabas)


        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)

# Tillåt nu att ändra i förutsättningarna
        self.lineEdit_Databas.setEnabled(True)
        self.lineEdit_Nydatabas.setEnabled(True)

# Ställ in startval

        self.radioButton_ExportDisbytutdrag.setChecked(True)  # förvälj utdragsfunktion till disbytutdrag
        self.huvudvalknapp()

        self.fontsizeset()
        self.ritaom()

        return
########################################################################################




########################################################################################
    def huvudvalknapp(self):

        fp = allmänt.förstaperson(allmänt(), self.databas.rstrip('/'))
        if fp != "":
            self.lineEdit_Databas.setText(self.databas)
            self.lineEdit_Startperson.setText(fp)
        else:
            self.lineEdit_Startperson.setText("")



        if self.radioButton_HelaDatabasen.isChecked():

            self.checkBox_Räknamarkeringar.setChecked(True)        # räkna/visa markeringar
            self.checkBox_Räknamarkeringar.setEnabled(True)        # valbart

            self.checkBox_BBryt.setChecked(False)                  # bryt inte vid B-markeringar
            self.checkBox_BBryt.setEnabled(False)                  # ovillkorligt
            self.checkBox_BBryt.setVisible(False)

            self.checkBox_Extrabryt.setChecked(False)              # bryt inte vid extra brytpunkter
            self.checkBox_Extrabryt.setEnabled(False)              # ovillkorligt
            self.checkBox_Extrabryt.setVisible(False)

            self.textEdit_Extrabryt.setEnabled(False)              # valbart
            self.textEdit_Extrabryt.setVisible(False)

            self.checkBox_Amarkerade.setChecked(False)             # Tag inte bort A-markerade
            self.checkBox_Amarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Amarkerade.setVisible(False)

            self.checkBox_Bmarkerade.setChecked(False)             # Tag inte bort B-markerade
            self.checkBox_Bmarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Bmarkerade.setVisible(False)

            self.checkBox_Cmarkerade.setChecked(False)             # Tag inte bort C-markerade
            self.checkBox_Cmarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Cmarkerade.setVisible(False)

            self.checkBox_1markerade.setChecked(True)              # Tag med 1-markerade
            self.checkBox_1markerade.setEnabled(False)             # ovillkorligt
            self.checkBox_1markerade.setVisible(False)


            self.checkBox_Käntdöda.setVisible(False)
            self.lineEdit_Käntdöda.setVisible(False)
            self.label_Käntdöda.setVisible(False)

            self.checkBox_Okäntdöda.setVisible(False)
            self.lineEdit_Okäntdöda.setVisible(False)
            self.label_Okäntdöda.setVisible(False)

            self.checkBox_Käntdöda.setChecked(False)               # använd inte åldersgräns
            self.checkBox_Käntdöda.setEnabled(False)               # ovillkorligt
            self.lineEdit_Käntdöda.setText("")                     # döda sedan minst 25 år
            self.lineEdit_Käntdöda.setEnabled(False)               # ovillkorligt
            self.label_Käntdöda.setEnabled(False)

            self.checkBox_Okäntdöda.setChecked(False)              # använd inte åldersgräns
            self.checkBox_Okäntdöda.setEnabled(False)              # ovillkorligt
            self.lineEdit_Okäntdöda.setText("")                    # födda för mer än 110 år sedan
            self.lineEdit_Okäntdöda.setEnabled(False)              # ovillkorligt
            self.label_Okäntdöda.setEnabled(False)


            self.checkBox_Nivå1_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå1_dok.setEnabled(True)               #  villkorligt
            self.checkBox_Nivå1_dok.setVisible(True)

            self.checkBox_Nivå2_dok.setChecked(False)              #  Tag inte med någon nivå2-doumentation
            self.checkBox_Nivå2_dok.setEnabled(False)              #  ovillkorligt
            self.checkBox_Nivå2_dok.setVisible(False)


            self.checkBox_wget_skript.setChecked(False)            # generera inte något wget-skript
            self.checkBox_wget_skript.setEnabled(False)            # ovillkorligt
            self.checkBox_wget_skript.setVisible(False)

            self.NyRad_widget.setVisible(True)
            self.radioButton_Unix.setChecked(True)                 # förvälj unix NyRad-format till icke-disbytutdrag


        elif self.radioButton_ExportDisbytutdrag.isChecked():
# Export till (egen) webbsida och export till Disbyt är i PUL-avseende samma publika publicering.
# Skillnad är att Disbyt inte vill ha personer med dåliga referenser eller personer utan efternamn

            self.checkBox_Räknamarkeringar.setChecked(True)        # räkna/visa markeringar
            self.checkBox_Räknamarkeringar.setEnabled(True)        # valbart

            self.checkBox_BBryt.setChecked(True)                   # bryt vid B-markeringar
            self.checkBox_BBryt.setEnabled(False)                  # ovillkorligt
            self.checkBox_BBryt.setVisible(True)

            self.checkBox_Extrabryt.setChecked(False)              # bryt inte vid extra brytpunkter
            self.checkBox_Extrabryt.setEnabled(True)               # valbart
            self.checkBox_Extrabryt.setVisible(True)

            self.textEdit_Extrabryt.setEnabled(True)               # valbart
            self.textEdit_Extrabryt.setVisible(True)

            self.checkBox_Bmarkerade.setChecked(True)              # Tag bort B-markerade
            self.checkBox_Bmarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Bmarkerade.setVisible(True)

            self.checkBox_Amarkerade.setChecked(True)              # Tag bort A-markerade
            self.checkBox_Amarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Amarkerade.setVisible(True)

            self.checkBox_Cmarkerade.setChecked(True)              # Tag bort C-markerade
            self.checkBox_Cmarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Cmarkerade.setVisible(True)

            self.checkBox_1markerade.setChecked(True)              # Tag med 1-markerade
            self.checkBox_1markerade.setEnabled(False)             # ovillkorligt
            self.checkBox_1markerade.setVisible(True)



            self.checkBox_Käntdöda.setVisible(True)
            self.lineEdit_Käntdöda.setVisible(True)
            self.label_Käntdöda.setVisible(True)

            self.checkBox_Okäntdöda.setVisible(True)
            self.lineEdit_Okäntdöda.setVisible(True)
            self.label_Okäntdöda.setVisible(True)

            self.checkBox_Käntdöda.setChecked(True)                # använd åldersgräns
            self.checkBox_Käntdöda.setEnabled(False)               # ovillkorligt
            self.lineEdit_Käntdöda.setText("25")                   # döda sedan minst 25 år
            self.lineEdit_Käntdöda.setEnabled(False)               # ovillkorligt
            self.label_Käntdöda.setEnabled(False)

            self.checkBox_Okäntdöda.setChecked(True)               # använd åldersgräns
            self.checkBox_Okäntdöda.setEnabled(False)              # ovillkorligt
            self.lineEdit_Okäntdöda.setText("110")                 # födda för mer än 110 år sedan
            self.lineEdit_Okäntdöda.setEnabled(False)              # ovillkorligt
            self.label_Okäntdöda.setEnabled(False)


            self.checkBox_Nivå1_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå1_dok.setEnabled(False)              #  ovillkorligt
            self.checkBox_Nivå1_dok.setVisible(False)

            self.checkBox_Nivå2_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå2_dok.setEnabled(False)              #  ovillkorligt
            self.checkBox_Nivå2_dok.setVisible(False)


            self.checkBox_wget_skript.setChecked(False)            # generera inte något wget-skript
            self.checkBox_wget_skript.setEnabled(False)             # valbart
            self.checkBox_wget_skript.setVisible(False)

            self.NyRad_widget.setVisible(True)
            self.radioButton_Windows.setChecked(True)              # förvälj Windows NyRad-format till disbytutdrag



        elif self.radioButton_ExportWebbutdrag.isChecked() :
# Export till (egen) webbsida och export till Disbyt är i PUL-avseende samma publika publicering.
# Skillnad är att Disbyt inte vill ha personer med dåliga referenser eller personer utan efternamn

            self.checkBox_Räknamarkeringar.setChecked(True)        # räkna/visa markeringar
            self.checkBox_Räknamarkeringar.setEnabled(True)        # valbart

            self.checkBox_BBryt.setChecked(True)                   # bryt vid B-markeringar
            self.checkBox_BBryt.setEnabled(False)                  # ovillkorligt
            self.checkBox_BBryt.setVisible(True)

            self.checkBox_Extrabryt.setChecked(False)              # bryt inte vid extra brytpunkter
            self.checkBox_Extrabryt.setEnabled(True)               # valbart
            self.checkBox_Extrabryt.setVisible(True)

            self.textEdit_Extrabryt.setEnabled(True)               # valbart
            self.textEdit_Extrabryt.setVisible(True)

            self.checkBox_Bmarkerade.setChecked(True)              # Tag bort B-markerade
            self.checkBox_Bmarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Bmarkerade.setVisible(True)

            self.checkBox_Amarkerade.setChecked(True)              # Tag bort A-markerade
            self.checkBox_Amarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Amarkerade.setVisible(True)

            self.checkBox_Cmarkerade.setChecked(True)              # Tag bort C-markerade
            self.checkBox_Cmarkerade.setEnabled(False)             # ovillkorligt
            self.checkBox_Cmarkerade.setVisible(True)

            self.checkBox_1markerade.setChecked(True)              # Tag med 1-markerade
            self.checkBox_1markerade.setEnabled(False)             # ovillkorligt
            self.checkBox_1markerade.setVisible(True)


            self.checkBox_Käntdöda.setVisible(True)
            self.lineEdit_Käntdöda.setVisible(True)
            self.label_Käntdöda.setVisible(True)

            self.checkBox_Okäntdöda.setVisible(True)
            self.lineEdit_Okäntdöda.setVisible(True)
            self.label_Okäntdöda.setVisible(True)

            self.checkBox_Käntdöda.setChecked(True)                # använd åldersgräns
            self.checkBox_Käntdöda.setEnabled(False)               # ovillkorligt
            self.lineEdit_Käntdöda.setText("25")                   # döda sedan minst 25 år
            self.lineEdit_Käntdöda.setEnabled(False)               # ovillkorligt
            self.label_Käntdöda.setEnabled(False)

            self.checkBox_Okäntdöda.setChecked(True)               # använd åldersgräns
            self.checkBox_Okäntdöda.setEnabled(False)              # ovillkorligt
            self.lineEdit_Okäntdöda.setText("110")                 # födda för mer än 110 år sedan
            self.lineEdit_Okäntdöda.setEnabled(False)              # ovillkorligt
            self.label_Okäntdöda.setEnabled(False)


            self.checkBox_Nivå1_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå1_dok.setEnabled(True)               #  villkorligt
            self.checkBox_Nivå1_dok.setVisible(True)

            self.checkBox_Nivå2_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå2_dok.setEnabled(False)              #  ovillkorligt
            self.checkBox_Nivå2_dok.setVisible(False)


            self.checkBox_wget_skript.setChecked(False)            # generera inte något wget-skript
            self.checkBox_wget_skript.setEnabled(False)            # ovillkorligt
            self.checkBox_wget_skript.setVisible(False)

            self.NyRad_widget.setVisible(False)


        elif self.radioButton_SärskiltUtdrag.isChecked():
# Egen komposition av utdragsvillkor

            self.checkBox_Räknamarkeringar.setChecked(True)        # räkna/visa markeringar
            self.checkBox_Räknamarkeringar.setEnabled(True)        # valbart

            self.checkBox_BBryt.setChecked(True)                   # bryt vid B-markeringar
            self.checkBox_BBryt.setEnabled(True)                   # valbart
            self.checkBox_BBryt.setVisible(True)

            self.checkBox_Extrabryt.setChecked(False)              # bryt inte vid extra brytpunkter
            self.checkBox_Extrabryt.setEnabled(True)               # valbart
            self.checkBox_Extrabryt.setVisible(True)

            self.textEdit_Extrabryt.setEnabled(True)               # valbart
            self.textEdit_Extrabryt.setVisible(True)

            self.checkBox_Bmarkerade.setChecked(True)              # Tag bort B-markerade
            self.checkBox_Bmarkerade.setEnabled(True)              # valbart
            self.checkBox_Bmarkerade.setVisible(True)

            self.checkBox_Amarkerade.setChecked(True)              # Tag bort A-markerade
            self.checkBox_Amarkerade.setEnabled(True)              # valbart
            self.checkBox_Amarkerade.setVisible(True)

            self.checkBox_Cmarkerade.setChecked(True)              # Tag bort C-markerade
            self.checkBox_Cmarkerade.setEnabled(True)              # valbart
            self.checkBox_Cmarkerade.setVisible(True)

            self.checkBox_1markerade.setChecked(True)              # Tag med 1-markerade
            self.checkBox_1markerade.setEnabled(True)              # valbart
            self.checkBox_1markerade.setVisible(True)


            self.checkBox_Käntdöda.setVisible(True)
            self.lineEdit_Käntdöda.setVisible(True)
            self.label_Käntdöda.setVisible(True)

            self.checkBox_Okäntdöda.setVisible(True)
            self.lineEdit_Okäntdöda.setVisible(True)
            self.label_Okäntdöda.setVisible(True)

            self.checkBox_Käntdöda.setChecked(False)               # använd inte åldersgräns
            self.checkBox_Käntdöda.setEnabled(True)                # valbart
            self.lineEdit_Käntdöda.setText("0")                    # valbart
            self.lineEdit_Käntdöda.setEnabled(True)                # ovillkorligt
            self.label_Käntdöda.setEnabled(True)                   # valbart

            self.checkBox_Okäntdöda.setChecked(False)              # använd inte åldersgräns
            self.checkBox_Okäntdöda.setEnabled(True)               # valbart
            self.lineEdit_Okäntdöda.setText("0")                   # valbart
            self.lineEdit_Okäntdöda.setEnabled(True)               # ovillkorligt
            self.label_Okäntdöda.setEnabled(True)                  # valbart


            self.checkBox_Nivå1_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå1_dok.setEnabled(True)               #  villkorligt
            self.checkBox_Nivå1_dok.setVisible(True)

            self.checkBox_Nivå2_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå2_dok.setEnabled(True)               #  villkorligt
            self.checkBox_Nivå2_dok.setVisible(True)


            self.checkBox_wget_skript.setChecked(False)            # generera inte något wget-skript
            self.checkBox_wget_skript.setEnabled(False)            # ovillkorligt
            self.checkBox_wget_skript.setVisible(False)

            self.NyRad_widget.setVisible(False)


        elif self.radioButton_Delmängder.isChecked():
# Alltid hela databasen. Bör kompletteras/kontrolleras beträffande uppdelning av icke-xml-filerna

            self.checkBox_Räknamarkeringar.setChecked(True)        # räkna/visa markeringar
            self.checkBox_Räknamarkeringar.setEnabled(True)        # valbart


            self.checkBox_BBryt.setChecked(False)                  # bryt inte vid B-markeringar
            self.checkBox_BBryt.setEnabled(True)                   # valbart
            self.checkBox_BBryt.setVisible(False)

            self.checkBox_Extrabryt.setChecked(False)              # bryt inte vid extra brytpunkter
            self.checkBox_Extrabryt.setEnabled(True)               # valbart
            self.checkBox_Extrabryt.setVisible(False)

            self.textEdit_Extrabryt.setEnabled(False)              # valbart
            self.textEdit_Extrabryt.setVisible(False)

            self.checkBox_Bmarkerade.setChecked(False)             # Tag inte bort B-markerade
            self.checkBox_Bmarkerade.setEnabled(True)              # valbart
            self.checkBox_Bmarkerade.setVisible(False)

            self.checkBox_Amarkerade.setChecked(False)             # Tag inte bort A-markerade
            self.checkBox_Amarkerade.setEnabled(True)              # valbart
            self.checkBox_Amarkerade.setVisible(False)

            self.checkBox_Cmarkerade.setChecked(False)             # Tag inte bort C-markerade
            self.checkBox_Cmarkerade.setEnabled(True)              # valbart
            self.checkBox_Cmarkerade.setVisible(False)

            self.checkBox_1markerade.setChecked(True)              # Tag med 1-markerade
            self.checkBox_1markerade.setEnabled(True)              # valbart
            self.checkBox_1markerade.setVisible(False)


            self.checkBox_Käntdöda.setVisible(False)
            self.lineEdit_Käntdöda.setVisible(False)
            self.label_Käntdöda.setVisible(False)

            self.checkBox_Okäntdöda.setVisible(False)
            self.lineEdit_Okäntdöda.setVisible(False)
            self.label_Okäntdöda.setVisible(False)

            self.checkBox_Käntdöda.setChecked(False)               # använd inte åldersgräns
            self.checkBox_Käntdöda.setEnabled(True)                # valbart
            self.lineEdit_Käntdöda.setText("")                     # valbart
            self.lineEdit_Käntdöda.setEnabled(True)                # valbart
            self.label_Käntdöda.setEnabled(True)                   # valbart

            self.checkBox_Okäntdöda.setChecked(False)              # använd inte åldersgräns
            self.checkBox_Okäntdöda.setEnabled(True)               # valbart
            self.lineEdit_Okäntdöda.setText("")                    # valbart
            self.lineEdit_Okäntdöda.setEnabled(True)               # valbart
            self.label_Okäntdöda.setEnabled(True)                  # valbart


            self.checkBox_Nivå1_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå1_dok.setEnabled(True)               #  villkorligt
            self.checkBox_Nivå1_dok.setVisible(True)

            self.checkBox_Nivå2_dok.setChecked(False)              #  Tag inte med någon nivå1-doumentation
            self.checkBox_Nivå2_dok.setEnabled(True)               #  villkorligt
            self.checkBox_Nivå2_dok.setVisible(True)


            self.checkBox_wget_skript.setVisible(False)
            self.checkBox_wget_skript.setChecked(False)            # generera inte något wget-skript
            self.checkBox_wget_skript.setEnabled(False)            # ovillkorligt

            self.NyRad_widget.setVisible(False)


        else:
            self.logga ("(huvudvalknapp) - Hit ska man inte kunna komma!\n")

        self.uppdateranydatabas()

        return
########################################################################################



###################################################################################################
    def uppdateranydatabas_2(self):

        tidigare = self.nydatabas
        self.nydatabas = self.lineEdit_Nydatabas.text()
        self.logga ('Nydatabas, tidigare: "' + tidigare + '"\nÄndrat till: "' + self.nydatabas + '"\n' )

        if self.nydatabas ==  "":
            self.nydatabas_auto = True
            self.uppdateranydatabas()
        else:
            self.nydatabas_auto = False

        return
###################################################################################################




###################################################################################################
    def uppdateranydatabas(self):

        if self.nydatabas_auto == False:  # efter manuell ändring av nydatabasnamnet gör ingen automatisk ändring p.g.a. val av typ av utdrag.
            return

        self.databas = self.lineEdit_Databas.text()

        if  self.radioButton_HelaDatabasen.isChecked():
            self.nydatabas = os.path.join(self.databas, self.datumtillägg)
        elif self.radioButton_ExportDisbytutdrag.isChecked():
            self.nydatabas = os.path.join(self.databas, "disbytutdrag-" + self.datumtillägg)
        elif  self.radioButton_ExportWebbutdrag.isChecked():
            self.nydatabas = os.path.join(self.databas, "webbutdrag-" + self.datumtillägg)
        elif self.radioButton_SärskiltUtdrag.isChecked():
            self.nydatabas = os.path.join(self.databas, "särskiltutdrag-" + self.datumtillägg)
        elif self.radioButton_Delmängder.isChecked():
            self.nydatabas = os.path.join(self.databas, "delmängder-" + self.datumtillägg)
        else:
            self.nydatabas = os.path.join(self.databas, "uniktutdrag-" + self.datumtillägg)

        tidigare = self.lineEdit_Nydatabas.text()
        self.logga ('Nydatabas, tidigare: "' + tidigare + '"\nÄndras till: "' + self.nydatabas + '"\n' )

        self.lineEdit_Nydatabas.setText(self.nydatabas)

        return
###################################################################################################




###################################################################################################
    def showDialogDatabas(self):

        svar =str( QtGui.QFileDialog.getExistingDirectory(self, "Databas att exportera från", "/home", QFileDialog.ShowDirsOnly) )
        fp = allmänt.förstaperson (allmänt(), svar.rstrip('/'))
        if fp != "":
            self.databas = svar
            self.lineEdit_Databas.setText(self.databas)
            self.lineEdit_Startperson.setText(fp)
            self.uppdateranydatabas()

        return
###################################################################################################




###################################################################################################
    def exporteraknapp(self):

        self.pushButton_Startaexport.setEnabled(False)
        self.databas = self.lineEdit_Databas.text()
        self.nydatabas = self.lineEdit_Nydatabas.text()

        self.idag =  datetime.datetime.today()
        self.datumtillägg = str(self.idag.year) + str(self.idag.month).zfill(2) + str(self.idag.day).zfill(2) + "_" + str(self.idag.hour).zfill(2) + str(self.idag.minute).zfill(2) + str(self.idag.second).zfill(2)

        self.startaexport()
###################################################################################################




###################################################################################################
    def startaexport(self):

        self.textEdit_logg.setDisabled(True)

        if not  os.path.exists(self.databas):
            self.logga ("(exportera.py)  Jag hittar inte databasen     " + self.databas + "\nAVBRYTER!\n" )

        elif not os.path.exists(os.path.join(self.databas, "data")):
            self.logga ("(exportera.py)  Jag känner inte igen databasen     " + self.databas + "\nAVBRYTER!\n" )

        elif not os.path.exists(os.path.join(self.databas, "senaste", "senasteperson.txt")):
            self.logga ("(exportera.py)  Jag känner inte igen databasen     " + self.databas + "\nAVBRYTER\n" )

        elif os.path.exists(os.path.join(self.databas, "data")):
            self.logga ("(exportera.py)  Startar generering av export\n")
            self.logga ("Från " + self.databas + "   Till " + self.nydatabas + "\n" )

# man ska inte kunna ändra på förutsättningarna när man startat
            self.top_widget.setEnabled(False)
            self.left_widget.setEnabled(False)
            self.textEdit_logg.setDisabled(False)

            self.Fas0()  # skapa primär lista med personnummer
            self.Fas1()  # skapa lista med alla personer relaterade till startpersonen
            self.Fas2()  # rensar bort i listan personer med markeringar och  personer som ej motsvarar PUL
            self.Fas3()  # genomför filkopiering efter lista och sedan rensning av länkar i parfiler
            self.Fas4()  # översätter, export: Gedcom, Disbyt
            self.Fas5()  # startar processer som genererar innehållsförteckningar
            self.logga ("FÄRDIG!\n")
            self.logga ("Exporten är klar. Dess innehållsförteckningar kommer efterhand\n")

# Tillåt nu åter att ändra i förutsättningarna
            self.top_widget.setEnabled(True)
            self.left_widget.setEnabled(True)
            self.textEdit_logg.setEnabled(True)
            self.textEdit_logg.setFocus()

        return
###################################################################################################




###################################################################################################
    def Fas0(self):
# skapa primärlistan, ID-nummer för alla personer i hela databasen

# läs sistanummer-filer
        senastepersonfilnamn = os.path.join(self.databas, "senaste", "senasteperson.txt")
        senastepersonfil = open( senastepersonfilnamn, 'r', encoding='utf-8' )
        self.senasteperson=senastepersonfil.readline().strip()      # tag bort ev newline och annan whitespace
        senastepersonfil.close()

        senasteparfilnamn = os.path.join(self.databas, "senaste", "senastepar.txt")
        senasteparfil = open( senasteparfilnamn, 'r', encoding='utf-8' )
        self.senastepar=senasteparfil.readline().strip()            # tag bort ev newline och annan whitespace
        senasteparfil.close()

        self.primärpersonlista[:] = []
        for i in range (1, int(self.senasteperson) + 1 ):
            aktuelltpersonnummer =  str(i).zfill(8)
            filnamn = os.path.join(self.databas, "data", aktuelltpersonnummer[:5], aktuelltpersonnummer + ".xml")
            if os.path.exists(filnamn):
                self.primärpersonlista.append(aktuelltpersonnummer)

        self.logga ("Antal personer i databasen:        " + str(len(self.primärpersonlista))  + '\n')

        self.primärparlista[:] = []
        for i in range (1, int(self.senastepar[3:11]) + 1 ):
            aktuelltparnummer = "par" + str(i).zfill(8)
            filnamn = os.path.join(self.databas, "data", aktuelltparnummer[:8], aktuelltparnummer + ".xml")
            if os.path.exists(filnamn):
                self.primärparlista.append(aktuelltparnummer)

        self.logga ("Antal par i databasen:        " + str(len(self.primärparlista)) + '\n')

        if self.checkBox_Räknamarkeringar.isChecked():
            allmänt.räknamarkeringar(allmänt(), self.databas, self.primärpersonlista, self.datumtillägg)
            self.logga ("Markeringar i  " + self.databas + '\n' )
            self.logga ("sparade i  " + os.path.join(self.databas, "kategorier_" + self.datumtillägg)  + '\n')
            räknafil = open( os.path.join(self.databas, "kategorier_" + self.datumtillägg, "summering.txt"), 'r', encoding='utf-8' )
            helafilen = räknafil.read()
            räknafil.close()
            self.logga ( helafilen + "\n" )

        return
####################################################################################################




###################################################################################################
    def Fas1(self):

# Indata till fas 1 är globala primärlista innehållande alla personer i databasen.

        self.logga ("FAS 1\n")

        tillista = []

        self.skapakataloger(self.databas, self.nydatabas)

# samla upp alla personer som är relaterade till startpersonen
# Filtreringen görs i self.flyttadelmängd

#        tillista [:] = []  nollställes i flyttadelmängd
        startpersonnr = self.lineEdit_Startperson.text()

        self.flyttadelmängd( self.primärpersonlista, tillista, startpersonnr)

        tillista.sort() # för att den sparade listan ska vara lättare att läsa
        tmplistfilnamn = os.path.join(self.nydatabas, "fullgrupp" + self.datumtillägg + ".txt")
        tmplistfil = open( tmplistfilnamn, 'w', encoding='utf-8' )
        for i in range (0, len(tillista)):
            tmplistfil.write(tillista[i] + "\n")
        tmplistfil.close()

        self.logga ("Antal personer till "+  tmplistfilnamn + ":  " + str(len(tillista)) + "\n")

# Utdata från fas 1 är en fil  /fullgrupp.txt

        return
###################################################################################################




###################################################################################################
    def Fas2(self):
# Indata är resultatfil/filer  /fullgrupp.txt från fas 1

#rensa bort alla andra filer som ska rensas bort: levande eller möjligen levande

        self.logga ("FAS 2\n")

        tillista = []
        tillista[:] = []

        PULlista = []
        PULlista[:] = []

        tmplistfilnamn = os.path.join(self.nydatabas, "fullgrupp" + self.datumtillägg + ".txt")

        if  os.path.exists( tmplistfilnamn):
            tmplistfil = open( tmplistfilnamn, 'r', encoding='utf-8' )
# Använd inte .readlines! NyRad läggs på slutet i varje element! Läs i stället hela filen i ett svep
            tmplista = tmplistfil.read().split("\n")    # och dela själv till lista med rader.
            tmplistfil.close()

            self.logga ("Läste lista " + tmplistfilnamn + " att rensa i: " + str(len(tmplista)) + "\n" )

            tillista, PULlista = self.rensaeftervillkor(tmplista, self.databas)

            self.logga ("Kvar efter rensning:  " + str(len(tillista)) + "\n" )
            self.logga ("Rensade pga PUL:  " + str(len(PULlista)) + "\n" )


            tillista.sort() # för att den sparade listan ska vara lättare att läsa
            tmplistfilnamn = os.path.join(self.nydatabas, "personurval" + self.datumtillägg + ".txt")

            tmplistfil = open( tmplistfilnamn, 'w', encoding='utf-8' )
            for i in range (0, len(tillista)):
                tmplistfil.write(tillista[i] + "\n")
            tmplistfil.close()
            self.logga ("Antal personer till "+  tmplistfilnamn + ":    " +  str(len(tillista)) + "\n" )


            PULlista.sort() # för att den sparade listan ska vara lättare att läsa
            tmplistfilnamn = os.path.join(self.nydatabas, "PULurval" + self.datumtillägg + ".txt")

            tmplistfil = open( tmplistfilnamn, 'w', encoding='utf-8' )
            for i in range (0, len(PULlista)):
                tmplistfil.write(PULlista[i] + "\n")
            tmplistfil.close()
            self.logga ("Antal personer till "+  tmplistfilnamn + ":    " +  str(len(PULlista)) + "\n" )



#  Resultatet efter fas 2 finns i en eller flera filer /personurval.txt
        return
###################################################################################################




###################################################################################################
    def Fas3(self):

        self.logga ("FAS 3\n")

        tmplistfilnamn = os.path.join(self.nydatabas, "personurval" + self.datumtillägg + ".txt")
        PULlistfilnamn = os.path.join(self.nydatabas, "PULurval" + self.datumtillägg + ".txt")

        if  os.path.exists          ( tmplistfilnamn):
            self.kopierapersonfiler ( tmplistfilnamn, self.databas, self.nydatabas)
            self.kopieraegnapar     ( tmplistfilnamn, PULlistfilnamn, self.databas, self.nydatabas)
            self.kopieraföräldrapar ( tmplistfilnamn, self.databas, self.nydatabas)
            self.kopieraövrigt      (                 self.databas, self.nydatabas)

            self.rensaparfiler(self.nydatabas)

            if self.checkBox_Nivå1_dok.isChecked() or self.checkBox_Nivå2_dok.isChecked():
                self.kopieradokument(                 self.databas, self.nydatabas)
        return
###################################################################################################




###################################################################################################
    def Fas4(self):
        self.logga ("FAS 4\n")

# Johan-databaser är klara.
# I Fas4 görs översättning till Gedcom

        if self.radioButton_HelaDatabasen.isChecked():
            db = self.databas
        elif self.radioButton_ExportDisbytutdrag.isChecked():
            db = self.nydatabas
        else:
            self.logga ("Jag kan tills vidare hantera gedcomexport endast för komplett databas och för disbytutdrag\n")
            return

        self.logga ("Skapar ny personlista och ny parlista direkt från databas " + db + "\n")

        personlista = []
        personlista[:] = []
        for i in range (1, int(self.senasteperson) + 1 ):
            aktuelltpersonnummer =  str(i).zfill(8)
            filnamn = os.path.join(db, "data", aktuelltpersonnummer[:5], aktuelltpersonnummer + ".xml")
            if os.path.exists(filnamn):
                personlista.append(aktuelltpersonnummer)

        parlista = []
        parlista[:] = []
        for i in range (1, int(self.senastepar[3:11]) + 1 ):
            aktuelltparnummer = "par" + str(i).zfill(8)
            filnamn = os.path.join(db, "data",  aktuelltparnummer[:8], aktuelltparnummer + ".xml")
            if os.path.exists(filnamn):
                parlista.append(aktuelltparnummer)

        self.logga ("Antal filer i vald databas: \n")
        self.logga ("         Personer     " + str(len(personlista)) + "\n")
        self.logga ("         Par:         " + str(len(parlista)) + "\n")

        self.skrivgedcomfil(db, personlista, parlista)


        if self.checkBox_Räknamarkeringar.isChecked() and not self.radioButton_HelaDatabasen.isChecked():
            allmänt.räknamarkeringar(allmänt(), db, personlista, self.datumtillägg)
            self.logga ("Markeringar i  " + db + "\n" )
            self.logga ("sparade i  " + os.path.join(db, "kategorier_" + self.datumtillägg) + "\n")
            räknafil = open( os.path.join(db, "kategorier_" + self.datumtillägg, "summering.txt"), 'r', encoding='utf-8' )
            helafilen = räknafil.read()
            räknafil.close()
            self.logga ( helafilen + "\n" )

        return
###################################################################################################




###################################################################################################
    def Fas5(self):

        self.logga ("FAS 5\n")

        if  os.path.exists          (os.path.join(self.nydatabas , "personurval" + self.datumtillägg + ".txt")):

            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"    -s F    ' + self.i_option + '   "' + self.nydatabas + '"'  # skapa innehållsförteckning sorterad på förnamn (ett eller flera per person)
            QtCore.QProcess().startDetached(kommando)
            self.logga ("exportera.py: Startade förnamnssorterad förteckning\n")

            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"    -s E    ' + self.i_option + '   "' + self.nydatabas + '"'  # skapa innehållsförteckning sorterad på förnamn (ett eller flera per person)
            QtCore.QProcess().startDetached(kommando)
            self.logga ("exportera.py: Startade efternamnssorterad förteckning\n")

            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"       ' + self.i_option + '   "' + self.nydatabas + '"'  # skapa innehållsförteckning sorterad på förnamn (ett eller flera per person)
            QtCore.QProcess().startDetached(kommando)
            self.logga ("exportera.py: Startade övriga förteckningar\n")

###################################################################################################




###########################################################################
    def skapakataloger(self, db, nydb):

# Anropas från Fas 1.    # db och nydb ska vara strängar

        os.mkdir(nydb)
        os.mkdir(os.path.join(nydb, "data"))
        os.mkdir(os.path.join(nydb, "locks"))
        os.mkdir(os.path.join(nydb, "senaste"))
        os.mkdir(os.path.join(nydb, "php"))
        os.mkdir(os.path.join(nydb, "xml"))
        os.mkdir(os.path.join(nydb, "xml", "images"))
        os.mkdir(os.path.join(nydb, "html"))
        os.mkdir(os.path.join(nydb, "html", "images"))

        folderinh = sorted( os.listdir(os.path.join(db, "data")) )
        for f in folderinh:
            if os.path.isdir(os.path.join(db, "data", f)):
                os.mkdir(os.path.join(nydb, "data", f))
################################################################################




#############################################################################################
    def flyttadelmängd(self, frånlista, tillista, startpersonnr):

# Anropas från Fas 1

        attkollalista = []
        tmplista = []
        spärrlista = []

        tillista[:] = []
        attkollalista[:] = []
        spärrlista[:] = []

        self.logga ( "Startpersonnr = " + str(startpersonnr) + '\n')

        Person1 = johanpersonfil()
        Par = johanparfil()
        try:
            startnummer = frånlista.index(startpersonnr)
        except:
            self.logga ("Hittade inte startperson = " + str(startpersonnr) + "  i från-listan\n")
            self.avsluta(1)

        startpos = frånlista.index(startpersonnr)  # Hämta startpersonnumret ur primärlistan, det ligger inte nödvändigtvis i listans första position
        attkollalista.append(frånlista[startpos])
        frånlista.remove(frånlista[startpos])

# Ta fram ev. spärrlista och kontrollera den
        if  self.checkBox_Extrabryt.isChecked():
            spärrlista = self.textEdit_Extrabryt.toPlainText().split(",")
            for sp in spärrlista:
                spärr = sp.strip()

                if (len(spärr) != 8) or (not spärr.isdigit()) :
                    self.logga ('VARNING! FEL FORMAT PÅ SPÄRRNUMMER: "' + spärr + '\n"')
                    self.logga ("      8 siffror, kommaseparerat, utan mellanslag\n")
                else:
                    self.logga ("Spärr vid person nummer " + spärr  + "\n" )


# Nu börjar vi:

        tillista[:] = []
        varv = 0

        flyttaigen = True
        while flyttaigen == True:
            flyttaigen = False
            flyttade = 0
            varv = varv + 1

            self.logga ("Inför varv " + str(varv) + ",\tfrån-lista: " +  str(len(frånlista)) + ",\tatt kolla-lista: " +  str(len(attkollalista)) + ",\ttill-lista: " +  str(len(tillista)) + "\n")

            if  self.checkBox_Extrabryt.isChecked():
                self.logga("Spärrlista, längd:" + str(len(spärrlista)) + "\n" )
                if len(spärrlista) > 0:
                    self.logga("  Spärrlista:" + str(spärrlista[0:len(spärrlista)]) + "\n" )

            tmplista[:] = []
# spara vad som hämtats till attkollalista under föregående varv
            for s3 in attkollalista:
                tillista.append(s3)   # dels tillfogat till "flytta-filer-senare"-listan
                tmplista.append(s3)   # dels i lista på filer som ska kollas under detta vawrv

# bygg en ny attkollalista med nummer på personer som ska kollas nästa varv
            attkollalista[:] = []



            for s7 in tmplista:# kolla en person i taget

                reflista = []  # Ny reflista för varje person i tmplistan
                reflista[:] = []  # Ny reflista för varje person i tmplistan
                filnamn1 =   os.path.join(self.databas, "data", s7[:5], s7 + ".xml")
                if os.path.exists(filnamn1):
                    allmänt.hämtapersonfil(allmänt(), filnamn1, Person1)

                    if  self.checkBox_Extrabryt.isChecked():
                        self.logga ( "s7", s7, "spärrlista.count(s7)", str(spärrlista.count(s7))  + "\n" )

 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# B-markerad eller spärrlistad person kommer att finnas kvar i exporten
# Bortom markeringen tas ingen med.

                    if  (( self.checkBox_BBryt.isChecked() )  and  ( Person1.person_kategori.upper() == "B" )) or (( self.checkBox_Extrabryt.isChecked() )  and  ( spärrlista.count(s7) > 0 )) :

                        if  ( Person1.person_kategori.upper() == "B" ):
                            self.logga ( "Kategori B: bryter vid " + s7 + "  " + Person1.kortnamn + "\n" )   #  UNICODE

                        if  ( spärrlista.count(s7) > 0 ):
                            self.logga ( "Spärrlista: bryter vid " + s7 + "  " +  Person1.kortnamn + "\n" )   #  UNICODE

                        pass

                    else:
 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


#                        if Person1.person_kategori.upper() == "B":
#                            self.logga ( "Hittade  person med B-markering; " + s7 + "; "   +  Person1.kortnamn + "\n"  )   #  UNICODE


# Hämta undersökt persons personfil och hämta föräldrar till den nya att-hämta-listan (mellanlandning i aktuell reflista)
                        föräldraparID= Person1.föräldrapar_ID
                        parfilnamn =  os.path.join(self.databas, "data", föräldraparID[:8], föräldraparID + ".xml")
                        if os.path.exists(parfilnamn):
                            allmänt.hämtaparfil(allmänt(), parfilnamn, Par)

                            if Par.person1_ID != "00000000" and Par.person1_ID != "":
                                reflista.append(Par.person1_ID)
                            if Par.person2_ID != "00000000" and Par.person2_ID != "":
                                reflista.append(Par.person2_ID)


# Hämta undersökt persons parfiler och hämta förekommande barn och förekommande make/maka
                        egnapar =   Person1.egna_par_ID.split("\n")

                        for egetpar in egnapar:
                            parfilnamn =  os.path.join(self.databas, "data", egetpar[:8], egetpar + ".xml")
                            if os.path.exists(parfilnamn):
                                allmänt.hämtaparfil(allmänt(), parfilnamn, Par)

                                # hämta länk till make/maka
                                if (Par.person1_ID != "00000000") and (Par.person1_ID != "") and (Par.person1_ID != s7) :
                                    reflista.append(Par.person1_ID)
                                if (Par.person2_ID != "00000000") and (Par.person2_ID != "") and (Par.person2_ID != s7) :
                                    reflista.append(Par.person2_ID)

                                # hämta länkar till parets barn
                                egnabarn = Par.barn_ID.split("\n")
                                for egetbarn in egnabarn:
                                    reflista.append(egetbarn)

# Hämta undersökt persons bonusrelationer
                        Egnarelationer = Person1.bonusrelation_ID.split("\n")
                        for egenrelation in Egnarelationer:
                            if len(egenrelation) == 8:          # referens till person
                                reflista.append(egenrelation)
                            elif len(egenrelation) == 11:       # referens till par
                                if os.path.exists(egenrelation):
                                    allmänt.hämtaparfil(allmänt(), egenrelation, Par)

                                if (Par.person1_ID != "00000000") and (Par.person1_ID != "") :
                                    reflista.append(Par.person1_ID)
                                if (Par.person2_ID != "00000000") and (Par.person2_ID != "") :
                                    reflista.append(Par.person2_ID)

                                # hämta länkar till relationsparets barn
                                relationsparsbarn = Par.barn_ID.split("\n")
                                for relbarn in relationsparsbarn:
                                    reflista.append(relbarn)

# OBS! konstruktionen innebär att person bakom en B-brytpunkt kan råka nås via bonuslänken eller anförlust.
# Hela grenen, som skulle döljas bakom B-markeringen, kan då komma att exponeras!!!!!





# överför från reflista till attkollalista innan vi börjar med nästa person
                        for p in reflista:
                            if frånlista.count(p) >0:
                                attkollalista.append(p)
                                frånlista.remove(p)
                                flyttade = flyttade+1
                                flyttaigen = True


        self.logga ("Efter varv " + str(varv) + ",\tfrån-lista: " +  str(len(frånlista)) + ",\tatt kolla-lista: " +  str(len(attkollalista)) + ",\ttill-lista: " +  str(len(tillista)) + "\n" )

#############################################################################################




#############################################################################################
    def rensaeftervillkor(self,tmplista, db):

# Anropas från Fas 2
# db ska vara sträng
# tmplista ska vara en lista av strängar (av personnummer)

        Person1 = johanpersonfil()

        if self.lineEdit_Käntdöda.text() == "":
            self.lineEdit_Käntdöda.setText("0")

        if self.lineEdit_Okäntdöda.text() == "":
            self.lineEdit_Okäntdöda.setText("0")

        try:
            dödgräns = int(self.lineEdit_Käntdöda.text())
        except:
            dödgräns = 0

        try:
            föddgräns = int(self.lineEdit_Okäntdöda.text())
        except:
            föddgräns = 0

        tillista = []
        tillista [:] = []

        PULlista = []
        PULlista [:] = []

        for pers in tmplista:
#            print ("(rensaeftervillkor) pers = " + pers)
            filnamn = os.path.join(db, "data", pers[:5], pers + ".xml")
            if os.path.exists(filnamn):
                allmänt.hämtapersonfil(allmänt(), filnamn, Person1)
               # personkategori( Person1)

# Lägg först upp på till-listan alla personer som INTE är A-märkta eller B-märkta eller C-märkta
                if (Person1.person_kategori.upper() == "A") and self.checkBox_Amarkerade.isChecked() == True:
                    self.logga ( "Tog bort person med A-markering: " + pers + " (" +  Person1.kortnamn + ")\n")
                elif (Person1.person_kategori.upper() == "B") and self.checkBox_Bmarkerade.isChecked() == True:
                    self.logga ( "Tog bort person med B-markering: " + pers + " (" +  Person1.kortnamn + ")\n")
                elif (Person1.person_kategori.upper() == "C"):
                    self.logga ( "Tog bort person med C-markering: " + pers + " (" +  Person1.kortnamn + ")\n")
                else:
                    tillista.append(pers)




# Tag bort igen från till-listan OM PUL-GODKÄNNANDE KRÄVS (Utdrag för webb och disbyt)
#  eller om samma eller liknande villkor manuellt åsatts vid Särskilt Utdrag


# Om PUL-GODKÄNNANDE eller motsvarande tillämpas gäller:
#     behåll personer som är 1-märkta
#     behåll personer som är döda sedan minst dödgräns år
#     behåll personer som är födda sedan minst föddgräns år.

# ALLA 1-märkta personer behålles ovillkorligt.
# unga personer som vill vara med
# personer längesedan om vilka varken födelse- eller dödsdatum är kända
                if Person1.person_kategori == "1":
                    self.logga ( "Hittade person med 1-markering: " + pers + " (" + Person1.kortnamn + ")\n")
                    pass

                elif  self.checkBox_Käntdöda.isChecked() == False and  self.checkBox_Okäntdöda.isChecked() == False:
                    pass

                elif  self.checkBox_Käntdöda.isChecked() == True  and  allmänt.PULdödgodk( allmänt(), Person1, dödgräns) == True:
                    pass

                elif  self.checkBox_Okäntdöda.isChecked() == True  and  allmänt.PULföddgodk( allmänt(), Person1, föddgräns) == True:
                    pass

                else:
                    try:
                        PULlista.append(pers)
                        tillista.remove(pers)
                    except:
                        pass



# i Disbyt-utdrag ska ytterligare ett antal personer tas bort:
                if self.radioButton_ExportDisbytutdrag.isChecked() == True:
            # 1) där ska inte finnas personer utan efternamn, inte ens "1"-markerade
                    if Person1.efternamn == "" or Person1.förnamn == "": # både förnamn och efternamn för att platsa hos Disbyt.
                        try:
                            tillista.remove(pers)
                            self.logga ("Tog bort person utan efternamn: " + pers + " ur till-lista[ ] (" + Person1.kortnamn + ")\n")
                        except:
                            pass

            # 2) där ska inte finnas personer utan åtminstone någon bra referens med både församling och tidpunkt
                    else:
                        if Person1.född_disbytförsamling + Person1.född_utrikesplats != "" and Person1.född_år != "" :
                            pass
                        elif Person1.död_disbytförsamling + Person1.död_utrikesplats != "" and Person1.död_år != "" :
                            pass
                        elif Person1.egna_par_ID != "": # tag tills vidare med personer som ingår i par och kolla vad Disbyt gör
                            pass
                        else:
                            try:
                                tillista.remove(pers)
                                self.logga ("Tog bort person utan referenser: " + pers + " ur till-lista[ ] (" + Person1.kortnamn + ")\n")
                            except:
                                pass

            elif pers != "":
                self.logga ("Hittar inte " + filnamn + "\n" )
        return tillista, PULlista
#############################################################################################




################################################################################
    def kopierapersonfiler(self, tag_med_filnamn, db, nydb):

# Anropas från Fas 3
# db och nydb ska vara strängar

        self.logga ("Kopierar personfiler\n")
        tag_med_fil = open(tag_med_filnamn, 'r', encoding='utf-8'  )
        helafilen=tag_med_fil.read()
        tag_med_fil.close()
        tag_med_filer = helafilen.split("\n")
# det tycks komma en tom rad på slutet

        for nr in tag_med_filer:
            if nr != "":
                xmlinfilnamn = os.path.join(db, "data", nr[0:5], nr + ".xml")
                xmlutfilnamn = os.path.join(nydb, "data", nr[0:5], nr + ".xml")
                if os.path.exists(xmlinfilnamn):
                    shutil.copy2( xmlinfilnamn, xmlutfilnamn)
                else:
                    self.logga ("VARNING! JAG HITTADE INTE PERSONFILEN " + xmlinfilnamn  + " att kopiera över till " + xmlutfilnamn + "\n" )
################################################################################




################################################################################
    def kopieraföräldrapar(self, tag_med_filnamn, db, nydb):

# Anropas från Fas 3
# db och nydb ska vara strängar
# tag_med_filnamn = lista på alla personer vars föräldrars eventuella parfiler ska kopieras över

        self.logga ("Kopierar föräldraparfiler\n")

        tag_med_fil = open(tag_med_filnamn, 'r', encoding='utf-8' )
        helafilen=tag_med_fil.read()
        tag_med_fil.close()
        tag_med_filer = helafilen.split("\n")
    # tycks komma en tom rad på slutet

        Person = johanpersonfil()

# Alla personfiler som är omnämnda i lista "tag_med_filer" ska redan vara kopierade till nydb

# Gå igenom personlistan igen. Kolla för säkerhets skull före varje person att personfilen
# redan finns i extraheradatabasen (nydb).
# Läs därefter personfilen och leta upp föräldraparets ID.
# Kopiera över denna parfil om det inte redan är gjort (för ett syskon tidigare i listan)


        for nr in tag_med_filer:
            if nr != "":
                xmlutfilnamn = os.path.join(nydb, "data", nr[0:5], nr + ".xml")
                if os.path.exists(xmlutfilnamn):
#                    self.logga ("jag hittar personfilen ;" + str(xmlutfilnamn) + "; och ska hämta föräldraparsfilen ;\n")

                    allmänt.hämtapersonfil(allmänt(), xmlutfilnamn, Person)
                    föräldrapar = Person.föräldrapar_ID
                    if föräldrapar != "":
                        xmlinparfilnamn = os.path.join(db, "data", föräldrapar[0:8], föräldrapar + ".xml")
                        xmlutparfilnamn = os.path.join(nydb, "data", föräldrapar[0:8], föräldrapar + ".xml")

                        if os.path.exists(xmlinparfilnamn) == True:
                            if os.path.exists(xmlutparfilnamn) == False:
                                shutil.copy2( xmlinparfilnamn, xmlutparfilnamn)
#                            else:
#                                self.logga ( "föräldraparsfilen ;" + str(xmlinparfilnamn) + "; är redan kopierad\n")
                        else:
                            self.logga ("jag hittar inte föräldraparsfilen ;" + (xmlinparfilnamn) + "; att kopiera\n")
                else:
                    self.logga ("jag hittar inte personfilen ;" + (xmlutfilnamn) + "; att söka föräldraparsfiler till ;\n")
################################################################################




################################################################################
    def kopieraegnapar(self, tag_med_filnamn, PUL_urval_filnamn, db, nydb):

# Anropas från Fas 3
# db och nydb ska vara strängar
# tag_med_filnamn = lista på alla personer vars eventuella parfiler ska kopieras över

        self.logga ("Kopierar egnaparfiler\n")
        self.logga ("tag_med_filnamn  " + tag_med_filnamn + '\n')
        self.logga ("PUL_urval_filnamn  " + PUL_urval_filnamn + '\n')


        tag_med_fil = open(tag_med_filnamn, 'r', encoding='utf-8' )
        helafilen = tag_med_fil.read()
        tag_med_fil.close()
        tag_med_filer = helafilen.split("\n")

#        print ( tag_med_filer )
    # tycks komma en tom rad på slutet


        PUL_fil = open(PUL_urval_filnamn, 'r', encoding='utf-8' )
        PUL_urval = PUL_fil.read()
        PUL_fil.close()

#        print ( PUL_urval )
    # tycks komma en tom rad på slutet


        Par = johanparfil()
        Person1 = johanpersonfil()
        Person2 = johanpersonfil()

# Alla personfiler som är omnämnda i lista "tag_med_filer" ska redan vara kopierade till nydb

# Gå igenom personlistan igen. Kolla för säkerhets skull före varje person att personfilen
# redan finns i extraheradatabasen (nydb).
# Läs därefter personfilen och leta upp fall egna pars ID. Kan vara noll till flera.
# Kopiera över denna parfil om det inte redan är gjort (för make/maka tidigare i listan)


        for nr in tag_med_filer:
            if nr != "":
                xmlutfilnamn = os.path.join(nydb, "data", nr[0:5], nr + ".xml")
                if os.path.exists(xmlutfilnamn):
#                    self.logga ("jag hittar personfilen ;" + str(xmlutfilnamn) + "; och ska hämta egnaparsfiler ;\n")


                    allmänt.hämtapersonfil(allmänt(), xmlutfilnamn, Person1)
                    egnapar = Person1.egna_par_ID
                    egnaparlista = egnapar.split("\n")

                    for par in egnaparlista:
                        if par != "":
                            xmlinparfilnamn =   os.path.join(db, "data", par[0:8], par + ".xml")
                            xmlutparfilnamn = os.path.join(nydb, "data", par[0:8], par + ".xml")

                            if os.path.exists(xmlinparfilnamn) == True:
                                if os.path.exists(xmlutparfilnamn) == False:

                                    allmänt.hämtaparfil(allmänt(), xmlinparfilnamn, Par)
                                     
                                    if PUL_urval.find(Par.person1_ID) >= 0  or PUL_urval.find(Par.person2_ID) >= 0:
                                        self.logga ("Hittar PUL-person i parfil " + par + '\n')
                                        self.PUL_copy( xmlinparfilnamn, xmlutparfilnamn)
                                    else:
                                        shutil.copy2( xmlinparfilnamn, xmlutparfilnamn)
#                                else:
#                                    self.logga ("egnaparsfilen ;" +  str(xmlinparfilnamn) + "; är redan kopierad\n")
                            else:
                                self.logga ("JAG HITTAR INTE egnaparsfilen ;" +  (xmlinparfilnamn) + "; att kopiera\n")
                else:
                    self.logga ("jag hittar inte personfilen ;" +  (xmlutfilnamn) + "; för att söka egnaparsfiler till;\n")

################################################################################




################################################################################
    def  PUL_copy(self, xmlinparfilnamn, xmlutparfilnamn):

        par_in = johanparfil()
        par_ut = johanparfil()

        allmänt.initparfil(allmänt(), par_ut )

        allmänt.hämtaparfil(allmänt(), xmlinparfilnamn, par_in )
# behåll de länkar som finns men rensa alla annan information som ev. kan avse den pulbegränsade personen
        par_ut.par_ID = par_in.par_ID
        par_ut.person1_ID = par_in.person1_ID
        par_ut.person2_ID = par_in.person2_ID
        par_ut.bonusrelation_ID = par_in.bonusrelation_ID
        par_ut.barn_ID = par_in.barn_ID

        allmänt.sparaparfil(allmänt(), xmlutparfilnamn, par_ut )
        self.logga ("Sparade PUL-begränsat par: " + xmlutparfilnamn + '\n')

        return
################################################################################




################################################################################
    def rensaparfiler(self, nydb):

# Anropas från Fas 3
# nydb ska vara sträng

# Radering i parfiler av länkar till borttagna personer är ett krav för GEDCOM,
# kan vara snyggt även annars.

# Det kommer att finnas kvar parfiler med länk till enbart ett eller flera barn
# utan någon förälder liksom länkar till ensamma "föräldrar" utan barn.
# Inte särskilt logiskt men kvarvarande länkar är korrekt utförda.

# Det kommer att finnas kvar parfiler där länk till en förälder eller båda föräldrar
# plockats bort pga PUL.
#

        self.logga ("Rensar brutna par-referenser\n")

        Person = johanpersonfil() 
        Par = johanparfil()


# Om man inte har raderat någon av de överkopierade personfilerna så skulle man kunna
# fortsätta att jämföra med innehållet i  omnämnda i listan "tag_med_filer"  för att bestämma om referenser i
# parfilerna ska plockas bort eller inte.
#
# För att ge utrymme för en radering bland personfilerna innan man kommer hit för att trimma referenserna
# i parfilerna så är det vettigare att i stället titta på faktiska innehållet av personfiler.

# Gör till att börja med inga raderingar alls av varken personfiler eller parfiler, bara borttagning av
# länkar inuti parfilerna.

# Utdrag ur databasen har nyss gjorts genom att en lista på personer betas av och därefter
# hämtas alla parfiler, både föräldrapars- och egnapars-.
# I parfilerna kan det finnas referenser till personer som inte valts att kopieras över.

# Sådana referenser får inte finnas i en GEDCOM-fil utan måste raderas.

# Johan-databasen är tänkt att som normaltillstånd alltid ha personfiler till varje parfil även om de
# inte är ifyllda med annat än ID-nummer.

# Gedcom-utdraget kommer att ha parfiler med bara en eller ingen förälder i. Detta måste accepteras för att
# hålla ihop helsyskon och halvsyskon när bara en eller ingen förälder är känd men syskonskapet är känt.


        folderinh = sorted( os.listdir(os.path.join(nydb, "data")) )
        for f in folderinh:
            if os.path.isdir(os.path.join(nydb, "data", f)):
                if len(f) == 8 and f[0:3]=="par" and f[3:8].isdigit() == True:
                        files = sorted( os.listdir(os.path.join(nydb, "data", f)) )
#                        self.logga  (str(files) + '\n')
                        for file in files:
#                            self.logga (file + ',  ' + file[0:3] + ',  ' + file[3:8] + ',  ' + file[11:15] + '\n')

                            if len(file) == 15 and file[0:3]=="par" and file[3:8].isdigit() == True and file[11:15]==".xml" :
                                parfilnamn = os.path.join(nydb, "data", (file[0:8]), (file))
                                allmänt.hämtaparfil(allmänt(), parfilnamn, Par)

                                ändrat = False
                                ändratbarn = False

                                if Par.person1_ID != "":
                                    if not os.path.exists(os.path.join(nydb, "data", Par.person1_ID [0:5], Par.person1_ID  + ".xml" )):
#                                        self.logga (file + "; Tar bort referens till Person1; " + Par.person1_ID + '\n')
                                        Par.person1_ID = ""
                                        ändrat = True

                                if Par.person2_ID != "":
                                    if not os.path.exists(os.path.join(nydb, "data", Par.person2_ID [0:5], Par.person2_ID  + ".xml" )):
#                                        self.logga  (file + "; Tar bort referens till Person2; "  + Par.person2_ID + '\n')
                                        Par.person2_ID = ""
                                        ändrat = True

                                allabarn = Par.barn_ID
                                for barn in allabarn.split("\n"):
                                    if barn != "":
                                        if not os.path.exists(os.path.join(nydb, "data", barn [0:5], barn  + ".xml" )):

#                                            self.logga  ("Par " + file + ": Tar bort referens till barn: " + barn + '\n')
#                                            self.logga  ("Par.barn_ID, före: " + Par.barn_ID  + '\n')

                                            Par.barn_ID = Par.barn_ID.replace(barn,"")
#                                            self.logga  ("Par.barn_ID, efter: " + Par.barn_ID  + '\n')

                                            ändrat = True
                                            ändratbarn = True


                                    if ändrat == True:
                                        if ändratbarn == True:
#                                            self.logga  ("Par.barn_ID, före: " + Par.barn_ID + '\n')

                                            Par.barn_ID = Par.barn_ID.strip("\n")
                                            Par.barn_ID = Par.barn_ID.replace("\n\n","\n")
#                                            self.logga  ("Par.barn_ID, efter: " + Par.barn_ID + '\n')

                                        allmänt.sparaparfil(allmänt(), parfilnamn, Par)
                                        if os.path.exists( parfilnamn + ".1"):
                                            os.remove(parfilnamn + ".1") # tag bort backupkopian i utdraget

#                                    self.logga  (Par.person1_ID + ',  ' +  Par.person2_ID + ',  ' +  Par.barn_ID + '\n')
                                    if Par.person1_ID == "" and  Par.person2_ID == "" and  Par.barn_ID == "":
                                         self.logga ("Parfil utan referenser ska inte finnas med. Men om, av misstag, så raderas nu: " + (file) + '\n')
                                         os.remove(parfilnamn)
#                                         self.logga  ("Raderade " + parfilnamn + '\n')


################################################################################




################################################################################
    def kopieraövrigt(self, db, nydb):

# Anropas från Fas 3
# db och nydb ska vara strängar


# db + "/senaste/senastepar"
# db + "/senaste/senasteperson"
# db + "/xml/images/*"
# db + "/xml/*.css"
# db + "/xml/*.xsl"
# db + "/xml/*.xsd"
# db + "/html/*.html"
# db + "/html/*.gif"
# db + "/html/images/*"
        self.logga ("Kopierar övrigt\n")


# senasteperson.txt behövs för att kunna göra innehållsförteckningar
        shutil.copy2(  os.path.join(db, "senaste", "senastepar.txt"),   os.path.join(nydb, "senaste", "senastepar.txt"))
        shutil.copy2(  os.path.join(db, "senaste", "senasteperson.txt"), os.path.join(nydb, "senaste", "senasteperson.txt"))



#        if self.radioButton_ExportWebbutdrag.isChecked() or self.radioButton_ExportDisbytutdrag.isChecked():
        if os.path.isfile( os.path.join(db, "start.webb.html")):
            shutil.copy2(  os.path.join(db, "start.webb.html"), os.path.join(nydb, "start.html"))
#        else:
#            if os.path.isfile( os.path.join(db, "start.html")):
#                shutil.copy2(  os.path.join(db, "start.html"), os.path.join(nydb, "start.html"))


        folderinh = sorted( os.listdir( os.path.join(db, "php")) )
        for f in folderinh:
            if os.path.isfile(  os.path.join(db, "php", f)):
                shutil.copy2(   os.path.join(db, "php", f), os.path.join(nydb, "php", f))


        folderinh = sorted( os.listdir( os.path.join(db, "xml")) )
        for f in folderinh:
            if os.path.isfile(  os.path.join(db, "xml", f)):
                shutil.copy2(   os.path.join(db, "xml", f), os.path.join(nydb, "xml", f))


        folderinh = sorted( os.listdir( os.path.join(db, "xml/images")) )
        for f in folderinh:
            if os.path.isfile(  os.path.join(db, "xml/images", f)):
                shutil.copy2(   os.path.join(db, "xml/images", f), os.path.join(nydb, "xml/images", f))


        if os.path.exists(os.path.join(db, "html.webb")):
            folderinh = sorted( os.listdir( os.path.join(db, "html.webb")) )
            for f in folderinh:
                if os.path.isfile(  os.path.join(db, "html.webb", f)):
                    shutil.copy2(   os.path.join(db, "html.webb", f), os.path.join(nydb, "html", f))


        if os.path.exists(os.path.join(db, "html.webb/images")):
            folderinh = sorted( os.listdir( os.path.join(db, "html.webb/images")) )
            for f in folderinh:
                if os.path.isfile(  os.path.join(db, "html.webb/images", f)):
                    shutil.copy2(   os.path.join(db, "html.webb/images", f), os.path.join(nydb, "html/images", f))

        self.logga ("Kopiering klar\n")
################################################################################




################################################################################
    def kopieradokument(self,  db, nydb):

# I grundläget, Nivå0, kopieras endast .xml-filer från db till nydb.
# Denna kod aktiveras då inte alls.


# Denna kod anropas endast vid extraheringar då ytterligare filer utöver .xml-filerna
# ska ingå i extraktet från db till nydb.

# I läge Nivå1 kopieras dessutom alla filer på samma nivå som person- och parblad
# samt dessutom alla filer utom kataloger som finns i den enda katalog som kan finnas
# tillsammans med person- och parblad.

# I Läge Nivå2 ska inkluderas allt som kopieras i Nivå1 samt dessutom alla underkataloger
# med komplett innehåll till kopierade personer och par.

        folderinh = sorted( os.listdir(os.path.join(nydb, "data")) )
        for f in folderinh:
            if os.path.isdir(os.path.join(nydb, "data", f)):
                if (len(f) == 8 and f[0:3]=="par" and f[3:8].isdigit() == True) or (len(f) == 5 and f[0:5].isdigit() == True):                    # huvudkatalog för parfiler resp personfiler
                    files = sorted ( os.listdir(os.path.join(nydb, "data", f)) )
                    #källfoldernamn = os.path.join(db, "data", f)
                    källfolderfiles = sorted(  os.listdir(os.path.join(db, "data", f)) )
                    for fil in files:   # här bör finnas enbart XML-filer
                        if os.path.splitext(fil)[1] != '.xml':
                            self.logga ("Oväntad fil i exporterad katalog: " + fil + "\n" )
                        else:
                            for källfil in källfolderfiles:
                                if os.path.splitext(källfil)[0] == os.path.splitext(fil)[0] and os.path.splitext(källfil)[1] != '.xml':
                                    sökväg_källfil = os.path.join(db, "data", f, källfil)
                                    sökväg_målfil  = os.path.join(nydb, "data", f, källfil)

                                    # Här kan finnas vanliga filer med annan filändelse än '.xml'
                                    #   De ska alla kopieras över vid Nivå1-kopiering
                                    if  os.path.isfile(sökväg_källfil ):
                                        #self.logga ("Hittade fil att kopiera:  " + sökväg_källfil  + "\n" )
                                        shutil.copy(sökväg_källfil, sökväg_målfil)

                                    # Här kan finnas en (1) katalog.
                                    #   i vilken kan finnas filer med godtyckliga filnamn
                                    #   och dessutom godtyckligt antal underkataloger.
                                    elif os.path.isdir(sökväg_källfil):
                                        self.logga ("Hittade katalog att kopiera:  " + sökväg_källfil + "\n" )
                                        if not os.path.exists(sökväg_målfil):
                                            os.mkdir(sökväg_målfil)

                                        källfoldersubfiles = sorted (  os.listdir(sökväg_källfil)  )
                                        for subfil in  källfoldersubfiles:
                                            sökväg_källsubfil = os.path.join(db, "data", f, källfil, subfil)
                                            sökväg_målsubfil  = os.path.join(nydb, "data", f, källfil, subfil)

                                            if  os.path.isfile(sökväg_källsubfil ):
                                                self.logga ("Hittade subfil att kopiera:  " + sökväg_källsubfil + "\n")
                                                shutil.copy(sökväg_källsubfil, sökväg_målsubfil)

                                            elif os.path.isdir(sökväg_källsubfil):
                                                if self.checkBox_Nivå2_dok.isChecked():
                                                    self.logga ("Hittade subkatalog att kopiera:  " + sökväg_källsubfil  + "\n" )
                                                    allmänt.kopierakatalog(allmänt(), sökväg_källsubfil, sökväg_målsubfil)
                                                else:
                                                    self.logga ("Hittade katalog UTAN att kopiera:  " + sökväg_källsubfil  + "\n" )
                                                    pass
        return
################################################################################




################################################################################
    def skrivgedcomfil(self, db, personlista, parlista):

# Anropas från Fas 4

        self.GedcomKodning = self.comboBox_Kodning.currentText()

        if self.GedcomKodning == "UTF-8":
            if self.radioButton_Windows.isChecked():
                self.GedcomNyRad = '\r\n'
            else:
                self.GedcomNyRad = '\n'
        else:
            if self.radioButton_Windows.isChecked():
                self.GedcomNyRad = b'\r\n'
            else:
                self.GedcomNyRad = b'\n'

        self.användaruppgifter = allmänt.hämtaanvändaruppgifter(allmänt(), self.inifilnamn).copy()

#        användaruppgifter = {
#           "DIS_medlemsnummer"    : DIS_medlemsnummer,
#           "disbyt_användarnamn"  : disbyt_användarnamn,
#           "disbyt_lösenord"      : disbyt_lösenord,
#           "namn"                 : namn,
#           "epost"                : epost,
#           "www"                  : www
#            }

        if self.radioButton_HelaDatabasen.isChecked():
            utfilnamn =  os.path.join(db, "komplett_" + self.datumtillägg + '_'+ self.GedcomKodning + ".ged")

        elif self.radioButton_ExportDisbytutdrag.isChecked():

            utfilnamn =  os.path.join(db, "disbytutdrag_" + self.datumtillägg + '_'+ self.GedcomKodning + ".ged")


#------------------------------------------------------------------------------------
# hämtalista
            if  self.checkBox_wget_skript.isChecked():
                if self.användaruppgifter["DIS_medlemsnummer"] != "":
                    dis_member = self.användaruppgifter["DIS_medlemsnummer"]
                else:
                    dis_member = ""

                if dis_member[0] == "m":
                    dis_member = dis_member[1:]
                while dis_member[0] == "0":
                    dis_member = dis_member[1:]

                if dis_member != "":
                    os.mkdir(os.path.join(db, "disbytkoll"))
                    hämtafråndisbytskript = open ( os.path.join(db, "disbytkoll", "hämtaskript_" + self.datumtillägg + ".sh"), 'w')    # skript för wget
                    hämtafråndisbyttext   = open ( os.path.join(db, "disbytkoll", "hämtalista_"  + self.datumtillägg + ".txt"), 'w')   # lista
                    self.skriptinledning (hämtafråndisbytskript , utfilnamn)    # enbart för skript
                else:
                    msg = "Jag måste ha ditt medlemsnummer i DIS för att skapa en hämtningslista"
                    QtGui.QMessageBox.information(self, "Johan - Exportera" , msg , QtGui.QMessageBox.Ok)
                    return

                if self.användaruppgifter["disbyt_användarnamn"] != "":
                    disbyt_user = self.användaruppgifter["disbyt_användarnamn"]
                else:
                    disbyt_user = "uuuuu"

                if self.användaruppgifter["disbyt_lösenord"] != "":
                    disbyt_passw = self.användaruppgifter["disbyt_lösenord"]
                else:
                    disbyt_passw = "ppppp"
#------------------------------------------------------------------------------------


        if self.GedcomKodning == "UTF-8":
            gedcomutfil = open( utfilnamn, "w")
        else:
            gedcomutfil = open( utfilnamn, "wb")


        self.gedcomradnr = 0
        self.skrivgedkominledning(gedcomutfil)

        for person in personlista:
            self.skrivgedcomindi( gedcomutfil, db, person, parlista)
            if self.radioButton_ExportDisbytutdrag.isChecked() and self.checkBox_wget_skript.isChecked() and dis_member!="":
                self.adderatillhämtafråndisbyt( hämtafråndisbytskript, hämtafråndisbyttext, self.nydatabas, person, disbyt_user,         disbyt_passw,         dis_member)    # hämtaskript, hämtalista

#               self.adderatillhämtafråndisbyt( hämtafråndisbytskript, hämtafråndisbyttext, databas,        person, disbyt_user="uuuuu", disbyt_passw="ppppp", dis_member="mmmmm"):



        if self.radioButton_ExportDisbytutdrag.isChecked() and self.checkBox_wget_skript.isChecked():
            hämtafråndisbytskript.close
            hämtafråndisbyttext.close
#------------------------------------------------------------------------------------

        for par in parlista:
            self.skrivgedcomfam( gedcomutfil, db, par, personlista)

        self.skrivgedkomavslutning( gedcomutfil )

        gedcomutfil.close
################################################################################




################################################################################
    def skriptinledning (self, hämtafråndisbytskript, utfilnamn):

        if self.användaruppgifter["DIS_medlemsnummer"] != "":
            dis_member = self.användaruppgifter["DIS_medlemsnummer"]
        else:
            dis_member = "mmmmm"

        if self.användaruppgifter["disbyt_användarnamn"] != "":
            disbyt_user = self.användaruppgifter["disbyt_användarnamn"]
        else:
            disbyt_user = "uuuuu"

        if self.användaruppgifter["disbyt_lösenord"] != "":
            disbyt_passw = self.användaruppgifter["disbyt_lösenord"]
        else:
            disbyt_passw = "ppppp"

        hämtafråndisbytskript.write('#! /bin/bash\n')
        hämtafråndisbytskript.write('# Detta skript är genererat ' + self.datumtillägg + ' av Johan tillsammans med samtidigt disbytutdrag\n')
        hämtafråndisbytskript.write('# med filnamn: ' + utfilnamn + '\n')
        hämtafråndisbytskript.write('# Sedan utdraget sänts till Disbyt och småningom lagts in i disbytdatabasen kan skriptet användas\n')
        hämtafråndisbytskript.write('# för kontrolläsning.\n')
        hämtafråndisbytskript.write('# Jämförelse kan göras för att bestämma vilka personer i utdraget som accepterats respektive \n')
        hämtafråndisbytskript.write('# refuserats av Disbyt.\n')
        hämtafråndisbytskript.write('# \n')
#
# Ny kod för att skapa rätt antal underkataloger av johantyp där wget kan lägga hemlästa html-filer
#
        hämtafråndisbytskript.write('# \n')
        dirnam = self.senasteperson[0:5]
        if dirnam.isdigit():
            while int(dirnam) >= 0:
                hämtafråndisbytskript.write (' mkdir "' + dirnam +  '" \n')
                dirnam = str(int(dirnam)-1).zfill(5)
        hämtafråndisbytskript.write('# \n')


        if disbyt_user == "uuuuu" or disbyt_passw == "ppppp" or dis_member == "mmmmm":
            hämtafråndisbytskript.write('# För användning av skriptet måste det färdigställas med användaruppgifter hos DIS och Disbyt:\n')
        if disbyt_user == "uuuuu":
            hämtafråndisbytskript.write('#    Ersätt "uuuuu" med användarnamnet hos Disbyt\n')
        if disbyt_passw == "ppppp":
            hämtafråndisbytskript.write('#    Ersätt "ppppp" med lösenordet hos Disbyt\n')
        if dis_member == "mmmmm":
            hämtafråndisbytskript.write('#    Ersätt "mmmmm" med medlemsnumret hos Disbyt\n')

        hämtafråndisbytskript.write('# \n')
        hämtafråndisbytskript.write('# OBS! Radera eller vakta väl ett skript med lösenord i klartext!\n')
        hämtafråndisbytskript.write('# \n')

        return disbyt_user, disbyt_passw, dis_member
#############################################################################################




################################################################################
    def skrivgedkominledning(self, gedcomutfil):

        self.skrivgedcomrad(gedcomutfil, "0 HEAD")
        self.skrivgedcomrad(gedcomutfil, "1 SOUR Johan")
        self.skrivgedcomrad(gedcomutfil, "2 VERS " + self.Johanversion_i_Gedcom )
#        self.skrivgedcomrad(gedcomutfil, "1 DEST DISBYT")
        self.skrivgedcomrad(gedcomutfil, "1 DATE " + allmänt.geddatum(allmänt(), self.idag.year, self.idag.month, self.idag.day))


        self.skrivgedcomrad(gedcomutfil, "1 SUBM @submitter@ ")
        self.skrivgedcomrad(gedcomutfil, "1 GEDC")
        self.skrivgedcomrad(gedcomutfil, "2 VERS 5.5")
        self.skrivgedcomrad(gedcomutfil, "2 FORM LINEAGE-LINKED")
        self.skrivgedcomrad(gedcomutfil, "1 CHAR " + self.GedcomKodning)  # [ vers 5.5 ANSEL|ASCII ]   [ föreslagen vers 5.5.1 ANSEL|ASCII(|UTF-8|UNICODE) ]
# Den fastställda version 5.5 (januari 1996) föreskriver ANSEL där inte ASCII räcker.
# Den föreslagna, men inte fastställda, version 5.5.1 (oktober 1999) föreslår att ANSEL ska användas så länge tills UTF-8 blir vanligt förekommande)
        self.skrivgedcomrad(gedcomutfil, "1 LANG Swedish")

        self.skrivgedcomrad(gedcomutfil, "0 @submitter@ SUBM" )
        self.skrivgedcomrad(gedcomutfil, "1 NAME " + self.användaruppgifter["namn"])

        if self.användaruppgifter["epost"] != "":
            self.skrivgedcomrad(gedcomutfil, "1 NOTE EMAIL " + self.användaruppgifter["epost"] )

        if self.användaruppgifter["www"] != "":
            self.skrivgedcomrad(gedcomutfil, "1 NOTE WWW " + self.användaruppgifter["www"] ) # t.ex.  www.sijohansson.com/slkt/webbutdrag/start.html")

        if self.användaruppgifter["DIS_medlemsnummer"] != "":
            self.skrivgedcomrad(gedcomutfil, "1 NOTE Medlem " + self.användaruppgifter["DIS_medlemsnummer"]  + " i DIS")

################################################################################




################################################################################
    def skrivgedkomavslutning(self, gedcomutfil):

        self.skrivgedcomrad(gedcomutfil, "0 TRLR")

################################################################################




################################################################################
    def skrivgedcomindi(self, gedcomutfil, db, pers, parlista):

        Person = johanpersonfil()
        filnamn = os.path.join( db, "data", pers[:5], pers + ".xml")

        allmänt.hämtapersonfil(allmänt(), filnamn, Person)


        self.skrivgedcomrad(gedcomutfil, "0 @" + Person.person_ID + "@ INDI")
        self.skrivgedcomrad(gedcomutfil, "1 NAME " +  Person.allaförnamn + " /" + Person.allaefternamn + "/" )

        if Person.person_kön == "m":
            self.skrivgedcomrad(gedcomutfil, "1 SEX M")
        elif Person.person_kön == "k":
            self.skrivgedcomrad(gedcomutfil, "1 SEX F")
        else:
            self.skrivgedcomrad(gedcomutfil, "1 SEX U")


        födddatum = allmänt.geddatum(allmänt(), Person.född_år, Person.född_månad, Person.född_dag)
        döddatum =allmänt.geddatum(allmänt(), Person.död_år, Person.död_månad, Person.död_dag)

###################################################################################################################
        if  self.radioButton_ExportDisbytutdrag.isChecked():
# redan i fas2()    har filtrerats bort personer som inte har bra nog  referenser för att komma med i disbytutdraget

# skriv BIRT-rad om det finns något innehåll alls att skriva i den
            if födddatum != ""  or Person.född_disbytförsamling != "" or  Person.född_utrikesplats != "":
                self.skrivgedcomrad(gedcomutfil, "1 BIRT")
                if födddatum != "":
                    self.skrivgedcomrad(gedcomutfil, "2 DATE " + födddatum)
                if Person.född_disbytförsamling != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Person.född_disbytförsamling)  # OBS! Disbyt-församling, enl. Riksskatteverkets lista 1989
                elif Person.född_utrikesplats != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Person.född_utrikesplats)

                if Person.född_källa != "":
                    källor =Person.född_källa.split("\n")
                    for källa in källor:
                        if källa != "":
                            self.skrivgedcomrad(gedcomutfil, "2 SOUR " + källa)

# skriv DEAT-rad om det finns något innehåll alls att skriva i den
            if döddatum != "" or Person.död_disbytförsamling != "" or Person.död_utrikesplats != "":
                self.skrivgedcomrad(gedcomutfil, "1 DEAT")
                if döddatum != "":
                    self.skrivgedcomrad(gedcomutfil, "2 DATE " + döddatum)
                if Person.död_disbytförsamling != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Person.död_disbytförsamling)  # OBS! Disbyt-församling, enl. Riksskatteverkets lista 1989
                elif Person.död_utrikesplats != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Person.död_utrikesplats)

                if Person.död_källa != "":
                    källor =Person.död_källa.split("\n")
                    for källa in källor:
                        if källa != "":
                            self.skrivgedcomrad(gedcomutfil, "2 SOUR " + källa)
###################################################################################################################
        else: # if (annan gedcom-export)

# skriv BIRT-rad om det finns något innehåll alls att skriva i den
            if födddatum != ""  or Person.född_församling != "" or  Person.född_utrikesplats != "":
                self.skrivgedcomrad(gedcomutfil, "1 BIRT")
                if födddatum != "":
                    self.skrivgedcomrad(gedcomutfil, "2 DATE " + födddatum)
                if Person.född_församling != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Person.född_församling)    # Församling, eget val av stavning, länstillhörighet mm.
                elif  Person.född_utrikesplats != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Person.född_utrikesplats)

                if Person.född_källa != "":
                    källor =Person.född_källa.split("\n")
                    for källa in källor:
                        if källa != "":
                            self.skrivgedcomrad(gedcomutfil, "2 SOUR " + källa)

# skriv DEAT-rad om det finns något innehåll alls att skriva i den
            if döddatum != "" or Person.död_disbytförsamling != "" or Person.död_utrikesplats != "":
                self.skrivgedcomrad(gedcomutfil, "1 DEAT")
                if döddatum != "":
                    self.skrivgedcomrad(gedcomutfil, "2 DATE " + döddatum)
                if Person.död_församling != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Person.död_församling)   # Församling, eget val av stavning, länstillhörighet mm.
                elif Person.död_utrikesplats != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Person.död_utrikesplats)

                if Person.död_källa != "":
                    källor =Person.död_källa.split("\n")
                    for källa in källor:
                        if källa != "":
                            self.skrivgedcomrad(gedcomutfil, "2 SOUR " + källa)
###################################################################################################################


        if Person.föräldrapar_ID != "":
            par = Person.föräldrapar_ID
            if parlista.count(par) == 1:
                self.skrivgedcomrad(gedcomutfil, "1 FAMC @" + par + "@")
# else: hittar flera föräldrapar - kör databaskontrollen

        if Person.egna_par_ID != "":
            egnapar = Person.egna_par_ID
            egnaparlista = egnapar.split("\n")
            for par in egnaparlista:
                if parlista.count(par) == 1:
                    self.skrivgedcomrad(gedcomutfil, "1 FAMS @" + par + "@")
# else: hittar flera egna par med samma nummer - kör databaskontrollen

        if Person.fler_källor != "":
#            f_källor = Person.fler_källor.split("\n")
            for källa in  Person.fler_källor.split("\n"):
                if källa != "":
                    self.skrivgedcomrad(gedcomutfil, "1 SOUR " + källa)
################################################################################




################################################################################
    def skrivgedcomfam(self, gedcomutfil,  db, par, personlista):

        Par = johanparfil()
        filnamn = os.path.join( db, "data", par[:8], par + ".xml")
        allmänt.hämtaparfil(allmänt(), filnamn, Par)

        self.skrivgedcomrad(gedcomutfil, "0 @" + Par.par_ID + "@ FAM")

        if  Par.person1_ID != "":
            pers = Par.person1_ID
            if personlista.count(pers) == 1:
                self.skrivgedcomrad(gedcomutfil, "1 HUSB @" + pers + "@")
# else: hittar flera karlar/makar med samma nummer - kör databaskontrollen

        if  Par.person2_ID != "":
            pers = Par.person2_ID
            if personlista.count(pers) == 1:
                self.skrivgedcomrad(gedcomutfil, "1 WIFE @" + pers + "@")
# else: hittar flera kvinnor/makar med samma nummer - kör databaskontrollen


###################################################################################################################
        vigdatum = allmänt.geddatum(allmänt(), Par.inledn_år, Par.inledn_månad, Par.inledn_dag)
        if  self.radioButton_ExportDisbytutdrag.isChecked():
            if vigdatum != ""  or Par.inledn_disbytförsamling != "" or Par.inledn_utrikesplats != "" :
                self.skrivgedcomrad(gedcomutfil, "1 MARR")
                if vigdatum != "":
                    self.skrivgedcomrad(gedcomutfil, "2 DATE " + vigdatum)
                if Par.inledn_disbytförsamling != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Par.inledn_disbytförsamling)    # OBS! Disbyt-församling, enl. Riksskatteverkets lista 1989
                elif Par.inledn_utrikesplats != "" :
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Par.inledn_utrikesplats)

                if Par.inledn_källa != "":
                    källor = Par.inledn_källa.split("\n")
                    for källa in källor:
                        if källa != "":
                            self.skrivgedcomrad(gedcomutfil, "2 SOUR " + källa)
###################################################################################################################
        else:
            if vigdatum != ""  or Par.inledn_församling != "" or Par.inledn_utrikesplats != "" :
                self.skrivgedcomrad(gedcomutfil, "1 MARR")
                if vigdatum != "":
                    self.skrivgedcomrad(gedcomutfil, "2 DATE " + vigdatum)
                if Par.inledn_församling != "":
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Par.inledn_församling)          # Församling, eget val av stavning, länstillhörighet mm.
                elif Par.inledn_utrikesplats != "" :
                    self.skrivgedcomrad(gedcomutfil, "2 PLAC " + Par.inledn_utrikesplats)

                if Par.inledn_källa != "":
                    källor = Par.inledn_källa.split("\n")
                    for källa in källor:
                        if källa != "":
                            self.skrivgedcomrad(gedcomutfil, "2 SOUR " + källa)
###################################################################################################################


        if Par.barn_ID != "":
            paretsbarn = Par.barn_ID
            barnlista = paretsbarn.split("\n")
            for barn in barnlista:
                if personlista.count(barn) == 1:
                    self.skrivgedcomrad(gedcomutfil, "1 CHIL @" + barn + "@")
# else: hittar flera barn med samma nummer - kör databaskontrollen
################################################################################




################################################################################
    def adderatillhämtafråndisbyt(self, hämtafråndisbytskript,  hämtafråndisbyttext, databas, person, disbyt_user="uuuuu", disbyt_passw="ppppp", dis_member="mmmmm"):

        Person = johanpersonfil()
        filnamn = os.path.join(str(databas), "data", str(person[:5]), str(person) + ".xml")

        allmänt.hämtapersonfil(allmänt(), filnamn, Person)
        sträng1 = "  wget -S --wait=20  --random-wait  --output-document=" + os.path.join(Person.person_ID[0:5], Person.person_ID) + ".html  --append-output=wgetlogfile --password=" + disbyt_passw + " --user=" + disbyt_user + "   'http://db.disbyt.se/~disbyt/cgi-bin/db/db08.cgi?execute=member&lingua=sv1&member="
        sträng2 =   dis_member + "&fam=" + Person.person_ID + "|" + Person.person_kön + "$" + Person.föräldrapar_ID + "$" + Person.egna_par_ID.replace("\n","$")
        sträng3 =  "$&original=1'"
        sträng = sträng1 + sträng2 + sträng3
        hämtafråndisbytskript.write(sträng + "\n")

        hämtafråndisbyttext.write( 'member=' + dis_member + '&fam=' +  Person.person_ID + '|' + Person.person_kön + '$' + Person.föräldrapar_ID + '$' + Person.egna_par_ID.replace('\n','$').strip('$') + '$&original=1' + '\n' )

        return
################################################################################




################################################################################
    def skrivgedcomrad(self, gedcomutfil, UTF8sträng):

        if self.GedcomKodning == "ANSEL":
#            Anselsträng = self.UnicodeTillAnselRad(UTF8sträng)
            gedcomutfil.write(self.UnicodeTillAnselRad(UTF8sträng))
            gedcomutfil.write(self.GedcomNyRad) # = b'\n' eller b'\r\n'
        elif self.GedcomKodning =="UTF-8":
            gedcomutfil.write(UTF8sträng)
            gedcomutfil.write(self.GedcomNyRad) # = '\n' eller '\r\n'
        else:
            gedcomutfil.write(UTF8sträng.encode(self.GedcomKodning))
            gedcomutfil.write(self.GedcomNyRad) # = '\n' eller '\r\n'

        return
########################################################################################



################################################################################
    def UnicodeTillAnselRad(self, UTF8sträng):

# UTF-8 till Ansel
#===================
#
# Översättning från utf-8 till ANSEL i Gedcom-fil,
# I utf-8 kommer combiner-tecken efter grundtecknet. I ANSEL kommer combiners före grundtecknet
# I utf-8 ska en rad inte kunna inledas med combiner.
#
#
# Läs ett tecken, och nästa tecken
#   Om första tecknet är en Unicode-combiner (dec 768-879) så har vi hamnat ur synk.
#   Skriv ett frågetecken, pos=pos+1, börja om
#
#
#   Om nästa inte är Unicode-combiner så är det första ett enkeltecken någonstans i hela unicoderymden (exkl combiners):
#        detta enkeltecken kan vara uppdelbart i grundtecken och en eller flera combiners.
#        o) Om enkeltecknet inte är uppdelbart; översätt om möjligt till ansel-enkeltecken, annars till frågetecken
#        o) Om enkeltecknet är uppdelbart:
#              -) översätt unicode-combiners, om möjligt till ansel-combiners annars till ett frågetecken
#              -) översätt grundtecknet, om möjligt till ansel-enkeltecken, annars till ett frågetecken
#
#    om nästa är en Unicode-combiner så läs eventuellt ytterligare staplade combiners, översätt till Ansel,
#    avsluta med översättning till Ansel av förstatecknet.
#
###############################################################################################################

        varvräknare = 0
        AnselRad = b''
        U_pos = 0

#        self.logga ( UTF8sträng + '\n')
#        self.logga ( '(len(UTF8sträng=' + str(len(UTF8sträng))  + '\n' )

        while U_pos < len(UTF8sträng):      # teckenposition, inte byteposition
            varvräknare = varvräknare + 1
            if varvräknare > 1000:
                self.avsluta(1)

            U_förstatecken =  UTF8sträng[U_pos]


# Här saknas en koll på att inte raden redan är slut (var bara ett tecken lång)
            U_pos = U_pos + 1
            U_nästatecken = self.nästatecken( UTF8sträng, U_pos)



#            self.logga ('Läge A, U_förstatecken=' + U_förstatecken + ',  U_nästatecken=' + U_nästatecken + ',  'ord(U_förstatecken)=' + (U_förstatecken) + '\n')

            if 768 <= ord(U_förstatecken) < 880:  # Jag vet inte hur jag ska hantera en Unicode_combiner som U_förstatecken.
#                self.logga ('Läge B\n')
                AnselRad = AnselRad + b'?'  # Lägg ett frågetecken på Anselraden och fortsätt i loopen
                U_pos = U_pos + 1

            else: # if U_förstatecken är vanligt tecken (1-4 bytes utf-8) men inte combiner (dec 768-879)
#                self.logga ('Läge C\n')
                U_combiner = ''
                while 768 <= ord(U_nästatecken) < 880: # Men om nästa tecken är combiner så samla ihop ev. staplade combiners

                    U_combiner = U_combiner + U_nästatecken
#                   self.logga ('Läge D, Combiner vid U_pos= ' + str(U_pos) + '\n' )
                    U_pos = U_pos + 1
                    U_nästatecken = self.nästatecken( UTF8sträng, U_pos)


        # Här fångar vi fyra fall:
        #   förstatecknet är inte uppdelbart grundtecken
        #   förstatecknet i sig är uppdelbart men det är inte följt av några explicita combiner(s)
        #   förstatecknet är ett grundtecken och det följs av efterföljande combiner(s)
        #   förstatecknet är uppdelbart i grundtecken och combiner(s) och följd dessutom av ytterligare combiner(s)
                try:
                    U_sträng = unicodedata.normalize('NFD', U_förstatecken + U_combiner)
                except:
                    self.logga  ('kunde inte normalisera(NFD) ' + U_förstatecken + U_combiner + '\n')
                    U_sträng = '???'

#                self.logga ('U_sträng=' + U_sträng + '\n' )
#                self.logga ('Läge E'\n)

                if len(U_sträng) < 1:
#                    self.logga ('????? längd == 0 \n')
                    pass

                if len(U_sträng) == 1: # Strängen innehåller enbart ett enkeltecken; översätt enligt tabell
                    AnselRad = AnselRad + self.anseltecken(U_sträng[0])
#                    self.logga  ('Läge F, U_pos= ' + str(U_pos)  + '\n' )
                    # U_pos pekar på nästa tecken, som vi ska ha som startpunkt för nästa varv i loopen

                elif len(U_sträng) > 1: # Unicode-sträng med ett grundtecken och sedan en eller flera combiners
                    for teck in U_sträng[1:] : # I Ansel ska combiners komma först och grundtecknet sist.
                        AnselRad = AnselRad + self.anseltecken(teck) #
                    AnselRad = AnselRad + self.anseltecken(U_sträng[0])
#                    self.logga  ('Läge G, U_pos= ' + str(U_pos) + '\n' )
                    # U_pos pekar på nästa tecken, som vi ska ha som startpunkt för nästa varv i loopen

        return AnselRad
################################################################################




################################################################################
    def nästatecken(self, UTF8sträng, U_pos):
        if U_pos < len(UTF8sträng):  # så är vi inte vid radslutet
            U_nästatecken = UTF8sträng[U_pos] # utf-8-tecken
        else:
            U_nästatecken = ' ' # sätt in ett ofarligt tecken som nästa (och obefintliga) tecken
        return U_nästatecken
################################################################################




################################################################################
    def anseltecken(self, U_tecken):
        try:
            A_tecken = self.dictUnicodeTillAnsel[U_tecken]
        except:
            A_tecken= b'?'
        return A_tecken

################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn, 'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Exportera_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

# logga till textruta i programfönster
        self.textEdit_logg.insertPlainText(txt )
        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)

        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Exportera_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winExportera = Exportera()
winExportera.show()
sys.exit(app.exec_())

################################################################################
