#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_anor.py

# Senast ändrad: 2011-02-04  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit
############################################################################




######################################################################################
class Anruta(QtCore.QObject):

    SenastÄndrad = '2011-02-04 08:33:57'  # Uppdateras automatiskt. Ändra inte manuellt.

    def __init__(self, parent, widget, parentfontsize):

        QtCore.QObject.__init__(self)

        self.skapa(parent,widget)
        self.Anruta_sättstorlek(parentfontsize)

        return
#-------------------------------------------

    def skapa(self,parent,widget):
        Anruta.setObjectName(self, "Anruta")

        self.frame_Person = QtGui.QFrame(widget)
        self.frame_Person.setObjectName("frame_Person")
        self.frame_Person.setFrameShape(QtGui.QFrame.Box)
        self.frame_Person.setFrameShadow(QtGui.QFrame.Raised)
        self.frame_Person.setLineWidth(1)
        self.frame_Person.setAutoFillBackground(True)


# Uppdelning av anrutan i två delar, utan kantlinjer
#  den större, till vänster, har uppgifter och och meny personen,
#  den mindre, till höger, har meny om föräldraparet,
        self.ruta_Person          =  QtGui.QWidget(self.frame_Person)
        self.ruta_Person.setAutoFillBackground(True)
        self.ruta_Person.setFocusPolicy(Qt.NoFocus)

        self.ruta_Föräldrapar     =  QtGui.QWidget(self.frame_Person)
        self.ruta_Föräldrapar.setAutoFillBackground(True)
        self.ruta_Föräldrapar.setFocusPolicy(Qt.NoFocus)

# Texter i den vänstra delen
#    Första raden
        self.label_namn = QtGui.QLabel(self.ruta_Person)
        self.label_namn.setObjectName("label_namn")
        self.label_namn.setAlignment     (Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.label_ID = QtGui.QLabel(self.ruta_Person)
        self.label_ID.setObjectName("label_ID")
        self.label_ID.setAlignment       (Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.label_kategori = QtGui.QLabel(self.ruta_Person)
        self.label_kategori.setObjectName("label_kategori")
        self.label_kategori.setAutoFillBackground(True)
        self.label_kategori.setAlignment (Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

        self.label_mera = QtGui.QLabel(self.ruta_Person)
        self.label_mera.setObjectName("label_mera")
        self.label_mera.setAutoFillBackground(True)
        self.label_mera.setAlignment     (Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

# Andra raden
        self.label_född = QtGui.QLabel(self.ruta_Person)
        self.label_född.setObjectName("label_född")
        self.label_född.setAlignment     (Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.label_född_ref = QtGui.QLabel(self.ruta_Person)
        self.label_född_ref.setObjectName("label_född_ref")
        self.label_född_ref.setAutoFillBackground(True)
        self.label_född_ref.setAlignment (Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

# Tredje raden
        self.label_död = QtGui.QLabel(self.ruta_Person)
        self.label_död.setObjectName("label_död")
        self.label_död.setAlignment      (Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.label_död_ref = QtGui.QLabel(self.ruta_Person)
        self.label_död_ref.setObjectName("label_död_ref")
        self.label_död_ref.setAutoFillBackground(True)
        self.label_död_ref.setAlignment  (Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

# Texterna i den högra delen
        self.label_föräldrapar = QtGui.QLabel(self.ruta_Föräldrapar)
        self.label_föräldrapar.setText("För-\näld-\nra-\npar")
        self.label_föräldrapar.setWordWrap(True)
        self.label_föräldrapar.setObjectName("label_föräldrapar")
        self.label_föräldrapar.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

        return

#-------------------------------------------


#####################################################################
# OBS! det finns flera rutiner med namnet 'sättstorlek'
# Denna 'sättstorlek' hör hemma i 'class Anruta'
    def Anruta_sättstorlek(self,fntsize):

# Texterna i den vänstra delen

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(fntsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        refbredd = metrics.width("Ref")

        self.label_namn.setGeometry     (                                      2,                                   2,      20*fs, fh )
        self.label_ID.setGeometry       ( 1 + self.label_namn.geometry().right(),                                   2,       8*fs, fh )
        self.label_kategori.setGeometry (   1 + self.label_ID.geometry().right(),                                   2, refbredd/2, fh )
        self.label_mera.setGeometry     ( self.label_kategori.geometry().right(),                                   2, refbredd/2, fh )
        self.label_född.setGeometry     (                                      2, self.label_namn.geometry().bottom(),      28*fs, fh )
        self.label_född_ref.setGeometry (  self.label_kategori.geometry().left(), self.label_namn.geometry().bottom(),   refbredd, fh )
        self.label_död.setGeometry      (                                      2, self.label_född.geometry().bottom(),      28*fs, fh )
        self.label_död_ref.setGeometry  (  self.label_kategori.geometry().left(), self.label_född.geometry().bottom(),   refbredd, fh )

#-------------------------------------------

# Texterna i den högra delen

        fontFp = QtGui.QFont()
        fontFp.setPointSize(0.8 * fntsize)
        self.label_föräldrapar.setFont(fontFp)
        metricsFp = QFontMetrics(fontFp)

        uppl=self.label_föräldrapar.text().split("\n")
        f1=0
        for rad in uppl:
            if f1<metricsFp.width(rad):
                f1=metricsFp.width(rad)

        self.label_föräldrapar.setGeometry ( 1, 1, 2 + f1, 6 + len(uppl)*metricsFp.height() )

#--------------------------------------------
# hela

        self.ruta_Person.setGeometry      (          self.frame_Person.frameWidth(),      self.frame_Person.frameWidth(), 2 + self.label_död_ref.geometry().right(),     2 + self.label_död_ref.geometry().bottom() )
        self.ruta_Föräldrapar.setGeometry ( 1 + self.ruta_Person.geometry().right(), + self.ruta_Person.geometry().top(), self.label_föräldrapar.geometry().width(), 2 + self.label_föräldrapar.geometry().height() )

        h1 = max ( self.ruta_Person.geometry().height(), self.ruta_Föräldrapar.geometry().height())

        self.ruta_Person.geometry().setHeight(h1)
        self.ruta_Föräldrapar.geometry().setHeight(h1)

        self.frame_Person.setGeometry( 0, 0, self.ruta_Föräldrapar.geometry().right()  +   self.frame_Person.frameWidth(),  self.ruta_Person.geometry().bottom() +   self.frame_Person.frameWidth())
        return
######################################################################################




######################################################################################
class gui_Anor(object):

    SenastÄndrad = '2011-02-04 08:33:57'  # Uppdateras automatiskt. Ändra inte manuellt.

######################################################################################
    def setupUi(self, Anor):

        Anor.setObjectName("Anor")

        self.setAttribute(Qt.WA_AlwaysShowToolTips)
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))

        from johangemensamt import allmänt as allm
        widgetfont = QtGui.QFont()
        widgetfont.setPointSize(self.fontsize)
        metrics = QFontMetrics(widgetfont)
        fh = allm.Vertikalfaktor * metrics.height()

        self.scrollyta = QtGui.QScrollArea(Anor)
        self.setCentralWidget(self.scrollyta)
        self.scrollyta.setFrameStyle(QFrame.NoFrame)
        self.scrollyta.verticalScrollBar().setFixedWidth(fh)
        self.scrollyta.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.scrollyta.setHorizontalScrollBarPolicy(Qt.ScrollBarAsNeeded)
        self.scrollyta.setAutoFillBackground(True)
        self.scrollyta.setObjectName("centralwidget")
        self.scrollyta.setFont(widgetfont)
        self.scrollyta.setFocusPolicy(Qt.NoFocus)


        self.widget_Antavla = QtGui.QWidget()
        self.scrollyta.setWidget(self.widget_Antavla )

        self.widget_Antavla.setObjectName("widget_Antavla")
        self.widget_Antavla.setAutoFillBackground(True)

        self.frame_top = QtGui.QFrame(self.widget_Antavla)
        self.frame_top.setFrameShape(QtGui.QFrame.StyledPanel)
        self.frame_top.setFrameShadow(QtGui.QFrame.Raised)
        self.frame_top.setObjectName("frame_top")


        self.label_Databas = QtGui.QLabel(self.frame_top)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText("Databas")
        self.label_Databas.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Databas = sijLineEdit(self.frame_top)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")
        self.lineEdit_Databas.setFocusPolicy(Qt.StrongFocus)

        self.pushButton_Databas = QtGui.QPushButton(self.frame_top)
        self.pushButton_Databas.setObjectName("pushButton_Databas")
        self.pushButton_Databas.setText(" Välj Databas ")

        self.label_Personnummer = QtGui.QLabel(self.frame_top)
        self.label_Personnummer.setObjectName("label_Personnummer")
        self.label_Personnummer.setText("Person-nr.")
        self.label_Personnummer.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Personnummer = sijLineEdit(self.frame_top)
        self.lineEdit_Personnummer.setObjectName("lineEdit_Personnummer")
        self.lineEdit_Personnummer.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))
        self.lineEdit_Personnummer.setText("00000000")
        self.lineEdit_Personnummer.setEnabled(False)
        self.lineEdit_Personnummer.setFocusPolicy(Qt.StrongFocus)

        self.pushButton_RitaOm = QtGui.QPushButton(self.frame_top)
        self.pushButton_RitaOm.setObjectName("pushButton_RitaOm")
        self.pushButton_RitaOm.setText("Rita om")
        self.pushButton_RitaOm.setEnabled(False)

        self.label_AntalGenerationer = QtGui.QLabel(self.frame_top)
        self.label_AntalGenerationer.setObjectName("label_AntalGenerationer")
        self.label_AntalGenerationer.setText("Antal angenerationer")

        self.lineEdit_AntalGenerationer = sijLineEdit(self.frame_top)
        self.lineEdit_AntalGenerationer.setObjectName("lineEdit_AntalGenerationer")
        self.lineEdit_AntalGenerationer.setText(str(self.antalgenerationer))
        self.lineEdit_AntalGenerationer.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))
        self.lineEdit_AntalGenerationer.setEnabled(False)
        self.lineEdit_AntalGenerationer.setFocusPolicy(Qt.StrongFocus)

        self.checkBox_VisaAllaNamn = QtGui.QCheckBox(self.frame_top)
        self.checkBox_VisaAllaNamn.setObjectName("checkBox_VisaAllaNamn")
        self.checkBox_VisaAllaNamn.setText("Visa alla namn ")
        self.checkBox_VisaAllaNamn.setEnabled(False)
        self.checkBox_VisaAllaNamn.setChecked(False)
        self.checkBox_VisaAllaNamn.setFocusPolicy(Qt.NoFocus)



        self.label_Upplysningar = QtGui.QLabel(self.widget_Antavla)
        self.label_Upplysningar.setWordWrap(True)
        self.label_Upplysningar.setObjectName("label_Upplysningar")
        self.label_Upplysningar.setFrameShape(QtGui.QFrame.Panel)
        self.label_Upplysningar.setFrameShadow(QtGui.QFrame.Sunken)
        self.label_Upplysningar.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.label_Upplysningar.setText("Högerklick på ruta ger tillämplig meny:\n"
        "  -  skapa parblad och personblad för föräldrar\n"
        "  -  editera personblad eller parblad\n"
        "  -  öppna ny ättlinglista eller anlista\n"
        "  -  öppna eller skapa dokument eller folder")

        self.label_Upplysningar.setAutoFillBackground(True)

        self.setupFärgschema0()
        self.setupPalettes()

        return
######################################################################################




######################################################################################
    def setupFärgschema0(self):  # (färgschema 0, "standard")
        brush = QtGui.QBrush()
        brush.setStyle(QtCore.Qt.SolidPattern)

#        palette_Antavla
        brush = QtGui.QBrush(QtGui.QColor(240,240,240)) # ljus grå
        self.palette_Antavla.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_Antavla.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush )
        self.palette_Antavla.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(0,0,0))       # svart
        self.palette_Antavla.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
        brush = QtGui.QBrush(QtGui.QColor(160,160,160)) # grå
        self.palette_Antavla.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
        self.palette_Antavla.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )

#        palette_Anruta
        brush = QtGui.QBrush(QtGui.QColor(248,248,248)) # nästan vit
        self.palette_Anruta.setBrush(QtGui.QPalette.Active,    QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå
        self.palette_Anruta.setBrush(QtGui.QPalette.Inactive,  QtGui.QPalette.Window, brush )
        self.palette_Anruta.setBrush(QtGui.QPalette.Disabled,  QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(0,0,0))       # svart
        self.palette_Anruta.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
        brush = QtGui.QBrush(QtGui.QColor(120,120,120)) # grå
        self.palette_Anruta.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
        self.palette_Anruta.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )

        self.scrollyta.setPalette(self.palette_Antavla)
        self.widget_Antavla.setPalette(self.palette_Antavla)

        return
######################################################################################




######################################################################################
    def setupFärgschema1(self):  # (färgschema 1, "master")
        brush = QtGui.QBrush()
        brush.setStyle(QtCore.Qt.SolidPattern)

#        palette_Antavla
        brush = QtGui.QBrush(QtGui.QColor(240,248,240)) # ljus grön
        self.palette_Antavla.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(232,240,232)) # något mörkare grön
        self.palette_Antavla.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush )
        self.palette_Antavla.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(0,64,0))       # mörk grön svart
        self.palette_Antavla.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
        brush = QtGui.QBrush(QtGui.QColor(160,160,160)) # grå
        self.palette_Antavla.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
        self.palette_Antavla.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )

#        palette_Anruta
        brush = QtGui.QBrush(QtGui.QColor(248,255,248)) # nästan vit grön
        self.palette_Anruta.setBrush(QtGui.QPalette.Active,    QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(240,248,240)) # något mörkare grön
        self.palette_Anruta.setBrush(QtGui.QPalette.Inactive,  QtGui.QPalette.Window, brush )
        self.palette_Anruta.setBrush(QtGui.QPalette.Disabled,  QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(0,64,0))       # mörk grön svart
        self.palette_Anruta.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
        brush = QtGui.QBrush(QtGui.QColor(120,120,120)) # grå
        self.palette_Anruta.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
        self.palette_Anruta.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )

        self.scrollyta.setPalette(self.palette_Antavla)
        self.widget_Antavla.setPalette(self.palette_Antavla)

        return
######################################################################################




######################################################################################
    def setupFärgschema2(self):  # (färgschema 2, "compare")
        brush = QtGui.QBrush()
        brush.setStyle(QtCore.Qt.SolidPattern)

#        palette_Antavla
        brush = QtGui.QBrush(QtGui.QColor(248,248,240)) # ljus gul
        self.palette_Antavla.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(240,240,232)) # något mörkare gul
        self.palette_Antavla.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush )
        self.palette_Antavla.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(64,64,0))       # mörk brun svart
        self.palette_Antavla.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
        brush = QtGui.QBrush(QtGui.QColor(160,160,160)) # grå
        self.palette_Antavla.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
        self.palette_Antavla.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )

#        palette_Anruta
        brush = QtGui.QBrush(QtGui.QColor(255,255,250)) # nästan vit gul
        self.palette_Anruta.setBrush(QtGui.QPalette.Active,    QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(248,248,240)) # något mörkare gul
        self.palette_Anruta.setBrush(QtGui.QPalette.Inactive,  QtGui.QPalette.Window, brush )
        self.palette_Anruta.setBrush(QtGui.QPalette.Disabled,  QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(64,64,0))       # mörk brun svart
        self.palette_Anruta.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
        brush = QtGui.QBrush(QtGui.QColor(120,120,120)) # grå
        self.palette_Anruta.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
        self.palette_Anruta.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )

        self.scrollyta.setPalette(self.palette_Antavla)
        self.widget_Antavla.setPalette(self.palette_Antavla)

        return
######################################################################################




######################################################################################
    def setupPalettes(self):

#        palette_Upplysning
        brush = QtGui.QBrush(QtGui.QColor(255,255,240)) # ljus gul
        self.palette_Upplysning.setBrush(QtGui.QPalette.Active,   QtGui.QPalette.Window, brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare ljusgrå
        self.palette_Upplysning.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush)
        self.palette_Upplysning.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush)
        self.label_Upplysningar.setPalette(self.palette_Upplysning)

#        palette_Född_ref
        brush = QtGui.QBrush(QtGui.QColor(240,240,240)) # ljus grå
        self.palette_Född_ref.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_Född_ref.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        self.palette_Född_ref.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

#        palette_Död_ref
        brush = QtGui.QBrush(QtGui.QColor(240,240,240)) # ljus grå
        self.palette_Död_ref.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_Död_ref.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        self.palette_Död_ref.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

#        palette_Mera
        brush = QtGui.QBrush(QtGui.QColor(160,255,255)) # ljus cyan
        self.palette_Mera.setBrush( QtGui.QPalette.Active  , QtGui.QPalette.Window, brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_Mera.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush)
        self.palette_Mera.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush)

#        palette_KatA
        brush = QtGui.QBrush(QtGui.QColor(255,192,255)) # magenta
        self.palette_KatA.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.Window, brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_KatA.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush)
        self.palette_KatA.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush)

#        palette_KatB
        brush = QtGui.QBrush(QtGui.QColor(255,255,224)) # ljusgul
        self.palette_KatB.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_KatB.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        self.palette_KatB.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

#        palette_KatC
        brush = QtGui.QBrush(QtGui.QColor(240,240,240))  # ljusgrå
        self.palette_KatC.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_KatC.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        self.palette_KatC.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

#        palette_Kat1
        brush = QtGui.QBrush(QtGui.QColor(160,255,160)) # grön
        self.palette_Kat1.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_Kat1.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        self.palette_Kat1.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

#        palette_KatPgodk
        brush = QtGui.QBrush(QtGui.QColor(207,255,207)) # ljus grön
        self.palette_KatPgodk.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_KatPgodk.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        self.palette_KatPgodk.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

#        palette_KatPsparr
        brush = QtGui.QBrush(QtGui.QColor(255,207,255)) # ljus magenta
        self.palette_KatPsparr.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_KatPsparr.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        self.palette_KatPsparr.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

        return
######################################################################################




###################################################################################################
    def enableUi(self):
        self.lineEdit_Personnummer.setEnabled(True)
        self.pushButton_RitaOm.setEnabled(True)
        self.lineEdit_AntalGenerationer.setEnabled(True)
        self.checkBox_VisaAllaNamn.setEnabled(True)
        return
###################################################################################################




###################################################################################################
    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()
        self.ritaom()
        return
###################################################################################################




###################################################################################################
    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()
        self.ritaom()
        return
###################################################################################################




###################################################################################################
    def fontsizeset(self):

        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()



        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.pushButton_Databas.setFont(font)
        self.label_Personnummer.setFont(font)
        self.lineEdit_Personnummer.setFont(font)
        self.label_AntalGenerationer.setFont(font)
        self.lineEdit_AntalGenerationer.setFont(font)
        self.checkBox_VisaAllaNamn.setFont(font)
        self.label_Upplysningar.setFont(font)

        self.pushButton_RitaOm.setFont(font)
        return
###################################################################################################




###################################################################################################
    def färskantavla(self):

# === radera alla gamla anrutor ==========================

        for i in range( len(self.anrutor) ):
            self.anrutor[i].frame_Person.setVisible(False)

        del self.anrutor[0: len(self.anrutor) - 1 ]

        self.anrutor = []
        self.anrutor[:] = []

        self.scrollyta.repaint()
        self.widget_Antavla.repaint()



        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        fontFp = QFont()
        fontsizeFp =0.75 * self.fontsize
        fontFp.setPointSize(fontsizeFp)

# === skapa nya, inledningsvis alla dolda, anrutor för maximalt antal generationer ==========================


        for i in range(2**(self.maximumgenerationer+1) ):
#            self.anrutor.append(Anruta(self))
            self.anrutor.append(Anruta(self,self.widget_Antavla,self.fontsize)) #parent, widget, parentfontsize)

            self.anrutor[i].frame_Person.setAutoFillBackground(True)
            self.anrutor[i].frame_Person.setPalette(self.palette_Anruta)
            self.anrutor[i].frame_Person.setFont(font)

            self.anrutor[i].ruta_Person.setAutoFillBackground(True)
            self.anrutor[i].ruta_Person.setPalette(self.palette_Anruta)
            self.anrutor[i].ruta_Person.setFont(font)

            self.anrutor[i].ruta_Föräldrapar.setAutoFillBackground(True)
            self.anrutor[i].ruta_Föräldrapar.setPalette(self.palette_Anruta)
            self.anrutor[i].ruta_Föräldrapar.setFont(fontFp)

            self.anrutor[i].frame_Person.setVisible(False)

        return

###################################################################################################




###################################################################################################
    def sijlayout(self):

# Layout av rutan frame_top högst uppe till vänster

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        b1 = 2*fs + max ( metrics.width(self.label_Databas.text()), metrics.width(self.label_Personnummer.text())  )

        self.label_Databas.setGeometry              (                                                         2,                                             2,                metrics.width(self.label_Databas.text()),     fh )
        self.lineEdit_Databas.setGeometry           (                                                        b1,                                             2,                                                   45*fs,     fh )
        self.pushButton_Databas.setGeometry         (              2 + self.lineEdit_Databas.geometry().right(),                                             2,           metrics.width(self.pushButton_Databas.text()),     fh )

        self.label_Personnummer.setGeometry         (                                                         2, 2 + self.lineEdit_Databas.geometry().bottom(),           metrics.width(self.label_Personnummer.text()),     fh )
        self.lineEdit_Personnummer.setGeometry      (                                                        b1, 2 + self.lineEdit_Databas.geometry().bottom(),                        metrics.width("00000000") + 2*fs,     fh )

        self.pushButton_RitaOm.setGeometry          (      3*fs + self.lineEdit_Personnummer.geometry().right(), 2 + self.lineEdit_Databas.geometry().bottom(),       fs + metrics.width(self.pushButton_RitaOm.text()), 1.2*fh )
        self.label_AntalGenerationer.setGeometry    (          3*fs + self.pushButton_RitaOm.geometry().right(), 2 + self.lineEdit_Databas.geometry().bottom(), fs + metrics.width(self.label_AntalGenerationer.text()),     fh )

        self.lineEdit_AntalGenerationer.setGeometry (       2 + self.label_AntalGenerationer.geometry().right(), 2 + self.lineEdit_Databas.geometry().bottom(),                                    metrics.width("000"),     fh )

        self.checkBox_VisaAllaNamn.setGeometry      ( 3*fs + self.lineEdit_AntalGenerationer.geometry().right(), 2 + self.lineEdit_Databas.geometry().bottom(), fs + metrics.width(self.checkBox_VisaAllaNamn.text())+ 3*fs, fh )

        return
###################################################################################################




###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret till tabellen

# windowlayout anropas endast som en fortsättning av sijlayout ovan
# inte någon annanstans ifrån..

# placering i widget_antavla av
# - frame_top
# alla synliga anrutor
# rutan label_Upplysningar

#   # probanden ej inräknad, har nivå 0
#    antal       antal   antal      antal rutor
# generationer   rutor  spalter    i sista spalt
#      0            1      1             1
#      1            3      2             2
#      2            7      3             4
#      3           15      4             8
#      4           31      5            16
#      5           63      6            32
#      6          127      7            64
#      7          255      8           128
# etcetera.
#
# antal generationer = n; (minsta värde = 3, största värde = 7)
# antal rutor = 2**(n+1)-1
# antal spalter = n+1
# antal rutor i sista spalt = 2**n
# antal generationer mindre än 3 ger kollision i vänsterkanten mellan anrutor och frame_top respektive label_Upplysning

#        print ""
#        print "Enter windowlayout()"

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        anrutanummergräns = 2**(self.antalgenerationer + 1)
        antalrutor = anrutanummergräns - 1
        antalspalter = self.antalgenerationer + 1
        antalrutorisistaspalt = 2**self.antalgenerationer

        anrutahöjd = self.anrutor[0].frame_Person.geometry().height()
        anrutabredd = self.anrutor[0].frame_Person.geometry().width()

        availablescreen_Rect = QtGui.QDesktopWidget().availableGeometry()

        scrollyta_Rect =  QtCore.QRect()

        scrollyta_Rect.setLeft(0)
        scrollyta_Rect.setTop(0)


        widgetantavlahöjd = antalrutorisistaspalt * anrutahöjd
        if (widgetantavlahöjd) < ( availablescreen_Rect.height() ) :
            scrollyta_Rect.setHeight(widgetantavlahöjd)
        else:
            scrollyta_Rect.setHeight(availablescreen_Rect.height())

        widgetantavlabredd = antalspalter * anrutabredd
        if (widgetantavlabredd) < ( availablescreen_Rect.width() ):
            scrollyta_Rect.setWidth(widgetantavlabredd)
        else:
            scrollyta_Rect.setWidth(availablescreen_Rect.width())

        self.resize(QtCore.QSize(scrollyta_Rect.width(), scrollyta_Rect.height() ))
        self.scrollyta.setGeometry(scrollyta_Rect)

        self.widget_Antavla.setGeometry( QtCore.QRect(0,0,widgetantavlabredd,widgetantavlahöjd))

        self.frame_top.setGeometry( 2, 2, 4 + max(  self.pushButton_Databas.geometry().right(), self.checkBox_VisaAllaNamn.geometry().right() ), 4 + self.pushButton_RitaOm.geometry().bottom()   )





# nollställ och gör synliga så många anrutor som ska användas i det aktuella fönstret
        for i in range(1, anrutanummergräns ):
            self.anrutor[i].frame_Person.setVisible(True)

            self.anrutor[i].label_mera.setText("")
            self.anrutor[i].label_kategori.setText("")
            self.anrutor[i].label_ID.setText("")
            self.anrutor[i].label_namn.setText("")
            self.anrutor[i].label_född.setText("")
            self.anrutor[i].label_död.setText("")
            self.anrutor[i].label_föräldrapar.setText("")
            self.anrutor[i].label_född_ref.setText("")
            self.anrutor[i].label_död_ref.setText("")

            self.anrutor[i].label_mera.setToolTip("")
            self.anrutor[i].label_kategori.setToolTip("")
            self.anrutor[i].label_ID.setToolTip("")
            self.anrutor[i].label_namn.setToolTip("")
            self.anrutor[i].label_född.setToolTip("")
            self.anrutor[i].label_död.setToolTip("")
            self.anrutor[i].label_föräldrapar.setToolTip("")
            self.anrutor[i].label_född_ref.setToolTip("")
            self.anrutor[i].label_död_ref.setToolTip("")

# Gör resten av anrutorna osynliga
        self.anrutor[0].frame_Person.setVisible(False)
        for i in range(anrutanummergräns, 2**(self.maximumgenerationer+1) ):
            self.anrutor[i].frame_Person.setVisible(False)

        return
###################################################################################################




###################################################################################################
    def resizeEvent(self, event):
        print ("Anor - resizing")
        self.windowlayout2()
        self.lineEdit_Personnummer.setFocus()
        return
###################################################################################################


###################################################################################################
    def windowlayout2(self):

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        anrutanummergräns = 2**(self.antalgenerationer + 1)
        antalrutor = anrutanummergräns - 1
        antalspalter = self.antalgenerationer + 1
        antalrutorisistaspalt = 2**self.antalgenerationer

        window_Rect = self.frameGeometry()
        scrollyta_Rect = self.scrollyta.geometry()

        self.scrollyta.setGeometry(0,0, self.geometry().width(), self.geometry().height())

        anrutahöjd = self.anrutor[0].frame_Person.geometry().height()
        anrutabredd = self.anrutor[0].frame_Person.geometry().width()

        widget_Antavla_Rect = QtCore.QRect()
        widget_Antavla_Rect.setLeft(0)
        widget_Antavla_Rect.setTop(0)
        widget_Antavla_Rect.setWidth(antalspalter * anrutabredd)

        if  widget_Antavla_Rect.width() <= scrollyta_Rect.width():
            if antalrutorisistaspalt * anrutahöjd < scrollyta_Rect.height():
                widget_Antavla_Rect.setHeight(antalrutorisistaspalt * anrutahöjd)
            else:
                widget_Antavla_Rect.setHeight(scrollyta_Rect.height())
        else:
            if antalrutorisistaspalt * anrutahöjd < scrollyta_Rect.height() - self.scrollyta.horizontalScrollBar().height():
                widget_Antavla_Rect.setHeight(antalrutorisistaspalt * anrutahöjd)
            else:
                widget_Antavla_Rect.setHeight(scrollyta_Rect.height() - self.scrollyta.horizontalScrollBar().height())

        widgetantavlahöjd = widget_Antavla_Rect.height()



        uppl=self.label_Upplysningar.text().split("\n")
        f1  = anrutabredd -5

        label_Upplysningar_Rect= QtCore.QRect()
        label_Upplysningar_Rect.setTop(widgetantavlahöjd - len(uppl)*fh)
        label_Upplysningar_Rect.setLeft(2)
        label_Upplysningar_Rect.setWidth(f1)
        label_Upplysningar_Rect.setHeight(len(uppl)*fh)
        self.label_Upplysningar.setGeometry(label_Upplysningar_Rect)
        self.label_Upplysningar.setVisible(True)


# placera anrutor i träd
        anrutaindex = 1
        spaltnummer=1
        while spaltnummer <= antalspalter:
            antalrutordennaspalt = 2**(spaltnummer-1)
            pos_x= anrutabredd * (spaltnummer -1)
            if antalrutordennaspalt * anrutahöjd > widgetantavlahöjd:
                första_pos_y = 0
                nyanrutahöjd = widgetantavlahöjd/antalrutordennaspalt
            else:
                första_pos_y = widgetantavlahöjd / antalrutordennaspalt / 2  - anrutahöjd / 2
                nyanrutahöjd = anrutahöjd
            nummerispalten = 0
            while nummerispalten <  antalrutordennaspalt:

                pos_y= första_pos_y +  nummerispalten * widgetantavlahöjd / antalrutordennaspalt
                self.anrutor[anrutaindex].frame_Person.setGeometry(pos_x, pos_y, anrutabredd, nyanrutahöjd)
                anrutaindex = anrutaindex + 1
                nummerispalten = nummerispalten + 1
            spaltnummer = spaltnummer + 1

        return
###################################################################################################




###################################################################################################
    def ui_connections(self):

#       Kopplingar, signaler i gui till slots i gui_anor.py
#       Ytterligare kopplingar, signaler i gui till slots i anor.py, finns i anor.py/mera_ui_connections(self)

        self.connect(self.lineEdit_Databas, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Databas, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_Personnummer, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Personnummer, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_AntalGenerationer, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_AntalGenerationer, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

###################################################################################################
