#!/usr/local/bin/python3
# -*- coding: utf-8 -*-


# gui_ättlingar.py
# Filnamnet i johan_py3 ändrat från gui_ättlingar.py till gui_attlingar.py för att
# komma förbi bug som syns vid Windowskörning och förväntas vara fixad till Python 3.2

# Senast ändrad: 2011-01-08  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTableWidget
############################################################################




###################################################################################################
class gui_Ättlingar(object):

    SenastÄndrad = '2011-01-08 13:50:09'  # Uppdateras automatiskt. Ändra inte manuellt.

    Ättlingkolumnbredder = [4,   30,  1.5,    9,
                           20,    3,    9,   20,
                            3,  5.5,    8,   11,
                           10,  3.5,    3,  3.5]
    Ättlingkolumnhuvud = ["rad",                "ättlingar", "",          "född den",
                          "född i, församling", "ref",       "död den",   "död i, församling",
                          "ref",                "ålder",     "person nr", "par nr",
                          "par år",             "kön",       "kat.",      "mer"]
    tabellBredd = 0
    tabellHöjd = 0

###################################################################################################
    def setupUi(self, Ättlingar):

        Ättlingar.setObjectName("Ättlingar")
#        Ättlingar.setWindowTitle("Ättlingar") # undvik detta, påverkar Tip
#        Ättlingar.setAcceptDrops(True)
        self.setAttribute(Qt.WA_AlwaysShowToolTips)
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))



        self.ytteryta = QtGui.QWidget(Ättlingar)
        self.ytteryta.setObjectName("ytteryta")
        self.setCentralWidget(self.ytteryta)
        self.ytteryta.setFocusPolicy(Qt.NoFocus)

        self.frame_top = QtGui.QFrame(self.ytteryta)
        self.frame_top.setFrameShape(QtGui.QFrame.StyledPanel)
        self.frame_top.setFrameShadow(QtGui.QFrame.Raised)
        self.frame_top.setObjectName("frame_top")


        self.label_Databas = QtGui.QLabel(self.frame_top)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText("Databas ")

        self.lineEdit_Databas = sijLineEdit(self.frame_top)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")

        self.pushButton_Databas = QtGui.QPushButton(self.frame_top)
        self.pushButton_Databas.setObjectName("pushButton_Databas")
        self.pushButton_Databas.setText(" Välj Databas ")

        self.label_Personnummer = QtGui.QLabel(self.frame_top)
        self.label_Personnummer.setObjectName("label_Personnummer")
        self.label_Personnummer.setText("Person-nr. ")

        self.lineEdit_Personnummer = sijLineEdit(self.frame_top)
        self.lineEdit_Personnummer.setObjectName("lineEdit_Personnummer")
        self.lineEdit_Personnummer.setAlignment(Qt.AlignCenter)
        self.lineEdit_Personnummer.setText("00000000")
        self.lineEdit_Personnummer.setEnabled(False)

        self.pushButton_RitaOm = QtGui.QPushButton(self.frame_top)
        self.pushButton_RitaOm.setObjectName("pushButton_RitaOm")
        self.pushButton_RitaOm.setText(" Rita om ")
        self.pushButton_RitaOm.setEnabled(False)

        self.label_AntalGenerationer = QtGui.QLabel(self.frame_top)
        self.label_AntalGenerationer.setObjectName("label_AntalGenerationer")
        self.label_AntalGenerationer.setText("Antal ättlinggenerationer ")
        self.label_AntalGenerationer.setWordWrap(False)

        self.lineEdit_AntalGenerationer = sijLineEdit(self.frame_top)
        self.lineEdit_AntalGenerationer.setObjectName("lineEdit_AntalGenerationer")
        self.lineEdit_AntalGenerationer.setText("")
        self.lineEdit_AntalGenerationer.setAlignment(Qt.AlignCenter)
        self.lineEdit_AntalGenerationer.setEnabled(False)

        self.checkBox_VisaFörsamling = QtGui.QCheckBox(self.frame_top)
        self.checkBox_VisaFörsamling.setObjectName("checkBox_VisaFörsamling")
        self.checkBox_VisaFörsamling.setText("Visa församlingar ")
        self.checkBox_VisaFörsamling.setEnabled(False)
        self.checkBox_VisaFörsamling.setChecked(True)
        self.checkBox_VisaFörsamling.setFocusPolicy(Qt.NoFocus)

        self.checkBox_VisaDatabasNummer = QtGui.QCheckBox(self.frame_top)
        self.checkBox_VisaDatabasNummer.setObjectName("checkBox_VisaDatabasNummer")
        self.checkBox_VisaDatabasNummer.setText("Visa databasnummer ")
        self.checkBox_VisaDatabasNummer.setEnabled(False)
        self.checkBox_VisaDatabasNummer.setChecked(True)
        self.checkBox_VisaDatabasNummer.setFocusPolicy(Qt.NoFocus)

        self.checkBox_VisaUppnåddÅlder = QtGui.QCheckBox(self.frame_top)
        self.checkBox_VisaUppnåddÅlder.setObjectName("checkBox_VisaUppnåddÅlder")
        self.checkBox_VisaUppnåddÅlder.setText("Visa uppnådd ålder ")
        self.checkBox_VisaUppnåddÅlder.setEnabled(False)
        self.checkBox_VisaUppnåddÅlder.setChecked(True)
        self.checkBox_VisaUppnåddÅlder.setFocusPolicy(Qt.NoFocus)

        self.checkBox_VisaDatabasFlaggor = QtGui.QCheckBox(self.frame_top)
        self.checkBox_VisaDatabasFlaggor.setObjectName("checkBox_VisaDatabasFlaggor")
        self.checkBox_VisaDatabasFlaggor.setText("Visa databasflaggor ")
        self.checkBox_VisaDatabasFlaggor.setEnabled(False)
        self.checkBox_VisaDatabasFlaggor.setChecked(True)
        self.checkBox_VisaDatabasFlaggor.setFocusPolicy(Qt.NoFocus)

        self.checkBox_VisaAllaNamn = QtGui.QCheckBox(self.frame_top)
        self.checkBox_VisaAllaNamn.setObjectName("checkBox_VisaAllaNamn")
        self.checkBox_VisaAllaNamn.setText("Visa alla namn ")
        self.checkBox_VisaAllaNamn.setEnabled(False)
        self.checkBox_VisaAllaNamn.setChecked(True)
        self.checkBox_VisaAllaNamn.setFocusPolicy(Qt.NoFocus)

        self.pushButton_SparaSomText = QtGui.QPushButton(self.frame_top)
        self.pushButton_SparaSomText.setObjectName("pushButton_SparaSomText")
        self.pushButton_SparaSomText.setText(" Spara som text ")
        self.pushButton_SparaSomText.setEnabled(False)
        self.pushButton_SparaSomText.setChecked(True)


        self.label_Upplysningar = QtGui.QLabel(self.ytteryta)
        self.label_Upplysningar.setWordWrap(True)
        self.label_Upplysningar.setObjectName("label_Upplysningar")
        self.label_Upplysningar.setFrameShape(QtGui.QFrame.Panel)
        self.label_Upplysningar.setFrameShadow(QtGui.QFrame.Sunken)
        self.label_Upplysningar.setAlignment(Qt.AlignVCenter)
        self.label_Upplysningar.setAlignment(Qt.AlignLeft)
        self.label_Upplysningar.setText("Högerklick på rad ger tillämplig meny: \n"
        "  -  skapa parblad och personblad för ny make/maka eller nytt barn \n"
        "  -  editera personblad eller parblad \n"
        "  -  öppna ny ättlinglista eller anlista \n"
        "  -  öppna eller skapa dokument eller folder ")


        self.tableWidget_Ättlingar = sijTableWidget(self.ytteryta)
        self.tableWidget_Ättlingar.setObjectName("tableWidget_Ättlingar")
        self.tableWidget_Ättlingar.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.tableWidget_Ättlingar.setDragEnabled(True)   # ???

        self.tableWidget_Ättlingar.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.tableWidget_Ättlingar.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.tableWidget_Ättlingar.setTextElideMode(QtCore.Qt.ElideMiddle)

        self.tableWidget_Ättlingar.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.tableWidget_Ättlingar.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)

        self.tableWidget_Ättlingar.verticalHeader().setVisible(False)

        self.tableWidget_Ättlingar.clear()
        self.tableWidget_Ättlingar.setRowCount(0)
        self.tableWidget_Ättlingar.setColumnCount(len(self.Ättlingkolumnhuvud))

        kol_nr=0
        for kol in self.Ättlingkolumnhuvud:
            self.tableWidget_Ättlingar.setHorizontalHeaderItem(kol_nr, QtGui.QTableWidgetItem(kol))
            kol_nr = kol_nr + 1


        self.label_Personnummer.setBuddy(self.lineEdit_Personnummer)
        self.label_AntalGenerationer.setBuddy(self.lineEdit_AntalGenerationer)


        brush = QtGui.QBrush()
        brush.setStyle(QtCore.Qt.SolidPattern)

#        palette_Bakgrund
        palette_Bakgrund = QtGui.QPalette()
        brush = QtGui.QBrush(QtGui.QColor(240,240,240)) # ljus grå
        palette_Bakgrund.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare ljusgrå
        palette_Bakgrund.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush )
        palette_Bakgrund.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush )
        brush = QtGui.QBrush(QtGui.QColor(0,0,0))  # svart
        palette_Bakgrund.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
        brush = QtGui.QBrush(QtGui.QColor(80,80,80))  # grå
        palette_Bakgrund.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
        palette_Bakgrund.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )

        self.ytteryta.setPalette(palette_Bakgrund)
        self.ytteryta.setAutoFillBackground(True)


#        palette_Upplysning
        palette_Upplysning = QtGui.QPalette()
        brush = QtGui.QBrush(QtGui.QColor(255,255,240)) # ljus gul
        palette_Upplysning.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        palette_Upplysning.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        palette_Upplysning.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)
        self.label_Upplysningar.setPalette(palette_Upplysning)

        self.label_Upplysningar.setPalette(palette_Upplysning)
        self.label_Upplysningar.setAutoFillBackground(True)

        return
###################################################################################################




###################################################################################################
    def enableUi(self):
        self.lineEdit_Personnummer.setEnabled(True)
        self.pushButton_RitaOm.setEnabled(True)
        self.lineEdit_AntalGenerationer.setEnabled(True)
        self.checkBox_VisaFörsamling.setEnabled(True)
        self.checkBox_VisaDatabasNummer.setEnabled(True)
        self.checkBox_VisaUppnåddÅlder.setEnabled(True)
        self.checkBox_VisaDatabasFlaggor.setEnabled(True)
        self.checkBox_VisaAllaNamn.setEnabled(True)
        self.pushButton_SparaSomText.setEnabled(True)
        return
###################################################################################################




####################################################
    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()

    def fontsizeset(self):

        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        font = QFont()
        font.setPointSize(self.fontsize)


        self.ytteryta.setFont(font)

        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.pushButton_Databas.setFont(font)
        self.label_Personnummer.setFont(font)
        self.lineEdit_Personnummer.setFont(font)
        self.label_AntalGenerationer.setFont(font)
        self.lineEdit_AntalGenerationer.setFont(font)

        self.tableWidget_Ättlingar.setFont(font)
        self.pushButton_SparaSomText.setFont(font)
        self.pushButton_RitaOm.setFont(font)
        self.lineEdit_Personnummer.setFont(font)

        self.checkBox_VisaFörsamling.setFont(font)
        self.checkBox_VisaUppnåddÅlder.setFont(font)
        self.checkBox_VisaDatabasNummer.setFont(font)
        self.checkBox_VisaDatabasFlaggor.setFont(font)
        self.checkBox_VisaAllaNamn.setFont(font)
        self.label_Upplysningar.setFont(font)

        self.ritaom()

        return
###################################################################################################




###################################################################################################
    def sijlayout(self):

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

# Layout av rutan frame_top högst uppe till vänster

        b1 = max (              metrics.width(self.label_Databas.text()),          metrics.width(self.label_Personnummer.text()) )
        d1 = max (    metrics.width(self.checkBox_VisaFörsamling.text()),   metrics.width(self.checkBox_VisaUppnåddÅlder.text()) )
        d3 = max ( metrics.width(self.checkBox_VisaDatabasNummer.text()), metrics.width(self.checkBox_VisaDatabasFlaggor.text()) )
        d4 = metrics.width(self.checkBox_VisaAllaNamn.text())

        self.label_Databas.setGeometry              (                                                      2,                                                     2,                   metrics.width(self.label_Databas.text()),  fh )
        self.lineEdit_Databas.setGeometry           (                                                     b1,                                                     2,                                                      45*fs,  fh )
        self.pushButton_Databas.setGeometry         (           2 + self.lineEdit_Databas.geometry().right(),                                                     2,              metrics.width(self.pushButton_Databas.text()),  fh )


        self.label_Databas.setGeometry              (                                                      2,                                                     2,                                                          b1, fh )
        self.label_Personnummer.setGeometry         (                                                      2,            2 + self.label_Databas.geometry().bottom(),                                                          b1, fh )
        self.lineEdit_Personnummer.setGeometry      (                                                 2 + b1,              self.label_Personnummer.geometry().top(),                                                        8*fs, fh )

        self.checkBox_VisaFörsamling.setGeometry    (                                                      2,       2 + self.label_Personnummer.geometry().bottom(),                                                     30 + d1, fh )
        self.checkBox_VisaUppnåddÅlder.setGeometry  (                                                      2, -2 + self.checkBox_VisaFörsamling.geometry().bottom(),                                                     30 + d1, fh )

        self.checkBox_VisaDatabasNummer.setGeometry (  2 + self.checkBox_VisaUppnåddÅlder.geometry().right(),         self.checkBox_VisaFörsamling.geometry().top(),                                                     30 + d3, fh )
        self.checkBox_VisaDatabasFlaggor.setGeometry(  2 + self.checkBox_VisaUppnåddÅlder.geometry().right(),       self.checkBox_VisaUppnåddÅlder.geometry().top(),                                                     30 + d3, fh )

        self.checkBox_VisaAllaNamn.setGeometry      ( 2 + self.checkBox_VisaDatabasNummer.geometry().right(),         self.checkBox_VisaFörsamling.geometry().top(),                                                     30 + d4, fh )

        self.pushButton_RitaOm.setGeometry          (   3*fs + self.lineEdit_Personnummer.geometry().right(),              self.label_Personnummer.geometry().top(),                metrics.width(self.pushButton_RitaOm.text()), fh )
        self.label_AntalGenerationer.setGeometry    (       3*fs + self.pushButton_RitaOm.geometry().right(),              self.label_Personnummer.geometry().top(),          metrics.width(self.label_AntalGenerationer.text()), fh )
        self.lineEdit_AntalGenerationer.setGeometry (    6 + self.label_AntalGenerationer.geometry().right(),              self.label_Personnummer.geometry().top(),                                                       2*fs , fh )
#        self.lineEdit_Databas.setGeometry           (                                                2 + b1,                                                     2, self.lineEdit_AntalGenerationer.geometry().right() - 2 - b1, fh )

        self.pushButton_SparaSomText.setGeometry    (self.pushButton_Databas.geometry().right() -  metrics.width(self.pushButton_SparaSomText.text()),  self.checkBox_VisaFörsamling.geometry().top(),metrics.width(self.pushButton_SparaSomText.text()), fh )

        f1=0
        for rad in self.label_Upplysningar.text().split("\n"):
            if f1<metrics.width(rad):
                f1=metrics.width(rad)

        self.frame_top.setGeometry          (                                     2,  2, 2 + self.pushButton_Databas.geometry().right(),  self.checkBox_VisaUppnåddÅlder.geometry().bottom() )

        self.label_Upplysningar.setGeometry ( 2 + self.frame_top.geometry().right(),  2,                                              2*fs + f1, len(self.label_Upplysningar.text().split("\n")) *fh )

        g1 = max ( self.frame_top.y() + self.frame_top.height(), self.label_Upplysningar.y() + self.label_Upplysningar.height() )

        g1 = max ( self.frame_top.geometry().bottom(),  self.label_Upplysningar.geometry().bottom() )
        self.tableWidget_Ättlingar.move     (                                     2, g1+3)

        return
###################################################################################################




###################################################################################################
    def newtablelayout(self):

        self.tablelayout()
        self.windowlayout()

        return
###################################################################################################




###################################################################################################
    def tablelayout(self):

        from johangemensamt import allmänt as allm
        font = self.tableWidget_Ättlingar.font()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.tableWidget_Ättlingar.setIconSize(QtCore.QSize(16,16))
        self.tableWidget_Ättlingar.verticalScrollBar().setFixedWidth(fh)
        self.tableWidget_Ättlingar.horizontalScrollBar().setFixedHeight(fh)


# Sätt alla kolumnbredderna
        kol_nr = 0
        for kol in self.Ättlingkolumnbredder:
            self.tableWidget_Ättlingar.setColumnWidth(kol_nr,  int( kol * fs ) )
            kol_nr = kol_nr + 1

# Sätt extra kolumnbredd för kol 1 om alla namn ska visas
        if  self.checkBox_VisaAllaNamn.checkState() != 0:
            self.tableWidget_Ättlingar.setColumnWidth(1,  int( (self.Ättlingkolumnbredder[1] + 10) * fs ) )

# Nollställ bredd för kolumner som inte ska synas
        if self.checkBox_VisaFörsamling.checkState() == 0:
            self.tableWidget_Ättlingar.setColumnWidth(4, 0)          #  kolumn  född i
            self.tableWidget_Ättlingar.setColumnWidth(7, 0)          #  kolumn  död i

        if self.checkBox_VisaUppnåddÅlder.checkState() == 0:
            self.tableWidget_Ättlingar.setColumnWidth(9, 0)          #  kolumn  uppnådd ålder

        if self.checkBox_VisaDatabasNummer.checkState() == 0:
            self.tableWidget_Ättlingar.setColumnWidth(10, 0)         #  kolumn  personnummer
            self.tableWidget_Ättlingar.setColumnWidth(11, 0)         #  kolumn  parnummer

        if self.checkBox_VisaDatabasFlaggor.checkState() == 0:
            self.tableWidget_Ättlingar.setColumnWidth(13, 0)         #  kolumn  kön
            self.tableWidget_Ättlingar.setColumnWidth(14, 0)         #  kolumn  kategori


# Bestäm bredden för färdig tabell
        self.tabellBredd = 0
        kol_nr = 0
        for kol in self.Ättlingkolumnbredder:
            kol_bredd = int( kol * fs )
            self.tabellBredd = self.tabellBredd + self.tableWidget_Ättlingar.columnWidth(kol_nr)
            kol_nr = kol_nr + 1


# Sätt radhöjd för varje rad och bestäm höjden för färdig tabell
        self.tabellHöjd =  self.tableWidget_Ättlingar.horizontalHeader().height()
        radHöjd = int(fh)
        for i in range (0, self.tableWidget_Ättlingar.rowCount()):
            self.tableWidget_Ättlingar.setRowHeight(i, radHöjd)
            self.tabellHöjd = self.tabellHöjd + radHöjd

            radnritem = QtGui.QTableWidgetItem( str(i+1) )      # strängen som ska skrivas som radnummer
            radnritem.setTextAlignment(Qt.Alignment(Qt.AlignRight))
            self.tableWidget_Ättlingar.setItem(i, 0, radnritem )

        tillgängligBredd = 0.9*QtGui.QDesktopWidget().availableGeometry().width()
        if self.tabellBredd < tillgängligBredd :
            tabellÄttlingar_bredd = self.tabellBredd
        else:
            tabellÄttlingar_bredd = tillgängligBredd

        tillgängligHöjd = 0.9*QtGui.QDesktopWidget().availableGeometry().height() - self.label_Upplysningar.geometry().bottom()
        if self.tabellHöjd < tillgängligHöjd  :
            tabellÄttlingar_höjd = self.tabellHöjd
        else:
            tabellÄttlingar_höjd = tillgängligHöjd

        self.tableWidget_Ättlingar.resize(tabellÄttlingar_bredd, tabellÄttlingar_höjd)

        return
###################################################################################################




###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret till tabellen

        self.ytteryta.setGeometry (0, 0,  2 + self.tableWidget_Ättlingar.geometry().right(),  2 + self.tableWidget_Ättlingar.geometry().bottom() )

        self.resize(QtCore.QSize(self.ytteryta.geometry().width(), self.ytteryta.geometry().height() ))

        return
###################################################################################################




###################################################################################################
    def resizeEvent(self, event):

# Anpassning av tabellen till fönstret på grund av användarens dragning av fönstrets kontur
# Hit kommer man magiskt, även efter storleksändringen vid första windowlayout()
#  Warning: resizing inside resizeEvent() or moveEvent() can lead to infinite recursion.

        ytteryta_Rect = self.ytteryta.geometry()
        tableWidget_Ättlingar_Rect = self.tableWidget_Ättlingar.geometry()

        self.tableWidget_Ättlingar.setFixedWidth( ytteryta_Rect.width() - tableWidget_Ättlingar_Rect.x() )
        self.tableWidget_Ättlingar.setFixedHeight( ytteryta_Rect.height() - tableWidget_Ättlingar_Rect.y() )



# välj skroll-lister
        tableWidget_Ättlingar_Rect = self.tableWidget_Ättlingar.geometry()

        if  self.tabellBredd > tableWidget_Ättlingar_Rect.width() and self.tabellHöjd > tableWidget_Ättlingar_Rect.height():
            self.tableWidget_Ättlingar.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            self.tableWidget_Ättlingar.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)

        elif  self.tabellBredd > tableWidget_Ättlingar_Rect.width():
            self.tableWidget_Ättlingar.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            if self.tabellHöjd + self.tableWidget_Ättlingar.horizontalScrollBar().height() > tableWidget_Ättlingar_Rect.height():
                self.tableWidget_Ättlingar.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            else:
                self.tableWidget_Ättlingar.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)

        elif  self.tabellHöjd > tableWidget_Ättlingar_Rect.height():
            self.tableWidget_Ättlingar.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            if  self.tabellBredd  + self.tableWidget_Ättlingar.verticalScrollBar().width() > tableWidget_Ättlingar_Rect.width():
                self.tableWidget_Ättlingar.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            else:
                self.tableWidget_Ättlingar.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)

        else:
            self.tableWidget_Ättlingar.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)  #
            self.tableWidget_Ättlingar.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)  #

        return
###################################################################################################




###################################################################################################
    def ui_connections(self):

#       Kopplingar, signaler i gui till slots i gui_ättlingar.py
#       Ytterligare kopplingar, signaler i gui till slots i ättlingar.py, finns i ättlingar.py/mera_ui_connections(self)

        self.connect ( self.lineEdit_Databas,            SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
        self.connect ( self.lineEdit_Databas,            SIGNAL("CtrlMinusPressed"), self.fontsizedown )

        self.connect ( self.lineEdit_Personnummer,       SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
        self.connect ( self.lineEdit_Personnummer,       SIGNAL("CtrlMinusPressed"), self.fontsizedown )

        self.connect ( self.lineEdit_AntalGenerationer,  SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
        self.connect ( self.lineEdit_AntalGenerationer,  SIGNAL("CtrlMinusPressed"), self.fontsizedown )

        self.connect ( self.tableWidget_Ättlingar,       SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
        self.connect ( self.tableWidget_Ättlingar,       SIGNAL("CtrlMinusPressed"), self.fontsizedown )

        self.connect ( self.checkBox_VisaFörsamling,     SIGNAL("clicked()"),        self.newtablelayout  )
        self.connect ( self.checkBox_VisaUppnåddÅlder,   SIGNAL("clicked()"),        self.newtablelayout  )
        self.connect ( self.checkBox_VisaDatabasNummer,  SIGNAL("clicked()"),        self.newtablelayout  )
        self.connect ( self.checkBox_VisaDatabasFlaggor, SIGNAL("clicked()"),        self.newtablelayout  )

# finns i ättlingar.py:
#        self.connect ( self.checkBox_VisaAllaNamn,       SIGNAL("clicked()"),        self.ritaom  )
###################################################################################################
