#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_inh.py

# Senast ändrad: 2011-01-01  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTextEdit, sijTableWidget
############################################################################




######################################################################################
class gui_Innehåll(object):

    SenastÄndrad = '2011-01-01 08:32:46'  # Uppdateras automatiskt. Ändra inte manuellt.
    Personlistakolumnhuvud = []
    Personlistakolumnbredder = []
    tabellBredd = 0
    tabellHöjd = 0


######################################################################################
    def setupUi(self, Innehåll):

# Gränsytans statiska definitioner

        self.Personlistakolumnhuvud = [ "Person", "sort.namn", "Förnamn", "Efternamn",   "kat",             # kolumn  0 -  4
                                        "Född",   "-m",        "-d",      "-församling", "DISBYT-förs.",    # kolumn  5 -  9
                                        "Död",    "-m",        "-d",      "-församling", "DISBYT-förs.",    # kolumn 10 - 14
                                        "År",     "  PUL  " ,  "-dagar"  ]                                  # kolumn 15 - 17

        self.Personlistakolumnbredder = [    8,   10,   20,   12,    3,    # kolumn   0 -  4
                                             8,    5,    5,   20,   20,    # kolumn   5 -  9
                                             8,    5,    5,   20,   20,    # kolumn  10 - 14
                                             8,    5,    6  ]              # kolumn  15 - 17


# OBS! Personlistakolumnbredder och Personlistakolumnhuvud ska definieras samhörande
# Personlistakolumnhuvud ställs in i setupUi
# Personlistakolumnbredder ställs in i sijLayout
# OBS! Kolumnnummer ska matchas med dict KolNr i inh.py


        Innehåll.setObjectName("Innehåll")
        Innehåll.setWindowTitle("Innehåll")
        self.setAttribute(Qt.WA_AlwaysShowToolTips)
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))



        self.ytteryta = QtGui.QWidget(Innehåll)
        self.ytteryta.setObjectName("ytteryta")
        self.setCentralWidget(self.ytteryta)

        self.ytteryta.setFocusPolicy(Qt.NoFocus)


# Rutan 'frame_top' högst uppe

        self.frame_top = QtGui.QFrame(self.ytteryta)
        self.frame_top.setFrameShape(QtGui.QFrame.StyledPanel)
        self.frame_top.setFrameShadow(QtGui.QFrame.Raised)
        self.frame_top.setObjectName("frame_top")


        self.label_Databas = QtGui.QLabel(self.frame_top)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText("Databas ")
        self.label_Databas.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Databas = sijLineEdit(self.frame_top)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")
        self.lineEdit_Databas.setAlignment(Qt.Alignment(Qt.AlignVCenter |Qt.AlignHCenter))
        self.lineEdit_Databas.setEnabled(False)

        self.label_Senasteperson = QtGui.QLabel(self.frame_top)
        self.label_Senasteperson.setObjectName("label_Senasteperson")
        self.label_Senasteperson.setText( "Sista person-nr.")
        self.label_Senasteperson.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Senasteperson = sijLineEdit(self.frame_top)
        self.lineEdit_Senasteperson.setObjectName("lineEdit_Senasteperson")
        self.lineEdit_Senasteperson.setAlignment(Qt.Alignment(Qt.AlignVCenter |Qt.AlignHCenter))
        self.lineEdit_Senasteperson.setEnabled(False)

        self.label_Antalpersoner = QtGui.QLabel(self.frame_top)
        self.label_Antalpersoner.setObjectName("label_Antalpersoner")
        self.label_Antalpersoner.setText( "Antal personer")
        self.label_Antalpersoner.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Antalpersoner = sijLineEdit(self.frame_top)
        self.lineEdit_Antalpersoner.setObjectName("lineEdit_Antalpersoner")
        self.lineEdit_Antalpersoner.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))
        self.lineEdit_Antalpersoner.setEnabled(False)


        self.label_KatA = QtGui.QLabel(self.frame_top)
        self.label_KatA.setObjectName("label_KatA")
        self.label_KatA.setText("KatA")
        self.label_KatA.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_KatA = sijLineEdit(self.frame_top)
        self.lineEdit_KatA.setObjectName("lineEdit_KatA")
        self.lineEdit_KatA.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))



        self.label_KatB = QtGui.QLabel(self.frame_top)
        self.label_KatB.setObjectName("label_KatB")
        self.label_KatB.setText("KatB")
        self.label_KatB.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_KatB = sijLineEdit(self.frame_top)
        self.lineEdit_KatB.setObjectName("lineEdit_KatB")
        self.lineEdit_KatB.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))



        self.label_KatC = QtGui.QLabel(self.frame_top)
        self.label_KatC.setObjectName("label_KatC")
        self.label_KatC.setText("KatC")
        self.label_KatC.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_KatC = sijLineEdit(self.frame_top)
        self.lineEdit_KatC.setObjectName("lineEdit_KatC")
        self.lineEdit_KatC.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))



        self.label_Kat1 = QtGui.QLabel(self.frame_top)
        self.label_Kat1.setObjectName("label_Kat1")
        self.label_Kat1.setText("Kat1")
        self.label_Kat1.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Kat1 = sijLineEdit(self.frame_top)
        self.lineEdit_Kat1.setObjectName("lineEdit_Kat1")
        self.lineEdit_Kat1.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))



        self.label_KatZ = QtGui.QLabel(self.frame_top)
        self.label_KatZ.setObjectName("label_KatZ")
        self.label_KatZ.setText("Kat-   ")
        self.label_KatZ.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_KatZ = sijLineEdit(self.frame_top)
        self.lineEdit_KatZ.setObjectName("lineEdit_KatZ")
        self.lineEdit_KatZ.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))



        self.label_KatÖvriga = QtGui.QLabel(self.frame_top)
        self.label_KatÖvriga.setObjectName("label_KatÖvriga")
        self.label_KatÖvriga.setText("Kat???")
        self.label_KatÖvriga.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_KatÖvriga = sijLineEdit(self.frame_top)
        self.lineEdit_KatÖvriga.setObjectName("lineEdit_KatÖvriga")
        self.lineEdit_KatÖvriga.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))




        self.label_KatPgodk = QtGui.QLabel(self.frame_top)
        self.label_KatPgodk.setObjectName("label_KatPgodk")
        self.label_KatPgodk.setText("PUL-godk")
        self.label_KatPgodk.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_KatPgodk = sijLineEdit(self.frame_top)
        self.lineEdit_KatPgodk.setObjectName("lineEdit_KatPgodk")
        self.lineEdit_KatPgodk.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))



        self.label_KatPspärr = QtGui.QLabel(self.frame_top)
        self.label_KatPspärr.setObjectName("label_KatPspärr")
        self.label_KatPspärr.setText("PUL-spärr")
        self.label_KatPspärr.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_KatPspärr = sijLineEdit(self.frame_top)
        self.lineEdit_KatPspärr.setObjectName("lineEdit_KatPspärr")
        self.lineEdit_KatPspärr.setAlignment(Qt.Alignment(Qt.AlignVCenter |Qt.AlignHCenter))



        self.label_KatPobest = QtGui.QLabel(self.frame_top)
        self.label_KatPobest.setObjectName("label_KatPobest")
        self.label_KatPobest.setText(", varav obest.")
        self.label_KatPobest.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_KatPobest = sijLineEdit(self.frame_top)
        self.lineEdit_KatPobest.setObjectName("lineEdit_KatPobest")
        self.lineEdit_KatPobest.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))



        self.frame_top.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_Databas.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_Senasteperson.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_Antalpersoner.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_KatA.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_KatB.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_KatC.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_Kat1.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_KatZ.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_KatPgodk.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_KatPspärr.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_KatÖvriga.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_KatPobest.setFocusPolicy(Qt.NoFocus)



# loggfönster till vänster
        self.textEdit_logg = sijTextEdit(self.ytteryta)
        self.textEdit_logg.setObjectName("textEdit_logg")
        self.textEdit_logg.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.textEdit_logg.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)





# Tabellen tableWidget_Personlista i resten av fönstret
        self.tableWidget_Personlista = sijTableWidget(self.ytteryta)
        self.tableWidget_Personlista.setObjectName("tableWidget_Personlista")
        self.tableWidget_Personlista.setFocusPolicy(QtCore.Qt.StrongFocus)
#        self.tableWidget_Personlista.setEnabled(False)
        self.tableWidget_Personlista.setFocusPolicy(Qt.NoFocus)

#        self.tableWidget_Personlista.setContextMenuPolicy(QtCore.Qt.DefaultContextMenu)

        self.tableWidget_Personlista.setDragEnabled(False)   # ???

        self.tableWidget_Personlista.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.tableWidget_Personlista.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.tableWidget_Personlista.setTextElideMode(QtCore.Qt.ElideMiddle)

        self.tableWidget_Personlista.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.tableWidget_Personlista.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)

        self.tableWidget_Personlista.verticalHeader().setVisible(False)

#        self.tableWidget_Personlista.setEditTriggers(QtGui.QAbstractItemView.NoEditTriggers)
#        self.tableWidget_Personlista.setAlternatingRowColors(True)




        self.tableWidget_Personlista.clear()
        self.tableWidget_Personlista.setRowCount(0)
        self.tableWidget_Personlista.setColumnCount(len(self.Personlistakolumnhuvud))

        kol_nr=0
        for kol in self.Personlistakolumnhuvud:
            self.tableWidget_Personlista.setHorizontalHeaderItem(kol_nr, QtGui.QTableWidgetItem(kol))
            kol_nr = kol_nr + 1

#        print "Exit setupUi (gui_innehåll)"
        return
###################################################################################################




###################################################################################################
    def enableUi(self):

        return
###################################################################################################




###################################################################################################
# Anpassning av storlekarna på de grafiska elementen när fontstorlek ändras.

    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()

    def fontsizeset(self):
        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18


        fontBold =  QFont()
        fontBold.setPointSize(self.fontsize)
        fontBold.setWeight(75)
        fontBold.setBold(True)

        font = QFont()
        font.setPointSize(self.fontsize)
        font.setWeight(50)
        font.setBold(False)

        self.ytteryta.setFont(font)

# frame_Top

        self.frame_top.setFont(fontBold)

        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.label_Senasteperson.setFont(font)
        self.lineEdit_Senasteperson.setFont(font)
        self.label_Antalpersoner.setFont(font)
        self.lineEdit_Antalpersoner.setFont(font)

        self.label_KatA.setFont(font)
        self.label_KatB.setFont(font)
        self.label_KatC.setFont(font)
        self.label_Kat1.setFont(font)
        self.label_KatZ.setFont(font)
        self.label_KatPgodk.setFont(font)
        self.label_KatPspärr.setFont(font)
        self.label_KatÖvriga.setFont(font)
        self.label_KatPobest.setFont(font)

        self.textEdit_logg.setFont(font)


# Tabellen tableWidget_Personlista i resten av fönstret
        self.tableWidget_Personlista.setFont(font)

#        self.ritaom() # Hämta data först och sätt storlekar sedan så får vi rätt antal rader i tabeller

        return
###################################################################################################




###################################################################################################
    def sijlayout(self):
# "Möblering" av de grafiska elementen, görs om efter ändring av fontstorlek

#        print "Enter sijlayout"

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.textEdit_logg.verticalScrollBar().setFixedWidth(fh-2)
        self.textEdit_logg.horizontalScrollBar().setFixedHeight(fh-2)

        self.tableWidget_Personlista.verticalScrollBar().setFixedWidth(fh-2)
        self.tableWidget_Personlista.horizontalScrollBar().setFixedHeight(fh-2)

# Layout av rutan frame_top högst uppe till vänster

        self.label_Databas.setGeometry          (                                                   2, 2,                    metrics.width( self.label_Databas.text()), fh )
        self.lineEdit_Databas.setGeometry       (  2          + self.label_Databas.geometry().right(), 2,         2*fs +  metrics.width( self.lineEdit_Databas.text()), fh )
        self.label_Senasteperson.setGeometry    ( 12       + self.lineEdit_Databas.geometry().right(), 2,              metrics.width( self.label_Senasteperson.text()), fh )
        self.lineEdit_Senasteperson.setGeometry (  2    + self.label_Senasteperson.geometry().right(), 2,    2*fs + metrics.width( self.lineEdit_Senasteperson.text()), fh )
        self.label_Antalpersoner.setGeometry    ( 12 + self.lineEdit_Senasteperson.geometry().right(), 2,              metrics.width( self.label_Antalpersoner.text()), fh )
        self.lineEdit_Antalpersoner.setGeometry (  2    + self.label_Antalpersoner.geometry().right(), 2,    2*fs + metrics.width( self.lineEdit_Antalpersoner.text()), fh )

        self.label_KatA.setGeometry         ( 12 + self.lineEdit_Antalpersoner.geometry().right(), 2,                metrics.width(self.label_KatA.text()), fh )
        self.lineEdit_KatA.setGeometry      (  2 + self.label_KatA.geometry().right()            , 2,      2*fs + metrics.width(self.lineEdit_KatA.text()), fh )
        self.label_KatB.setGeometry         ( 12 + self.lineEdit_KatA.geometry().right()         , 2,                metrics.width(self.label_KatB.text()), fh )
        self.lineEdit_KatB.setGeometry      (  2 + self.label_KatB.geometry().right()            , 2,      2*fs + metrics.width(self.lineEdit_KatB.text()), fh )
        self.label_KatC.setGeometry         ( 12 + self.lineEdit_KatB.geometry().right()         , 2,                metrics.width(self.label_KatC.text()), fh )
        self.lineEdit_KatC.setGeometry      (  2 + self.label_KatC.geometry().right()            , 2,      2*fs + metrics.width(self.lineEdit_KatC.text()), fh )
        self.label_Kat1.setGeometry         ( 12 + self.lineEdit_KatC.geometry().right()         , 2,                metrics.width(self.label_Kat1.text()), fh )
        self.lineEdit_Kat1.setGeometry      (  2 + self.label_Kat1.geometry().right()            , 2,      2*fs + metrics.width(self.lineEdit_Kat1.text()), fh )

        self.label_KatZ.setGeometry         ( 12 + self.lineEdit_Kat1.geometry().right()         , 2,                metrics.width(self.label_KatZ.text()), fh )
        self.lineEdit_KatZ.setGeometry      (  2 + self.label_KatZ.geometry().right()            , 2,      2*fs + metrics.width(self.lineEdit_KatZ.text()), fh )

        self.label_KatÖvriga.setGeometry    ( 12 + self.lineEdit_KatZ.geometry().right()         , 2,           metrics.width(self.label_KatÖvriga.text()), fh )
        self.lineEdit_KatÖvriga.setGeometry (  2 + self.label_KatÖvriga.geometry().right()       , 2, 2*fs + metrics.width(self.lineEdit_KatÖvriga.text()), fh )

        self.label_KatPgodk.setGeometry     ( 32 + self.lineEdit_KatÖvriga.geometry().right()         , 2,            metrics.width(self.label_KatPgodk.text()), fh )
        self.lineEdit_KatPgodk.setGeometry  (  2 + self.label_KatPgodk.geometry().right()        , 2,  2*fs + metrics.width(self.lineEdit_KatPgodk.text()), fh )
        self.label_KatPspärr.setGeometry    ( 12 + self.lineEdit_KatPgodk.geometry().right()     , 2,           metrics.width(self.label_KatPspärr.text()), fh )
        self.lineEdit_KatPspärr.setGeometry (  2 + self.label_KatPspärr.geometry().right()       , 2, 2*fs + metrics.width(self.lineEdit_KatPspärr.text()), fh )

        self.label_KatPobest.setGeometry    (  2 + self.lineEdit_KatPspärr.geometry().right()    , 2,            metrics.width(self.label_KatPobest.text()), fh )
        self.lineEdit_KatPobest.setGeometry (  2 + self.label_KatPobest.geometry().right()       , 2,  2*fs + metrics.width(self.lineEdit_KatPobest.text()), fh )

        self.frame_top.setGeometry        (                                         2,                                      2, 2 + self.lineEdit_KatPobest.geometry().right(), 2 + self.lineEdit_KatPobest.geometry().bottom() )
        self.textEdit_logg.setGeometry    (                                         2, 2 + self.frame_top.geometry().bottom(),                                         30*fs,                                      20*fh )
        self.tableWidget_Personlista.move ( 2 + self.textEdit_logg.geometry().right(), 2 + self.frame_top.geometry().bottom())

        return
###################################################################################################




###################################################################################################
    def tablelayout(self):

        from johangemensamt import allmänt as allm
        font = self.tableWidget_Personlista.font()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.tableWidget_Personlista.setIconSize(QtCore.QSize(16,16))
#        self.tableWidget_Personlista.verticalScrollBar().setFixedWidth(fh-2)
#        self.tableWidget_Personlista.horizontalScrollBar().setFixedHeight(fh-2)

        self.tabellBredd = 0
        kol_nr = 0
        for kol in self.Personlistakolumnbredder:
            kol_bredd = int( kol * fs )
            self.tableWidget_Personlista.setColumnWidth(kol_nr, kol_bredd )
            self.tabellBredd =  self.tabellBredd + self.tableWidget_Personlista.columnWidth(kol_nr)
            kol_nr = kol_nr + 1

        self.tabellHöjd = self.tableWidget_Personlista.horizontalHeader().height()
        for r in range (0, int(self.tableWidget_Personlista.rowCount())):
            self.tabellHöjd = self.tabellHöjd + self.tableWidget_Personlista.rowHeight(r)


# Placera tabellen preliminärt för att kunna beräkna slutlig utsträckning på skärmen
# availablescreen_Rect = QtGui.QDesktopWidget().availableGeometry()

        tableWidget_Personlista_Rect = self.tableWidget_Personlista.geometry()


        if self.tabellBredd < ( 0.9*QtGui.QDesktopWidget().availableGeometry().width() - self.textEdit_logg.geometry().width() ) :
            tableWidget_Personlista_Rect.setWidth ( self.tabellBredd + self.tableWidget_Personlista.verticalScrollBar().width() )
        else:
            tableWidget_Personlista_Rect.setWidth (0.9*QtGui.QDesktopWidget().availableGeometry().width() - self.textEdit_logg.geometry().width() )

        if self.tabellHöjd < ( 0.9*QtGui.QDesktopWidget().availableGeometry().height() - self.frame_top.geometry().height() ) :
            tableWidget_Personlista_Rect.setHeight (self.tabellHöjd + self.tableWidget_Personlista.horizontalScrollBar().height() )
        else:
            tableWidget_Personlista_Rect.setHeight (0.9*QtGui.QDesktopWidget().availableGeometry().height() - self.frame_top.geometry().height() )

        self.tableWidget_Personlista.setGeometry(tableWidget_Personlista_Rect)

        return

###################################################################################################




###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret till tabellen

#        availablescreen_Rect = QtGui.QDesktopWidget().availableGeometry()
        tableWidget_Personlista_Rect = self.tableWidget_Personlista.geometry()

        self.ytteryta.setGeometry (0, 0,  2         + self.tableWidget_Personlista.geometry().right(),  2 + self.tableWidget_Personlista.geometry().bottom() )

        self.resize(QtCore.QSize(self.ytteryta.geometry().width(), self.ytteryta.geometry().height() ))

        return
###################################################################################################




###################################################################################################
    def resizeEvent(self, event):

# Anpassning av tabellen till fönstret på grund av användarens dragning av fönstrets kontur
# Hit kommer man magiskt, även efter storleksändringen vid första windowlayout()
#  Warning: resizing inside resizeEvent() or moveEvent() can lead to infinite recursion.

        ytteryta_Rect = self.ytteryta.geometry()
        textEdit_logg_Rect = self.textEdit_logg.geometry()
        tableWidget_Personlista_Rect = self.tableWidget_Personlista.geometry()

        self.textEdit_logg.setFixedHeight( ytteryta_Rect.height() - textEdit_logg_Rect.y() )
        self.tableWidget_Personlista.setFixedWidth( ytteryta_Rect.width() - tableWidget_Personlista_Rect.x() )
        self.tableWidget_Personlista.setFixedHeight( ytteryta_Rect.height() - tableWidget_Personlista_Rect.y() )


# välj skroll-lister
        tableWidget_Personlista_Rect = self.tableWidget_Personlista.geometry()

        if  self.tabellBredd > tableWidget_Personlista_Rect.width() and self.tabellHöjd > tableWidget_Personlista_Rect.height():
            self.tableWidget_Personlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            self.tableWidget_Personlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)

        elif  self.tabellBredd > tableWidget_Personlista_Rect.width():
            self.tableWidget_Personlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            if self.tabellHöjd + self.tableWidget_Personlista.horizontalScrollBar().height() > tableWidget_Personlista_Rect.height():
                self.tableWidget_Personlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            else:
                self.tableWidget_Personlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)

        elif  self.tabellHöjd > tableWidget_Personlista_Rect.height():
            self.tableWidget_Personlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            if  self.tabellBredd  + self.tableWidget_Personlista.verticalScrollBar().width() > tableWidget_Personlista_Rect.width():
                self.tableWidget_Personlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            else:
                self.tableWidget_Personlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)

        else:
            self.tableWidget_Personlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)  #
            self.tableWidget_Personlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)  #

        self.textEdit_logg.setFocus()
        return

###################################################################################################




###################################################################################################
    def ui_connections(self):

#       Kopplingar, signaler i gui till slots i gui_inh.py
#       Ytterligare kopplingar, signaler i gui till slots i inh.py, kan finnas i inh.py/mera_ui_connections(self)

#        print "Enter ui_connections"

#        QtCore.QObject.connect(self.tableWidget_Personlista,QtCore.SIGNAL("cellPressed(int,int)"), self.tabellrutaklick)
#        QtCore.QObject.connect(self.tableWidget_Personlista,QtCore.SIGNAL("cellClicked(int,int)"), self.tabellrutaklick)
#        QtCore.QObject.connect(self.tableWidget_Personlista,QtCore.SIGNAL("cellDoubleClicked(int,int)"), self.tabellrutadubbelklick)

        self.connect(self.lineEdit_Databas, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Databas, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_Senasteperson, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Senasteperson, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_Antalpersoner, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Antalpersoner, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.tableWidget_Personlista, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.tableWidget_Personlista, SIGNAL("CtrlMinusPressed"), self.fontsizedown)


        self.connect(self.textEdit_logg, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.textEdit_logg, SIGNAL("CtrlMinusPressed"), self.fontsizedown)



        return
###################################################################################################
