#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_nydatabas.py

# Senast ändrad: 2011-01-10  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTextEdit
############################################################################




############################################################################
class gui_Nydatabas(object):

    SenastÄndrad = '2011-01-10 17:56:26'  # Uppdateras automatiskt. Ändra inte manuellt.

############################################################################
    def setupUi(self, Nydatabas):

# Gränsytans statiska definitioner

#        print "Enter setupUi (gui_Nydatabas)"

        Nydatabas.setObjectName("Nydatabas")
        Nydatabas.setWindowTitle("Ny databas")
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))

        self.scrollyta = QtGui.QScrollArea(Nydatabas)
        self.setCentralWidget(self.scrollyta)
        self.scrollyta.setFrameStyle(QFrame.NoFrame)
        self.scrollyta.setVerticalScrollBarPolicy(Qt.ScrollBarAsNeeded)
        self.scrollyta.setHorizontalScrollBarPolicy(Qt.ScrollBarAsNeeded)
        self.scrollyta.setAutoFillBackground(True)
        self.scrollyta.setObjectName("centralwidget")
        self.scrollyta.setFocusPolicy(Qt.NoFocus)

# -----------------------------------------------------------------

        self.mainwidget = QtGui.QWidget()
        self.scrollyta.setWidget(self.mainwidget)
        self.mainwidget.setObjectName("mainwidget")
        self.mainwidget.setFocusPolicy(Qt.NoFocus)

        self.top_widget = QtGui.QWidget(self.mainwidget)
        self.top_widget.setObjectName("top_widget")
        self.top_widget.setFocusPolicy(Qt.NoFocus)

        self.import_widget = QtGui.QWidget(self.mainwidget)
        self.import_widget.setObjectName("import_widget")
        self.import_widget.setFocusPolicy(Qt.NoFocus)

        self.textEdit_logg = sijTextEdit(self.mainwidget)
        self.textEdit_logg.setObjectName("textEdit_logg")
        self.textEdit_logg.verticalScrollBar().show()

# -----------------------------------------------------------------

        self.label_Title = QtGui.QLabel(self.top_widget)
        self.label_Title.setObjectName("label_Title")
        self.label_Title.setText("Skapa ny databas:")

        self.radioButton_TomDatabas = QtGui.QRadioButton(self.top_widget)
        self.radioButton_TomDatabas.setChecked(False)
        self.radioButton_TomDatabas.setObjectName("radioButton_TomDatabas")
        self.radioButton_TomDatabas.setText("Tom databas")


        self.radioButton_GedcomImport = QtGui.QRadioButton(self.top_widget)
        self.radioButton_GedcomImport.setChecked(False)
        self.radioButton_GedcomImport.setObjectName("radioButton_GedcomImport")
        self.radioButton_GedcomImport.setText("Importera data från Gedcom-fil")


        self.label_Sökväg = QtGui.QLabel(self.top_widget)
        self.label_Sökväg.setObjectName("label_Sökväg")
        self.label_Sökväg.setText("Ny eller befintlig sökväg till ny databas ")

        self.label_NyttDBNamn = QtGui.QLabel(self.top_widget)
        self.label_NyttDBNamn.setObjectName("label_NyttDBNamn")
        self.label_NyttDBNamn.setText("Nytt Databasnamn ")

        self.lineEdit_Sökväg = sijLineEdit(self.top_widget)
        self.lineEdit_Sökväg.setObjectName("lineEdit_Sökväg")

        self.lineEdit_NyttDBNamn = sijLineEdit(self.top_widget)
        self.lineEdit_NyttDBNamn.setObjectName("lineEdit_NyttDBNamn")

        self.pushButton_Sökväg = QtGui.QPushButton(self.top_widget)
        self.pushButton_Sökväg.setObjectName("pushButton_Sökväg")
        self.pushButton_Sökväg.setText("Välj sökväg")

        self.label_NyttDBNamn2 = QtGui.QLabel(self.top_widget)
        self.label_NyttDBNamn2.setObjectName("label_NyttDBNamn2")
        self.label_NyttDBNamn2.setText("(blir huvudkatalog för ny databas)")

        self.pushButton_Fortsätt = QtGui.QPushButton(self.top_widget)
        self.pushButton_Fortsätt.setObjectName("pushButton_Fortsätt")
        self.pushButton_Fortsätt.setText("Fortsätt")

# -----------------------------------------------------------------

        self.label_Importfil = QtGui.QLabel(self.import_widget)
        self.label_Importfil.setObjectName("label_Importfil")
        self.label_Importfil.setText("Från gedcom-fil")

        self.lineEdit_Importfil = sijLineEdit(self.import_widget)
        self.lineEdit_Importfil.setObjectName("lineEdit_Importfil")

        self.pushButton_Importfil = QtGui.QPushButton(self.import_widget)
        self.pushButton_Importfil.setObjectName("pushButton_Importfil")
        self.pushButton_Importfil.setText("Välj fil\natt importera")
        self.pushButton_Importfil.setIcon(QIcon("ikoner/32x32/J.png"))

        self.pushButton_Startaimport = QtGui.QPushButton(self.import_widget)
        self.pushButton_Startaimport.setObjectName("pushButton_Startaimport")
        self.pushButton_Startaimport.setText("Starta import")

        self.lineEdit_Pågår = sijLineEdit(self.import_widget)
        self.lineEdit_Pågår.setObjectName("lineEdit_Pågår")
        self.lineEdit_Pågår.setAlignment(Qt.AlignCenter)

# -----------------------------------------------------------------


        return
###################################################################################################




###################################################################################################
    def enableUi(self):

        return
###################################################################################################




###################################################################################################
# Anpassning av storlekarna på de grafiska elementen när fontstorlek ändras.

    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()

    def fontsizeset(self):


        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.scrollyta.setFont(font)
        self.mainwidget.setFont(font)
        self.top_widget.setFont(font)
        self.import_widget.setFont(font)

        self.label_Importfil.setFont(font)
        self.lineEdit_Importfil.setFont(font)

        self.textEdit_logg.setFont(font)

        self.pushButton_Importfil.setFont(font)
        self.pushButton_Startaimport.setFont(font)

        self.lineEdit_Pågår.setFont(font)

        self.ritaom()

        return
###################################################################################################




###################################################################################################
    def sijlayout(self):
# "Möblering" av de grafiska elementen, görs om efter ändring av fontstorlek

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

# Layout av rutan top_widget högst uppe till vänster
        self.pushButton_Sökväg.setIconSize(QSize(  fh,  fh ))

        a1 = max(metrics.width(self.label_Sökväg.text()), metrics.width(self.label_NyttDBNamn.text()) )

        self.label_Title.setGeometry             ( QtCore.QRect (                                                2,                                                          2,                      metrics.width(self.label_Title.text()),   fh ))
        self.radioButton_TomDatabas.setGeometry  ( QtCore.QRect (                                           2 + fs,                   5 + self.label_Title.geometry().bottom(),   10*fs + metrics.width(self.radioButton_TomDatabas.text()),   fh ))
        self.radioButton_GedcomImport.setGeometry( QtCore.QRect (                                           2 + fs,        5 + self.radioButton_TomDatabas.geometry().bottom(), 10*fs + metrics.width(self.radioButton_GedcomImport.text()),   fh ))

        self.label_Sökväg.setGeometry            ( QtCore.QRect ( 2 + a1 - metrics.width(self.label_Sökväg.text()),        5 + self.radioButton_GedcomImport.geometry().bottom(),                     metrics.width(self.label_Sökväg.text()),   fh ))
        self.lineEdit_Sökväg.setGeometry         ( QtCore.QRect (         2 + self.label_Sökväg.geometry().right(),        5 + self.radioButton_GedcomImport.geometry().bottom(),                                                       35*fs,   fh ))
        self.pushButton_Sökväg.setGeometry       ( QtCore.QRect (      2 + self.lineEdit_Sökväg.geometry().right(), 2 - fh/2 + self.radioButton_GedcomImport.geometry().bottom(),                                                       10*fs, 2*fh ))
        c1 = 2 + a1 - metrics.width(self.label_NyttDBNamn.text())
        self.label_NyttDBNamn.setGeometry        ( QtCore.QRect ( c1,                  5 + self.label_Sökväg.geometry().bottom(),                 metrics.width(self.label_NyttDBNamn.text()),   fh ))
        self.lineEdit_NyttDBNamn.setGeometry     ( QtCore.QRect (         2 + self.label_NyttDBNamn.geometry().right(),                  5 + self.label_Sökväg.geometry().bottom(),                                                       20*fs,   fh ))
        self.label_NyttDBNamn2.setGeometry       ( QtCore.QRect (c1,              2 + self.label_NyttDBNamn.geometry().bottom(),               metrics.width(self.label_NyttDBNamn2 .text()),   fh ))

        b2 = fs +  metrics.width( self.pushButton_Fortsätt.text() )
        self.pushButton_Fortsätt.setGeometry ( QtCore.QRect ( 2 + a1 - metrics.width(self.label_NyttDBNamn.text()),    5 + self.label_NyttDBNamn2.geometry().bottom(), b2, 2*fh ))

        self.top_widget.setFixedSize( 2 + self.pushButton_Sökväg.geometry().right(), 2 + self.pushButton_Fortsätt.geometry().bottom() )


# Layout av rutan import_widget

        self.pushButton_Importfil.setIconSize(QSize(  fh,  fh ))

        b1 = fs + metrics.width(self.label_Importfil.text())
        b3 = fs + self.maxlinelength ( metrics, self.pushButton_Importfil.text()  )
#        print ("b1="+str(b1))
#        print ("b3="+str(b3))

        self.label_Importfil.setGeometry      ( QtCore.QRect (                                              2,                                                  2, metrics.width(self.label_Importfil.text()),   fh ))
        self.lineEdit_Importfil.setGeometry   ( QtCore.QRect (                                             b1,                                                  2,                                      60*fs,   fh ))
        self.pushButton_Importfil.setGeometry ( QtCore.QRect ( 2 + self.lineEdit_Importfil.geometry().right(),                                                  2,                                         b3, 2*fh ))



        pushbuttonwidth = fs +self.maxlinelength (  metrics, self.pushButton_Startaimport.text()  )
        self.pushButton_Startaimport.setGeometry ( QtCore.QRect(   c1,      2+self.pushButton_Importfil.geometry().bottom(),                            pushbuttonwidth , 2*fh ))

        self.lineEdit_Pågår.setGeometry       ( QtCore.QRect (5+self.pushButton_Startaimport.geometry().right(), self.pushButton_Startaimport.geometry().top() - 2,  24*fs, fh ))

        self.import_widget.setFixedSize(4+ self.pushButton_Importfil.geometry().right(), self.pushButton_Startaimport.geometry().bottom() )


# Layout av  loggrutan
        bredd = max( self.top_widget.geometry().width(), self.import_widget.geometry().width() )

        self.textEdit_logg.setFixedSize(bredd, 10*fh )
        self.textEdit_logg.setFocus()

        return
###################################################################################################




###################################################################################################
    def maxlinelength(self, metrics, line):
        li = line.split('\n')
        le= 0
        for l in li:
            if le < metrics.width(l):
                le = metrics.width(l)
        return le
###################################################################################################




###################################################################################################
    def tablelayout(self):

        return
################v###################################################################################




###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.top_widget.setGeometry ( 2, 2, 3 + self.pushButton_Sökväg.geometry().right(), 3 + 2*fh + self.label_NyttDBNamn2.geometry().bottom())

        if self.radioButton_TomDatabas.isChecked():
            self.import_widget.setVisible(False)
            self.pushButton_Fortsätt.setVisible(True)
            self.textEdit_logg.move ( 2, 2 + self.top_widget.geometry().bottom() )

        elif self.radioButton_GedcomImport.isChecked():
            self.import_widget.setVisible(False)
            self.pushButton_Fortsätt.setVisible(True)
            self.import_widget.move ( 2, 2 + self.top_widget.geometry().bottom() )
            self.textEdit_logg.move ( 2, 2 + self.import_widget.geometry().bottom() )

        else:
            self.import_widget.setVisible(False)
            self.pushButton_Fortsätt.setVisible(False)
            self.textEdit_logg.move(2, 2 + self.top_widget.geometry().bottom())

        self.resize ( 2 + self.textEdit_logg.geometry().width(),  2 + self.textEdit_logg.geometry().bottom()  )

        return
###################################################################################################




###################################################################################################
    def resizeEvent(self, event):

# Anpassning av tabellen till fönstret på grund av användarens dragning av fönstrets kontur
# Hit kommer man magiskt, även efter storleksändringen vid första windowlayout()
#  Warning: resizing inside resizeEvent() or moveEvent() can lead to infinite recursion.

#        print "\nEnter resizeEvent, newwidth, newheight. oldwidth, oldheight ", event.size().width(), event.size().height(), event.oldSize().width(), event.oldSize().height()

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()




        self.textEdit_logg.setUpdatesEnabled(False)

        self.textEdit_logg.setMaximumSize (QtCore.QSize(16777215, 16777215))
        self.mainwidget.resize(QtCore.QSize( self.geometry().width(), self.geometry().height() ))


        textEdit_logg_Rect = QtCore.QRect( self.textEdit_logg.geometry() )

        if self.geometry().right()  > self.pushButton_Importfil.geometry().right():
            textEdit_logg_Rect.setRight( self.mainwidget.geometry().right() )
        else:
            textEdit_logg_Rect.setRight( self.lineEdit_Importfil.geometry().right() )

        textEdit_logg_Rect.setBottom( self.mainwidget.geometry().bottom() )

        self.textEdit_logg.setGeometry ( textEdit_logg_Rect )
        self.textEdit_logg.setMaximumSize (QtCore.QSize( self.textEdit_logg.geometry().width(), self.textEdit_logg.geometry().height()  ))
        self.textEdit_logg.setVerticalScrollBarPolicy ( Qt.ScrollBarAlwaysOn)
        self.textEdit_logg.setHorizontalScrollBarPolicy ( Qt.ScrollBarAsNeeded )

        self.textEdit_logg.setUpdatesEnabled(True)

#        print "Exit resizeEvent"

        return
###################################################################################################




###################################################################################################
    def ui_connections(self):

#       Kopplingar, signaler i gui till slots i gui_Nydatabas.py
#       Ytterligare kopplingar, signaler i gui till slots i extrahera.py, finns i extrahera.py/mera_ui_connections(self)

        self.connect(self.lineEdit_Importfil, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.textEdit_logg, SIGNAL("CtrlPlusPressed"), self.fontsizeup)


        self.connect(self.lineEdit_Importfil, SIGNAL("CtrlMinusPressed"), self.fontsizedown)
        self.connect(self.textEdit_logg, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

###################################################################################################
