#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_parlist.py

# Senast ändrad: 2011-03-02  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTextEdit, sijTableWidget
############################################################################




####################################################################
class gui_Parlista(object):

    SenastÄndrad = '2011-03-01 20:17:59'  # Uppdateras automatiskt. Ändra inte manuellt.

    Parlistakolumnhuvud = []
    Parlistakolumnbredder =[]

    tabellBredd = 0
    tabellHöjd = 0

####################################################################
    def setupUi(self, Parlista):

# Gränsytans statiska definitioner
# Tabeller nollställs helt

        self.Parlistakolumnhuvud = ["Par",              "Person 1 ID",      "Person 2 ID",    #  kolumn   0 -  2
                                    "Person 1 namn",    "Person 2 namn",    "Bonusrel.",      #  kolumn   3 -  5

     "Inledn-typ",   "Inledn",      "-m.",              "-d.",              "-gata",          #  kolumn   6 - 10
     "-by",          "-kvarter",    "-socken",          "-församling",      "-disbytförs.",   #  kolumn  11 - 15
     "-stad",        "-härad",      "-län",             "-utrikes",         "-källa",         #  kolumn  16 - 20

     "Upplösn-typ",  "Upplösn",     "-m.",              "-d.",              "-gata",          #  kolumn  21 - 25
     "-by",          "-kvarter",    "-socken",          "-församling",      "-disbytförs.",   #  kolumn  26 - 30
     "-stad",        "-härad",      "-län",             "-utrikes",         "-källa",         #  kolumn  31 - 35

     "Barn",         "fler källor", "anteckn.",         "sparat" ]                            #  kolumn  36 - 39


        self.Parlistakolumnbredder = [   11,   8,    8,        #  kolumn   0 -  2
                                         16,  16,   11,        #  kolumn   3 -  5

                                6,   5,   3,   3,    5,        #  kolumn   6 - 10
                                5,   5,  10,  10,   11,        #  kolumn  11 - 15
                                6,   6,  11,   6,   11,        #  kolumn  16 - 20

                                8,   5,   3,   3,    5,        #  kolumn  21 - 25
                                5,   5,  10,  10,   11,        #  kolumn  26 - 30
                                6,   6,  11,   6,   11,        #  kolumn  31 - 35

                                8,   6,  10,  13]              #  kolumn  36 - 39


# OBS! Parlistakolumnbredder och Parlistakolumnhuvud ska definieras samhörande
# Parlistakolumnhuvud ställs in i setupUi
# Parlistakolumnbredder ställs in i sijLayout

# Storlekar och placeringar bestäms någon annanstans.

        Parlista.setObjectName("Parlista")
        Parlista.setWindowTitle( "Parlista")
        self.setAttribute(Qt.WA_AlwaysShowToolTips)
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))


        self.ytteryta = QtGui.QWidget(Parlista)
        self.ytteryta.setObjectName("ytteryta")
        self.setCentralWidget(self.ytteryta)

        self.ytteryta.setFocusPolicy(Qt.NoFocus)



# Rutan 'frame_top' högst uppe

        self.frame_top2 = QtGui.QFrame( self.ytteryta)
        self.frame_top2.setFrameShape(QtGui.QFrame.StyledPanel)
        self.frame_top2.setFrameShadow(QtGui.QFrame.Raised)
        self.frame_top2.setObjectName("frame_top2")

        self.label_startnr = QtGui.QLabel(self.frame_top2)
        self.label_startnr.setObjectName("label_startnr")
        self.label_startnr.setText(" Från par nr ")
        self.label_startnr.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignRight))

        self.lineEdit_startnr = sijLineEdit(self.frame_top2)
        self.lineEdit_startnr.setObjectName("lineEdit_startnr")
        self.lineEdit_startnr.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

        self.label_stoppnr = QtGui.QLabel(self.frame_top2)
        self.label_stoppnr.setObjectName("label_stoppnr")
        self.label_stoppnr.setText(" Till par nr ")
        self.label_stoppnr.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignRight))

        self.lineEdit_stoppnr = sijLineEdit(self.frame_top2)
        self.lineEdit_stoppnr.setObjectName("lineEdit_stoppnr")
        self.lineEdit_stoppnr.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

        self.pushButton_starta = QtGui.QPushButton(self.frame_top2)
        self.pushButton_starta.setObjectName("pushButton_starta")
        self.pushButton_starta.setText(" Starta Skapa Tabell och Lista ")


        self.frame_top = QtGui.QFrame( self.ytteryta)
        self.frame_top.setFrameShape(QtGui.QFrame.StyledPanel)
        self.frame_top.setFrameShadow(QtGui.QFrame.Raised)
        self.frame_top.setObjectName("frame_top")

        self.label_Databas = QtGui.QLabel(self.frame_top)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText(" Databas ")
        self.label_Databas.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Databas = sijLineEdit(self.frame_top)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")
        self.lineEdit_Databas.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

        self.label_Senastepar = QtGui.QLabel(self.frame_top)
        self.label_Senastepar.setObjectName("label_Senastepar")
        self.label_Senastepar.setText( " Sista par-nr. ")
        self.label_Senastepar.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Senastepar = sijLineEdit(self.frame_top)
        self.lineEdit_Senastepar.setObjectName("lineEdit_Senastepar")
        self.lineEdit_Senastepar.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

        self.label_Antalpar = QtGui.QLabel(self.frame_top)
        self.label_Antalpar.setObjectName("label_Antalpar")
        self.label_Antalpar.setText( " Antal par ")
        self.label_Antalpar.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Antalpar = sijLineEdit(self.frame_top)
        self.lineEdit_Antalpar.setObjectName("lineEdit_Antalpar")
        self.lineEdit_Antalpar.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))

        self.checkBox_TillåtUppdatering = QtGui.QCheckBox(self.frame_top)
        self.checkBox_TillåtUppdatering.setObjectName("checkBox_TillåtUppdatering")
        self.checkBox_TillåtUppdatering.setText( " Tillåt uppdatering ")
        self.checkBox_TillåtUppdatering.setChecked(False)
        self.checkBox_TillåtUppdatering.setEnabled(False)

        self.frame_top.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_Databas.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_Senastepar.setFocusPolicy(Qt.NoFocus)
        self.lineEdit_Antalpar.setFocusPolicy(Qt.NoFocus)
        self.checkBox_TillåtUppdatering.setFocusPolicy(Qt.NoFocus)

# loggfönster till vänster
        self.textEdit_logg = sijTextEdit(self.ytteryta)
        self.textEdit_logg.setObjectName("textEdit_logg")
        self.textEdit_logg.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.textEdit_logg.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)




# Tabellen tableWidget_Parlista i resten av fönstret
        self.tableWidget_Parlista = sijTableWidget(self.ytteryta)
        self.tableWidget_Parlista.setObjectName("tableWidget_Parlista")
        self.tableWidget_Parlista.setFocusPolicy(QtCore.Qt.ClickFocus)

        self.tableWidget_Parlista.setEditTriggers(QtGui.QAbstractItemView.NoEditTriggers)
        self.tableWidget_Parlista.setAlternatingRowColors(True)
        self.tableWidget_Parlista.setIconSize(QtCore.QSize(16,16))

        self.tableWidget_Parlista.setDragEnabled(True)
       # self.tableWidget_Parlista.setDragEnabled(False)   # ???

       # self.tableWidget_Parlista.setSelectionBehavior(QtGui.QAbstractItemView.SelectItems)
        self.tableWidget_Parlista.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.tableWidget_Parlista.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.tableWidget_Parlista.setTextElideMode(QtCore.Qt.ElideMiddle)

        self.tableWidget_Parlista.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.tableWidget_Parlista.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)

#        self.tableWidget_Parlista.setFocus()
#        self.tableWidget_Parlista.setContextMenuPolicy(QtCore.Qt.DefaultContextMenu)
#        self.tableWidget_Parlista.verticalHeader().setVisible(False)


        self.tableWidget_Parlista.clear()
        self.tableWidget_Parlista.setRowCount(0)
        self.tableWidget_Parlista.setColumnCount(len(self.Parlistakolumnhuvud))

        kol_nr = 0
        for kol in self.Parlistakolumnhuvud:
            self.tableWidget_Parlista.setHorizontalHeaderItem(kol_nr, QtGui.QTableWidgetItem(kol))
            kol_nr = kol_nr + 1

        palette_Bakgrund = QtGui.QPalette()

        brush = QtGui.QBrush(QtGui.QColor(248,248,248))
        brush.setStyle(QtCore.Qt.SolidPattern)
        palette_Bakgrund.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)

        brush = QtGui.QBrush(QtGui.QColor(240,255,255))
        brush.setStyle(QtCore.Qt.SolidPattern)
        palette_Bakgrund.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)

        brush = QtGui.QBrush(QtGui.QColor(240,255,255))
        brush.setStyle(QtCore.Qt.SolidPattern)
        palette_Bakgrund.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

        self.ytteryta.setPalette(palette_Bakgrund)
        self.ytteryta.setAutoFillBackground(True)

        return
###################################################################################################




###################################################################################################
    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()

    def fontsizeset(self):
        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        font = QFont()
        font.setPointSize(self.fontsize)
        font.setWeight(50)
        font.setBold(False)

        fontBold =  QFont()
        fontBold.setPointSize(self.fontsize)
        fontBold.setWeight(75)
        fontBold.setBold(True)

        self.ytteryta.setFont(font)

# frame_Top

        self.frame_top2.setFont(fontBold)

        self.label_startnr.setFont(font)
        self.label_startnr.setFont(font)
        self.lineEdit_startnr.setFont(font)
        self.lineEdit_stoppnr.setFont(font)
        self.pushButton_starta.setFont(font)

        self.frame_top.setFont(fontBold)

        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.label_Senastepar.setFont(font)
        self.lineEdit_Senastepar.setFont(font)
        self.label_Antalpar.setFont(font)
        self.lineEdit_Antalpar.setFont(font)
        self.checkBox_TillåtUppdatering.setFont(font)

        self.textEdit_logg.setFont(font)


# Tabellen tableWidget_Parlista i resten av fönstret
        self.tableWidget_Parlista.setFont(font)

        return
###################################################################################################




###################################################################################################
    def sijlayout(self):
# "Möblering" av de grafiska elementen, görs om efter ändring av fontstorlek

#        print "Enter sijlayout"

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.textEdit_logg.verticalScrollBar().setFixedWidth(fh-2)
        self.textEdit_logg.horizontalScrollBar().setFixedHeight(fh-2)

      #  self.tableWidget_Parlista.verticalScrollBar().setFixedWidth(fh-2)
      #  self.tableWidget_Parlista.horizontalScrollBar().setFixedHeight(fh-2)

# Layout av överlappande rutorna frame_top2 och frame_top högst uppe till vänster

        self.label_startnr.setGeometry       (                                             2, 2, 2*fs + metrics.width( self.label_startnr.text()), fh )
        self.lineEdit_startnr.setGeometry    (  5    + self.label_startnr.geometry().right(), 2,           2*fs + metrics.width( " par00000000 "), fh )
        self.label_stoppnr.setGeometry       ( 12 + self.lineEdit_startnr.geometry().right(), 2, 2*fs + metrics.width( self.label_stoppnr.text()), fh )
        self.lineEdit_stoppnr.setGeometry    (  5    + self.label_stoppnr.geometry().right(), 2,           2*fs + metrics.width( " par00000000 "), fh )
        self.pushButton_starta.setGeometry   ( 12 + self.lineEdit_stoppnr.geometry().right(), 2,    metrics.width( self.pushButton_starta.text()), fh )


        self.label_Databas.setGeometry       (                                             2, 2,           metrics.width( self.label_Databas.text()), fh )
        self.lineEdit_Databas.setGeometry    (  2    + self.label_Databas.geometry().right(), 2, 2*fs + metrics.width( self.lineEdit_Databas.text()), fh )
        self.label_Senastepar.setGeometry    ( 12 + self.lineEdit_Databas.geometry().right(), 2,        metrics.width( self.label_Senastepar.text()), fh )
        self.lineEdit_Senastepar.setGeometry (  2 + self.label_Senastepar.geometry().right(), 2,              2*fs + metrics.width( " par00000000 "), fh )

        self.label_Antalpar.setGeometry   ( 12 + self.lineEdit_Senastepar.geometry().right(), 2,          metrics.width( self.label_Antalpar.text()), fh )
        self.lineEdit_Antalpar.setGeometry ( 2      + self.label_Antalpar.geometry().right(), 2,                   2*fs + metrics.width( "00000000"), fh )


        self.checkBox_TillåtUppdatering.setGeometry (12 + self.lineEdit_Antalpar.geometry().right(), 2,   5*fs + metrics.width(self.checkBox_TillåtUppdatering.text()), fh )


        self.frame_top.setGeometry     ( 2,                                      2, 2 + self.checkBox_TillåtUppdatering.geometry().right(), 2 + self.checkBox_TillåtUppdatering.geometry().bottom() )
        self.textEdit_logg.setGeometry ( 2, 2 + self.frame_top.geometry().bottom(),                                    self.loggwidth * fs,                                                   20*fh )

        self.tableWidget_Parlista.move ( 2 + self.textEdit_logg.geometry().right(), 2 + self.frame_top.geometry().bottom())

        return
###################################################################################################




###################################################################################################
    def tablelayout(self):

        from johangemensamt import allmänt as allm
        font = self.tableWidget_Parlista.font()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.tabellBredd = 0
        kol_nr = 0
        for kol in self.Parlistakolumnbredder:
            kol_bredd = int( kol * fs )
            self.tableWidget_Parlista.setColumnWidth(kol_nr, kol_bredd )
            self.tabellBredd =  self.tabellBredd + self.tableWidget_Parlista.columnWidth(kol_nr)
            kol_nr = kol_nr + 1

        self.tabellHöjd = self.tableWidget_Parlista.horizontalHeader().height()
        for r in range (0, int(self.tableWidget_Parlista.rowCount())):
            self.tabellHöjd = self.tabellHöjd + self.tableWidget_Parlista.rowHeight(r)

# Placera tabellen preliminärt för att kunna beräkna slutlig utsträckning på skärmen
# availablescreen_Rect = QtGui.QDesktopWidget().availableGeometry()

        tableWidget_Parlista_Rect = self.tableWidget_Parlista.geometry()
        tableWidget_Parlista_Rect.setHeight( self.tabellHöjd)

        if self.tabellBredd < ( 0.9*QtGui.QDesktopWidget().availableGeometry().width() - self.textEdit_logg.geometry().width() ) :
            tableWidget_Parlista_Rect.setWidth ( self.tabellBredd + self.tableWidget_Parlista.verticalScrollBar().width() )
        else:
            tableWidget_Parlista_Rect.setWidth (0.9*QtGui.QDesktopWidget().availableGeometry().width() - self.textEdit_logg.geometry().width() )

        if self.tabellHöjd < ( 0.9*QtGui.QDesktopWidget().availableGeometry().height() - self.frame_top.geometry().height() ) :
            tableWidget_Parlista_Rect.setHeight (self.tabellHöjd + self.tableWidget_Parlista.horizontalScrollBar().height() )
        else:
            tableWidget_Parlista_Rect.setHeight (0.9*QtGui.QDesktopWidget().availableGeometry().height() - self.frame_top.geometry().height() )

        self.tableWidget_Parlista.setMaximumSize(16777215, 16777215)
        self.tableWidget_Parlista.setGeometry(tableWidget_Parlista_Rect)

        return

###################################################################################################




###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret till tabellen
        self.ytteryta.setGeometry (0, 0,  2 + self.tableWidget_Parlista.geometry().right(),  2 + self.tableWidget_Parlista.geometry().bottom() )
        self.resize(QtCore.QSize(self.ytteryta.geometry().width(), self.ytteryta.geometry().height() ))
        return
###################################################################################################




###################################################################################################
    def resizeEvent(self, event):

# Anpassning av tabellen till fönstret på grund av användarens dragning av fönstrets kontur
# Hit kommer man magiskt, även efter storleksändringen vid första windowlayout()
#  Warning: resizing inside resizeEvent() or moveEvent() can lead to infinite recursion.

        ytteryta_Rect = self.ytteryta.geometry()
        textEdit_logg_Rect = self.textEdit_logg.geometry()
        tableWidget_Parlista_Rect = self.tableWidget_Parlista.geometry()

        self.textEdit_logg.setFixedHeight( ytteryta_Rect.height() - textEdit_logg_Rect.y() )
        self.tableWidget_Parlista.setFixedWidth( ytteryta_Rect.width() - tableWidget_Parlista_Rect.x() )
        self.tableWidget_Parlista.setFixedHeight( ytteryta_Rect.height() - tableWidget_Parlista_Rect.y() )


# välj skroll-lister
        tableWidget_Parlista_Rect = self.tableWidget_Parlista.geometry()

        if  self.tabellBredd > tableWidget_Parlista_Rect.width() and self.tabellHöjd > tableWidget_Parlista_Rect.height():
            self.tableWidget_Parlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            self.tableWidget_Parlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)

        elif  self.tabellBredd > tableWidget_Parlista_Rect.width():
            self.tableWidget_Parlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            if self.tabellHöjd + self.tableWidget_Parlista.horizontalScrollBar().height() > tableWidget_Parlista_Rect.height():
                self.tableWidget_Parlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            else:
                self.tableWidget_Parlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)

        elif  self.tabellHöjd > tableWidget_Parlista_Rect.height():
            self.tableWidget_Parlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            if  self.tabellBredd  + self.tableWidget_Parlista.verticalScrollBar().width() > tableWidget_Parlista_Rect.width():
                self.tableWidget_Parlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
            else:
                self.tableWidget_Parlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)

        else:
            self.tableWidget_Parlista.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)  #
            self.tableWidget_Parlista.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)  #

        return
###################################################################################################




#############################################################################################################
# kopplingar till knappar i grafiska gränsytan
    def ui_connections(self):

        self.connect(self.lineEdit_Databas, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Databas, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_Senastepar, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Senastepar, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_Antalpar, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Antalpar, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.tableWidget_Parlista, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.tableWidget_Parlista, SIGNAL("CtrlMinusPressed"), self.fontsizedown)


        self.connect(self.textEdit_logg, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.textEdit_logg, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        return
#############################################################################################################
