#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_personblad.py

# Senast ändrad: 2011-01-10  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTableWidget, sijTextEdit, Händelseruta
############################################################################



####################################################################
class gui_Personblad(object):

    SenastÄndrad = '2011-01-10 18:39:31'  # Uppdateras automatiskt. Ändra inte manuellt.

####################################################################
    def setupUi(self, Personblad):

# Här definieras alla objekt inklusive fasta texter och statiska egenskaper
# Tabeller nollställs helt

# Storlekar och placeringar bestäms någon annanstans.

        Personblad.setObjectName("Personblad")
        Personblad.setWindowTitle("Johan - personblad")
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))

        self.ytteryta = QtGui.QWidget(Personblad)
        self.ytteryta.setObjectName("centralwidget")
        self.setCentralWidget(self.ytteryta)
        self.ytteryta.setAutoFillBackground(True)


        self.inneryta = QtGui.QWidget(self.ytteryta)
        self.inneryta.setObjectName("inneryta")
        self.inneryta.setAutoFillBackground(True)

        self.scrollyta = QtGui.QScrollArea(self.inneryta)

        self.scrollyta.setFrameStyle(QFrame.NoFrame)

        self.scrollyta.setVerticalScrollBarPolicy(Qt.ScrollBarAsNeeded)
        self.scrollyta.setHorizontalScrollBarPolicy(Qt.ScrollBarAsNeeded)
#        self.scrollyta.setAutoFillBackground(True)
        self.scrollyta.setObjectName("scrollyta")

        self.scrollyta.setFocusPolicy(Qt.NoFocus)
# sij tolkar att detta ärvs till alla underliggande objekt utom lineEdit, textEdit och tableWidget



# Rutan 'frame_top' högst uppe till vänster
        self.frame_top = QtGui.QFrame( self.inneryta)
        self.frame_top.setFrameShape(QtGui.QFrame.StyledPanel)
        self.frame_top.setFrameShadow(QtGui.QFrame.Raised)
        self.frame_top.setObjectName("frame_top")


        self.label_Databas = QtGui.QLabel(self.frame_top)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText("Databas ")
        self.label_Databas.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Databas = sijLineEdit(self.frame_top)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")

        self.pushButton_Databas = QtGui.QPushButton(self.frame_top)
        self.pushButton_Databas.setObjectName("pushButton_Databas")
        self.pushButton_Databas.setText(" Välj Databas ")


        self.label_Personnummer = QtGui.QLabel(self.frame_top)
        self.label_Personnummer.setObjectName("label_Personnummer")
        self.label_Personnummer.setText("Person-nr. ")
        self.label_Personnummer.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Personnummer = sijLineEdit(self.frame_top)
        self.lineEdit_Personnummer.setObjectName("lineEdit_Personnummer")
        self.lineEdit_Personnummer.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))
        self.lineEdit_Personnummer.setText("00000000")
        self.lineEdit_Personnummer.setEnabled(False)

        self.pushButton_RitaOm = QtGui.QPushButton(self.frame_top)
        self.pushButton_RitaOm.setObjectName("pushButton_RitaOm")
        self.pushButton_RitaOm.setText("Rita om")
        self.pushButton_RitaOm.setEnabled(False)


        self.pushButton_Spara = QtGui.QPushButton(self.frame_top)
        self.pushButton_Spara.setObjectName("pushButton_Spara ")
        self.pushButton_Spara.setText("Spara")
        self.pushButton_Spara.setEnabled(False)

        self.label_Databas.setBuddy(self.lineEdit_Databas)
        self.label_Personnummer.setBuddy(self.lineEdit_Personnummer)


# Rutan 'groupBox_Person'

        self.groupBox_Person = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Person.setObjectName("groupBox_Person")
        self.groupBox_Person.setTitle("Person")

        self.label_Person_ID = QtGui.QLabel(self.groupBox_Person)
        self.label_Person_ID.setObjectName("label_Person_ID")
        self.label_Person_ID.setText("Person_ID")

        self.lineEdit_Person_ID = sijLineEdit(self.groupBox_Person)
        self.lineEdit_Person_ID.setObjectName("lineEdit_Person_ID")
        self.lineEdit_Person_ID.setEnabled(False)

        self.label_Person_Kön = QtGui.QLabel(self.groupBox_Person)
        self.label_Person_Kön.setObjectName("label_Person_Kön")
        self.label_Person_Kön.setText("Kön")

        self.lineEdit_Person_Kön = sijLineEdit(self.groupBox_Person)
        self.lineEdit_Person_Kön.setObjectName("lineEdit_Person_Kön")

        self.label_Person_Kategori = QtGui.QLabel(self.groupBox_Person)
        self.label_Person_Kategori.setObjectName("label_Person_Kategori")
        self.label_Person_Kategori.setText("Kategori")

        self.lineEdit_Person_Kategori = sijLineEdit(self.groupBox_Person)
        self.lineEdit_Person_Kategori.setObjectName("lineEdit_Person_Kategori")

        self.label_Förnamn = QtGui.QLabel(self.groupBox_Person)
        self.label_Förnamn.setObjectName("label_Förnamn")
        self.label_Förnamn.setText("Förnamn")

        self.textEdit_Förnamn = sijTextEdit(self.groupBox_Person)
        self.textEdit_Förnamn.setObjectName("textEdit_Förnamn")

        self.label_Tilltal = QtGui.QLabel(self.groupBox_Person)
        self.label_Tilltal.setObjectName("label_Tilltal")
        self.label_Tilltal.setText("Tilltalsnamn")

        self.textEdit_Tilltal = sijTextEdit(self.groupBox_Person)
        self.textEdit_Tilltal.setObjectName("textEdit_Tilltal")

        self.label_Efternamn = QtGui.QLabel(self.groupBox_Person)
        self.label_Efternamn.setObjectName("label_Efternamn")
        self.label_Efternamn.setText("Efternamn")

        self.textEdit_Efternamn = sijTextEdit(self.groupBox_Person)
        self.textEdit_Efternamn.setObjectName("textEdit_Efternamn")


        self.label_Person_ID.setBuddy(self.lineEdit_Person_ID)
        self.label_Person_Kön.setBuddy(self.lineEdit_Person_Kön)
        self.label_Person_Kategori.setBuddy(self.lineEdit_Person_Kategori)
        self.label_Förnamn.setBuddy(self.textEdit_Förnamn)
        self.label_Tilltal.setBuddy(self.textEdit_Tilltal)
        self.label_Efternamn.setBuddy(self.textEdit_Efternamn)



        self.label_Upplysningar = QtGui.QLabel(self.inneryta)
        self.label_Upplysningar.setWordWrap(True)
        self.label_Upplysningar.setObjectName("label_Upplysningar")
        self.label_Upplysningar.setFrameShape(QtGui.QFrame.Panel)
        self.label_Upplysningar.setFrameShadow(QtGui.QFrame.Sunken)
        self.label_Upplysningar.setAlignment(Qt.Alignment(Qt.AlignTop | Qt.AlignLeft))

        self.label_Upplysningar.setText("\nkön:   k / m\n\n"
        "kat: A,B,C,1\n\n"
        "1 namn/rad\n\n"
        "namn-tab-kommentar\n\n"
        )

        self.label_Upplysningar.setAutoFillBackground(True)



# Rutan 'groupBox_Föräldraparet
        self.groupBox_Föräldrapar = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Föräldrapar.setObjectName("groupBox_Föräldrapar")
        self.groupBox_Föräldrapar.setTitle("Föräldraparet")


        self.label_Föräldrapar_ID = QtGui.QLabel(self.groupBox_Föräldrapar)
        self.label_Föräldrapar_ID.setObjectName("label_Föräldrapar_ID")
        self.label_Föräldrapar_ID.setText("Föräldrapar_ID")

        self.lineEdit_Föräldrapar_ID = sijLineEdit(self.groupBox_Föräldrapar)
        self.lineEdit_Föräldrapar_ID.setEnabled(False)
        self.lineEdit_Föräldrapar_ID.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_Föräldrapar_ID.setObjectName("lineEdit_Föräldrapar_ID")

        self.textEdit_Föräldrapar_Namn = sijTextEdit(self.groupBox_Föräldrapar)
        self.textEdit_Föräldrapar_Namn.setEnabled(False)
        self.textEdit_Föräldrapar_Namn.setObjectName("textEdit_Föräldrapar_Namn")

        self.label_Föräldrapar_ID.setBuddy(self.lineEdit_Föräldrapar_ID)

# Rutan 'groupBox_Egna par'
        self.groupBox_Egna_Par = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Egna_Par.setObjectName("groupBox_Egna_Par")
        self.groupBox_Egna_Par.setTitle("Egna par")


        self.pushButton_Upp = QtGui.QPushButton(self.groupBox_Egna_Par)
        self.pushButton_Upp.setEnabled(False)
        self.pushButton_Upp.setDefault(True)
        self.pushButton_Upp.setObjectName("pushButton_Upp")
        self.pushButton_Upp.setText("upp")

        self.pushButton_Ned = QtGui.QPushButton(self.groupBox_Egna_Par)
        self.pushButton_Ned.setEnabled(False)
        self.pushButton_Ned.setObjectName("pushButton_Ned")
        self.pushButton_Ned.setText("ned")

        self.tableWidget_Egna_Par = sijTableWidget(self.groupBox_Egna_Par)
        self.tableWidget_Egna_Par.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.tableWidget_Egna_Par.setContextMenuPolicy(QtCore.Qt.DefaultContextMenu)
        self.tableWidget_Egna_Par.setDragEnabled(False)
#        self.tableWidget_Egna_Par.setAlternatingRowColors(True)
        self.tableWidget_Egna_Par.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.tableWidget_Egna_Par.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.tableWidget_Egna_Par.setTextElideMode(QtCore.Qt.ElideMiddle)
#       self.tableWidget_Egna_Par.setShowGrid(False)
        self.tableWidget_Egna_Par.setObjectName("tableWidget_Egna_Par")

        self.tableWidget_Egna_Par.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.tableWidget_Egna_Par.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)
        self.tableWidget_Egna_Par.verticalHeader().setVisible(False)


# preparera tabell för att visa barn i (så de kan sorteras)
# Måste göras före anropet till self.fyllGui
# --- Tömmer och nollställer eventuell gammal tabell ---
        self.tableWidget_Egna_Par.clear()
        self.tableWidget_Egna_Par.setColumnCount(4)
        self.tableWidget_Egna_Par.setRowCount(0)

# --- Preparerar tabell ---
        headerItem0 = QtGui.QTableWidgetItem( "par ID")
        headerItem1 = QtGui.QTableWidgetItem( "make/maka ID")
        headerItem2 = QtGui.QTableWidgetItem( "make/maka namn")
        headerItem3 = QtGui.QTableWidgetItem( "par år")

        self.tableWidget_Egna_Par.setHorizontalHeaderItem( 0, headerItem0)
        self.tableWidget_Egna_Par.setHorizontalHeaderItem( 1, headerItem1)
        self.tableWidget_Egna_Par.setHorizontalHeaderItem( 2, headerItem2)
        self.tableWidget_Egna_Par.setHorizontalHeaderItem( 3, headerItem3)


# Rutan 'groupBox_Bonusrelationer'
        self.groupBox_Bonusrelationer = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Bonusrelationer.setObjectName("groupBox_Bonusrelationer")
        self.groupBox_Bonusrelationer.setTitle("Bonusrelationer")

        self.textEdit_Bonusrelation_ID = sijTextEdit(self.groupBox_Bonusrelationer)
        self.textEdit_Bonusrelation_ID.setEnabled(False)
        self.textEdit_Bonusrelation_ID.setObjectName("textEdit_Bonusrelation_ID")

        self.textEdit_Bonusrelation_ID_2 = sijTextEdit(self.groupBox_Bonusrelationer)
        self.textEdit_Bonusrelation_ID_2.setEnabled(False)
        self.textEdit_Bonusrelation_ID_2.setObjectName("textEdit_Bonusrelation_ID_2")

        self.textEdit_Bonusrelation_ID.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.textEdit_Bonusrelation_ID.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)

        self.textEdit_Bonusrelation_ID_2.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)     #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.textEdit_Bonusrelation_ID_2.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)


# Rutan 'groupBox_Länkar'
        self.groupBox_Länkar = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Länkar.setObjectName("groupBox_Länkar")
        self.groupBox_Länkar.setTitle("Länkar")

        self.tableWidget_länkar = sijTableWidget(self.groupBox_Länkar)
        self.tableWidget_länkar.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.tableWidget_länkar.setContextMenuPolicy(QtCore.Qt.DefaultContextMenu)
        self.tableWidget_länkar.setDragEnabled(False)
        self.tableWidget_länkar.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.tableWidget_länkar.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.tableWidget_länkar.setTextElideMode(QtCore.Qt.ElideMiddle)
        self.tableWidget_länkar.setObjectName("tableWidget_länkar")

        self.tableWidget_länkar.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.tableWidget_länkar.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)
        self.tableWidget_länkar.verticalHeader().setVisible(False)

        self.tableWidget_länkar.clear()
        self.tableWidget_länkar.setColumnCount(3)
        self.tableWidget_länkar.setRowCount(0)

# --- Preparerar tabell ---
# OBS kolumn nr 0 är dold (bredd=0) och utnyttjas av programkoden
#        headerItem0 = QtGui.QTableWidgetItem( "")
        headerItem1 = QtGui.QTableWidgetItem( "Skapa/Öppna ... ")
        headerItem2 = QtGui.QTableWidgetItem( "Filnamn")

#        self.tableWidget_länkar.setHorizontalHeaderItem( 0, headerItem0)
        self.tableWidget_länkar.setHorizontalHeaderItem( 1, headerItem1)
        self.tableWidget_länkar.setHorizontalHeaderItem( 2, headerItem2)



# Rutan 'groupBox_Anteckningar'
        self.groupBox_Anteckningar = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Anteckningar.setObjectName("groupBox_Anteckningar")
        self.groupBox_Anteckningar.setTitle("Anteckningar")

        self.textEdit_Anteckningar = sijTextEdit(self.groupBox_Anteckningar)
        self.textEdit_Anteckningar.setObjectName("textEdit_Anteckningar")
        self.textEdit_Anteckningar.setTabChangesFocus(True)


# Rutan 'Händelse_född
        self.Händelse_född = Händelseruta(self.inneryta, self.fontsize)
        self.Händelse_född.groupBox_Händelse.setTitle("Född")
        self.Händelse_född.groupBox_typ.setVisible(False)
        self.Händelse_född.groupBox_typ.setGeometry(0,0,0,0)

# Rutan 'Händelse_död
        self.Händelse_död = Händelseruta(self.inneryta, self.fontsize)
        self.Händelse_död.groupBox_Händelse.setTitle("Död")
        self.Händelse_död.groupBox_typ.setVisible(False)
        self.Händelse_död.groupBox_typ.setGeometry(0,0,0,0)



# Rutan 'groupBox_Fler_Källor
        self.groupBox_Fler_Källor = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Fler_Källor.setObjectName("groupBox_Fler_Källor")
        self.groupBox_Fler_Källor.setTitle("Fler källor")

        self.textEdit_Fler_Källor = sijTextEdit(self.groupBox_Fler_Källor)
        self.textEdit_Fler_Källor.setObjectName("textEdit_Fler_Källor")
        self.textEdit_Fler_Källor.setTabChangesFocus(True)

# Längst ner till höger
        self.label_SenastSparat = QtGui.QLabel(self.inneryta)
        self.label_SenastSparat.setObjectName(" self.label_SenastSparat")
        self.label_SenastSparat.setText("Senast sparat/ändrat  ")
#       self.label_SenastSparat.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_SenastSparat = sijLineEdit(self.inneryta)
        self.lineEdit_SenastSparat.setObjectName("lineEdit_SenastSparat")
        self.lineEdit_SenastSparat.setEnabled(False)

#*****************************************************************************************

        brush = QtGui.QBrush()
        brush.setStyle(QtCore.Qt.SolidPattern)

        if self.färgschema == '0':         # Standard
    #        palette_inneryta
            brush = QtGui.QBrush(QtGui.QColor(240,240,240,255)) # ljus grå
            self.palette_inneryta.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Window,brush)
            brush = QtGui.QBrush(QtGui.QColor(230,230,230,255)) # något mörkare grå grå
            self.palette_inneryta.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window,brush)
            self.palette_inneryta.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window,brush)
            brush = QtGui.QBrush(QtGui.QColor(0,0,0,255))       # svart
            self.palette_inneryta.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
            brush = QtGui.QBrush(QtGui.QColor(0,0,0,120))    # grå
            self.palette_inneryta.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
            self.palette_inneryta.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )
            self.inneryta.setPalette(self.palette_inneryta)


        elif self.färgschema == '1':       # Master
    #        palette_inneryta
            brush = QtGui.QBrush(QtGui.QColor(0,255,0,16)) # ljus grön
            self.palette_inneryta.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Window,brush)
            brush = QtGui.QBrush(QtGui.QColor(232,240,232)) # något mörkare grön grå
            self.palette_inneryta.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window,brush)
            self.palette_inneryta.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window,brush)
            brush = QtGui.QBrush(QtGui.QColor(0,0,0,255))       # svart
            self.palette_inneryta.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
            brush = QtGui.QBrush(QtGui.QColor(80,80,80))    # grå
            self.palette_inneryta.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
            self.palette_inneryta.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )
            self.inneryta.setPalette(self.palette_inneryta)


        elif self.färgschema == '2':       # Compare
    #        palette_inneryta
            brush = QtGui.QBrush(QtGui.QColor(255,255,0,32)) # ljus gul
            self.palette_inneryta.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Window,brush)
            brush = QtGui.QBrush(QtGui.QColor(240,240,232)) # något mörkare gul
            self.palette_inneryta.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window,brush)
            self.palette_inneryta.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window,brush)
            brush = QtGui.QBrush(QtGui.QColor(0,0,0))       # svart
            self.palette_inneryta.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
            brush = QtGui.QBrush(QtGui.QColor(80,80,80))    # grå
            self.palette_inneryta.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
            self.palette_inneryta.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )
            self.inneryta.setPalette(self.palette_inneryta)


#        palette_ytteryta_normal
        brush = QtGui.QBrush(QtGui.QColor(240,240,240)) # ljus grå
        self.palette_ytteryta_normal.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Window, brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_ytteryta_normal.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush)
        self.palette_ytteryta_normal.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush)

#        palette_ytteryta_spara
        brush = QtGui.QBrush(QtGui.QColor(255,200,200))  # ljus röd
        self.palette_ytteryta_spara.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Window, brush)
        brush = QtGui.QBrush(QtGui.QColor(240,0,0))      # stark röd
        self.palette_ytteryta_spara.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush)
        self.palette_ytteryta_spara.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush)
        self.ytteryta.setPalette(self.palette_ytteryta_normal)

 #       self.palette_sparaknapp_normal
        brush = QtGui.QBrush(QtGui.QColor(80,80,80))    # grå
        self.palette_sparaknapp_normal.setBrush(QtGui.QPalette.Active, QtGui.QPalette.ButtonText, brush)
        brush = QtGui.QBrush(QtGui.QColor(80,80,80))    # grå
        self.palette_sparaknapp_normal.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.ButtonText, brush)
        self.palette_sparaknapp_normal.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.ButtonText, brush)

#        self.palette_sparaknapp_spara
        brush = QtGui.QBrush(QtGui.QColor(255,0,0))  # stark röd
        self.palette_sparaknapp_spara.setBrush(QtGui.QPalette.Active, QtGui.QPalette.ButtonText, brush)
        brush = QtGui.QBrush(QtGui.QColor(240,0,0))  # stark röd
        self.palette_sparaknapp_spara.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.ButtonText, brush)
        self.palette_sparaknapp_spara.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.ButtonText, brush)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_normal)


#         self.palette_Upplysning
        brush = QtGui.QBrush(QtGui.QColor(255,255,240)) # ljus gul
        self.palette_Upplysning.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare ljusgrå
        self.palette_Upplysning.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)
        self.palette_Upplysning.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)
        self.label_Upplysningar.setPalette(self.palette_Upplysning)




#*****************************************************************************************

# detta ska vara med på något sätt

        Personblad.setTabOrder(self.textEdit_Förnamn,self.textEdit_Tilltal)
        Personblad.setTabOrder(self.textEdit_Tilltal,self.textEdit_Efternamn)
#        Personblad.setTabOrder(self.textEdit_Efternamn,self.lineEdit_Fodd_Ar)

        Personblad.setTabOrder(self.lineEdit_Föräldrapar_ID,self.textEdit_Anteckningar)
        Personblad.setTabOrder(self.textEdit_Anteckningar,self.lineEdit_Person_Kategori)
        Personblad.setTabOrder(self.lineEdit_Person_Kategori,self.lineEdit_Person_Kön)
        Personblad.setTabOrder(self.lineEdit_Person_Kön,self.lineEdit_Person_ID)
        Personblad.setTabOrder(self.lineEdit_Person_ID,self.lineEdit_Databas)
        Personblad.setTabOrder(self.lineEdit_Databas,self.lineEdit_Personnummer)
#        Personblad.setTabOrder(self.lineEdit_Personnummer,self.pushButton_RitaOm)
#        Personblad.setTabOrder(self.pushButton_RitaOm,self.pushButton_Spara)
        Personblad.setTabOrder(self.pushButton_Spara,self.textEdit_Föräldrapar_Namn)

###################################################################################################




###################################################################################################
    def enableUi(self):
        self.lineEdit_Personnummer.setEnabled(True)
        self.pushButton_RitaOm.setEnabled(True)

        self.pushButton_Upp.setEnabled(True)
        self.pushButton_Ned.setEnabled(True)

        self.textEdit_Bonusrelation_ID.setEnabled(True)
        self.textEdit_Bonusrelation_ID_2.setEnabled(False) # endast för utmatning från programmet
###################################################################################################




###################################################################################################
    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()

    def fontsizeset(self):
        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        font = QFont()
        font.setPointSize(self.fontsize)
        font.setWeight(50)
        font.setBold(False)

        fontBold =  QFont()
        font.setPointSize(self.fontsize)
        fontBold.setWeight(75)
        fontBold.setBold(True)

        self.scrollyta.setFont(font)

# frame_Top

        self.frame_top.setFont(fontBold)
        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.pushButton_Databas.setFont(font)
        self.label_Personnummer.setFont(font)
        self.lineEdit_Personnummer.setFont(font)
        self.pushButton_RitaOm.setFont(font)
        self.pushButton_Spara.setFont(font)


# groupBox Person
        self.groupBox_Person.setFont(fontBold)

        self.label_Person_ID.setFont(font)
        self.lineEdit_Person_ID.setFont(font)
        self.label_Person_Kön.setFont(font)
        self.lineEdit_Person_Kön.setFont(font)
        self.label_Person_Kategori.setFont(font)
        self.lineEdit_Person_Kategori.setFont(font)

        self.label_Förnamn.setFont(font)
        self.textEdit_Förnamn.setFont(font)

        self.label_Tilltal.setFont(font)
        self.textEdit_Tilltal.setFont(font)

        self.label_Efternamn.setFont(font)
        self.textEdit_Efternamn.setFont(font)



# groupBox Föräldrapar
        self.groupBox_Föräldrapar.setFont(fontBold)

        self.label_Föräldrapar_ID.setFont(font)
        self.lineEdit_Föräldrapar_ID.setFont(font)
        self.textEdit_Föräldrapar_Namn.setFont(font)



# groupBox Egna Par
        self.groupBox_Egna_Par.setFont(fontBold)
        self.pushButton_Upp.setFont(font)
        self.pushButton_Ned.setFont(font)
        self.tableWidget_Egna_Par.setFont(font)


# groupBox Bonusrelationer
        self.groupBox_Bonusrelationer.setFont(fontBold)
        self.textEdit_Bonusrelation_ID.setFont(font)
        self.textEdit_Bonusrelation_ID_2.setFont(font)



# groupBox Länkar
        self.groupBox_Länkar.setFont(fontBold)
        self.tableWidget_länkar.setFont(font)


# groupBox Anteckningar
        self.groupBox_Anteckningar.setFont(fontBold)
        self.textEdit_Anteckningar.setFont(font)

# groupBox Fler Källor
        self.groupBox_Fler_Källor.setFont(fontBold)
        self.textEdit_Fler_Källor.setFont(font)


# Längst ner till höger
        self.label_SenastSparat.setFont(font)
        self.lineEdit_SenastSparat.setFont(font)

# groupBox Född
# groupBox Död
        self.Händelse_född.sättHändelsestorlek(self.fontsize)
        self.Händelse_död.sättHändelsestorlek(self.fontsize)

        for each in [ self.Händelse_född, self.Händelse_död ]:

            each.groupBox_Händelse.setFont(fontBold)

#            each.groupBox_typ.setFont(fontBold)
            each.groupBox_datum.setFont(fontBold)
            each.groupBox_plats.setFont(fontBold)
            each.groupBox_källa.setFont(fontBold)

#            each.lineEdit_typ.setFont(font)
            each.label_dag.setFont(font)
            each.lineEdit_dag.setFont(font)
            each.label_månad.setFont(font)
            each.lineEdit_månad.setFont(font)
            each.label_år.setFont(font)
            each.lineEdit_år.setFont(font)
            each.label_gata.setFont(font)
            each.lineEdit_gata.setFont(font)
            each.label_by.setFont(font)
            each.lineEdit_by.setFont(font)
            each.label_kvarter.setFont(font)
            each.lineEdit_kvarter.setFont(font)
            each.label_socken.setFont(font)
            each.lineEdit_socken.setFont(font)
            each.label_församling.setFont(font)
            each.lineEdit_församling.setFont(font)
            each.label_disbytförsamling.setFont(font)
            each.lineEdit_disbytförsamling.setFont(font)
            each.label_stad.setFont(font)
            each.lineEdit_stad.setFont(font)
            each.label_härad.setFont(font)
            each.lineEdit_härad.setFont(font)
            each.label_län.setFont(font)
            each.lineEdit_län.setFont(font)
            each.label_utrikesplats.setFont(font)
            each.lineEdit_utrikesplats.setFont(font)
            each.textEdit_källa.setFont(font)

        self.ritaom() # Hämta data först och sätt storlekar sedan så får vi rätt antal rader i tabeller

        return
###################################################################################################




###################################################################################################
    def sijlayout(self):

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.scrollyta.verticalScrollBar().setFixedWidth(fh)

        self.tableWidget_Egna_Par.verticalScrollBar().setFixedWidth(fh)
        self.tableWidget_Egna_Par.horizontalScrollBar().setFixedHeight(fh)

        self.tableWidget_länkar.horizontalScrollBar().setFixedHeight(fh)

        self.textEdit_Bonusrelation_ID.verticalScrollBar().setFixedWidth(fh)
        self.textEdit_Bonusrelation_ID.horizontalScrollBar().setFixedHeight(fh)

        self.tableWidget_länkar.verticalScrollBar().setFixedWidth(fh)

        self.textEdit_Bonusrelation_ID_2.verticalScrollBar().setFixedWidth(fh)
        self.textEdit_Bonusrelation_ID_2.horizontalScrollBar().setFixedHeight(fh)

# Layout av rutan frame_top högst uppe till vänster

#        rad1top = 3+fh

        b1 = max([metrics.width(self.label_Databas.text()), metrics.width(self.label_Personnummer.text())])
        sparaBredd = fs + metrics.width(self.pushButton_RitaOm.text())

        self.label_Databas.setGeometry         (                                         2,                                          2,                               b1, fh )
        self.lineEdit_Databas.setGeometry      ( 1 + self.label_Databas.geometry().right(),                                          2,                          40 * fs, fh )
        self.label_Personnummer.setGeometry    (                                         2, 1 + self.label_Databas.geometry().bottom(),                               b1, fh )
        self.lineEdit_Personnummer.setGeometry ( 1 + self.label_Databas.geometry().right(),   self.label_Personnummer.geometry().top(), fs + metrics.width("00000000"), fh )

        pushButtonBredd1 = fs + max ( metrics.width(self.pushButton_RitaOm.text()), metrics.width(self.pushButton_Spara.text()) )
        pushButtonBredd2 = fs + metrics.width(self.pushButton_Databas.text())

        self.pushButton_RitaOm.setGeometry     (          2*fs+self.lineEdit_Personnummer.geometry().right(), self.label_Personnummer.geometry().top(), pushButtonBredd1,  fh )
        self.pushButton_Spara.setGeometry      (             2*fs +self.pushButton_RitaOm.geometry().right(), self.label_Personnummer.geometry().top(), pushButtonBredd1,  fh )
        self.pushButton_Databas.setGeometry    ( self.lineEdit_Databas.geometry().right() - pushButtonBredd2, self.label_Personnummer.geometry().top(), pushButtonBredd2,  fh )
# --------------------------------

# Layout av rutan 'groupBox Person

        b1 = max ([ metrics.width(self.label_Person_ID.text()), metrics.width(self.label_Förnamn.text()), metrics.width(self.label_Tilltal.text()), metrics.width(self.label_Efternamn.text()) ])

        self.label_Person_ID.setGeometry          (                                             2, fh,                                                   b1, fh )
        self.lineEdit_Person_ID.setGeometry       (                                            2 + b1, fh,                   fs + metrics.width("00000000"), fh )
        self.label_Person_Kön.setGeometry         (    2 + self.lineEdit_Person_ID.geometry().right(), fh,      metrics.width(self.label_Person_Kön.text()), fh )
        self.lineEdit_Person_Kön.setGeometry      (      2 + self.label_Person_Kön.geometry().right(), fh,                                             3*fs, fh )
        self.label_Person_Kategori.setGeometry    (   2 + self.lineEdit_Person_Kön.geometry().right(), fh, metrics.width(self.label_Person_Kategori.text()), fh )
        self.lineEdit_Person_Kategori.setGeometry ( 2 + self.label_Person_Kategori.geometry().right(), fh,                                             3*fs, fh )


        self.label_Förnamn.setGeometry      (      2, 1 + self.lineEdit_Person_ID.geometry().bottom(),    b1,   fh )
        self.textEdit_Förnamn.setGeometry   ( 2 + b1, 1 + self.lineEdit_Person_ID.geometry().bottom(), 30*fs, 3*fh )

        self.label_Tilltal.setGeometry      (      2,   1 + self.textEdit_Förnamn.geometry().bottom(),    b1,   fh )
        self.textEdit_Tilltal.setGeometry   ( 2 + b1,   1 + self.textEdit_Förnamn.geometry().bottom(), 30*fs, 3*fh )

        self.label_Efternamn.setGeometry    (      2,   1 + self.textEdit_Tilltal.geometry().bottom(),    b1,   fh )
        self.textEdit_Efternamn.setGeometry ( 2 + b1,   1 + self.textEdit_Tilltal.geometry().bottom(), 30*fs, 3*fh )


# Layout av rutan 'groupBox Föräldrapar

        b1 = max ([ metrics.width(self.label_Föräldrapar_ID.text()), 11*fs ])

        self.label_Föräldrapar_ID.setGeometry      ( 2,                                                fh, metrics.width(self.label_Föräldrapar_ID.text()), fh)
        self.lineEdit_Föräldrapar_ID.setGeometry   ( 2, 1 + self.label_Föräldrapar_ID.geometry().bottom(),                                           11*fs, fh)

        self.textEdit_Föräldrapar_Namn.setGeometry ( fs + self.label_Föräldrapar_ID.geometry().right(), fh, 30*fs, 2.5*fh)

# Layout av rutan 'groupBox Egna Par


        b1 = fs + max ([ metrics.width(self.pushButton_Upp.text()),metrics.width(self.pushButton_Ned.text()) ])
        self.pushButton_Upp.setGeometry ( 2,                                     2 * fh , b1,  fh )
        self.pushButton_Ned.setGeometry ( 2, 2 + self.pushButton_Upp.geometry().bottom(), b1,  fh )

        if self.tableWidget_Egna_Par.rowCount() > 1:
            self.pushButton_Upp.setVisible(True)
            self.pushButton_Ned.setVisible(True)
        else:
            self.pushButton_Upp.setVisible(False)
            self.pushButton_Ned.setVisible(False)


# radhöjd för alla rader
        for i in range (0, self.tableWidget_Egna_Par.rowCount()):
           self.tableWidget_Egna_Par.setRowHeight(i, fh)

# kolumnbredder
        self.tableWidget_Egna_Par.setColumnWidth(0, 11 * fs)
        self.tableWidget_Egna_Par.setColumnWidth(1, 9 * fs)
        self.tableWidget_Egna_Par.setColumnWidth(2, 14 * fs)
        self.tableWidget_Egna_Par.setColumnWidth(3, 9.5 * fs)

        s1=4
        i1=0
        while i1 <  self.tableWidget_Egna_Par.columnCount():
            s1 = s1 + self.tableWidget_Egna_Par.columnWidth(i1)
            i1=i1+1

        tableWidget_Egna_Par_Rect = self.tableWidget_Egna_Par.geometry()
        tableWidget_Egna_Par_Rect.setLeft( 3 + self.pushButton_Upp.geometry().right(),)
        tableWidget_Egna_Par_Rect.setTop(fh)
        tableWidget_Egna_Par_Rect.setWidth(s1)
        tableWidget_Egna_Par_Rect.setHeight( self.tableWidget_Egna_Par.rowViewportPosition( self.tableWidget_Egna_Par.rowCount()-1 ) + 2.5*fh + 6)
        self.tableWidget_Egna_Par.setGeometry(tableWidget_Egna_Par_Rect )

# Layout av rutan 'groupBox Bonusrelationer
        b1 =  2*fs + metrics.width("par00000000") + self.textEdit_Bonusrelation_ID.verticalScrollBar().width()
        self.textEdit_Bonusrelation_ID.setGeometry ( 2, fh, b1 , 4*fh )
        self.textEdit_Bonusrelation_ID_2.setGeometry (3+self.textEdit_Bonusrelation_ID.geometry().right(), fh, 31*fs , 4*fh )

# Layout av rutan 'groupBox Länkar
# radhöjd för alla rader
        for i in range (0, self.tableWidget_länkar.rowCount()):
           self.tableWidget_länkar.setRowHeight(i, fh)

# kolumnbredder
        self.tableWidget_länkar.setColumnWidth(0,  0)
        self.tableWidget_länkar.setColumnWidth(1, 20 * fs)
        self.tableWidget_länkar.setColumnWidth(2, 23 * fs)

        s1=4
        i1=0
        while i1 <  self.tableWidget_länkar.columnCount():
            s1 = s1 + self.tableWidget_länkar.columnWidth(i1)
            i1=i1+1

        tableWidget_länkar_Rect = self.tableWidget_länkar.geometry()
        tableWidget_länkar_Rect.setLeft( 2)
        tableWidget_länkar_Rect.setTop(fh)
        tableWidget_länkar_Rect.setWidth(s1)
        tableWidget_länkar_Rect.setHeight( self.tableWidget_länkar.rowViewportPosition( self.tableWidget_länkar.rowCount()-1 ) + 2.5*fh + 6)
        self.tableWidget_länkar.setGeometry(tableWidget_länkar_Rect )

# Layout av rutan 'groupBox Anteckningar
        self.textEdit_Anteckningar.setGeometry ( 2, fh, 43*fs , 6*fh )

# Layout av rutan 'groupBox Fler Källor
        self.textEdit_Fler_Källor.setGeometry( 2, fh, 43*fs , 6*fh )

# Layout av rutan 'groupBox Född
# Layout av rutan 'groupBox Död


        return
###################################################################################################

####################################################
##                                                ##
##   setGeometry ( int x, int y, int w, int h )   ##
##                                                ##
####################################################

#################################    ----------> X
##                             ##    |
##   resize ( int w, int h )   ##    |
##                             ##    |
#################################    V  y

###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret till tabellen

# windowlayout anropas endast som en fortsättning av sijlayout ovan
# inte någon annanstans ifrån..

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.frame_top.setGeometry                ( 2,                                                          2,   3 + self.lineEdit_Databas.geometry().right(),         4 + self.pushButton_RitaOm.geometry().bottom() )
        self.groupBox_Person.setGeometry          ( 2,                     2 + self.frame_top.geometry().bottom(), 3 + self.textEdit_Efternamn.geometry().right(),        3 + self.textEdit_Efternamn.geometry().bottom() )
        self.groupBox_Föräldrapar.setGeometry     ( 2,          2 + self.groupBox_Person.frameGeometry().bottom(),              self.frame_top.geometry().width(), 3 + self.textEdit_Föräldrapar_Namn.geometry().bottom() )
        self.groupBox_Egna_Par.setGeometry        ( 2,     2 + self.groupBox_Föräldrapar.frameGeometry().bottom(),              self.frame_top.geometry().width(),      3 + self.tableWidget_Egna_Par.geometry().bottom() )
        self.groupBox_Bonusrelationer.setGeometry ( 2,        2 + self.groupBox_Egna_Par.frameGeometry().bottom(),              self.frame_top.geometry().width(), 3 + self.textEdit_Bonusrelation_ID.geometry().bottom() )
        self.groupBox_Länkar.setGeometry          ( 2, 2 + self.groupBox_Bonusrelationer.frameGeometry().bottom(),              self.frame_top.geometry().width(),        3 + self.tableWidget_länkar.geometry().bottom() )
        self.groupBox_Anteckningar.setGeometry    ( 2,          2 + self.groupBox_Länkar.frameGeometry().bottom(),              self.frame_top.geometry().width(),     3 + self.textEdit_Anteckningar.geometry().bottom() )
        self.groupBox_Fler_Källor.setGeometry     ( 2,    2 + self.groupBox_Anteckningar.frameGeometry().bottom(),              self.frame_top.geometry().width(),      3 + self.textEdit_Fler_Källor.geometry().bottom() )

        self.Händelse_född.groupBox_Händelse.setGeometry (                         5 + self.frame_top.geometry().right(),                                                                 2, self.Händelse_född.groupBox_Händelse.geometry().width() , self.Händelse_född.groupBox_Händelse.geometry().height() )
        self.Händelse_död.groupBox_Händelse.setGeometry  (   self.Händelse_född.groupBox_Händelse.frameGeometry().left(), 2 + self.Händelse_född.groupBox_Händelse.frameGeometry().bottom(),   self.Händelse_död.groupBox_Händelse.geometry().width(),  self.Händelse_död.groupBox_Händelse.geometry().height() )

# Rutan 'Upplysningar'
        self.label_Upplysningar.resize (self.frame_top.geometry().right() - self.groupBox_Person.geometry().right() -2, self.groupBox_Person.geometry().height() - 4 )
        self.label_Upplysningar.move(self.groupBox_Person.geometry().right() + 2, self.groupBox_Person.geometry().top() + 4 )



# Längst ner till höger


        self.lineEdit_SenastSparat.resize( 17*fs, fh)
        self.label_SenastSparat.resize   ( 3 + metrics.width(self.label_SenastSparat.text()), fh)




# placering inom inneryta

        nettohojd  = 2 + max ([ self.groupBox_Fler_Källor.frameGeometry().bottom() ,  self.Händelse_död.groupBox_Händelse.frameGeometry().bottom() + 2 + fh  ]) # innehåller höjdutrymme=fh för SenastSparat
        nettobredd = 2 + self.Händelse_död.groupBox_Händelse.frameGeometry().right()


        self.lineEdit_SenastSparat.move (nettobredd - 2 - self.lineEdit_SenastSparat.geometry().width(),  nettohojd - 2 - fh)
        self.label_SenastSparat.move    ( self.lineEdit_SenastSparat.geometry().left() - self.label_SenastSparat.geometry().width(), self.lineEdit_SenastSparat.geometry().top() )



        self.inneryta.setGeometry( QtCore.QRect ( 5, 5, 2 + nettobredd, 2 + nettohojd ))
        self.scrollyta.setGeometry =  self.inneryta.geometry()
        self.ytteryta.setGeometry( QtCore.QRect ( 0, 0, 7 + nettobredd, 7 + nettohojd ))
        self.resize(QtCore.QSize(12 + nettobredd, 12 + nettohojd ))

        self.textEdit_Anteckningar.setFocus()

        return
###################################################################################################




###################################################################################################
# kopplingar till knappar i grafiska gränsytan
    def ui_connections(self):

        for each in [ self.Händelse_född, self.Händelse_död ]:

#            self.connect(each.lineEdit_typ,                  SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_dag,                   SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_månad,                 SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_år,                    SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_gata,                  SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_by,                    SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_kvarter,               SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_socken,                SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_församling,            SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_disbytförsamling,      SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_stad,                  SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_härad,                 SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_län,                   SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.lineEdit_utrikesplats,          SIGNAL("textEdited(QString)"), self.dirtybit_set )
            self.connect(each.textEdit_källa,                 SIGNAL("textChanged()"),       self.dirtybit_set )

#            self.connect(each.lineEdit_typ,                  SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_dag,                   SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_månad,                 SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_år,                    SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_gata,                  SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_by,                    SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_kvarter,               SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_socken,                SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_församling,            SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_disbytförsamling,      SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_stad,                  SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_härad,                 SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_län,                   SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.lineEdit_utrikesplats,          SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each.textEdit_källa,                 SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )

#            self.connect(each.lineEdit_typ,                  SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_dag,                   SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_månad,                 SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_år,                    SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_gata,                  SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_by,                    SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_kvarter,               SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_socken,                SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_församling,            SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_disbytförsamling,      SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_stad,                  SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_härad,                 SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_län,                   SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.lineEdit_utrikesplats,          SIGNAL("CtrlMinusPressed"), self.fontsizedown )
            self.connect(each.textEdit_källa,                 SIGNAL("CtrlMinusPressed"), self.fontsizedown )

#            self.connect(each.lineEdit_typ,                  SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_dag,                   SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_månad,                 SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_år,                    SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_gata,                  SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_by,                    SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_kvarter,               SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_socken,                SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_församling,            SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_disbytförsamling,      SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_stad,                  SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_härad,                 SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_län,                   SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_utrikesplats,          SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.textEdit_källa,                 SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )


        self.connect ( self.lineEdit_Databas,             SIGNAL("CtrlPlusPressed"),     self.fontsizeup   )
        self.connect ( self.lineEdit_Databas,             SIGNAL("CtrlMinusPressed"),    self.fontsizedown )
        self.connect ( self.lineEdit_Databas,             SIGNAL("Ctrl_S_Pressed"),      self.sparaknapp   )

        self.connect ( self.lineEdit_Personnummer,        SIGNAL("CtrlPlusPressed"),     self.fontsizeup   )
        self.connect ( self.lineEdit_Personnummer,        SIGNAL("CtrlMinusPressed"),    self.fontsizedown )
        self.connect ( self.lineEdit_Personnummer,        SIGNAL("Ctrl_S_Pressed"),      self.sparaknapp   )

        self.connect ( self.tableWidget_Egna_Par,         SIGNAL("CtrlPlusPressed"),     self.fontsizeup   )
        self.connect ( self.tableWidget_Egna_Par,         SIGNAL("CtrlMinusPressed"),    self.fontsizedown )
        self.connect ( self.tableWidget_Egna_Par,         SIGNAL("Ctrl_S_Pressed"),      self.sparaknapp   )

        self.connect ( self.textEdit_Bonusrelation_ID,    SIGNAL("CtrlPlusPressed"),     self.fontsizeup   )
        self.connect ( self.textEdit_Bonusrelation_ID,    SIGNAL("CtrlMinusPressed"),    self.fontsizedown )
        self.connect ( self.textEdit_Bonusrelation_ID,    SIGNAL("Ctrl_S_Pressed"),      self.sparaknapp   )

        self.connect ( self.tableWidget_länkar,           SIGNAL("CtrlPlusPressed"),     self.fontsizeup   )
        self.connect ( self.tableWidget_länkar,           SIGNAL("CtrlMinusPressed"),    self.fontsizedown )
        self.connect ( self.tableWidget_länkar,           SIGNAL("Ctrl_S_Pressed"),      self.sparaknapp   )

        self.connect ( self.textEdit_Anteckningar,        SIGNAL("CtrlPlusPressed"),     self.fontsizeup   )
        self.connect ( self.textEdit_Anteckningar,        SIGNAL("CtrlMinusPressed"),    self.fontsizedown )
        self.connect ( self.textEdit_Anteckningar,        SIGNAL("Ctrl_S_Pressed"),      self.sparaknapp   )

        self.connect ( self.textEdit_Fler_Källor,         SIGNAL("CtrlPlusPressed"),     self.fontsizeup   )
        self.connect ( self.textEdit_Fler_Källor,         SIGNAL("CtrlMinusPressed"),    self.fontsizedown )
        self.connect ( self.textEdit_Fler_Källor,         SIGNAL("Ctrl_S_Pressed"),      self.sparaknapp   )


        self.connect ( self.lineEdit_Person_ID,           SIGNAL("textEdited(QString)"), self.dirtybit_set )
        self.connect ( self.lineEdit_Föräldrapar_ID,      SIGNAL("textEdited(QString)"), self.dirtybit_set )
        self.connect ( self.textEdit_Bonusrelation_ID,    SIGNAL("textChanged()"),       self.dirtybit_set )
        self.connect ( self.lineEdit_Person_Kön,          SIGNAL("textEdited(QString)"), self.dirtybit_set )
        self.connect ( self.lineEdit_Person_Kategori,     SIGNAL("textEdited(QString)"), self.dirtybit_set )
        self.connect ( self.textEdit_Förnamn,             SIGNAL("textChanged()"),       self.dirtybit_set )
        self.connect ( self.textEdit_Tilltal,             SIGNAL("textChanged()"),       self.dirtybit_set )
        self.connect ( self.textEdit_Efternamn,           SIGNAL("textChanged()"),       self.dirtybit_set )


        self.connect ( self.textEdit_Fler_Källor,             SIGNAL("textChanged()"),        self.dirtybit_set )
        self.connect ( self.textEdit_Anteckningar,            SIGNAL("textChanged()"),        self.dirtybit_set )

        self.connect ( self.pushButton_Upp,                   SIGNAL("clicked()"),            self.uppknapp     )
        self.connect ( self.pushButton_Ned,                   SIGNAL("clicked()"),            self.nedknapp     )

        self.connect ( self.pushButton_Spara,                 SIGNAL("clicked()"),            self.sparaknapp   )
        self.connect ( self.pushButton_RitaOm,                SIGNAL("clicked()"),            self.ritaomknapp  )
        self.connect ( self.lineEdit_Personnummer,            SIGNAL("returnPressed()"),      self.ritaomknapp  )

        self.connect ( self.tableWidget_länkar,           SIGNAL("cellClicked(int,int)"), self.lankarknapp)

###################################################################################################
