#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# inh.py

# Senast ändrad: 2011-02-24  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




###########################################################################
#    Programmet anropas från kommandorad                                  #
#    Den grafiska gränssytan behöver inte synas                           #
#    Men! - Jag använder QTableWidget ur det grafiska paketet             #
#    för att sortera data i de olika sorteringsordningarna.               #
#                                                                         #
#    För en fullständig uppsättning innehållsförteckningar krävs att      #
#    programmet anropas tre gånger, med respektive optioner               #
#    " --sortering efternamn", " --sortering förnamn" eller ingendera av  #
#    dem.                                                                 #
#                                                                         #
#    Vid sortering på förnamn eller efternamn skapas listor där personer  #
#    med flera förnamn eller flera efternamn införs på motsvarande        #
#    flera ställen.                                                       #
#                                                                         #
#    Utan angiven sortering skapas en grupp av listor, sorterade efter    #
#    resp.databasnummer, födelsedatum, dödsdatum, födelseförsamling,      #
#    dödsförsamling, födelsedag, kategorimarkering.                       #
#                                                                         #
###########################################################################




############################################################################
import sys
import os
import datetime
import time
import shutil
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from optparse import OptionParser
from gui_inh import gui_Innehåll

from johangemensamt import allmänt
from johanklasser import johanpersonfil
###########################################################################




###########################################################################
class Innehåll(QtGui.QMainWindow, gui_Innehåll):

    SenastÄndrad = '2011-02-24 07:10:00'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'inh_py3_'
    loggfilopen = False

    fontsize = 9
    användaruppgifter = {}
    databas = ""

    htmlkatalog = ""
    justnu = ""
    sorteringstyp = ""

    inifilnamn = ''

    KatA_antal = 0
    KatB_antal = 0
    KatC_antal = 0
    Kat1_antal = 0
    KatZ_antal = 0
    KatPgodk_antal = 0
    KatPspärr_antal = 0
    KatPobest_antal = 0
    KatÖvriga_antal = 0

    inhsida_author = ""
    inhsida_KeyWords = ""

    inhsida_banner = ""
    inhsida_description = ""

    inifilnamn = ''
    inifiltext = ''
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    options = {}
    args = []

    färgschema = '0'     # '0' = Standard, '1' = Master, '2' = Compare
    färgschemabakgrund = QColor()

    f_option = ""
    i_option = ""
    s_option = ""

    KolNr = { "person_ID"         :  0,
              "sorteringsnamn"    :  1,
              "allaförnamn"       :  2,
              "allaefternamn"     :  3,
              "person_kategori"   :  4,
              "född_år"           :  5,
              "född_månad"        :  6,
              "född_dag"          :  7,
              "född_församling"   :  8,
              "DISBYT_född"       :  9,
              "död_år"            : 10,
              "död_månad"         : 11,
              "död_dag"           : 12,
              "död_församling"    : 13,
              "DISBYT_död"        : 14,
              "ålder_år"          : 15,
              "PUL"               : 16,
              "ålder_dagar"       : 17
              }

############################################################################




######################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-s", "--sortering", dest="sorteringstyp", help="Sortering på e[fternamn] eller f[örnamn]")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder =  os.path.join( os.environ['APPDATA'], 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass

        self.setupUi(self)

        self.inledning()
        self.ritaom()

        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()


# Öppna inte avbrotten för ändringar i inmatningsfälten förrän de fyllts första gången!
        self.ui_connections()

        self.logga ("\nFärdig - stäng fönstret !\n")

######################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Inh_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




##### Stöd för tänkta olika val i menyrutan  ################################################################

    def tabellrutaklick(self,r,c):
        return

    def tabellrutadubbelklick(self,r,c):
        return
#############################################################################################################




######################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        if len(self.args) != 1 : # Jag förväntar mig exakt ett argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt ett argument i anropet: Databasadress. Jag avbryter här.\n ")
            self.avsluta(1)

        self.databas = str(self.args[0])
        self.lineEdit_Databas.setText(self.databas)

        self.sorteringstyp = str(self.options.sorteringstyp)
#        self.logga('sorteringstyp: "' + self.sorteringstyp  + '"\n' )

        if self.sorteringstyp  == "None":
#            self.logga ("Startar generering av flera sorterade innehållsförteckningar för databas " + self.databas + '\n' )
            self.setWindowTitle ('Personlista för flera sorterade innehållsförteckningar för databas   ' + self.databas)

        elif self.sorteringstyp[0].lower() == "e":
#            self.logga ("Startar generering av efternamnssorterad innehållsförteckning för databas " + self.databas + '\n' )
            self.setWindowTitle ('Personlista för efternamnssorterad innehållsförteckning för databas   ' + self.databas)

        elif self.sorteringstyp[0].lower() == "f":
#            self.logga ("Startar generering av förnamnssorterad innehållsförteckning för databas " + self.databas + '\n' )
            self.setWindowTitle ('Personlista för förnamnssorterad innehållsförteckning för databas   ' + self.databas)

        else:
            self.logga ('Jag känner inte igen sorteringstyp "' + self.sorteringstyp  + '"\n' )
            exit (1)
# Nu kan vi hämta information i förvalda och den eventuella extra INIfilen.
#--------------------------------------------------------------------------------------------
        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)

        avbryt = False

        self.htmlkatalog = os.path.join(self.databas, "html")

        if os.path.exists(self.databas) == True:
            if os.path.isdir(self.databas):
                pass
#                self.logga ("Tillverkar innehållsförteckningar för " + self.databas + ".\n" )

            else:
                msg = self.databas + " är inte en katalog.\nAVBRYTER"
                reply = QtGui.QMessageBox.critical(self, "OBS!",   msg,  "OK")
                self.avsluta(1)
        else:
            msg =  "Jag hittar inte databasen \n" + self.databas + ".\nAVBRYTER"
            reply = QtGui.QMessageBox.critical(self, "OBS!",   msg,  "OK")
            self.avsluta(1)


        if  os.path.exists(self.htmlkatalog) == False:
            os.mkdir(self.htmlkatalog)
        if not os.path.isdir(self.htmlkatalog):
            msg = self.htmlkatalog + " är inte en katalog.\nAVBRYTER"
            reply = QtGui.QMessageBox.critical(self, "OBS!",   msg,  "OK")
            self.avsluta(1)

        self.justnu = time.localtime(time.time())

        self.användaruppgifter = allmänt.hämtaanvändaruppgifter(allmänt(), self.inifilnamn).copy()

#        printmsg = "inh.py: användaruppgifter - "
#        printmsg = printmsg + self.användaruppgifter['DIS_medlemsnummer']
#        printmsg = printmsg + ' ' + self.användaruppgifter['namn']
#        printmsg = printmsg + ' ' + self.användaruppgifter['epost']
#        printmsg = printmsg + ' ' + self.användaruppgifter['www']
#        print (printmsg)

# Dessa texter borde hämtas från en ini-fil --------------------
        self.inhsida_author = self.användaruppgifter["namn"]
        self.inhsida_KeyWords = "släktforskning, genealogi, genealogy"

        self.inhsida_banner = "johanbanner.jpg"
        self.inhsida_description = ""
#---------------------------------------------------------------

        return
###################################################################################################




###################################################################################################
    def ritaom (self):

        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allmänt.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allmänt.Vertikalfaktor * metrics.height()


# --- Preparerar tabell ---
        self.KatA_antal = 0
        self.KatB_antal = 0
        self.KatC_antal = 0
        self.Kat1_antal = 0
        self.KatZ_antal = 0
        self.KatPgodk_antal = 0
        self.KatPspärr_antal = 0
        self.KatÖvriga_antal = 0
        self.KatPobest_antal = 0

# läs sistanummer-filerna
        senastepersonfilnamn = os.path.join(self.databas, "senaste", "senasteperson.txt")
        senastepersonfil = open( senastepersonfilnamn, "r", encoding="utf-8" )
        senasteperson=senastepersonfil.readline().strip()    # tag bort ev newline och annan whitespace
        senastepersonfil.close()
        self.lineEdit_Senasteperson.setText(senasteperson)

# --- Tömmer och nollställer eventuell gammal tabell ---
        self.tableWidget_Personlista.clearContents()
        self.tableWidget_Personlista.setRowCount(0)
        self.tableWidget_Personlista.setSortingEnabled(False) # måste vara False medan man fyller i data. Ändra till True sedan.

        Person1 = johanpersonfil()
###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###
        antalpersoner = 0
        aktuelltpersonnummer = 0
        gransantalpersoner = int(senasteperson)
#-#-# Använd begränsning under programinkörning #-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#
#        gransantalpersoner = 20
#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#
        while (antalpersoner < gransantalpersoner) and (aktuelltpersonnummer < int(senasteperson)):
            aktuelltpersonnummer = aktuelltpersonnummer + 1
            aktuellperson_ID = str(aktuelltpersonnummer).zfill(8)
            filnamn = os.path.join(self.databas, "data", aktuellperson_ID[:5], aktuellperson_ID + ".xml")
            if os.path.exists(filnamn):
                allmänt.hämtapersonfil ( allmänt(), filnamn, Person1 )  # Läs alla personer - en i taget

                self.fyllnästarad ( Person1, fh )
                antalpersoner = antalpersoner + 1
        self.logga ("Listade " + str(antalpersoner) + " personer med person_ID upp till " + str(aktuelltpersonnummer).zfill(8) + (".\n"))
###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###



#  Nu är tabellen färdigifylld
        self.logga ("Visar tabellen.\n")

# skriv statistik

        self.lineEdit_Databas.setText  ( self.databas )
        self.lineEdit_Antalpersoner.setText(str(antalpersoner))

        self.lineEdit_KatA.setText     ( str(self.KatA_antal) )
        self.lineEdit_KatB.setText     ( str(self.KatB_antal) )
        self.lineEdit_KatC.setText     ( str(self.KatC_antal) )
        self.lineEdit_Kat1.setText     ( str(self.Kat1_antal) )
        self.lineEdit_KatZ.setText     ( str(self.KatZ_antal) )
        self.lineEdit_KatPgodk.setText ( str(self.KatPgodk_antal) )
        self.lineEdit_KatPspärr.setText( str(self.KatPspärr_antal) )
        self.lineEdit_KatÖvriga.setText( str(self.KatÖvriga_antal) )
        self.lineEdit_KatPobest.setText( str(self.KatPobest_antal) )

        self.skapautfiler()

        self.tableWidget_Personlista.setCurrentCell(0,0)         # annars står man sist i tabellen när man skapat färdigt - inte vackert.
        self.tableWidget_Personlista.setSortingEnabled(True)     # sorterar på klickad kolumn, varannangång neråt, varannan gång uppåt.
        self.tableWidget_Personlista.resizeColumnsToContents()

        return

#### end def ritaom ####################################################################




###################################################################################################
    def skapautfiler(self):

        if self.sorteringstyp.lower() == "e":    # efternamnssorterad innehållsförteckning
            self.logga ("Sorterar på efternamn\n")
            self.innehåll_efternamn()
#            self.logga("Sparade sorterad innehållsförteckning på\n" + self.htmlkatalog + "\n")

        elif self.sorteringstyp.lower() == "f":    # förnamnssorterad innehållsförteckning
            self.logga ("Sorterar på förnamn\n")
            self.innehåll_förnamn()
#            self.logga("Sparade sorterad innehållsförteckning på\n" + self.htmlkatalog + "\n")

        else: # övriga innehållsförteckningar
            self.innehåll_föddatum()
            self.innehåll_födförsamling()
            self.innehåll_döddatum()
            self.innehåll_dödförsamling()
            self.innehåll_ålder()
            self.innehåll_dbnummer()

#            self.innehåll_föddag()# Tag bort kommenteringen för att få födelsedagslista
#            self.innehåll_kategori()# Tag bort kommenteringen för att få en lista sorterad på kategorimarkeringar
#            self.innehåll_PUL()# Tag bort kommenteringen för att få en lista sorterad på PUL-villkor

#            self.logga("Sparade sorterade innehållsförteckningar på\n" + self.htmlkatalog + "\n")

        return
###################################################################################################




###################################################################################################
    def innehåll_PUL(self):

        inhfilnamn =  os.path.join(self.htmlkatalog, "inhPUL.html")
        inhfiltitel = "Innehållsförteckning sorterad på PUL-villkoren"
        self.tableWidget_Personlista.sortItems(14,Qt.SortOrder(Qt.DescendingOrder))
        checkkolumn=0
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev PUL-villkorssorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
    def innehåll_kategori(self):

        inhfilnamn =  os.path.join(self.htmlkatalog, "inhkategori.html")
        inhfiltitel = "Innehållsförteckning sorterad på  kategorimarkering"
        self.tableWidget_Personlista.sortItems(4,Qt.SortOrder(Qt.DescendingOrder))
        checkkolumn=0
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev kategorisorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
    def innehåll_dbnummer(self):

        inhfilnamn =  os.path.join(self.htmlkatalog, "inhdbnummer.html")
        inhfiltitel = "Innehållsförteckning sorterad på databasnummer"
        self.tableWidget_Personlista.sortItems(0,Qt.SortOrder(Qt.AscendingOrder))
        checkkolumn=0
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ( "Skrev databasnummersorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
    def innehåll_föddag(self):

        inhfilnamn =  os.path.join(self.htmlkatalog, "inhföddag.html")
        inhfiltitel = "Innehållsförteckning sorterad på födelsedag"
        self.tableWidget_Personlista.sortItems(5,Qt.SortOrder(Qt.AscendingOrder)) # Födelse -år
        self.tableWidget_Personlista.sortItems(7,Qt.SortOrder(Qt.AscendingOrder)) # Födelse -dag
        self.tableWidget_Personlista.sortItems(6,Qt.SortOrder(Qt.AscendingOrder)) # Födelse -månad
        checkkolumn=5
        self.skrivFödelsedagHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev födelsedagssorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
    def innehåll_föddatum(self):

        inhfilnamn = os.path.join(self.htmlkatalog, "inhföddatum.html")
        inhfiltitel = "Innehållsförteckning sorterad på födelsedatum"
        self.tableWidget_Personlista.sortItems(7,Qt.SortOrder(Qt.AscendingOrder)) # Födelse -dag
        self.tableWidget_Personlista.sortItems(6,Qt.SortOrder(Qt.AscendingOrder)) # Födelse -månad
        self.tableWidget_Personlista.sortItems(5,Qt.SortOrder(Qt.AscendingOrder)) # Födelse -år
        checkkolumn=5
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev födelsedatumssorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
    def innehåll_födförsamling(self):

        inhfilnamn = os.path.join(self.htmlkatalog, "inhfödförs.html")
        inhfiltitel = "Innehållsförteckning sorterad på födelseförsamling"
        self.tableWidget_Personlista.sortItems(8,Qt.SortOrder(Qt.AscendingOrder)) # Födelse -församling
        checkkolumn=8
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev födelseförsamlingssorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
    def innehåll_döddatum(self):

        inhfilnamn =  os.path.join(self.htmlkatalog, "inhdöddatum.html")
        inhfiltitel = "Innehållsförteckning sorterad på dödsdatum"
        self.tableWidget_Personlista.sortItems(11,Qt.SortOrder(Qt.AscendingOrder)) # Död -dag
        self.tableWidget_Personlista.sortItems(10,Qt.SortOrder(Qt.AscendingOrder)) # Död -månad
        self.tableWidget_Personlista.sortItems(9,Qt.SortOrder(Qt.AscendingOrder))  # Död -år
        checkkolumn=9
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev dödsdatumsorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
    def innehåll_dödförsamling(self):

        inhfilnamn = os.path.join(self.htmlkatalog, "inhdödförs.html")
        inhfiltitel = "Innehållsförteckning sorterad på dödförsamling"
        self.tableWidget_Personlista.sortItems(12,Qt.SortOrder(Qt.AscendingOrder)) # Död -församling
        checkkolumn=12
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev dödförsamlingssorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
    def innehåll_ålder(self):

        inhfilnamn = os.path.join(self.htmlkatalog, "inhålder.html")
        inhfiltitel = "Innehållsförteckning sorterad på uppnådd ålder"
        self.tableWidget_Personlista.sortItems(15,Qt.SortOrder(Qt.DescendingOrder)) # Uppnådd ålder
        checkkolumn=13
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev ålderssorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
###################################################################################################
    def innehåll_efternamn(self):

        inhfilnamn =  os.path.join(self.databas, "html", "inhefternamn.html")
        inhfiltitel = "Innehållsförteckning sorterad på efternamn"
        self.tableWidget_Personlista.sortItems(1,Qt.SortOrder(Qt.AscendingOrder))
        checkkolumn=1
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev efternamnssorterad innehållsförteckning " + inhfilnamn + "\n")

###################################################################################################
###################################################################################################
    def innehåll_förnamn(self):

        inhfilnamn =  os.path.join(self.databas, "html", "inhförnamn.html")
        inhfiltitel = "Innehållsförteckning sorterad på förnamn"
        self.tableWidget_Personlista.sortItems(1,Qt.SortOrder(Qt.AscendingOrder))
        checkkolumn=1
        self.skrivInnehållHTML(inhfilnamn, inhfiltitel, checkkolumn)
        self.logga ("Skrev förnamnssorterad innehållsförteckning " + inhfilnamn + "\n")

########################################################################################
    def skrivInnehållHTML(self, filnamn, titel, checkkolumn):

        utfil = open(filnamn, "w", encoding='utf-8')

        utfil.write( '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n' )
        utfil.write( '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="sv" lang="sv">\n' )

        utfil.write( '<head>\n' )
        utfil.write( '    <meta http-equiv="content-type" content="text/html; charset=utf-8" />\n' )

        utfil.write( '    <meta name="author" content="')
        utfil.write( self.inhsida_author )
        utfil.write( '" />\n' )

        utfil.write( '    <meta name="generator" content="johan" /> \n' )
        utfil.write( '\n' )

        utfil.write( '    <meta name="KeyWords" content="' )
        utfil.write( self.inhsida_KeyWords )
        utfil.write( '" />\n' )

        utfil.write( '    <meta name="description" content="' )
        utfil.write( self.inhsida_description )
        utfil.write( '" />\n' )


        utfil.write( '\n' )

        utfil.write( '    <title>' )
        utfil.write( titel )
        utfil.write( '</title>\n' )

        utfil.write( '\n' )

        utfil.write( '    <link rel="SHORTCUT ICON" href="johan.ico" />\n' )
        utfil.write( '    <link type="text/css" href="johan.css" rel="stylesheet" />\n' )
        utfil.write( '    <link type="text/css" href="johaninh.css" rel="stylesheet" />\n' )

        utfil.write( '</head>\n' )

        utfil.write( '<body>\n' )

        utfil.write( '<img style="margin: 0px;" alt="" src="')
        utfil.write( self.inhsida_banner )
        utfil.write( '" />\n' )

        utfil.write( '<p style="margin-left: 5px; margin-top: 5px;">\n' )

        utfil.write( '<a href="../start.html">Ny startsida</a>\n' )

        utfil.write( '</p>\n' )


        utfil.write( '<h3>' )
        utfil.write( titel )
        utfil.write( '</h3>\n' )


        utfil.write( '<table style="text-align: left; width: 100%;" border="1" cellpadding="3" cellspacing="0">\n' )

        utfil.write( '<thead>\n' )
        utfil.write( '<tr>\n' )
        utfil.write( '<td><strong>' + 'person-ID'         + '</strong></td>\n' )
#        utfil.write( '<td><strong>' + 'sorteringsnamn'           + '</strong></td>\n' ) # ta bort efter inkörning
        utfil.write( '<td><strong>' + 'förnamn'           + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'efternamn'         + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'födelsedatum'      + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'födelseförsamling' + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'döddatum'          + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'dödförsamling'     + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'uppnådd ålder'     + '</strong></td>\n' )
        utfil.write( '</tr>\n' )
        utfil.write( '</thead>\n' )

        utfil.write( '<tbody>\n' )

        for row in range (0, self.tableWidget_Personlista.rowCount() ):
            self.tableWidget_Personlista.setCurrentCell(row,checkkolumn)
            text = self.tableWidget_Personlista.currentItem().text().strip()
            if text=="":
                continue


            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["person_ID"] )
            personnr = self.tableWidget_Personlista.currentItem().text().strip()
            utfil.write( '<tr>\n' )

            utfil.write( '<td><a href="../php/personsida.php?person=' + personnr + '" target="_blank">' + personnr + '</a></td>\n')

            utfil.write( '<td>' ) # förnamn
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["allaförnamn"] )
            text = self.tableWidget_Personlista.currentItem().text().strip()
            self.skrivutrad(utfil, text)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # efternamn
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["allaefternamn"] )
            text = self.tableWidget_Personlista.currentItem().text().strip()
            self.skrivutrad(utfil, text)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # födelsedatum
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["född_år"] )
            text5 = self.tableWidget_Personlista.currentItem().text().strip()
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["född_månad"] )
            text6 = self.tableWidget_Personlista.currentItem().text().strip()
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["född_dag"] )
            text7 = self.tableWidget_Personlista.currentItem().text().strip()

            if text5 != "":
                text = text5
            else:
                text = "&nbsp;&nbsp;&nbsp;&nbsp;"

            if text6 != "" or text7 != "" :

                if text6 == "":
                     text = text + ",  , "
                elif  text6.isdigit:
                    text= text + "-" + text6
                else:
                    text = text + ", "+ text6

                if text7 == "":
                     pass
                elif text7.isdigit:
                    text= text + "-" + text7
                else:
                    text = text + ", "+ text7

            self.skrivutrad(utfil, text)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # födelseförsamling
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["född_församling"])
            text = self.tableWidget_Personlista.currentItem().text().strip()
            self.skrivutrad(utfil, text)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # döddatum
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["död_år"])
            text9 = self.tableWidget_Personlista.currentItem().text().strip()
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["död_månad"])
            text10 = self.tableWidget_Personlista.currentItem().text().strip()
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["död_dag"])
            text11 = self.tableWidget_Personlista.currentItem().text().strip()

            if text9 != "":
                text = text9
            else:
                text = "&nbsp;&nbsp;&nbsp;&nbsp;"

            if text10 != "" or text11 != "" :

                if text10 == "":
                     text = text + ",  , "
                elif text10.isdigit:
                    text= text + "-" + text10
                else:
                    text = text + ", "+ text10


                if text11 == "":
                     pass
                elif text11.isdigit:
                    text= text + "-" + text11
                else:
                    text = text + ", "+ text11

            self.skrivutrad(utfil, text)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # dödförsamling
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["död_församling"])
            text = self.tableWidget_Personlista.currentItem().text().strip()
            self.skrivutrad(utfil, text)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # uppnådd ålder
            self.tableWidget_Personlista.setCurrentCell(row,  self.KolNr["ålder_år"])
            text = self.tableWidget_Personlista.currentItem().text().strip()
            self.skrivutrad(utfil, text)
            utfil.write( '</td>\n' )

            utfil.write( '</tr>\n' )

        utfil.write( '</tbody>\n' )
        utfil.write( '</table>\n' )
        utfil.write( '<br />\n')
        utfil.write( '<hr />\n' )
        utfil.write( '<p class="notis">Senast ändrad ' )
        utfil.write(  time.strftime("%Y-%m-%d",self.justnu)  )
        utfil.write( '</p>\n' )
        utfil.write( '<hr />\n' )
        utfil.write( '<center><img src="sidfot.gif" alt="" /></center>\n' )
        utfil.write( '</body>\n' )
        utfil.write( '</html>\n' )

        utfil.close()
########################################################################################################




########################################################################################
    def skrivFödelsedagHTML(self, filnamn, titel, checkkolumn):

        justnuår    = time.strftime("%Y",self.justnu)
        justnumånad = time.strftime("%m",self.justnu)
        justnudag   = time.strftime("%d",self.justnu)

        utfil = open(filnamn, "w", encoding='utf-8')

        utfil.write( '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n' )
        utfil.write( '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="sv" lang="sv">\n' )

        utfil.write( '<head>\n' )
        utfil.write( '    <meta http-equiv="content-type" content="text/html; charset=utf-8" />\n' )

        utfil.write( '    <meta name="author" content="')
        utfil.write( self.inhsida_author )
        utfil.write( '" />\n' )

        utfil.write( '    <meta name="generator" content="johan" /> \n' )
        utfil.write( '\n' )

        utfil.write( '    <meta name="KeyWords" content="' )
        utfil.write( self.inhsida_KeyWords )
        utfil.write( '" />\n' )

        utfil.write( '    <meta name="description" content="' )
        utfil.write( self.inhsida_description )
        utfil.write( '" />\n' )


        utfil.write( '\n' )

        utfil.write( '    <title>' )
        utfil.write( titel )
        utfil.write( '</title>\n' )

        utfil.write( '\n' )

        utfil.write( '    <link rel="SHORTCUT ICON" href="johan.ico" />\n' )
        utfil.write( '    <link type="text/css" href="johan.css" rel="stylesheet" />\n' )
        utfil.write( '    <link type="text/css" href="johaninh.css" rel="stylesheet" />\n' )

        utfil.write( '</head>\n' )

        utfil.write( '<body>\n' )

        utfil.write( '<img style="margin: 0px;" alt="" src="')
        utfil.write( self.inhsida_banner )
        utfil.write( '" />\n' )

        utfil.write( '<p style="margin-left: 5px; margin-top: 5px;">\n' )

        utfil.write( '<a href="../start.html">Ny startsida</a>\n' )

        utfil.write( '</p>\n' )


        utfil.write( '<h3>' )
        utfil.write( titel )
        utfil.write( '</h3>\n' )


        utfil.write( '<table style="text-align: left; width: 100%;" border="1" cellpadding="3" cellspacing="0">\n' )

        utfil.write( '<thead>\n' )
        utfil.write( '<tr>\n' )
        utfil.write( '<td><strong>' + 'person-ID'         + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'förnamn'           + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'efternamn'         + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'födelsedag'        + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'födelseförsamling' + '</strong></td>\n' )
        utfil.write( '<td><strong>' + 'fyller nästa gång' + '</strong></td>\n' )
        utfil.write( '</tr>\n' )
        utfil.write( '</thead>\n' )

        utfil.write( '<tbody>\n' )

        for row in range (0, self.tableWidget_Personlista.rowCount() ):
            self.tableWidget_Personlista.setCurrentCell(row,checkkolumn)
            text = self.tableWidget_Personlista.currentItem().text()
            if text=="":
                continue

            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["allaförnamn"])   # förnamn
            förnamn = self.tableWidget_Personlista.currentItem().text()

            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["allaefternamn"])   # efternamn
            efternamn = self.tableWidget_Personlista.currentItem().text()

            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["född_år"])   # född år

            text5 = self.tableWidget_Personlista.currentItem().text()
            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["född_månad"])   # född månad
            text6 = self.tableWidget_Personlista.currentItem().text()
            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["född_dag"])   # född dag
            text7 = self.tableWidget_Personlista.currentItem().text()

            if text5=="" or text6=="" or text7=="":  # gå förbi om jag saknar någon del av födelsedatum
                continue

            if text5.isdigit() == False:
                continue        # gå förbi om jag inte kan hantera årtalsangivelsen

            föddag = int(text7)
            föddmånad = int(text6)
            föddår = int(text5)
            nudag = int(justnudag)
            numånad = int(justnumånad)
            nuår = int(justnuår)

            if föddag > nudag:
                numånad = numånad -1
            if föddmånad > numånad:
                nuår = nuår - 1
            nastaarsdag = str(nuår - föddår +1 )

            if nuår - föddår > 105:
                continue   # gå förbi om orimligt gammal

            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["född_församling"])
            fodelseförsamling = self.tableWidget_Personlista.currentItem().text()

            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["död_år"])  # död år
            text9 = self.tableWidget_Personlista.currentItem().text()       
            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["död_månad"]) # död månad
            text10 = self.tableWidget_Personlista.currentItem().text()
            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["död_dag"]) # död dag
            text11 = self.tableWidget_Personlista.currentItem().text()
            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["död_församling"]) # död församling
            text12 = self.tableWidget_Personlista.currentItem().text()

            if text9 != "" or text10 != "" or text11 != ""  or text12 != "" : # gå förbi om något indikerar avliden person
                continue

# Nu, efter alla kontroller ovan, ska vi skriva en komplett rad i tabellen

            self.tableWidget_Personlista.setCurrentCell(row, self.KolNr["person_ID"])
            personnr = self.tableWidget_Personlista.currentItem().text()
            utfil.write( '<tr>\n' )


            utfil.write( '<td><a href="../php/personsida.php?person=' + personnr + '" target="_blank">' + personnr + '</a></td>\n')

            utfil.write( '<td>' ) # förnamn
            self.skrivutrad(utfil, förnamn)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # efternamn
            self.skrivutrad(utfil, efternamn)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # födelsedatum

            if text5 != "":
                text = text5
            else:
                text = "&nbsp;&nbsp;&nbsp;&nbsp;"

            if text6 != "" or text7 != "" :

                if text6 == "":
                     text = text + ",  , "
                elif  str(text6).isdigit:
                    text= text + "-" + text6
                else:
                    text = text + ", "+ text6

                if text7 == "":
                     pass
                elif  str(text7).isdigit:
                    text= text + "-" + text7
                else:
                    text = text + ", "+ text7

            self.skrivutrad(utfil, text)
            utfil.write( '</td>\n' )

            utfil.write( '<td>' ) # födelseförsamling
            self.skrivutrad(utfil, fodelseförsamling )
            utfil.write( '</td>\n' )


            utfil.write( '<td>' ) # fyller nästa gång
            self.skrivutrad(utfil, nastaarsdag )  #  beräknat ovan utgående från födelsedatum och self.justnu.
            utfil.write( '</td>\n' )

            utfil.write( '</tr>\n' )

        utfil.write( '</tbody>\n' )
        utfil.write( '</table>\n' )
        utfil.write( '<br />\n')
        utfil.write( '<hr />\n' )
        utfil.write( '<p class="notis">\nSenast ändrad ' )
        utfil.write(  time.strftime("%Y-%m-%d",self.justnu)  )
        utfil.write( '\n</p>\n' )
        utfil.write( '<hr />\n' )
        utfil.write( '<center><img src="sidfot.gif" alt="" /></center>\n' )
        utfil.write( '</body>\n' )
        utfil.write( '</html>\n' )

        utfil.close()
########################################################################################################




########################################################################################################
    def skrivutrad(self, utfil, radtext):
        if radtext == "":
            utfil.write('&nbsp;')
        else:
            utfil.write(radtext)
##################################################################################################




########################################################################################################
    def fyllnästarad(self, person, radhojd):

        if self.sorteringstyp == "None":        # övriga listor
            self.adderaenrad( person,  "", radhojd)

        elif self.sorteringstyp.lower() == "e":      # efternamnssorterad lista
            efternamnen =  person.allaefternamn.split(" ")
            for sorteringsnamn in efternamnen:
                if sorteringsnamn != "":
                    self.adderaenrad( person,  sorteringsnamn, radhojd)

        elif self.sorteringstyp.lower() == "f":      # förnamnssorterad lista
            förnamnen =  person.allaförnamn.split(" ")
            for sorteringsnamn in förnamnen:
                if sorteringsnamn != "":
                    self.adderaenrad( person,  sorteringsnamn, radhojd)
########################################################################################################




########################################################################################################
    def adderaenrad(self, person, sorteringsnamn, radhojd):
        row = self.tableWidget_Personlista.rowCount()
        self.tableWidget_Personlista.insertRow(row)

        self.tableWidget_Personlista.setItem(row, self.KolNr["person_ID"]       , QtGui.QTableWidgetItem( person.person_ID              ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["sorteringsnamn"]  , QtGui.QTableWidgetItem( sorteringsnamn                ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["allaförnamn"]     , QtGui.QTableWidgetItem( person.allaförnamn            ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["allaefternamn"]   , QtGui.QTableWidgetItem( person.allaefternamn          ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["person_kategori"] , QtGui.QTableWidgetItem( person.person_kategori        ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["född_år"]         , QtGui.QTableWidgetItem( person.född_år                ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["född_månad"]      , QtGui.QTableWidgetItem( person.född_månad             ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["född_dag"]        , QtGui.QTableWidgetItem( person.född_dag               ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["född_församling"] , QtGui.QTableWidgetItem( person.född_församling        ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["DISBYT_född"]     , QtGui.QTableWidgetItem( person.född_disbytförsamling  ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["död_år"]          , QtGui.QTableWidgetItem( person.död_år                 ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["död_månad"]       , QtGui.QTableWidgetItem( person.död_månad              ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["död_dag"]         , QtGui.QTableWidgetItem( person.död_dag                ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["död_församling"]  , QtGui.QTableWidgetItem( person.död_församling         ))
        self.tableWidget_Personlista.setItem(row, self.KolNr["DISBYT_död"]      , QtGui.QTableWidgetItem( person.död_disbytförsamling   ))

        self.tableWidget_Personlista.setRowHeight(row, radhojd)


        ålder_år, ålder_dagar= allmänt.personålder(allmänt(), person)

        ålderitem = QtGui.QTableWidgetItem( ålder_år )
        ålderitem.setTextAlignment(Qt.Alignment(Qt.AlignHCenter))
        self.tableWidget_Personlista.setItem(row, self.KolNr["ålder_år"], ålderitem)


        ålderitem = QtGui.QTableWidgetItem( ålder_dagar )
        ålderitem.setTextAlignment(Qt.Alignment(Qt.AlignHCenter))
        self.tableWidget_Personlista.setItem(row, self.KolNr["ålder_dagar"], ålderitem)

        svar = self.personkategoriraknare ( person )
        svaritem =  QtGui.QTableWidgetItem( svar )
        svaritem.setTextAlignment(Qt.Alignment(Qt.AlignHCenter))
        self.tableWidget_Personlista.setItem(row, self.KolNr["PUL"], svaritem)

        return
########################################################################################################




#############################################################################################################
    def personkategoriraknare( self, person ):

        person_ID = person.person_ID
        kategori = person.person_kategori
        född_år = person.född_år
        död_år = person.död_år
        svar = ""

        if kategori == "A":                                     # explicit spärrade
            self.KatA_antal = self.KatA_antal + 1
        elif kategori == "1":                                   # EXPLICIT GODKÄNDA
            self.Kat1_antal = self.Kat1_antal + 1
        elif kategori == "B":                                   # PUL-kollas tills vidare
            self.KatB_antal = self.KatB_antal + 1
        elif kategori == "C":                                   # spärras tills vidare
            self.KatC_antal = self.KatC_antal + 1
        elif kategori == "":                                    # PUL-kollas
            self.KatZ_antal = self.KatZ_antal + 1
        else:  # om okänd/felstavad kategori                    # PUL-kollas
            self.KatÖvriga_antal = self.KatÖvriga_antal + 1


        if not (kategori == "A" or kategori == "1" or kategori == "C" ):   # PUL är irrelevant
            if allmänt.KategoriPgodk( allmänt(), person):
                self.KatPgodk_antal = self.KatPgodk_antal + 1
                svar = "godk"
            else:
                self.KatPspärr_antal = self.KatPspärr_antal + 1
                svar = "spärr"
                if (person.allaförnamn != "") or (person.allaefternamn != "") and ( (född_år == "") and (död_år == "") ) :
                    self.KatPobest_antal = self.KatPobest_antal + 1
                    svar = "obest"

        return svar
###################################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn,'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Inh_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

# logga till textruta i programfönster
        self.textEdit_logg.insertPlainText(txt )
        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)

        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Inh_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################
###################################################################################################




################################################################################
# Här  startar  programmet
app = QtGui.QApplication(sys.argv)
winWebblista = Innehåll()
winWebblista.show()
sys.exit(app.exec_())
################################################################################
