#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# FÖR PYTHON v3

# johan.py

# Senast ändrad: 2011-03-02  - Uppdateras automatiskt. Ändra inte manuellt.



#############################################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#############################################################################################




#############################################################################################
# De två johanversionerna för Python 2 resp. Python 3 kan inte, av misstag eller med avsikt,
# köras med fel huvudversion av Python.
#
#
# I johan_py2 ingår bl.a. strängar med unicode-markör
# som syntaxkontrollen i Python 3 omedelbart säger till om.
# T.ex.:
"""
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help=u"Läs INI-data från INIfilnamn")
                                                                    ^
SyntaxError: invalid syntax
"""
#
#
#
# I johan_py3 ingår bl.a. identifierare med svenska tecken
# som syntaxkontrollen i Python 2 omedelbart säger till om.
# T.ex.:
"""
from johangemensamt import allmänt
                               ^
SyntaxError: invalid syntax
"""
#
#############################################################################################




#############################################################################################
import sys
import os
import datetime, time
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from optparse import OptionParser
from gui_johan import *

from johangemensamt import allmänt
from johanklasser import johanpersonfil, johanparfil
#############################################################################################




#############################################################################################
class Johan(QtGui.QMainWindow, gui_Johan):

    SenastÄndrad = '2011-02-22 08:42:27'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'johan_py3_'
    loggfilopen = False

    fontsize = 9

    alla_knapptext = []
    alla_kommando = []

    options = {}
    args = []

    inifilnamn = ''
    inifiltext = ''
    programkatalog = ''
    projektkatalog = ''


    i_option = ''

    jämförlistaadress =""

#############################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]", version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        # Denna pekare till INI-fil skickas vidare från program till program som startas av varandra inom johangruppen.
        print ("self.i_option " + str (self.i_option ))

        # Skalfaktorer för grafiken hämtas innan man startar grafikrutinerna
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize



        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder =  os.path.join( os.environ['APPDATA'], 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], "johanloggar" )
            except:
                pass


        self.setupUi(self)
        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]
        self.projektkatalog = os.path.split( os.path.abspath( self.programkatalog ) )[0]
        self.skapaStatiskMeny()
        self.inledning()
        self.ritaom()








        self.ui_connections()   # signaler i gui till slots i gui
        self.setupmeraUi()      # signaler i gui till slots i johan.py

        self.enableUi()

        self.kollalås() # Kolla om det finns aktiva låsfiler

        return
#############################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Johan_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




#############################################################################################
    def setupmeraUi(self):

        self.lineEdit_Personnamn.setEnabled(False)

        self.connect(self.lineEdit_Databas,      SIGNAL("returnPressed()"), self.ändradatabas)
        self.connect(self.lineEdit_Personnummer, SIGNAL("returnPressed()"), self.ändradatabas_person)
        self.connect(self.lineEdit_Parnummer,    SIGNAL("returnPressed()"), self.ändradatabas_par)

        self.connect(self.pushButton_Ättlingar,  SIGNAL("clicked()"), self.visaättlingarknapp)
        self.connect(self.pushButton_Anor,       SIGNAL("clicked()"), self.visaanorknapp)
        self.connect(self.pushButton_Personblad, SIGNAL("clicked()"), self.editerapersonbladknapp)
        self.connect(self.pushButton_Parblad,    SIGNAL("clicked()"), self.editeraparbladknapp)

        self.connect(self.pushButton_Databas,    SIGNAL('clicked()'), self.showDialogDatabas)
#############################################################################################




#############################################################################################
    def inledning(self):

# Python-tuple sys.version_info har olika format i Python 2 resp Python 3. Användes inte här.

# Python-strängen sys.version inleds med en angivelse av Python-version på samma format i Python 2 och Python 3.
        pythonversion = sys.version.split(" ")[0] # t.ex. pythonversion = '3.1.2'      # (en teckensträng)
        pythonvers = pythonversion.split(".")     # t.ex. pythonvers = ['3', '1', '2'] # (tre teckensträngar, en siffra i varje)

        program        = sys.argv[0]
        programväg     = os.path.abspath(    sys.argv[0] )
        programnamn    = os.path.split( os.path.abspath( sys.argv[0] ) )[1]
        arbetskatalog  = os.getcwd()

        sysplatform = sys.platform
        sysversion = sys.version.replace('\n', ' ')
        sysexecutable = sys.executable

        sparafont =  self.textEdit_logg.currentFont()
        self.textEdit_logg.setFontFamily ("Monospace")
        self.textEdit_logg.setReadOnly(True)

        dt = datetime.datetime.today()
        self.logga ("****************  Johan -- startsida -- " + str(dt.strftime("%Y-%m-%d  %H:%M:%S")) + "  ****************\n")
        self.logga ("Johan,  version:  Johan_py3\n")
        self.logga ("Python, version:  " + sysversion    + "\n")
        self.logga ("Python, sökväg:   " + sysexecutable + "\n")
        self.logga ("sys.platform:     " + sysplatform   + "\n")

        if sysplatform != "linux2" and sysplatform != "win32":
            msg = 'Jag känner till sys.platform "linux2" och "win32" men inte "' + sysplatform + '". \nJag AVBRYTER!'
            reply = QtGui.QMessageBox.critical(self, 'Johan: tvärstopp', msg, 'OK')
            sys.exit()

        self.logga ("program:          " + program             + "\n")  # program:          /home/ingemar/PIGAN/slkt/program/johan_py3/source/johan.py
        self.logga ("källtextkatalog:  " + self.programkatalog + "\n")  # källtextkatalog:  /home/ingemar/PIGAN/slkt/program/johan_py3/source
        self.logga ("projektkatalog:   " + self.projektkatalog + "\n")  # projektkatalog:   /home/ingemar/PIGAN/slkt/program/johan_py3
        self.logga ("programnamn:      " + programnamn         + "\n")  # programnamn:      johan.py


        if  sysplatform == "win32":
            try:
                self.logga ("APPDATA:          " + os.environ['APPDATA'] + "\n" )
            except:
                pass

        if  sysplatform == "linux2":
            try:
                self.logga ("HOME:             " + os.environ['HOME'] + "\n" )
            except:
                pass

        self.logga ("INI-fil:          " + self.inifilnamn + "\n")

        if self.loggfilfolder != "":
            self.logga ("loggfiler:        " + self.loggfilfolder + "\n"  )
            self.textEdit_logg.setCurrentFont (sparafont)
        else:
            self.textEdit_logg.setCurrentFont (sparafont)
            self.logga ("Jag hittar ingenstans att spara loggfiler" + "\n\n" )


        if len(self.args) != 0 : # Jag förväntar mig noll argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt noll argument i anropet. Jag avbryter här.\n ")
            self.avsluta(1)

        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)
# nu finns värden som ska gälla i  allmant.PYTON/EDITOR/FILHANTERARE/ORDBEHANDLARE

        self.skapaLokalMeny(self.inifiltext)

        return
###################################################################################################




###################################################################################################
    def kollalås(self):  # Kolla Lås för databaser i INI-fil!
        i=0
        while i <  self.tableWidget_Startpunkter.rowCount():

            self.tableWidget_Startpunkter.setCurrentCell(i,1)
            db = self.tableWidget_Startpunkter.currentItem().text()
            redanhittad = False
            j=0
            while j < i:
                self.tableWidget_Startpunkter.setCurrentCell(j,1)
                if db == self.tableWidget_Startpunkter.currentItem().text():
                    redanhittad = True
                    break
                j = j+1
            if not redanhittad:
                self.kollalåsdb(db)
            i = i+1

# återställ vald rad till första raden
        if self.tableWidget_Startpunkter.rowCount() > 0:
            self.tableWidget_Startpunkter.selectRow(0)

        return
###################################################################################################




###################################################################################################
    def kollalåsdb(self, db):  # Kolla lås för databasen
        if not  os.path.exists(db):
            return

        if not os.path.exists(os.path.join(db, "senaste")):
            msg =  "Databasen   " + db + " saknar katalogen \n" + os.path.join(db, "senaste")
            msg = msg + "\nDatabasen måste repareras med denna katalog och två filer"
            msg = msg + "\n(senasteperson.txt och senastepar.txt, se dokumentationen)"
            msg = msg + "\n innan den får användas!"
            msg = msg + "\nAVBRYTER HÄR !"
            reply = QtGui.QMessageBox.critical(self, 'Johan: tvärstopp', msg, 'AVBRYT NU')
            sys.exit()








        return
###################################################################################################




###################################################################################################
    def showDialogDatabas(self):
        sijDialog = QtGui.QFileDialog()
        databas = sijDialog.getExistingDirectory(self, "Välj johan-databas", self.lineEdit_Databas.text(), QFileDialog.ShowDirsOnly)
        self.lineEdit_Databas.setText(databas)
        return
###################################################################################################




###################################################################################################
    def ritaom (self):
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()
        return
###################################################################################################




###################################################################################################
    def skapaLokalMeny (self, inifiltext):

        if inifiltext != '':

# Ur ini-fil, adresslista för databasjämförelser
            self.jämförlistaadress = allmänt.hittaparam(allmänt(), inifiltext, 'jämförelselista')   # , 0, len(inifiltext) )

# Ur ini-fil, skapa tabell: Databaser
            self.databastabell(inifiltext)

# Ur ini-fil, hitta huvudmenyer för externa program
            externamenyer = self.externahuvudmenyer(inifiltext)


            self.alla_knapptext[:] = []
            self.alla_kommando[:] = []

# Skapa ytterligare huvudmenyer dynamiskt
            for meny in externamenyer:

                self.mnu = QtGui.QMenu(self.menuBar)
                self.mnu.setObjectName("menu_" + meny)
                self.mnu.setTitle(meny)
                self.menuBar.addAction(self.mnu.menuAction())

                externmeny_knapptext = []
                externmeny_kommando = []

# Ur ini-fil, hitta undermenyer för externa program
                externmeny_knapptext, externmeny_kommando  = self.externundermeny(meny, inifiltext)
                self.alla_knapptext = self.alla_knapptext +  externmeny_knapptext
                self.alla_kommando = self.alla_kommando + externmeny_kommando

# Skapa tillhörande undermenyer dynamiskt
                for i in range(0, len(externmeny_knapptext)):

                    self.mmenu = QtGui.QAction(self)
                    self.mmenu.setObjectName("action_" + externmeny_knapptext[i] )
                    self.mmenu.setText(externmeny_knapptext[i])
                    self.mnu.addAction(self.mmenu)
                    self.connect(self.mmenu, QtCore.SIGNAL("triggered()"), self.starta_externt_program)

        return
#############################################################################################




#############################################################################################
    def starta_externt_program(self):

        vemtext = self.sender().text()

        i = self.alla_knapptext.index(vemtext)
#        self.logga ("Startar externt program nr. " + str(i) +  ":   " + vemtext + '\n')

        kommandon = self.alla_kommando[i].split('\n')
        for kommando in kommandon:
            QtCore.QProcess().startDetached(kommando )

        return
#############################################################################################




#############################################################################################
    def externahuvudmenyer(self, inifiltext):
        maxlen = len(inifiltext)
        område_start, område_end = allmänt.hittaområde(allmänt(), inifiltext, "lokala_menyer", 0 , maxlen)
        externamenyer = allmänt.hittamultiparam(allmänt(), inifiltext, "meny", område_start, område_end).split("\n")

        return externamenyer
#############################################################################################




#############################################################################################
    def externundermeny(self, meny, inifiltext):
        maxlen = len(inifiltext)
        undermeny_knapptext = []
        undermeny_kommando = []
        område1_start, område1_end = allmänt.hittaområde(allmänt(), inifiltext, meny,  0 , maxlen)

        while område1_start < område1_end:
            område2_start, område2_end = allmänt.hittaområde(allmänt(), inifiltext, "program",  område1_start, område1_end)
            if område2_start == 0:
                break
            knapptext = allmänt.hittaparam(allmänt(), inifiltext, "menyrad", område2_start, område2_end)
            kommando = allmänt.hittamultiparam(allmänt(), inifiltext, "kommando", område2_start, område2_end)
            område1_start = område2_end + 11
            undermeny_knapptext.append(knapptext)
            undermeny_kommando.append(kommando)

        return undermeny_knapptext, undermeny_kommando
#############################################################################################




#############################################################################################
    def databastabell(self, inifiltext):

# --- Preparerar tabell ---
        self.tableWidget_Startpunkter.clear()
        self.tableWidget_Startpunkter.setRowCount(0)
        self.tableWidget_Startpunkter.setColumnCount(len(self.Startpunkterkolumnbredder))

        iniPerson = johanpersonfil()

# Obs! innehållet i inifil är individuellt gjort för viss installation:
#    linux/windows, aktuella databaser, aktuella externa program, användarpreferenser, mm.

        hittat_1 = False
        hittat_2 = False
        maxlen = len(inifiltext)

        område_start, område_end = allmänt.hittaområde(allmänt(), inifiltext, "databas", 0 , maxlen)
        while område_start>0 and område_end>område_start:

            tidigareperson = ''
            tidigarepar = ''

            tidigaredatabas = allmänt.hittaparam(allmänt(), inifiltext, "adress", område_start, område_end)
            tidigareperson  = allmänt.hittaparam(allmänt(), inifiltext, "person", område_start, område_end)
            tidigarepar     = allmänt.hittaparam(allmänt(), inifiltext, "par",    område_start, område_end)

            tidigarepersonfilnamn = os.path.join (tidigaredatabas, "data", tidigareperson[0:5], tidigareperson + ".xml")

            if not os.path.exists(tidigarepersonfilnamn): # angiven person finns inte i databasen
                tidigareperson = ''
                tidigarepar = ''
                if os.path.exists(tidigaredatabas):
                    pers_nr=1
                    while pers_nr < 1100: # hitta första bästa person i databasen, men leta inte för långt
                        tidigareperson = (str(pers_nr)).zfill(8)
                        tidigarepersonfilnamn = os.path.join (tidigaredatabas, "data", tidigareperson[0:5], tidigareperson + ".xml")
                        if os.path.exists( tidigarepersonfilnamn ):
    #                        self.logga ("HITTADE FÖRSTA BÄSTA PERSON I DATABASEN\n")
                            break
                        else:
                            pass
                        pers_nr = pers_nr +1

            if os.path.exists(tidigarepersonfilnamn):
                allmänt.hämtapersonfil(allmänt(), tidigarepersonfilnamn, iniPerson)
                tidigarepersonnamn =  iniPerson.kortnamn

                tidigareparfilnamn = os.path.join (tidigaredatabas, "data", tidigarepar[0:8],    tidigarepar    + ".xml")
                if not os.path.exists(tidigareparfilnamn):
                    tidigarepar = ''

                if tidigarepar == '':
                    tidigareparen = iniPerson.egna_par_ID.split("\n") # hämta noll, ett eller flera par för den person vi nu har.
                    for tidigarepar in tidigareparen:
                        tidigareparfilnamn = os.path.join (tidigaredatabas, "data", tidigarepar[0:8],    tidigarepar    + ".xml")
                        if os.path.exists(tidigareparfilnamn):
                            break

# --------------------------------------------------------------------------
                row = self.tableWidget_Startpunkter.rowCount()
                self.tableWidget_Startpunkter.insertRow(row)
                self.tableWidget_Startpunkter.setItem(row, 1, QtGui.QTableWidgetItem(tidigaredatabas))
                self.tableWidget_Startpunkter.item(row, 1).setToolTip(tidigaredatabas)
                self.tableWidget_Startpunkter.setItem(row, 2, QtGui.QTableWidgetItem(tidigareperson))

                if os.path.exists(tidigarepersonfilnamn):
                    self.tableWidget_Startpunkter.setItem(row, 3, QtGui.QTableWidgetItem(tidigarepersonnamn))
                    self.tableWidget_Startpunkter.item(row, 3).setToolTip( iniPerson.allaförnamn + " " +  iniPerson.allaefternamnmedant)

                    if not hittat_1: # Lägg upp först hittade av databaser i INI-filen som förvald
                        hittat_1 = True
                        self.lineEdit_Databas.setText(tidigaredatabas)
                        self.lineEdit_Personnummer.setText(tidigareperson)
                        self.lineEdit_Personnamn.setText(tidigarepersonnamn)


                else:
                    self.tableWidget_Startpunkter.setItem(row, 3, QtGui.QTableWidgetItem("personfilen är inte åtkomlig"))

                if os.path.exists(tidigareparfilnamn):
                    self.tableWidget_Startpunkter.setItem(row, 4, QtGui.QTableWidgetItem(tidigarepar))
                else:
                    tidigarepar = ''
                    self.tableWidget_Startpunkter.setItem(row, 4, QtGui.QTableWidgetItem(""))

                if hittat_1 and not hittat_2:
                    hittat_2 = True
                    self.lineEdit_Parnummer.setText(tidigarepar)


            else: # if not os.path.exists(tidigarepersonfilnamn)
                if not os.path.exists(tidigaredatabas):
                    row = self.tableWidget_Startpunkter.rowCount()
                    self.tableWidget_Startpunkter.insertRow(row)
                    self.tableWidget_Startpunkter.setItem(row, 1, QtGui.QTableWidgetItem(tidigaredatabas))
                    self.tableWidget_Startpunkter.item(row, 1).setToolTip(tidigaredatabas)
                    self.tableWidget_Startpunkter.setItem(row, 3, QtGui.QTableWidgetItem("databasen är inte åtkomlig"))


            område_start, område_end =  allmänt.hittaområde(allmänt(), inifiltext, "databas", område_end , maxlen)
        #end while

        return
#############################################################################################




#############################################################################################
    def visaanorknapp(self):
        msg = allmänt.validera(allmänt(), self.lineEdit_Personnummer.text(), self.lineEdit_Databas.text())
        if msg == True:
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + '   "' + self.lineEdit_Databas.text() + '"   ' +  self.lineEdit_Personnummer.text()
            QtCore.QProcess().startDetached(kommando)
        else:
            QtGui.QMessageBox.information(self, 'Johan: okänd person', msg, 'OK')

#############################################################################################
    def visaättlingarknapp(self):
        msg = allmänt.validera(allmänt(), self.lineEdit_Personnummer.text(), self.lineEdit_Databas.text())
        if msg == True:
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + '   "' + self.lineEdit_Databas.text() + '"   ' + self.lineEdit_Personnummer.text()
            QtCore.QProcess().startDetached(kommando )
        else:
            QtGui.QMessageBox.information(self, 'Johan: okänd person', msg, 'OK')

#############################################################################################
    def editerapersonbladknapp(self):
        msg = allmänt.validera(allmänt(), self.lineEdit_Personnummer.text(), self.lineEdit_Databas.text())
        if msg == True:
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + '   "' + self.lineEdit_Databas.text() + '"   ' + self.lineEdit_Personnummer.text()
            QtCore.QProcess().startDetached(kommando )
        else:
            QtGui.QMessageBox.information(self, 'Johan: okänd person', msg, 'OK')

#############################################################################################
    def editeraparbladknapp(self):
        msg = allmänt.validerapar(allmänt(), self.lineEdit_Parnummer.text(), self.lineEdit_Databas.text())
        if msg == True:
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'parblad.py') + '"   ' + self.i_option + '   "' + self.lineEdit_Databas.text() + '"   ' + self.lineEdit_Parnummer.text()
            QtCore.QProcess().startDetached(kommando )
        else:
            QtGui.QMessageBox.information(self, 'Johan: okänt par', msg, 'OK')

#############################################################################################




#############################################################################################
    def väljdatabas(self):
#        Välj databas ur tabell med i förväg inskrivna databaser

        aktuellrad = self.tableWidget_Startpunkter.currentRow()

        self.tableWidget_Startpunkter.setCurrentCell(aktuellrad,1)
        databaskatalog = self.tableWidget_Startpunkter.currentItem().text()

        self.tableWidget_Startpunkter.setCurrentCell(aktuellrad,2)
        aktuelltpersonnummer = self.tableWidget_Startpunkter.currentItem().text()

        self.tableWidget_Startpunkter.setCurrentCell(aktuellrad,3)
        aktuelltpersonnamn = self.tableWidget_Startpunkter.currentItem().text()

        self.tableWidget_Startpunkter.setCurrentCell(aktuellrad,4)
        try:
            aktuelltparnummer = self.tableWidget_Startpunkter.currentItem().text()
        except:
            aktuelltparnummer = ""

        if allmänt.validera(allmänt(), aktuelltpersonnummer, databaskatalog) == True\
            and allmänt.validerapar(allmänt(), aktuelltparnummer,databaskatalog) == True:
            self.lineEdit_Databas.setText(databaskatalog)
            self.lineEdit_Personnummer.setText(aktuelltpersonnummer)
            self.lineEdit_Personnamn.setText(aktuelltpersonnamn)
            self.lineEdit_Personnamn.setToolTip(self.tableWidget_Startpunkter.currentItem().toolTip())
            self.lineEdit_Parnummer.setText(aktuelltparnummer)
        else:
            self.lineEdit_Databas.setText("")
            self.lineEdit_Personnummer.setText("")
            self.lineEdit_Personnamn.setText("")
            self.lineEdit_Personnamn.setToolTip("")
#############################################################################################




#############################################################################################
    def ändradatabas(self):
        databas = self.lineEdit_Databas.text()

        self.lineEdit_Personnummer.setText("")
        self.lineEdit_Personnummer.setToolTip("")

        self.lineEdit_Personnamn.setText("")
        self.lineEdit_Personnamn.setToolTip("")

        self.lineEdit_Parnummer.setText("")
        self.lineEdit_Parnummer.setToolTip("")

# hitta första personen i databasen
        senastefil = open( os.path.join(databas, "senaste", "senasteperson.txt") , "r")
        senasteperson=senastefil.readline().strip()       # tag bort ev newline och annan whitespace
        senastefil.close()

        for i in range (1, int(senasteperson) + 1 ):
            personnummer =  str(i).zfill(8)

            personfilnamn = os.path.join( databas, "data",  personnummer[0:5],  personnummer + ".xml")

            if os.path.exists(personfilnamn):
                self.lineEdit_Personnummer.setText(personnummer)
                person2=johanpersonfil()
                allmänt.hämtapersonfil(allmänt(), personfilnamn, person2)
                self.lineEdit_Personnamn.setText(person2.kortnamn)
                self.lineEdit_Personnamn.setToolTip( person2.allaförnamn + " " +  person2.allaefternamnmedant)
                if person2.egna_par_ID != "":
                    parnummer = person2.egna_par_ID.split("\n")[0]
                    self.lineEdit_Parnummer.setText(parnummer)
                    self.lineEdit_Parnummer.setToolTip(person2.egna_par_ID.replace("\n",", "))

                break
#############################################################################################




#############################################################################################
    def ändradatabas_person(self):
        databas = self.lineEdit_Databas.text()
        personnummer =  self.lineEdit_Personnummer.text()

        self.lineEdit_Personnummer.setText("")
        self.lineEdit_Personnummer.setToolTip("")

        self.lineEdit_Personnamn.setText("")
        self.lineEdit_Personnamn.setToolTip("")

        self.lineEdit_Parnummer.setText("")
        self.lineEdit_Parnummer.setToolTip("")

# hitta personen i databasen
        personfilnamn = os.path.join( databas, "data", personnummer[0:5], personnummer + ".xml")
        if os.path.exists(personfilnamn):
            self.lineEdit_Personnummer.setText(personnummer)
            person2=johanpersonfil()
            allmänt.hämtapersonfil(allmänt(), personfilnamn, person2)
            self.lineEdit_Personnamn.setText(person2.kortnamn)
            self.lineEdit_Personnamn.setToolTip( person2.allaförnamn + " " +  person2.allaefternamnmedant)
            if person2.egna_par_ID != "":
                parnummer = person2.egna_par_ID.split("\n")[0]
                self.lineEdit_Parnummer.setText(parnummer)
                self.lineEdit_Parnummer.setToolTip(person2.egna_par_ID.replace("\n",", "))
#############################################################################################




#############################################################################################
    def ändradatabas_par(self):
        databas = self.lineEdit_Databas.text()
        parnummer =  self.lineEdit_Parnummer.text()

        self.lineEdit_Personnummer.setText("")
        self.lineEdit_Personnummer.setToolTip("")

        self.lineEdit_Personnamn.setText("")
        self.lineEdit_Personnamn.setToolTip("")

        self.lineEdit_Parnummer.setText("")
        self.lineEdit_Parnummer.setToolTip("")

# hitta paret i databasen
        parfilnamn = os.path.join( databas, "data", parnummer[0:8], parnummer + ".xml")
        if os.path.exists(parfilnamn):
            self.lineEdit_Parnummer.setText(parnummer)

            par2 = johanparfil()
            allmänt.hämtaparfil(allmänt(), parfilnamn, par2)
            self.lineEdit_Personnummer.setText(par2.person1_ID)
            self.lineEdit_Personnamn.setText("person1: "+ par2.person1_ID + ", person2: "+ par2.person2_ID)
#############################################################################################




# ¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤ Här börjar Meny "Arkiv"
#############################################################################################
    def NydatabasAct (self):

        databaserkatalog = os.path.split( os.path.abspath( self.lineEdit_Databas.text() ) )[0]
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'nydatabas.py') + '"   ' + self.i_option + '   "' + databaserkatalog + '"'
        QtCore.QProcess().startDetached(kommando )
        return
#############################################################################################
# ¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤ Här slutar Meny "Arkiv"




# ¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤ Här börjarar Meny "Hjälp"
#############################################################################################
    def OmJohanAct (self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'omjohan')
        QtCore.QProcess().startDetached(kommando )
        return
#############################################################################################
#############################################################################################
    def OmGPL_txtAct (self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'copying.py')
        QtCore.QProcess().startDetached(kommando )
        return
#############################################################################################
#############################################################################################
    def OmGPL_wwwAct (self):
        import webbrowser
        webbrowser.open("http://www.gnu.org/licenses/gpl-3.0.html")
        return
#############################################################################################
#############################################################################################
    def OmPythonAct(self):
        import webbrowser
        webbrowser.open("http://www.python.org/download/releases/3.1.1/license/")
        return
#############################################################################################
#############################################################################################
    def OmPyQt4Act(self):
        import webbrowser
        webbrowser.open("http://www.riverbankcomputing.co.uk/software/pyqt/license/")
        return
#############################################################################################
#############################################################################################
    def OmQtAct (self):
        import webbrowser
        webbrowser.open("http://qt.nokia.com/products/licensing/")
        #http://qt.nokia.com/products/licensing/licensing#qt-gnu-gpl-v
        return
#############################################################################################
#############################################################################################
    def InstallationAct(self):
        import webbrowser
        webbrowser.open("http://www.sijohansson.com/program/johan/beskrivning/installation.html")
        return
#############################################################################################
#############################################################################################
    def ProgramAct(self):
        import webbrowser
        webbrowser.open("http://www.sijohansson.com/program/johan/beskrivning/program.html")
        return
#############################################################################################
#############################################################################################
    def DatabasAct(self):
        import webbrowser
        webbrowser.open("http://www.sijohansson.com/program/johan/beskrivning/databas.html")
        return
#############################################################################################
# ¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤ Här slutar Meny "Hjälp"



# ¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤ Här börjar Meny "Åtgärder"
#############################################################################################
    def VisaPersonlistaAct(self):
        databaskatalog = self.lineEdit_Databas.text()
        if  os.path.exists ( databaskatalog ):
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personlista.py') + '"   ' + self.i_option + '   "' + databaskatalog + '"'
            QtCore.QProcess().startDetached(kommando )
        else:
            self.HittarInte(databaskatalog)
        return
#############################################################################################
    def VisaParlistaAct(self):
        databaskatalog = self.lineEdit_Databas.text()
        if  os.path.exists ( databaskatalog ):
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'parlista.py') + '"   ' + self.i_option + '   "' + databaskatalog + '"'
            QtCore.QProcess().startDetached(kommando )
        else:
            self.HittarInte(databaskatalog)
        return
#############################################################################################
    def SkapaInnehållsFörteckningarAct(self):
        databaskatalog = self.lineEdit_Databas.text()
        if  os.path.exists ( databaskatalog ):
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"   -s F   ' + self.i_option + '   "' + databaskatalog + '"'  # skapa innehållsförteckning sorterad på förnamn (ett eller flera per person)
            QtCore.QProcess().startDetached(kommando)
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"   -s E   ' + self.i_option + '   "' + databaskatalog + '"'  # skapa innehållsförteckning sorterad på efternamn (ett eller flera per person)
            QtCore.QProcess().startDetached(kommando)
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"   '        + self.i_option + '   "' + databaskatalog + '"'  # skapa övriga innehållsförteckningar
            QtCore.QProcess().startDetached(kommando)
        else:
            self.HittarInte(databaskatalog)
        return
#############################################################################################
    def JämförDatabaserAct (self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'jämföra.py') + '"   ' + self.i_option + '   "' + self.jämförlistaadress + '"'
        QtCore.QProcess().startDetached(kommando )
        return
#############################################################################################
    def KontrolleraDatabasAct (self):
        databaskatalog = self.lineEdit_Databas.text()
        if  os.path.exists ( databaskatalog ):
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'kontrollera.py') + '"   ' + self.i_option + '   "' + databaskatalog + '"'
            QtCore.QProcess().startDetached(kommando )
        else:
            self.HittarInte(databaskatalog)
        return
#############################################################################################
    def ExporteraDatabasAct (self):
        databaskatalog = self.lineEdit_Databas.text()
        if  os.path.exists ( databaskatalog ):
            kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'exportera.py') + '"   ' + self.i_option + '   "' + databaskatalog + '"' # + '   "' + nydatabaskatalog + '"'
            QtCore.QProcess().startDetached(kommando)
        else:
            self.HittarInte(databaskatalog)
        return
#############################################################################################
    def HittarInte(self, msg):
        QtGui.QMessageBox.information(self, 'Johan: okänd databas', 'Jag hittar inte\n' + msg, 'OK')
        return
# ¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤ Här slutar Meny "Åtgärder"




# ¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤ Här börjar Meny "Källtexter"
#############################################################################################
    def VisaProgramkodAct(self):

        kommando = allmänt.FILHANTERARE

        if kommando[-8:] == 'krusader':
            krusaderheader = '"Källtexterna för Johan_py3"'
            kommando = kommando  + ' -caption ' + krusaderheader + ' --left ' + self.projektkatalog + ' --right ' + self.programkatalog
        else:
            kommando = kommando  + '  ' + self.programkatalog
        QtCore.QProcess().startDetached(kommando)

#############################################################################################
    def VisaINIfilAct(self):

#INI-fil:          /home/ingemar/.johan_py2/johan_ini.xml

        kommando = allmänt.EDITOR + " " + self.inifilnamn
        QtCore.QProcess().startDetached(kommando)

#############################################################################################
# ¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤ Här slutar Meny "Källtexter"




#############################################################################################
    def logga(self, txt):
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn,'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Johan_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print(ptxt)

# logga tilltextruta i johanfönstret
        self.textEdit_logg.insertPlainText(txt )
        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)

        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

## gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

## gör detta någon nytta?
#        self.repaint()

## gör detta någon nytta?
#        app.processEvents()

#############################################################################################




#############################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Johan_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
#############################################################################################




#############################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winJohan = Johan()
winJohan.show()
sys.exit(app.exec_())
#############################################################################################
