#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# johangemensamt.py

# Senast ändrad: 2011-01-18  - Uppdateras automatiskt. Ändra inte manuellt.
########################################################################################




########################################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
########################################################################################




########################################################################################
import sys
import os

import datetime 

from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

# OBS johanklasser och johangemensamt får inte importera allting från varandra.
# Cirkelberoende kan uppstå.

########################################################################################
# I johangemensamt finns endast en (1) class, men den innehåller många rutiner
# class allmänt()
#
#
########################################################################################
class allmänt():

    SenastÄndrad = '2011-01-18 09:03:58'  # Uppdateras automatiskt. Ändra inte manuellt.

# Dessa fyra konstanter tilldelas innehåll av programmet 'hämtaprogramsökvägar' nedan
    PYTON = ''        # laddas med sökväg och programnamn för det python som just nu
                      # tolkar detta program  så att alla nystartade johan-program ska
                      # tolkas med samma python.

    EDITOR  = ''      # sökväg och programnamn för användens favoriteditor hämtas ur INI-filen
                      # t.ex kate (linux) eller PSPad (windows)

    FILHANTERARE = '' # sökväg och programnamn för användens favoritfilhanterare hämtas ur INI-filen
                      # t.ex krusader (linux) eller ztree (windows)

    ORDBEHANDLARE = '' # sökväg och programnamn för användens favoritordbehandlare hämtas ur INI-filen
                       # t.ex 'ooffice -writer'



    Startfontsize = 9 # INI-fil kan medföra annat värde


    # ÄNDRA VÄRDEN HÄR EFTER TYCKE OCH SMAK OCH AKTUELL OS-MILJÖ
    # Välj anpassningsfaktorer, nära 1, efter den grafiska stil som väljes.
    Vertikalfaktor = 1.0    # Plastik 1.0, Oxygen 1.3
    Horisontalfaktor = 1.0  # Plastik 1.0, Oxygen 1.0
#   Med Vertikalfaktor = 1.0 ryms ibland inte text i höjled i det utrymme som blir kvar när stilen
#   har tagit sitt. "Plastik" ser simplare ut men det ryms mera information på bildskärmen.

########################################################################################




########################################################################################
    def hittaparam (self, helafilen, tag, start=0, end=-1):

# Inkommande sökbegrepp:  tag   - ska innehålla sträng med kodning utf-8
# Resultatet, sträng vid denna XML-tag levereras som utf-8

        findpos1 = helafilen.find("<"+tag+">",start,end)
        if findpos1 > 0:
            findpos2 = helafilen.find("</"+tag+">", findpos1, end)
            extractpos1 = findpos1 + len("<"+tag+">")
            extractpos2 = findpos2
            return helafilen[extractpos1:extractpos2]
        else:
            return ""

########################################################################################




########################################################################################
    def skapanydatabas (self, nydatabas):  # nydatabas ska komma som unicode, inkl ev citattecken för att maskera mellanslag i namnet

        programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]
        projektkatalog = os.path.split( os.path.abspath( programkatalog ) )[0]
        tomdatabas = os.path.join(projektkatalog, "tomdatabas") # Tom databas = preparerad MALL att kopiera

        self.kopierakatalog (tomdatabas, nydatabas)
        return
########################################################################################




########################################################################################
    def hittamultiparam (self, helafilen, tag, start, end):
# Hittamultiparam är ett superset av Hittaparam och skulle i princip kunna ersätta den senare.
# Använd Hittaparam från ställen där endast enkelradsparametrar tillåts.
# Använd Hittamultiparam från ställen där fleraradsparametrar tillåts.

# Inkommande sökbegrepp:  tag   - ska innehålla sträng med kodning utf-8
# Resultatet, sträng vid denna XML-tag levereras som utf-8

        param = ""
        findpos1 = helafilen.find("<"+tag+">",start,end)

        if findpos1 > 0:
            findpos2 = helafilen.find("</"+tag+">", findpos1, end)
            extractpos1 = findpos1 + len("<"+tag+">")
            extractpos2 = findpos2
            param = helafilen[extractpos1:extractpos2]

        while findpos1 > 0:
            findpos1 = helafilen.find("<"+tag+">",findpos2+len("</"+tag+">"),end)
            if findpos1 > 0:
                findpos2 = helafilen.find("</"+tag+">", findpos1, end)
                extractpos1 = findpos1 + len("<"+tag+">")
                extractpos2 = findpos2
                en_till_param = helafilen[extractpos1:extractpos2]
                param = param + "\n" + en_till_param

        return param
########################################################################################




########################################################################################
    def hittaområde (self, helafilen, tag, start, end):
        extractpos1 = 0
        extractpos2 = 0
        findpos1 = helafilen.find("<"+tag+">",start,end)
        if findpos1 > 0:
            findpos2 = helafilen.find("</"+tag+">", findpos1, end)
            extractpos1 = findpos1 + len("<"+tag+">")
            extractpos2 = findpos2
        return extractpos1, extractpos2
########################################################################################




########################################################################################
    def hämtapersonfil(self, infilnamn, pers):

# infilnamn i utf-8. Motsvarande fil har XML-format och är kodad utf-8

        from johanklasser import johanpersonfil
# pers ska vara en struktur enligt   class johanpersonfil()    ovan

# för ifyllande av strukturen ska användas rutinerna hittaområde, hittaparam, hittamultiparam,
# i vilkas anrop den andra parametern ska vara en sträng kodad enligt utf-8
# (eftersom XML-filerna är kodade utf-8)
# svaren från hittaparam och hittamultiparam är kodade utf-8

        self.initpersonfil(pers)

        if os.path.split(infilnamn)[1] == '.xml':  # Inget personnummer alls!
            return

        try:
            infile = open( infilnamn, "r", encoding='utf-8' )
            helafilen=infile.read()
            infile.close()
        except:
            print("(hämtapersonfil) Jag kunde inte läsa hitta eller läsa filen " + infilnamn)
            return


        maxlen = len(helafilen)

        pers.person_ID = self.hittaparam( helafilen, "person_ID", 0, maxlen)
        pers.föräldrapar_ID = self.hittaparam( helafilen, "föräldrapar_ID", 0, maxlen)
        pers.bonusrelation_ID = self.hittamultiparam( helafilen, "bonusrelation_ID", 0, maxlen)

        område_start, område_end = self.hittaområde( helafilen, "egnapar", 0 , maxlen)
        pers.egna_par_ID = self.hittamultiparam( helafilen, "egetpar_ID", område_start, område_end)

        område_start, område_end = self.hittaområde( helafilen, "namn", 0 , maxlen)

# OBS! förnamn, tilltal och efternamn innehåller var sin tabell
#   med \n mellan raderna och \t mellan fälten
        pers.förnamn = self.hittanamn( helafilen, "förnamn", område_start, område_end)
        pers.tilltal =  self.hittanamn( helafilen, "tilltal", område_start, område_end)
        pers.efternamn = self.hittanamn( helafilen, "efternamn", område_start, område_end)

# OBS! Anrop till hittanamnkombi får inte göras förrän förnamn, tilltal och efternamn hämtats till pers

        pers.allaförnamn, pers.allatilltal, pers.allaefternamn, pers.allaförnamnmedant, pers.allatilltalmedant, pers.allaefternamnmedant, pers.kortnamn, pers.långtnamn, pers.långtnamnmedant = self.hittanamnkombi(pers)


        pers.person_kön = self.hittaparam( helafilen, "kön", 0, maxlen)
        pers.person_kategori = self.hittaparam( helafilen, "kategori",  0 , maxlen)

        område_start, område_end = self.hittaområde( helafilen, "födelse", 0 , maxlen)
        område_start1, område_end1 = self.hittaområde( helafilen, "datum", område_start,område_end)
        pers.född_år = self.hittaparam( helafilen, "år", område_start1, område_end1)
        pers.född_månad = self.hittaparam( helafilen, "månad", område_start1, område_end1)
        pers.född_dag =  self.hittaparam( helafilen, "dag", område_start1, område_end1)

        område_start1, område_end1 = self.hittaområde( helafilen, "plats", område_start,område_end)
        pers.född_gata =  self.hittaparam( helafilen, "gata", område_start1, område_end1)
        pers.född_by = self.hittaparam( helafilen, "by", område_start1, område_end1)
        pers.född_kvarter = self.hittaparam( helafilen, "kvarter", område_start1, område_end1)
        pers.född_socken = self.hittaparam( helafilen, "socken", område_start1, område_end1)
        pers.född_församling = self.hittaparam( helafilen, "församling", område_start1, område_end1)
        pers.född_disbytförsamling = self.hittaparam( helafilen, "disbytförsamling", område_start1, område_end1)
        pers.född_stad = self.hittaparam( helafilen, "stad", område_start1, område_end1)
        pers.född_härad = self.hittaparam( helafilen, "härad", område_start1, område_end1)
        pers.född_län = self.hittaparam( helafilen, "län", område_start1, område_end1)
        pers.född_utrikesplats = self.hittaparam( helafilen, "utrikesplats", område_start1, område_end1)
        pers.född_källa = self.hittamultiparam( helafilen, "källa", område_start, område_end)

        område_start, område_end = self.hittaområde( helafilen, "död", 0 , maxlen)
        område_start1,område_end1 = self.hittaområde( helafilen, "datum", område_start,område_end)
        pers.död_år = self.hittaparam( helafilen, "år", område_start1, område_end1)
        pers.död_månad = self.hittaparam( helafilen, "månad", område_start1, område_end1)
        pers.död_dag = self.hittaparam( helafilen, "dag", område_start1, område_end1)

        område_start1,område_end1 = self.hittaområde( helafilen, "plats", område_start,område_end)
        pers.död_gata = self.hittaparam( helafilen, "gata", område_start1, område_end1)
        pers.död_by = self.hittaparam( helafilen, "by", område_start1, område_end1)
        pers.död_kvarter = self.hittaparam( helafilen, "kvarter", område_start1, område_end1)
        pers.död_socken = self.hittaparam( helafilen, "socken", område_start1, område_end1)
        pers.död_församling = self.hittaparam( helafilen, "församling", område_start1, område_end1)
        pers.död_disbytförsamling = self.hittaparam( helafilen, "disbytförsamling", område_start1, område_end1)
        pers.död_stad = self.hittaparam( helafilen, "stad", område_start1, område_end1)
        pers.död_härad = self.hittaparam( helafilen, "härad", område_start1, område_end1)
        pers.död_län = self.hittaparam( helafilen, "län", område_start1, område_end1)
        pers.död_utrikesplats = self.hittaparam( helafilen, "utrikesplats", område_start1, område_end1)
        pers.död_källa = self.hittamultiparam( helafilen, "källa", område_start, område_end)

        pers.fler_källor = self.hittamultiparam( helafilen, "källor",  0 , maxlen)
        pers.anteckning = self.hittamultiparam( helafilen, "anteckning",  0 , maxlen)
        pers.senastsparat = self.hittaparam( helafilen, "sparat",  0 , maxlen)

        return
########################################################################################




########################################################################################
    def hittanamnkombi(self, pers):

# OBS! Anrop till hittanamnkombi får inte göras förrän förnamn, tilltal och efternamn hämtats till pers
# Den inlästa filen var kodad  utf-8
# Strängarna i strukturen pers kodades om till unicode i  hittaparam och hittamultiparam.

        förnamnen = pers.förnamn
        tilltalsnamnen = pers.tilltal
        efternamnen = pers.efternamn

        N1 = förnamnen.split("\n")
        T1 = tilltalsnamnen.split("\n")
        E1 = efternamnen.split("\n")

        N10 = N1[0].split("\t")
        T10 = T1[0].split("\t")
        E10 = E1[0].split("\t")


        allaförnamn = ""
        for N in N1:
            if allaförnamn == "":
                allaförnamn = N.split("\t")[0]
            else:
                allaförnamn = allaförnamn  + " " + N.split("\t")[0]       # alla förnamn, med mellanslag, utan anteckning


        allatilltal =""
        for T in T1:
            if allatilltal == "":
                allatilltal = T.split("\t")[0]
            else:
                allatilltal = allatilltal + " " + T.split("\t")[0]        # alla tilltalsnamn, med mellanslag, utan anteckning


        allaefternamn = ""
        for E in E1:
            if allaefternamn == "":
                allaefternamn = E.split("\t")[0]
            else:
                allaefternamn = allaefternamn  + " " + E.split("\t")[0]   # alla efternamn, med mellanslag, utan anteckning


        allaförnamnmedant = ""
        for N in N1:
            Nx = N.split("\t")
            anttxt = ""
            antnr = 1
            while antnr < len(Nx) :
                anttxt = anttxt + Nx[antnr] + ", "
                antnr = antnr + 1
            if len(anttxt) > 2:
                anttxt = anttxt[0:-2]
                allaförnamnmedant = allaförnamnmedant + anttxt + ": " + Nx[0] + "   "



        allatilltalmedant = ""
        for T in T1:
            Tx = T.split("\t")
            anttxt = ""
            antnr = 1
            while antnr < len(Tx) :
                anttxt = anttxt + Tx[antnr] + ", "
                antnr = antnr + 1
            if len(anttxt) > 2:
                anttxt = anttxt[0:-2]
                allatilltalmedant = allatilltalmedant + anttxt + ": " + Tx[0] + "   "



        allaefternamnmedant = ""
        for E in E1:
            Ex = E.split("\t")
            anttxt = ""
            antnr = 1
            while antnr < len(Ex) :
                anttxt = anttxt + Ex[antnr] + ", "
                antnr = antnr + 1
            if len(anttxt) > 2:
                anttxt = anttxt[0:-2]
            else:
                anttxt = ""
            allaefternamnmedant = (allaefternamnmedant + anttxt + ": " + Ex[0] + ", ")
        allaefternamnmedant =  allaefternamnmedant.strip(" ,:")





        if T10[0] != "":
            kortnamn = T10[0] + " " + E10[0]   # om tilltal finns: första tilltalsnamn, mellanslag, första efternamn, utan anteckning
#            if len(E10) > 1:
#                kortnamn = kortnamn + " " + E10[1]
        else:
            kortnamn = N10[0] + " " + E10[0]   # annars: första förnamnsnamn, mellanslag, första efternamn, utan anteckning
#            if len(E10) > 1:
#                kortnamn = kortnamn + " " + E10[1]


        långtnamn = allaförnamn + " " + E10[0]
#        if len(E10) > 1:
#            långtnamn = långtnamn + " " + E10[1]

        långtnamnmedant = allaförnamnmedant + " " + allaefternamnmedant

# Att hämtas direkt ur personfilen:
#    förnamn = "",      #  tabell med \n mellan raderna och \t mellan fälten
#    tilltal = "",      #  tabell med \n mellan raderna och \t mellan fälten
#    efternamn = "",    #  tabell med \n mellan raderna och \t mellan fälten

# Att skapas efter hämtning, ur hämtat innehåll
#    allaförnamn = "",      # alla förnamn, med mellanslag, utan anteckning
#    allatilltal = "",      # alla tilltal, med mellanslag, utan anteckning
#    allaefternamn = "",    # alla efternamn, med mellanslag, utan anteckning

#    allaförnamnmedant = "",      # alla förnamn, formaterad, med anteckningar
#    allatilltalmedant = "",      # alla tilltal, formaterad, med anteckningar
#    allaefternamnmedant = "",    # alla efternamn, formaterad, med anteckningar

#    kortnamn = "",        # första tilltal/första förnamn, mellanslag, första efternamn, utan anteckningar
#    långtnamn = "",           # alla förnamn och första efternamn, med mellanslag, utan anteckningar
#    långtnamnmedant = "",         # alla förnamn och alla efternamn, formaterat, med anteckningar



        return allaförnamn, allatilltal, allaefternamn, allaförnamnmedant, allatilltalmedant, allaefternamnmedant, kortnamn, långtnamn, långtnamnmedant
########################################################################################




########################################################################################
    def hämtaparfil(self, infilnamn, par):

        self.initparfil(par)

        if not os.path.exists(infilnamn):
            return

        infile = open( infilnamn, "r", encoding='utf-8' )
        helafilen=infile.read()
        infile.close()
        maxlen = len(helafilen)

        par.par_ID = self.hittaparam( helafilen, "par_ID", 0, maxlen)
        par.person1_ID = self.hittaparam( helafilen, "person1_ID", 0, maxlen)
        par.person2_ID = self.hittaparam( helafilen, "person2_ID", 0, maxlen)
        par.bonusrelation_ID = self.hittamultiparam( helafilen, "bonusrelation_ID", 0, maxlen)

        område_start, område_end = self.hittaområde( helafilen, "inledning", 0 , maxlen)
        par.inledn_typ = self.hittaparam( helafilen, "typ", område_start, område_end)
        område_start1, område_end1 = self.hittaområde( helafilen, "datum", område_start,område_end)
        par.inledn_år = self.hittaparam( helafilen, "år", område_start1, område_end1)
        par.inledn_månad = self.hittaparam( helafilen, "månad", område_start1, område_end1)
        par.inledn_dag =  self.hittaparam( helafilen, "dag", område_start1, område_end1)

        område_start1, område_end1 = self.hittaområde( helafilen, "plats", område_start,område_end)
        par.inledn_gata =  self.hittaparam( helafilen, "gata", område_start1, område_end1)
        par.inledn_by = self.hittaparam( helafilen, "by", område_start1, område_end1)
        par.inledn_kvarter = self.hittaparam( helafilen, "kvarter", område_start1, område_end1)
        par.inledn_socken = self.hittaparam( helafilen, "socken", område_start1, område_end1)
        par.inledn_församling = self.hittaparam( helafilen, "församling", område_start1, område_end1)
        par.inledn_disbytförsamling = self.hittaparam( helafilen, "disbytförsamling", område_start1, område_end1)
        par.inledn_stad = self.hittaparam( helafilen, "stad", område_start1, område_end1)
        par.inledn_härad = self.hittaparam( helafilen, "härad", område_start1, område_end1)
        par.inledn_län = self.hittaparam( helafilen, "län", område_start1, område_end1)
        par.inledn_utrikesplats = self.hittaparam( helafilen, "utrikesplats", område_start1, område_end1)
        par.inledn_källa = self.hittamultiparam( helafilen, "källa", område_start, område_end)

        område_start, område_end = self.hittaområde( helafilen, "upplösning", 0 , maxlen)
        par.upplösn_typ = self.hittaparam( helafilen, "typ", område_start, område_end)
        område_start1,område_end1 = self.hittaområde( helafilen, "datum", område_start,område_end)
        par.upplösn_år = self.hittaparam( helafilen, "år", område_start1, område_end1)
        par.upplösn_månad = self.hittaparam( helafilen, "månad", område_start1, område_end1)
        par.upplösn_dag = self.hittaparam( helafilen, "dag", område_start1, område_end1)

        område_start1,område_end1 = self.hittaområde( helafilen, "plats", område_start,område_end)
        par.upplösn_gata = self.hittaparam( helafilen, "gata", område_start1, område_end1)
        par.upplösn_by = self.hittaparam( helafilen, "by", område_start1, område_end1)
        par.upplösn_kvarter = self.hittaparam( helafilen, "kvarter", område_start1, område_end1)
        par.upplösn_socken = self.hittaparam( helafilen, "socken", område_start1, område_end1)
        par.upplösn_församling = self.hittaparam( helafilen, "församling", område_start1, område_end1)
        par.upplösn_disbytförsamling = self.hittaparam( helafilen, "disbytförsamling", område_start1, område_end1)
        par.upplösn_stad = self.hittaparam( helafilen, "stad", område_start1, område_end1)
        par.upplösn_härad = self.hittaparam( helafilen, "härad", område_start1, område_end1)
        par.upplösn_län = self.hittaparam( helafilen, "län", område_start1, område_end1)
        par.upplösn_utrikesplats = self.hittaparam( helafilen, "utrikesplats", område_start1, område_end1)
        par.upplösn_källa = self.hittamultiparam( helafilen, "källa", område_start, område_end)

        område_start, område_end = self.hittaområde( helafilen, "barn", 0 , maxlen)
        par.barn_ID = self.hittamultiparam( helafilen, "barn_ID", område_start, område_end)

        par.fler_källor = self.hittamultiparam( helafilen, "källor",  0 , maxlen)
        par.anteckning = self.hittamultiparam( helafilen, "anteckning",  0 , maxlen)
        par.senastsparat = self.hittaparam( helafilen, "sparat",  0 , maxlen)

########################################################################################




#############################################################################################
    def hämtaanvändaruppgifter (self, inifilnamn):

# Hämta ur INI_filen

        try:
            inifil = open(inifilnamn, "r", encoding='utf-8' )
            inifiltext = inifil.read()
            inifil.close()
        except:
            inifiltext = ""

        område_start, område_end = allmänt.hittaområde( allmänt(), inifiltext, "användaruppgifter",             0 , len(inifiltext) )
        DIS_medlemsnummer        = allmänt.hittaparam( allmänt(), inifiltext, "DIS_medlemsnummer",   område_start,      område_end )
        disbyt_användarnamn      = allmänt.hittaparam( allmänt(), inifiltext, "disbyt_användarnamn", område_start,      område_end )
        disbyt_lösenord          = allmänt.hittaparam( allmänt(), inifiltext, "disbyt_lösenord",     område_start,      område_end )
        namn                     = allmänt.hittaparam( allmänt(), inifiltext, "namn",                område_start,      område_end )
        epost                    = allmänt.hittaparam( allmänt(), inifiltext, "epost",               område_start,      område_end )
        www                      = allmänt.hittaparam( allmänt(), inifiltext, "www",                 område_start,      område_end )

        användaruppgifter = {
           "DIS_medlemsnummer"    : DIS_medlemsnummer,
           "disbyt_användarnamn"  : disbyt_användarnamn,
           "disbyt_lösenord"      : disbyt_lösenord,
           "namn"                 : namn,
           "epost"                : epost,
           "www"                  : www
           }

        return användaruppgifter
#############################################################################################




########################################################################################
    def initpersonfil(self, pers):

        pers.person_ID = ""
        pers.föräldrapar_ID = ""
        pers.bonusrelation_ID = ""

        pers.egna_par_ID = ""

    # Att hämtas direkt ur personfilen:
        pers.förnamn = ""      #  tabell med \n mellan raderna och \t mellan fälten
        pers.tilltal = ""      #  tabell med \n mellan raderna och \t mellan fälten
        pers.efternamn = ""    #  tabell med \n mellan raderna och \t mellan fälten

    # Att skapas efter hämtning, ur hämtat innehåll
        pers.allaförnamn = ""      # alla förnamn, med mellanslag, utan anteckning
        pers.allatilltal = ""      # alla tilltal, med mellanslag, utan anteckning
        pers.allaefternamn = ""    # alla efternamn, med mellanslag, utan anteckning

        pers.allaförnamnmedant = ""      # alla förnamn, formaterad, med anteckningar
        pers.allatilltalmedant = ""      # alla tilltal, formaterad, med anteckningar
        pers.allaefternamnmedant = ""    # alla efternamn, formaterad, med anteckningar

        pers.kortnamn = ""        # första tilltal/första förnamn, mellanslag, första efternamn, utan anteckningar
        pers.långtnamn = ""           # alla förnamn och första efternamn, med mellanslag, utan anteckningar
        pers.långtnamnmedant = ""         # alla förnamn och alla efternamn, formaterat, med anteckningar


        pers.person_kön = ""
        pers.person_kategori = ""

        pers.född_år = ""
        pers.född_månad = ""
        pers.född_dag = ""

        pers.född_gata = ""
        pers.född_by = ""
        pers.född_kvarter = ""
        pers.född_socken = ""
        pers.född_församling = ""
        pers.född_disbytförsamling = ""
        pers.född_stad = ""
        pers.född_härad = ""
        pers.född_län = ""
        pers.född_utrikesplats = ""
        pers.född_källa = ""

        pers.död_år = ""
        pers.död_månad = ""
        pers.död_dag = ""

        pers.död_gata = ""
        pers.död_by = ""
        pers.död_kvarter = ""
        pers.död_socken = ""
        pers.död_församling = ""
        pers.död_disbytförsamling = ""
        pers.död_stad = ""
        pers.död_härad = ""
        pers.död_län = ""
        pers.död_utrikesplats = ""
        pers.död_källa = ""
        pers.fler_källor = ""
        pers.anteckning = ""
        pers.senastsparat = ""

########################################################################################




########################################################################################
    def initparfil(self, par):

        par.par_ID = ""
        par.person1_ID = ""
        par.person2_ID = ""
        par.bonusrelation_ID = ""

        par.inledn_typ = ""
        par.inledn_år = ""
        par.inledn_månad = ""
        par.inledn_dag = ""

        par.inledn_gata = ""
        par.inledn_by = ""
        par.inledn_kvarter = ""
        par.inledn_socken = ""
        par.inledn_församling = ""
        par.inledn_disbytförsamling = ""
        par.inledn_stad = ""
        par.inledn_härad = ""
        par.inledn_län = ""
        par.inledn_utrikesplats = ""
        par.inledn_källa = ""

        par.upplösn_typ = ""
        par.upplösn_år = ""
        par.upplösn_månad = ""
        par.upplösn_dag = ""

        par.upplösn_gata = ""
        par.upplösn_by = ""
        par.upplösn_kvarter = ""
        par.upplösn_socken = ""
        par.upplösn_församling = ""
        par.upplösn_disbytförsamling = ""
        par.upplösn_stad = ""
        par.upplösn_härad = ""
        par.upplösn_län = ""
        par.upplösn_utrikesplats = ""
        par.upplösn_källa = ""

        par.barn_ID = ""

        par.fler_källor = ""
        par.anteckning = ""
        par.senastsparat = ""
########################################################################################




########################################################################################
    def skrivindent(self, utfil, indentlevel):
        intlevel = int ( indentlevel)
        while intlevel > 0:
            utfil.write('\t')
            intlevel = intlevel-1
########################################################################################




########################################################################################
    def skrivrad(self, utfil, indentlevel, tagtext, radtext):
#
#  parametern tagtext kommer som utf-8 och ska skrivas ut som utf-8
#  parametern radtext kommer som unicode och ska skrivas ut som utf-8
#  (radtext görs om från QString till unicode i anropande program

# Tillåt tab inuti rad. men inte i början eller slutet
# "\n" inuti rad byts till " ", tas bort i början och slutet av rad
# "\x00" tas bort i hela raden
# tag bort vitt i början och slutet av raden



        tmp1 = radtext.replace("\x00","")                  # tag bort binärnollor
        tmp2 = tmp1.replace("\n"," ")                      # alla "\n" ->" "
        utf8rad = tmp2.rstrip(" \t")                       # tag bort vitt i radbörjan och -slut

        if utf8rad == "":
            self.skrivindent(utfil, indentlevel)  # indenteringen i xml-filen
            utfil.write('<'+tagtext+'/>\n')
        else:
            self.skrivindent(utfil, indentlevel)  # indenteringen i xml-filen
            utfil.write("<"+tagtext+">")
            utfil.write(utf8rad)
            utfil.write('</'+tagtext+'>\n')
########################################################################################




########################################################################################
    def skrivmultirad(self, utfil, indentlevel, tagtext, radtext):
#
#  parametern tagtext kommer som utf-8 och ska skrivas ut som utf-8
#  parametern radtext kommer som unicode och ska skrivas ut som utf-8
#  (radtext görs om från QString till unicode i anropande program

#  I radtext kan ingå \n (ny rad). Flera sådana rader inom radtext ska
#  delas upp på separata rader med var sin av samma tag i XML-filen
#


        utf8tmp = radtext.replace("\x00","")                  # tag bort binärnollor
        utf8rad = utf8tmp.rstrip(" \n\t")                     # tag bort vitt i radbörjan och -slut

# Om raden nu är helt tom skriv motsvarande tag utan rad.
        if utf8rad == "":
            self.skrivindent(utfil, indentlevel)  # indenteringen i xml-filen
            utfil.write('<'+tagtext+'/>\n')
# Dela upp raden efter "\n" och strunta helt i att skriva ut eventuella tomma delrader
        else:
            for rad in utf8rad.split("\n"):
                radtmp = rad.rstrip(" \t")                         # tag bort vitt i radbörjan och -slut
                if len(radtmp) > 0 :                             # skriv bara delrader med verkligt innehåll
                    self.skrivindent(utfil, indentlevel)
                    utfil.write('<'+tagtext+'>')
                    utfil.write(radtmp)
                    utfil.write('</'+tagtext+'>\n')
########################################################################################




########################################################################################
    def skrivnamnrader(self, utfil, indentlevel, tagtext, radtext):

#  parametern tagtext kommer som utf-8 och ska skrivas ut som utf-8
#  parametern radtext kommer som unicode och ska skrivas ut som utf-8
#  (radtext görs om från QString till unicode i anropande program


# radtext innehåller från noll till många rader
# där varje rad innehåller från ett till många fält
# med längden ett (noll?) till många tecken
# Raderna i radtext åtskiljs med \n
# Fälten på en rad åtskiljs med \t

# tagtext är huvudtag och skrivs indentlevel tabtecken in på filens rad

# Första fältet på raden får tagg <nam>
#    som skrivs indentlevel+1 tabtecken in på filens rad
# Alla eventuella efterföljande fält på samma rad får tagg <ant>
#    som skrivs indentlevel+1 tabtecken in på filens rad


        utf8tmp = radtext.replace("\x00","")  # tag bort binärnollor
        utf8rad = utf8tmp.rstrip(" \n\t")                     # tag bort vitt i radbörjan och -slut

        if utf8rad == "":  # inget namn alls
            self.skrivindent(utfil, indentlevel)    # indenteringen i xml-filen
            utfil.write('<'+tagtext+'/>\n')         # t.ex. <förnamn/>
        else:
            for rad in utf8rad.split("\n"):
                radtmp = rad.rstrip(" ")      # tag bort " " men inte "\t" i radbörjan och -slut

                if radtmp != "" :

                    self.skrivindent(utfil, indentlevel)    # indenteringen i xml-filen
                    utfil.write('<'+tagtext+'>\n')          # t.ex. <förnamn>


                    allafalt = radtmp.split("\t")

                    if allafalt[0] == "":
                        self.skrivindent(utfil, indentlevel+1)      # indenteringen i xml-filen
                        utfil.write('<nam/>\n')                     # <nam/>
                    else:
                        self.skrivindent(utfil, indentlevel+1)      # indenteringen i xml-filen
                        utfil.write('<nam>')                        # <nam>
                        utfil.write(allafalt[0])
                        utfil.write('</nam>\n')                     # </nam>

                    j=1
                    while j < len(allafalt):
                        anttmp = allafalt[j].rstrip(" ")
#                        if anttmp == "":                            # om tomma fält ska skrivas ut
#                            self.skrivindent(utfil, indentlevel+1)  # indenteringen i xml-filen
#                            utfil.write('<ant/>\n')                 # <ant/>
                        if anttmp != "":
                            self.skrivindent(utfil, indentlevel+1)  # indenteringen i xml-filen
                            utfil.write('<ant>')                    # <ant>
                            utfil.write(anttmp)
                            utfil.write('</ant>\n')                 # </ant>
                        j=j+1

                    self.skrivindent(utfil, indentlevel)    # indenteringen i xml-filen
                    utfil.write('</'+tagtext+'>\n')         # t.ex. </förnamn>
########################################################################################




########################################################################################
    def hittanamn (self, helafilen, tag, start, end):

# Hittanamn ersätter Hittamultiparam för att hämta namn ur XML-filen

# inkommande tag kan vara 'förnamn', 'tilltal' eller 'efternamn'

# start och end anger del av strängen helafilen som ska avsökas
# inom området kan angiven tag förekomma flera gånger , t.ex.  <förnamn>   </förnamn>


# Inkommande sökbegrepp:  tag   - ska innehålla sträng med kodning utf-8
# Resultatet, sträng vid denna XML-tag levereras som unicode

        svar = ""
        param = ""
        sokborjan = start
#        sokslut = end
        hittat = True
        while hittat == True and sokborjan < end:
            posrad     = helafilen.find ( "<"+tag+">",  sokborjan, end)
            posradslut = helafilen.find ( "</"+tag+">", posrad,    end)

            if posrad>0 and posradslut>0:
                hittat = True
            else:
                hittat = False

            if hittat == True:
                radparam = ""
#                rad = helafilen [ posrad + len("<"+tag+">") : posradslut ]
                posnam     = helafilen.find ( "<nam>", posrad + len("<"+tag+">"), posradslut )
                posnamslut = helafilen.find ( "</nam>", posrad + len("<"+tag+">"), posradslut )
                posant     = helafilen.find ( "<ant>", posrad + len("<"+tag+">"), posradslut )
                posantslut = helafilen.find ( "</ant>", posrad + len("<"+tag+">"), posradslut )

                if posnam==-1 and posant==-1:
                    radparam = helafilen [ posrad + len("<"+tag+">") : posradslut ]     # Kompatibilitet med föregående XML-definition

                if posnam>0 and posnamslut>0:
                    radparam = helafilen [ posnam + len("<nam>") : posnamslut ]

                while posant>0 and posantslut>0:
                    radparam = radparam + "\t" +  helafilen [ posant + len("<ant>") : posantslut ]

                    posant     = helafilen.find ( "<ant>", posantslut + len("</ant>"), posradslut )
                    posantslut = helafilen.find ( "</ant>", posantslut + len("</ant>"), posradslut )

                if radparam != "":
                    if param == "":
                        param = radparam
                    else:
                        param = param + "\n"  + radparam

            sokborjan = posradslut + len("</"+tag+">")


        return param
########################################################################################




########################################################################################
    def sparapersonfil(self, utfilnamn, pers, backupnivå=8):

        import os

        idag = datetime.datetime.today()
        senastsparat = str(idag.year) + '-' +  str(idag.month).zfill(2) + '-' +  str(idag.day).zfill(2) + "  " + str(idag.hour).zfill(2) + ':' +  str(idag.minute).zfill(2) + ':' +  str(idag.second).zfill(2)

        tmpfilnamn = utfilnamn + ".tmp"
        utfil=open(tmpfilnamn, 'w', encoding='utf-8')

        utfil.write('<?xml version="1.0" encoding="UTF-8"?>\n')
        utfil.write('<?xml-stylesheet type="text/xsl" href="../../xml/johan_person.xsl"?>\n')
        utfil.write('<person xsi:noNamespaceSchemaLocation="../../xml/johan_schema_person.xsd"\n')
        utfil.write('        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">\n')

        self.skrivrad(utfil,1, 'person_ID', pers.person_ID)
        self.skrivrad(utfil,1,'föräldrapar_ID', pers.föräldrapar_ID)
        utfil.write('\t<egnapar>\n')
        self.skrivmultirad(utfil,2,'egetpar_ID', pers.egna_par_ID)
        utfil.write('\t</egnapar>\n')
        self.skrivmultirad(utfil,1,'bonusrelation_ID', pers.bonusrelation_ID)

        self.skrivrad(utfil,1,'kön', pers.person_kön)
        self.skrivrad(utfil,1,'kategori', pers.person_kategori)

        utfil.write('\t<namn>\n')

        self.skrivnamnrader(utfil,2,'förnamn', pers.förnamn)
        self.skrivnamnrader(utfil,2,'tilltal', pers.tilltal)
        self.skrivnamnrader(utfil,2,'efternamn', pers.efternamn)

        utfil.write('\t</namn>\n')

        utfil.write('\t<födelse>\n')
        utfil.write('\t\t<datum>\n')
        self.skrivrad(utfil,3,'år', pers.född_år)
        self.skrivrad(utfil,3,'månad', pers.född_månad)
        self.skrivrad(utfil,3,'dag', pers.född_dag)
        utfil.write('\t\t</datum>\n')
        utfil.write('\t\t<plats>\n')
        self.skrivrad(utfil,3,'gata', pers.född_gata)
        self.skrivrad(utfil,3,'by', pers.född_by)
        self.skrivrad(utfil,3,'kvarter', pers.född_kvarter)
        self.skrivrad(utfil,3,'socken', pers.född_socken)

        self.skrivrad(utfil,3,'församling',pers.född_församling)
        self.skrivrad(utfil,3,'disbytförsamling',pers.född_disbytförsamling)

        self.skrivrad(utfil,3,'stad', pers.född_stad)
        self.skrivrad(utfil,3,'härad', pers.född_härad)
        self.skrivrad(utfil,3,'län', pers.född_län)
        self.skrivrad(utfil,3,'utrikesplats', pers.född_utrikesplats)
        utfil.write('\t\t</plats>\n')
        self.skrivmultirad(utfil,2,'källa', pers.född_källa)
        utfil.write('\t</födelse>\n')

        utfil.write('\t<död>\n')
        utfil.write('\t\t<datum>\n')
        self.skrivrad(utfil,3,'år', pers.död_år)
        self.skrivrad(utfil,3,'månad', pers.död_månad)
        self.skrivrad(utfil,3,'dag', pers.död_dag)
        utfil.write('\t\t</datum>\n')
        utfil.write('\t\t<plats>\n')
        self.skrivrad(utfil,3,'gata', pers.död_gata)
        self.skrivrad(utfil,3,'by', pers.död_by)
        self.skrivrad(utfil,3,'kvarter', pers.död_kvarter)
        self.skrivrad(utfil,3,'socken', pers.död_socken)
        self.skrivrad(utfil,3,'församling', pers.död_församling)
        self.skrivrad(utfil,3,'disbytförsamling', pers.död_disbytförsamling)
        self.skrivrad(utfil,3,'stad', pers.död_stad)
        self.skrivrad(utfil,3,'härad', pers.död_härad)
        self.skrivrad(utfil,3,'län', pers.död_län)
        self.skrivrad(utfil,3,'utrikesplats', pers.död_utrikesplats)
        utfil.write('\t\t</plats>\n')
        self.skrivmultirad(utfil,2,'källa', pers.död_källa)
        utfil.write('\t</död>\n')
        self.skrivmultirad(utfil,1, 'källor', pers.fler_källor)
        self.skrivmultirad(utfil,1, 'anteckning', pers.anteckning)
        self.skrivrad(utfil,1, 'sparat', pers.senastsparat)
        utfil.write('</person>\n')

        utfil.close()

        if backupnivå >0:
            #backupnivå = 8
            while backupnivå >0:
                if os.path.exists(str(utfilnamn) + "." + str(backupnivå)):
                    os.rename( str(utfilnamn) + "."  + str(backupnivå), str(utfilnamn) + "." + str(backupnivå+1))
                backupnivå = backupnivå - 1
            if os.path.exists(utfilnamn):
                os.rename( utfilnamn, utfilnamn + "." + str(backupnivå+1))

        if os.path.exists(tmpfilnamn):
            os.rename( tmpfilnamn, utfilnamn )
        return
########################################################################################




########################################################################################
    def sparaparfil(self, utfilnamn, par, backupnivå=8):

        import os

        tmpfilnamn = utfilnamn + ".tmp"
        utfil=open(tmpfilnamn, 'w', encoding='utf-8')

        utfil.write('<?xml version="1.0" encoding="UTF-8"?>\n')
        utfil.write('<?xml-stylesheet type="text/xsl" href="../../xml/johan_par.xsl"?>\n')
        utfil.write('<par xsi:noNamespaceSchemaLocation="../../xml/johan_schema_par.xsd"\n')
        utfil.write('     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">\n')

        self.skrivrad(utfil,1, 'par_ID', par.par_ID)
        self.skrivrad(utfil,1, 'person1_ID', par.person1_ID)
        self.skrivrad(utfil,1, 'person2_ID', par.person2_ID)
        self.skrivmultirad(utfil,1,'bonusrelation_ID', par.bonusrelation_ID)

        utfil.write('\t<inledning>\n')
        self.skrivrad(utfil,2,'typ', par.inledn_typ)
        utfil.write('\t\t<datum>\n')
        self.skrivrad(utfil,3,'år', par.inledn_år)
        self.skrivrad(utfil,3,'månad', par.inledn_månad)
        self.skrivrad(utfil,3,'dag', par.inledn_dag)
        utfil.write('\t\t</datum>\n')
        utfil.write('\t\t<plats>\n')
        self.skrivrad(utfil,3,'gata', par.inledn_gata)
        self.skrivrad(utfil,3,'by', par.inledn_by)
        self.skrivrad(utfil,3,'kvarter', par.inledn_kvarter)
        self.skrivrad(utfil,3,'socken', par.inledn_socken)
        self.skrivrad(utfil,3,'församling', par.inledn_församling)
        self.skrivrad(utfil,3,'disbytförsamling', par.inledn_disbytförsamling)
        self.skrivrad(utfil,3,'stad', par.inledn_stad)
        self.skrivrad(utfil,3,'härad', par.inledn_härad)
        self.skrivrad(utfil,3,'län', par.inledn_län)
        self.skrivrad(utfil,3,'utrikesplats', par.inledn_utrikesplats)
        utfil.write('\t\t</plats>\n')
        self.skrivmultirad(utfil,2,'källa', par.inledn_källa)
        utfil.write('\t</inledning>\n')

        utfil.write('\t<upplösning>\n')
        self.skrivrad(utfil,2,'typ', par.upplösn_typ)
        utfil.write('\t\t<datum>\n')
        self.skrivrad(utfil,3,'år', par.upplösn_år)
        self.skrivrad(utfil,3,'månad', par.upplösn_månad)
        self.skrivrad(utfil,3,'dag', par.upplösn_dag)
        utfil.write('\t\t</datum>\n')
        utfil.write('\t\t<plats>\n')
        self.skrivrad(utfil,3,'gata', par.upplösn_gata)
        self.skrivrad(utfil,3,'by', par.upplösn_by)
        self.skrivrad(utfil,3,'kvarter', par.upplösn_kvarter)
        self.skrivrad(utfil,3,'socken', par.upplösn_socken)
        self.skrivrad(utfil,3,'församling', par.upplösn_församling)
        self.skrivrad(utfil,3,'disbytförsamling', par.upplösn_disbytförsamling)
        self.skrivrad(utfil,3,'stad', par.upplösn_stad)
        self.skrivrad(utfil,3,'härad', par.upplösn_härad)
        self.skrivrad(utfil,3,'län', par.upplösn_län)
        self.skrivrad(utfil,3,'utrikesplats', par.upplösn_utrikesplats)
        utfil.write('\t\t</plats>\n')
        self.skrivmultirad(utfil,2,'källa', par.upplösn_källa)
        utfil.write('\t</upplösning>\n')
        utfil.write('\t<barn>\n')
        self.skrivmultirad(utfil,2,'barn_ID', par.barn_ID)
        utfil.write('\t</barn>\n')
        self.skrivmultirad(utfil,1, 'källor', par.fler_källor)
        self.skrivmultirad(utfil,1, 'anteckning', par.anteckning)
        self.skrivrad(utfil,1, 'sparat', par.senastsparat)
        utfil.write('</par>\n')

        utfil.close()

        if backupnivå >0:
            #backupnivå = 8
            while backupnivå >0:
                if os.path.exists(str(utfilnamn) + "." + str(backupnivå)):
                    os.rename( str(utfilnamn) + "."  + str(backupnivå), str(utfilnamn) + "." + str(backupnivå+1))
                backupnivå = backupnivå - 1
            if os.path.exists(utfilnamn):
                os.rename( utfilnamn, utfilnamn + "." + str(backupnivå+1))

        if os.path.exists(tmpfilnamn):
            os.rename( tmpfilnamn, utfilnamn )
        return
########################################################################################




########################################################################################
    def johanlock(self, låsfilnamn, msg = ""):

# Anropas: (radnummer i maj 2010)
#
# anor.py:752:            lockresponsesenaste   = allmänt.johanlock(allmänt(),lockfilesenaste)
# anor.py:758:            lockresponseperson    = allmänt.johanlock(allmänt(),lockfileperson)
# anor.py:784:            lockresponsenyperson1 = allmänt.johanlock(allmänt(),lockfilenyperson1)
# anor.py:805:            lockresponsenyperson2 = allmänt.johanlock(allmänt(),lockfilenyperson2)
# anor.py:852:            lockresponsenyttpar   = allmänt.johanlock(allmänt(),lockfilenyttpar)
# dubbelanor.py:749:      lockresponsesenaste   = allmänt.johanlock(allmänt(),lockfilesenaste)
# dubbelanor.py:755:      lockresponseperson    = allmänt.johanlock(allmänt(),lockfileperson)
# dubbelanor.py:781:      lockresponsenyperson1 = allmänt.johanlock(allmänt(),lockfilenyperson1)
# dubbelanor.py:802:      lockresponsenyperson2 = allmänt.johanlock(allmänt(),lockfilenyperson2)
# dubbelanor.py:834:      lockresponsenyttpar   = allmänt.johanlock(allmänt(),lockfilenyttpar)

# ättlingar.py:642:       lockresponsesenaste   = allmänt.johanlock(allmänt(),lockfilesenaste)
# ättlingar.py:647:       lockresponseperson    = allmänt.johanlock(allmänt(),lockfileperson)
# ättlingar.py:699:       lockresponsenyperson  = allmänt.johanlock(allmänt(),lockfilenyperson)
# ättlingar.py:704:       lockresponsenyttpar   = allmänt.johanlock(allmänt(),lockfilenyttpar)
# ättlingar.py:852:       lockresponsesenaste   = allmänt.johanlock(allmänt(),lockfilesenaste)
# ättlingar.py:858:       lockresponsepar       = allmänt.johanlock(allmänt(),lockfilepar)
# ättlingar.py:888:       lockresponsenyperson  = allmänt.johanlock(allmänt(),lockfilenyperson)
# dubbelättlingar.py:701: lockresponsesenaste   = allmänt.johanlock(allmänt(),lockfilesenaste)
# dubbelättlingar.py:706: lockresponseperson    = allmänt.johanlock(allmänt(),lockfileperson)
# dubbelättlingar.py:758: lockresponsenyperson  = allmänt.johanlock(allmänt(),lockfilenyperson)
# dubbelättlingar.py:763: lockresponsenyttpar   = allmänt.johanlock(allmänt(),lockfilenyttpar)
# dubbelättlingar.py:912: lockresponsesenaste   = allmänt.johanlock(allmänt(),lockfilesenaste)
# dubbelättlingar.py:918: lockresponsepar       = allmänt.johanlock(allmänt(),lockfilepar)
# dubbelättlingar.py:948: lockresponsenyperson  = allmänt.johanlock(allmänt(),lockfilenyperson)

# parblad.py:266:         lockresponsepar       = allmänt.johanlock(allmänt(),lockfilepar)
# personblad.py:302:      lockresponseperson    = allmänt.johanlock(allmänt(),lockfileperson)
#

        import os
        import errno
        import sys
        import datetime
        import time
        import stat
        import socket


        persontext = (
          '\nPersonfiler öppnas för uppdatering av programmet personblad.py.'
        + ' För varje personfil som öppnas skapas en tillhörande låsfil, DATABAS/locks/pers_nr.lock.'
        + '\n\nDenna varning innebär som regel att du försöker öppna en personfil som redan'
        + ' är öppnad för uppdatering från en annan förekomst av personblad.py i samma dator'
        + ' eller i någon annan dator med åtkomst till samma databas.'
        + '\nLåsfilen tas bort automatiskt när denna uppdatering avslutas.'
        + '\n\nOm en uppdatering har avbrutits onormalt kan motsvarande låsfil ha lämnats kvar.'
        + ' Verifiera att uppdatering faktiskt inte pågår från den dator som'
        + ' anges ovan, innan du manuellt raderar låsfilen för att kunna fortsätta.')

        partext = (
          '\nParfiler öppnas för uppdatering av programmet parblad.py.'
        + ' För varje parfil som öppnas skapas en tillhörande låsfil, DATABAS/locks/par_nr.lock.'
        + '\n\nDenna varning innebär som regel att du försöker öppna en parfil som redan'
        + ' är öppnad för uppdatering från en annan förekomst av parblad.py i samma dator'
        + ' eller i någon annan dator med åtkomst till samma databas.'
        + '\nLåsfilen tas bort automatiskt när denna uppdatering avslutas.'
        + '\n\nOm en uppdatering har avbrutits onormalt kan motsvarande låsfil ha lämnats kvar.'
        + ' Verifiera att uppdatering faktiskt inte pågår från den dator som'
        + ' anges ovan, innan du manuellt raderar låsfilen för att kunna fortsätta.')


        senastetext = (
          '\n\nFör filerna DATABAS/senaste/senasteperson.txt och DATABAS/senaste/senastepar.txt'
        + ' skapas en gemensam låsfil, DATABAS/locks/senaste.lock.'
        + ' Låsfilen existerar endast under bråkdelar av någon sekund,'
        + ' medan programmen anor.py eller ättlingar.py skapar nummer för nya filer.'
        + '\n\nDenna varning innebär att låsfilen fortfarande finns och troligen'
        + ' är kvarlämnad sedan en förekomst av anor.py eller ättlingar.py avbrutits onormalt.'
        + '\n\n1) Avsluta alla Johan-program som kör mot den aktuella databasen.'
        + '\n2) Radera låsfilen manuellt'
        + '\n3) Starta Johan och kör databaskontrollen')

        max_väntetid = 5  # Om låsfilen är mindre än 5 sekunder gammal så väntar vi tills den blir det
        max_försök = 3

        while True:
            try:
                låsfildeskriptor = os.open(låsfilnamn, os.O_EXCL | os.O_RDWR | os.O_CREAT)
                # låsfilen skapades så vi är ägare. 
                break
            except OSError as e:
                if e.errno != errno.EEXIST:
                    return "Okänt fel - kan inte skapa låsfilen " + låsfilnamn

            #  'Låsfilen ' + låsfilnamn + ' finns redan'

            try:
                #  låsfilen finns sedan tidigare; försök bestämma dess ålder och innehåll och ägare.
                låsfil = open(låsfilnamn, "r", encoding='utf-8')
                s = os.stat(låsfilnamn)

            except OSError as e:
                if e.errno != errno.ENOENT:
                    return "Låsfilen\n" + låsfilnamn + "\ntycks finnas redan men jag kan inte få status för den:\n" + e.strerror
                else:  # det var inte vi som skapade låsfilen, den fanns nyss men är borta nu. Försök igen att skapa en åt oss.
                    max_försök = max_försök - 1
                    if max_försök < 0: # efter tre omförsök ger vi upp.
                        return "Låsfilen\n" + låsfilnamn + "\ntycks ha funnits och försvunnit men jag kan ändå inte skapa ny:\n" + e.strerror
                    continue # gå upp och försök igen

            # låsfilen finns där sedan tidigare, läs dess innehåll
            if int(time.time()) - s[stat.ST_MTIME] > max_väntetid:
                lästlåstext = låsfil.read()
                låsfil.close()

                returnmsg = "LÅS-filen  " + låsfilnamn + "\när " + lästlåstext

                låsnamn = os.path.split(låsfilnamn)[1]
                if låsnamn.find("senaste") != -1:
                    returnmsg = returnmsg + senastetext
                elif låsnamn.find("par") == 0:
                    returnmsg = returnmsg + partext
                else:
                    returnmsg = returnmsg + persontext

                return returnmsg
            else:
                time.sleep(1) # vänta en sekund i taget och försök igen


# Kommer vi hit så har vi skapat vår nya låsfil
# Skriv nu vårt innehåll i den
# låst (kl) från (hostname) av (user) med (prog), PID=(pid)
        justnu = datetime.datetime.today()
        hostname = socket.gethostname()

        användare = 'Okänd'

        if  sys.platform == "win32":
            try:
                användare = unicode(os.environ['USERNAME'])
            except:
                pass

        if  sys.platform == "linux2":
            try:
                användare = unicode(os.environ['USER'])
            except:
                pass

        program = os.path.split(sys.argv[0])[1]
        PID = str(os.getpid())

        låstext = 'låst ...'
        låstext = låstext + '\n    sedan ' + justnu.strftime("%Y-%m-%d %H:%M:%S")
        låstext = låstext + '\n    från dator "'   + hostname  + '"'
        låstext = låstext + '\n    av användare "' + användare + '"'
        låstext = låstext + '\n    med program "'  + program   + '"'
        låstext = låstext + ', (PID=' + PID + ')'

        låsfil = os.fdopen(låsfildeskriptor, "w", encoding='utf-8') # Convert the os.open file descriptor into a Python file object
        låsfil.write(låstext) # skriv i den nya låsfilen vem som äger låset
        if msg != "":
            låsfil.write ('\n' + msg) # utrymme för mera meddelande från anropande program
        låsfil.write('\n')
        låsfil.close()

# retur utan svar betyder att vi skapade låset
        return ""
########################################################################################




########################################################################################
    def sijstrip(self, sträng):
        tmp=sträng
        pos = tmp.find("\n")
        while pos >= 0:
            if pos==0:
                tmp = tmp[1:]
            elif pos>0:
                tmp = tmp[:pos] +" "+ tmp[pos+1:]
            pos = tmp.find("\n")

        pos = tmp.find("  ")
        while pos >= 0:
            if pos==0:
                tmp = tmp[1:]
            elif pos>0:
                tmp = tmp[:pos] + tmp[pos+1:]
            pos = tmp.find("  ")
        return tmp.strip()
########################################################################################




########################################################################################
    def personålder(self, person):
        validdöddatum=False
        validfödddatum=False
        cirkadöddatum=False
        cirkafödddatum=False
        svar=""

        try:
            döddatum = datetime.datetime(int(person.död_år), int(person.död_månad), int(person.död_dag))
            validdöddatum=True
        except:
            try:
                döddatum = datetime.datetime(int(person.död_år),7,1)  # försök med bara årtal och 1 juli
                cirkadöddatum=True
            except:
                cirkadöddatum=False
#                print "Kunde inte tolka datum:", person.död_år, person.död_månad, person.död_dag
        try:
            födddatum = datetime.datetime(int(person.född_år), int(person.född_månad), int(person.född_dag))
            validfödddatum=True
        except:
            try:
                födddatum = datetime.datetime(int(person.född_år),7,1)  # försök med bara årtal och 1 juli
                cirkafödddatum=True
            except:
                cirkafödddatum=False
#                print "Kunde inte tolka datum:", person.född_år, person.född_månad, person.född_dag


        svar_år=""
        svar_dagar=""
        if (validdöddatum==True and validfödddatum==True) or (cirkadöddatum==True and validfödddatum==True) or (validdöddatum==True and cirkafödddatum==True) or (cirkadöddatum==True and cirkafödddatum==True):

            uppnåddålder = döddatum - födddatum
            uppnåddålderår=int((uppnåddålder.days + 3)/365.25)

            if uppnåddålderår <10:
                svar_år = "  " + str(uppnåddålderår)
            elif uppnåddålderår <100:
                svar_år = " " + str(uppnåddålderår)
            else:
                svar_år = str(uppnåddålderår)


            svara_dagar = str(int(uppnåddålder.days)).zfill(5)


        if validdöddatum==True and validfödddatum==True:
            return svar_år , svara_dagar
        elif (cirkadöddatum==True and validfödddatum==True) or (validdöddatum==True and cirkafödddatum==True) or (cirkadöddatum==True and cirkafödddatum==True):
            return svar_år + " ca", svara_dagar
        else:
            return "", "99999"



#        if validdöddatum==True and validfödddatum==True:
#            uppnåddålder = döddatum - födddatum
#            uppnåddålderår=int((uppnåddålder.days + 3)/365.25)
#            return str(uppnåddålderår)
#        elif (cirkadöddatum==True and validfödddatum==True) or (validdöddatum==True and cirkafödddatum==True) or (cirkadöddatum==True and cirkafödddatum==True):
#            uppnåddålder = döddatum - födddatum
#            uppnåddålderår=int((uppnåddålder.days + 3)/365.25)
#            return str(uppnåddålderår) + " ca"
#        else:
#            return ""
########################################################################################



########################################################################################
    def gedfödddatum(self, person):
        return geddatum(person.född_år, person.född_månad, person.född_dag)
########################################################################################
    def gedvigdatum(self, par):
        return geddatum(par.inledn_år, par.inledn_månad, par.inledn_dag)
########################################################################################
    def geddöddatum(self, person):
        return geddatum(person.död_år, person.död_månad, person.död_dag)
########################################################################################


########################################################################################
    def geddatum(self, år, månad, dag):

# OBS! Månader med nummer 1 - 12 har index i båda de två listorna 0 - 11
        ged_månad = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"]
        gräns_dag = [31,29,31,30,31,30,31,31,30,31,30,31]

        svar = ""


        try:
            år_int = int(år)
            if år_int != 0:
                svar = str(år_int)
            else:
                return ""
        except:
            return ""

        try:
            månad_int = int(månad)
            if månad_int > 0 and månad_int < 13:
                svar = ged_månad[månad_int-1] + " " + svar
            else:
                return svar
        except:
            return svar


        try:
            dag_int = int(dag)
            if dag_int > 0 and dag_int <= gräns_dag[månad_int-1]:
                svar = str(dag_int) + " " + svar
            else:
                return svar
        except:
            return svar

        return svar
########################################################################################




########################################################################################
    def KategoriPgodk(self, person):

        if self.PULdödgodk( person, 25):    # PUL-godkänd om död sedan 25 år.
            return True

        if self.PULföddgodk (person, 110):  # anses PUL-godkänd om född för mera än 110 år sedan
            return True

        return False    # annars inte godkänd direkt
#                       # (kan vara person från äldre generation med varken
#                       # födelsedatum eller dödsdatum kända)
########################################################################################




########################################################################################
    def PULdödgodk(self, person, dödgräns):

        dödsedanår=0
        try:
            döddatum = datetime.datetime(int(person.död_år), int(person.död_månad), int(person.död_dag))
            dödsedan =  datetime.datetime.today() - döddatum
            dödsedanår = int((dödsedan.days + 3)/365.25)
            if dödsedanår >= dödgräns:
                return True
            else:
                return False
        except:
            try:
                döddatum = datetime.datetime(int(person.död_år),12,31)
                cirkadöddatum=True
                dödsedan = datetime.datetime.today() - döddatum
                dödsedanår =  int((dödsedan.days + 3)/365.25)
                if dödsedanår >= dödgräns:
                    return True
                else:
                    return False
            except:
                return False
# Svarar True om känt dödsdatum eller födelseår är mera än 'dödgräns" år tillbaka i tiden
# Annars False
########################################################################################




########################################################################################
    def PULföddgodk(self, person, föddgräns):

        föddsedanår=0
        try:
            födddatum = datetime.datetime(int(person.född_år), int(person.född_månad), int(person.född_dag))
            föddsedan = datetime.datetime.today() - födddatum
            föddsedanår =  int((föddsedan.days + 3)/365.25)
            if föddsedanår >=föddgräns:
                return True
            else:
                return False
        except:
            try:
                födddatum = datetime.datetime(int(person.född_år),12,31)
                cirkafödddatum=True
                föddsedan = datetime.datetime.today() - födddatum
                föddsedanår =  int((föddsedan.days + 3)/365.25)
                if föddsedanår >=föddgräns:
                    return True
                else:
                    return False
            except:
                return False
# Svarar True om känt födelsedatum eller känt födelseår är mera än 'föddgräns" år tillbaka i tiden
# Annars False
########################################################################################




###################################################################################################
    def räknamarkeringar(self, databas, lista, datumtillagg):

        from johanklasser import johanpersonfil

# Indata lista innehållande alla personer i databasen

        KatA_antal = 0
        KatB_antal = 0
        KatC_antal = 0
        Kat1_antal = 0
        KatO_antal = 0
        KatZ_antal = 0

        listkatalog = os.path.join(str(databas), "kategorier_" + str(datumtillagg))
        os.mkdir(listkatalog)

        utfilA      = open(os.path.join(str(listkatalog), "katA.txt"), 'w', encoding='utf-8')
        utfilB      = open(os.path.join(str(listkatalog), "katB.txt"), 'w', encoding='utf-8')
        utfilC      = open(os.path.join(str(listkatalog), "katC.txt"), 'w', encoding='utf-8')
        utfil1      = open(os.path.join(str(listkatalog), "kat1.txt"), 'w', encoding='utf-8')
        utfilO      = open(os.path.join(str(listkatalog), "katO.txt"), 'w', encoding='utf-8')
        utfilZ      = open(os.path.join(str(listkatalog), "katZ.txt"), 'w', encoding='utf-8')
        utfilSum    = open(os.path.join(str(listkatalog), "summering.txt"), 'w', encoding='utf-8')

        utfil1.write('\n')
        utfil1.write('\nKategori 1')
        utfil1.write('\n')
        utfil1.write('\nMarkeringen avser personer som ska tas med i utdrag för webb- och disbyt-')
        utfil1.write('\npublicering trots PUL-villkoren: dels personer som lämnat sitt tillstånd,')
        utfil1.write('\ndels personer från äldre generationer för vilka uppgift saknas beträffande')
        utfil1.write('\nbåde födelse och död.')
        utfil1.write('\n\n')


        utfilA.write('\n')
        utfilA.write('\nKategori A')
        utfilA.write('\n')
        utfilA.write('\nMarkeringen är avsedd för personer som jag inte alls vill lämna till webb-')
        utfilA.write('\neller disbytpublicering.')
        utfilA.write('\n\n')

        utfilC.write('\n')
        utfilC.write('\nKategori C')
        utfilC.write('\n')
        utfilC.write('\nMarkeringen är avsedd för personer som jag inte alls vill lämna till webb-')
        utfilC.write('\neller disbytpublicering eftersom uppgifterna lämnats mig av andra forskare.')
        utfilC.write('\n\n')


        utfilB.write('\n')
        utfilB.write('\nKategori B')
        utfilB.write('\n')
        utfilB.write('\nPersoner bortom en B-märkt person, sett från startpunkten vid sökning genom')
        utfilB.write('\ngrenar och rötter, undantas från utdrag för webb- och disbytpublicering.')
        utfilB.write('\nB-märkt person tas normalt med om PUL-villkoren medger detta.')
        utfilB.write('\nMed särskilt val kan även samtliga B-märkta personer undantas från utdraget.')
        utfilB.write('\n\n')

        utfilZ.write('\n')
        utfilZ.write('\nPersoner utan kategorimarkering kan tas med i utdrag för webb- och disbyt-')
        utfilZ.write('\npublicering om PUL-villkoren medger detta.')
        utfilZ.write('\n\n')


        utfilO.write('\n')
        utfilO.write('\nPersoner med okänd kategorimarkering.')
        utfilO.write('\n\n')


        Person1 = johanpersonfil()

        for pers in lista:
            filnamn = os.path.join(str(databas), "data", str(pers[:5]), str(pers) + ".xml")
            allmänt.hämtapersonfil(allmänt(), filnamn, Person1)

            kategori = Person1.person_kategori
            persontext=  Person1.person_ID + "  " + Person1.kortnamn + "\n"


            if kategori == "A":
                KatA_antal = KatA_antal + 1
                utfilA.write(persontext)

            elif kategori == "B":
                KatB_antal = KatB_antal + 1
                utfilB.write(persontext)

            elif kategori == "C":
                KatC_antal = KatC_antal + 1
                utfilC.write(persontext)

            elif kategori == "1":
                Kat1_antal = Kat1_antal + 1
                utfil1.write(persontext)

            elif kategori != "":
                KatO_antal = KatO_antal + 1
                utfilO.write(persontext)

            else:
                KatZ_antal = KatZ_antal + 1
                utfilZ.write(persontext)

        utfilA.write   ( '\nKategorimarkering "A", antal:   ' + str(KatA_antal) )
        utfilB.write   ( '\nKategorimarkering "B", antal:   ' + str(KatB_antal) )
        utfilC.write   ( '\nKategorimarkering "C", antal:   ' + str(KatC_antal) )
        utfil1.write   ( '\nKategorimarkering "1", antal:   ' + str(Kat1_antal) )
        utfilO.write   ( '\nOkänd kategorimarkering, antal: ' + str(KatO_antal) )
        utfilZ.write   ( '\nUtan kategorimarkering, antal:  ' + str(KatZ_antal) )

        utfilSum.write ( '\nKategorimarkering "A", antal:   ' + str(KatA_antal) )
        utfilSum.write ( '\nKategorimarkering "B", antal:   ' + str(KatB_antal) )
        utfilSum.write ( '\nKategorimarkering "C", antal:   ' + str(KatC_antal) )
        utfilSum.write ( '\nKategorimarkering "1", antal:   ' + str(Kat1_antal) )
        utfilSum.write ( '\nOkänd kategorimarkering, antal: ' + str(KatO_antal) )
        utfilSum.write ( '\nUtan kategorimarkering, antal:  ' + str(KatZ_antal) )

        utfilA.close()
        utfilB.close()
        utfilC.close()
        utfil1.close()
        utfilO.close()
        utfilZ.close()
        utfilSum.close()
###################################################################################################




###################################################################################################
    def kopierakatalog(self, katalog, nykatalog):

        import shutil

        if not os.path.exists(nykatalog):
            os.mkdir(nykatalog)

        folderinh =  os.listdir(katalog)

        for f in folderinh:
            if os.path.isfile(os.path.join(str(katalog), str(f))):      #Hittade vanlig fil att kopiera:
                shutil.copy2(  os.path.join(str(katalog) , str(f)), os.path.join(str(nykatalog), str(f)))

            elif os.path.isdir(os.path.join(str(katalog), str(f))):     # Hittade katalog att kopiera
                self.kopierakatalog (  os.path.join(str(katalog) , str(f)), os.path.join(str(nykatalog), str(f))) # rekursiv kopiering

            elif os.path.islink(os.path.join(str(katalog), str(f))):
                self.logga ("\nVARNING  Jag har inte lärt mig kopiera symlinks - lämnar " + str(f)  + " varken kopierad eller länkad")

            else:
                self.logga ("\nKOPIERADE INTE " +     str( os.path.join(str(katalog) , str(f))) + ". Känner inte igen filtypen som någon av fil, katalog eller länk" )

# symlink inom databas till fil inom databas bör kopieras som en motsvarande symlink inom nydatabas till motsvarande fil inom nydatabas
#   måste filen som länkas i nydatabas till redan vara kopierad eller kan den komma i efterhand?
# symlink inom databas till fil utom databas bör kopieras som en motsvarande symlink inom nydatabas till samma fil utom databas (och utom nydatabas)
###################################################################################################




###################################################################################################
    def förstaperson(self,db):
        if not os.path.exists(db):
            return ""
        senastepersonfilnamn = os.path.join( str(db), "senaste", "senasteperson.txt" )

        if not os.path.exists(senastepersonfilnamn):
            return ""
        if not os.path.isfile(senastepersonfilnamn):
            return ""
        senastepersonfil = open( senastepersonfilnamn, "r", encoding="utf-8" )
        senasteperson=senastepersonfil.readline().strip()# tag bort ev newline och annan whitespace
        senastepersonfil.close()
        for i in range (1, int(senasteperson) + 1 ):
            aktuelltpersonnummer =  str(i).zfill(8)
            filnamn = os.path.join(str(db), "data", str(aktuelltpersonnummer[:5]), str(aktuelltpersonnummer) + ".xml")
            if os.path.exists(filnamn):
                return str(aktuelltpersonnummer)
        return ""
###################################################################################################




###################################################################################################
    def förstapar(self,db):
        if not os.path.exists(db):
            return ""
        senasteparfilnamn = os.path.join( str(db), "senaste", "senastepar.txt" )
        if not os.path.exists(senasteparfilnamn):
             return ""
        if not os.path.isfile(senasteparfilnamn):
             return ""
        senasteparfil = open( senasteparfilnamn, "r", encoding="utf-8" )
        senastepar=senasteparfil.readline().strip()# tag bort ev newline och annan whitespace
        senasteparfil.close()
        for i in range (1, int(senastepar[3:11]) + 1 ):
            aktuelltparnummer =  "par" + str(i).zfill(8)
            filnamn = os.path.join(str(db), "data", str(aktuelltparnummer[:8]), str(aktuelltparnummer) + ".xml")
            if os.path.exists(filnamn):
                return str(aktuelltparnummer)
        return ""
###################################################################################################




#############################################################################################
    def validera(self, person, databas):
# person och databas kommer som QString
        if os.path.exists(os.path.join (str(databas), "data", str(person[0:5]), str(person) + '.xml')):
            return True
        else:
            msg = 'Person nr ' + str(person) + ' finns inte i databasen\n' + str(databas)
            if len(person) != 8:
                msg = msg + '\nRätt personnummerformat är sträng med 8 tecken: inledande nollor och decimalt tal'
            return msg
#############################################################################################




#############################################################################################
    def validerapar(self, par, databas):
# par och databas kommer som QString
#        parfiladress = os.path.join (str(databas), "data", str(par[0:8]), str(par) + '.xml')

        if os.path.exists( os.path.join (str(databas), "data", str(par[0:8]), str(par) + '.xml')):
            return True
        else:
            msg = 'Par nr ' + str(par) + ' finns inte i databasen\n' + str(databas)
            if len(par) != 11:
                msg = msg + '\nRätt parnummerformat: Sträng med 11 tecken: "par" + utfyllande nollor och decimalt tal'
            return msg
###########################################################################################




###################################################################################################
#       De första 32 tecknen i ASCII tabellen är ej skrivbara.
#       DEC 	HEX 	Symbol 	HTML  	Beskrivning
#       0	00	NUL		Null char.
#       1	01	SOH		Start of Header
#       2	02	STX		Start of Text
#       3	03	ETX		End of Text
#       4	04	EOT		End of Transmission
#       5	05	ENQ		Enquiry
#       6	06	ACK		Acknowledgment
#       7	07	BEL		Bell
#       8	08	BS		Backspace
#       9	09	HT		Horizontal Tab
#       10	0A	LF		Line Feed
#       11	0B	VT		Vertical Tab
#       12	0C	FF		Form Feed
#       13	0D	CR		Carriage Return
#       14	0E	SO		Shift Out
#       15	0F	SI		Shift In
#       16	10	DLE 		Data Link Escape
#       17	11	Dcl 		XON Device Control 1
#       18	12	DC2 		Device Control 2
#       19	13	DC3 		XOFFDevice Control 3
#       20	14	DC4 		Device Control 4
#       21	15	NAK 		Negative Acknowledgement
#       22	16	SYN 		Synchronous Idle
#       23	17	ETB 		End of Trans. Block
#       24	18	CAN 		Cancel
#       25	19	EM		End of Medium
#       26	1A	SUB 		Substitute
#       27	1B	ESC 		Escape
#       28	1C	FS		File Separator
#       29	1D	GS		Group Separator
#       30	1E	RS		Record Separator
#       31	1F	US		Unit Separator
#
#       Tecknen 32-127 är gemensam för alla varianter av ASCII-tabeller,
#       de kallas även för de skrivbara tecknen i ASCII.
#
#       32	20	 	 	Mellanslag
#       33	21	!	 	Utropstecken
#       34	22	"	&quot;	Citationstecken (Citattecken)
#       35	23	#	 	Nummertecken (staket)
#       36	24	$	 	Dollartecken
#       37	25	%	 	Procenttecken
#       38	26	&	&amp;	Ochtecken
#       39	27	'	 	Apostrof
#       40	28	(	 	Vänster parentes
#       41	29	)	 	Höger parentes
#       42	2A	*	 	Asterisk
#       43	2B	+	 	Plus
#       44	2C	,	 	Komma
#       45	2D	-	 	Minus
#       46	2E	.	 	Punkt
#       47	2F	/	 	Divisionstecken (Slash)
#       48	30	0	 	Siffran 0
#       |
#       57	39	9	 	Siffran 9
#       58	3A	:	 	Kolon
#       59	3B	;	 	Semikolon
#       60	3C	<	&lt;	Mindre än
#       61	3D	=	 	Lika med
#       62	3E	>	&gt;	Större än
#       63	3F	?	 	Frågetecken
#       64	40	@	 	Snabel-A (At)
#       65	41	A	 	Versalt A
#       |
#       90	5A	Z	 	Versalt Z
#       91	5B	[	 	Vänster hakparentes
#       92	5C	\	 	Backslash
#       93	5D	]	 	Höger hakparentes
#       94	5E	^	 	Utelämningstecken (Caret)
#       95	5F	_	 	Horisontell linje
#       96	60	`	 	Grav ( Acute accent )
#       97	61	a	 	Gement a
#       |
#       122	7A	z	 	Gement z
#       123	7B	{	 	Vänster krullparentes
#       124	7C	|	 	Vertikal linje
#       125	7D	}	 	Höger krullparentes
#       126	7E	~	 	Tilde
#       127	7F		 	Delete




    def validpathname(self, s):
        for i in range(0,len(s)):
            try:
                j= ord(s[i])
            except:
                return False, i
            if j>=123:              # { | } ~
                return False, i
            if j<=44:               # ! " # $ % & ' ( ) * + ,
                return False, i

# kolon får inte finnas i linuxsökvägar, men finns i windowssökvägar. Strunta tills vidare i att kolla alls
#            if j>=58 and j<=64:     # : ; < = > ? @
#                return False, i
            if j>=59 and j<=64:     # ; < = > ? @
                return False, i

            if j == 91:             # [
                return False, i
            if j == 93:             # ]
                return False, i
            if j == 94:             # ^
                return False, i
            if j == 96:             # `
                return False, i

        return True, i      # - . / 0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ \ _ abcdefghijklmnopqrstuvwxyz




    def validfilename(self, s):
        for i in range(0,len(s)):
            try:
                j= ord(s[i])
            except:
                return False, i
            if j>=123:              # { | } ~
                return False, i
            if j<=44:               # ! " # $ % & ' ( ) * + ,
                return False, i
            if j==47:               # /
                return False, i
            if j>=58 and j<=64:     # : ; < = > ? @
                return False, i
            if j>=91 and j<=94:     # [ \ ] ^
                return False, i
            if j == 96:             # `
                return False, i

        return True, i      # - . 0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ _ abcdefghijklmnopqrstuvwxyz

###################################################################################################




#############################################################################################
    def  bestäminifil(self, parent, INIfilnamn):      # INIfilnamn = str(self.options.INIfilnamn)

# Detta program körs innan anroparens grafiska del är etablerad
# besked till användaren genom 'print' eller 'QMessageBox'
#
# I INI-filen finns skalfaktor som ska användas vid den följande
# inställningen av anroparens grafiska del.
#
# Detta program behövs således av alla johan-program med grafisk gränsyta

        inifiltext = ''

        inifilnamn = INIfilnamn
#        print ("parent = " + str(parent) + "   inifilnamn = " + str(inifilnamn) )


        if inifilnamn == 'None':
            inifilnamn = ''
        elif not os.path.exists( str(inifilnamn) ):
            msg = 'Jag hittar inte utpekad startfil: ' + inifilnamn
            QtGui.QMessageBox.warning(parent, '', msg, QtGui.QMessageBox.Ok )
            inifilnamn = ''
        else:
            inifil = open(str(inifilnamn), 'r', encoding='utf-8')
            inifiltext = inifil.read()
            inifil.close()
            if inifiltext != '':
                return inifilnamn, inifiltext
            else:
                msg = 'Utpekad startfil, ' + inifilnamn + ', är tom. Ge den gärna innehåll.'
                QtGui.QMessageBox.warning(parent, '', msg, QtGui.QMessageBox.Ok )
                inifilnamn = ''

        inifilnamn = self.förvaldINIfil()
        if not os.path.exists(inifilnamn):
            msg = 'Jag hittar inte förvald startfil: ' + inifilnamn
            QtGui.QMessageBox.warning(parent, '', msg, QtGui.QMessageBox.Ok  )
            inifilnamn = ''
        else:
            inifil = open(inifilnamn, 'r', encoding='utf-8')
            inifiltext = inifil.read()
            inifil.close()
            if inifiltext == '':
                msg = 'Förvald startfil, ' + inifilnamn + ', är tom. Ge den gärna innehåll.'
                QtGui.QMessageBox.warning(parent, '', msg, QtGui.QMessageBox.Ok )


        return inifilnamn, inifiltext
# inifiltexten kan användas i aktuellt program
# inifilnamn skickas vidare vid anrop av andra johan-program
#############################################################################################




#############################################################################################
    def förvaldINIfil(self):

# Bestäm ini-fil på hemkatalog, skapa vid behov sökväg och tom fil
        sysplatform = sys.platform

        if sysplatform == "linux2":
            try:
                hemma = os.environ['HOME']  # ex. /home/ingemar
                if not os.path.exists(os.path.join(hemma,'.johan_py3')):
                    os.mkdir(os.path.join(hemma,'.johan_py3'))
                inifilnamn = os.path.join(hemma,'.johan_py3','johan_ini.xml')
                if not os.path.exists(inifilnamn):
                    tominifil = open(inifilnamn, 'a')
                    tominifil.close()
            except:
                inifilnamn = ''

        elif sysplatform == "win32":
            try:
                hemma = os.environ['APPDATA']  # ex. C:\Documents and Settings\ingemar\Application Data
                if not os.path.exists(os.path.join(hemma,'sij')):
                    os.mkdir(os.path.join(hemma,'sij'))
                if not os.path.exists(os.path.join(hemma,'sij','johan_py3')):
                    os.mkdir(os.path.join(hemma,'sij','johan_py3'))
                inifilnamn = os.path.join(hemma,'sij','johan_py3','johan_ini.xml')
                if not os.path.exists(inifilnamn):
                    tominifil = open(inifilnamn, 'a')
                    tominifil.close()
            except:
                inifilnamn = ''

        else:  # varken linux eller windows, vad gör jag då?
            msg = 'Jag känner inte igen sys.platform = ' + sys.platform
            msg = msg + '\n\n   platform.uname() = ' + platform.uname()
            msg = msg + '\n   platform.platform() = ' + platform.platform()
            QtGui.QMessageBox.warning(self, 'Johan: okänd miljö', msg, 'Fortsätt ändå!')

            inifilnamn = ''

        return inifilnamn
#############################################################################################




#############################################################################################
    def hämtaprogramsökvägar (self, inifiltxt):

        sysplatform = sys.platform
# 1)  I botten ställs in programnamn (inkl. ev. sökvägar) med i detta program förinställda värden.
# 2)  Eventuella värden i den ordinarie INI-filen skriver över.
# 3)  Eventuella värden i en eventuell INI-fil från kommandoraden skriven över.


#--------------------------------------------------------------------------------------------
# Förvalda inställningar som används om inte nedanstående tar överhanden

# för aktuellt system

        allmänt.PYTON = sys.executable # För anrop av program i Johan-gruppen ska väljas samma Python som detta program körs med.

        if sysplatform == "linux2":
            allmänt.EDITOR = '/usr/bin/kate'     # förvald editor, finns i min Ubuntu/Kubuntu och kanske fler
            allmänt.FILHANTERARE = '/usr/bin/krusader'
            allmänt.ORDBEHANDLARE = '/usr/bin/ooffice -writer'

        elif sysplatform == "win32":
            allmänt.EDITOR = 'C:\\Program\\PSPad\\Lang\\PSPad.exe'   # förvald editor
            allmänt.FILHANTERARE = 'C:\\Program\\Ztree174\\ztw.exe'     # min favoritfilhanterare, se www.ztree.com
            allmänt.ORDBEHANDLARE = 'C:\\Program\\OpenOffice.org 3\\program\\swriter.exe'

        else: # okänt operativsystem
            allmänt.EDITOR = ''
            allmänt.FILHANTERARE = ''
            allmänt.ORDBEHANDLARE = ''

#--------------------------------------------------------------------------------------------
# Anpassade inställningar hämtas ur INI-fil

        if inifiltxt != '':

            område_start, område_end = allmänt.hittaområde( allmänt(), inifiltxt, "sökvägar", 0, len(inifiltxt) )

            tmp = allmänt.hittaparam( allmänt(), inifiltxt, "editor",        område_start, område_end )
            if tmp != "":
                allmänt.EDITOR = tmp

            tmp = allmänt.hittaparam( allmänt(), inifiltxt, "filhanterare",  område_start, område_end )
            if tmp != "":
                allmänt.FILHANTERARE = tmp

            tmp = allmänt.hittaparam( allmänt(), inifiltxt, "ordbehandlare", område_start, område_end )
            if tmp != "":
                allmänt.ORDBEHANDLARE = tmp

        return
#############################################################################################




#############################################################################################
    def hämtavertikalfaktor (self, inifiltxt):

        maxlen = len(inifiltxt)

        try:
            tmp  = float(allmänt.hittaparam(allmänt(), inifiltxt, "radhöjdsfaktor", 0 , maxlen))
        except:
            tmp = 1.1

        if 0.3 < tmp < 3.0:
            allmänt.Vertikalfaktor = tmp
        else:
            allmänt.Vertikalfaktor = 1.1

        return
###################################################################################################




###################################################################################################
    def hämtastartfontsize (self, inifiltxt):

        maxlen = len(inifiltxt)

        try:
            start_fs = int(allmänt.hittaparam(allmänt(), inifiltxt, "startfontsize", 0 , maxlen))
        except:
            start_fs = 10

        if 6 < start_fs < 15:
            allmänt.Startfontsize = start_fs
        else:
            allmänt.Startfontsize = 10

        return
###################################################################################################
