#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# kontrollera.py

# Senast ändrad: 2011-02-28  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
# kontroller som kanske kommer att införas i programmet
# kontrollera att för parfiler med barn, person1 är man, person2 är kvinna (tillåtes enkönade par - utan barn)
# kontrollera att inga filer för par eller personer bortom "senastepar" och "senasteperson"
# kontrollera att alla korsvisa länkar finns på plats
#   par till två personer, båda personer till paret
#   par till barn, barn till paret
#   bonusrelation (par eller person) till bonusrelation (par eller person)
#       par-par, par-person, person-person
# kontrollera att moders ålder är trovärdig (införes senare)
# kontrollera att persons årtal/datum ligger i rätt ordning och är trovärdiga
#    födelse, barn/gifte, död  (införes senare)
############################################################################




############################################################################
import sys
import os
import datetime
import shutil
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from optparse import OptionParser
from gui_kontrollera import gui_Kontrollera

from johanklasser import johanpersonfil, johanparfil
from johangemensamt import allmänt

########################################################################################




########################################################################################
class Kontrollera(QtGui.QMainWindow, gui_Kontrollera):

    SenastÄndrad = '2011-02-28 18:28:58'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'kontrollera_py3_'
    loggfilopen = False

    fontsize = 9
    förstagången = True

    databas = ''
    datumtillägg = ''

    senasteperson = ''
    senastepar = ''

    primärpersonlista = []
    primärparlista = []
    datakataloglista = []
    parlista = []
    personlista = []

    sverigesförsamlingar   = ''   # för närvarande identisk med "Sveriges Församlingar Genom Tiderna", 1989
    minaförsamlingar  = ''        # ny, daterad version byggs upp vid varje körning av detta program

    options = {}
    args = []

    färgschema = '0'     # '0' = Standard, '1' = Master, '2' = Compare
    färgschemabakgrund = QColor()

    inifilnamn = ''
    inifiltext = ''
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]


    f_option = ""
    i_option = ""

########################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-f", "--färg", dest="färgschema", help="färgschema vid databasjämförelser")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize
        self.bestämbakgrundsfärg()

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder =  os.path.join( os.environ['APPDATA'], 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass

        self.setupUi(self)

        self.inledning()

        self.ui_connections()      # signaler i gui till slots i gui_kontrollera.py

        self.mera_ui_connections() # signaler i gui till slots i kontrollera.py

# Öppna inte avbrotten för ändringar i inmatningsfälten förrän de fyllts första gången!
        self.enableUi()

        return
########################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Kontrollera_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




###################################################################################################
    def bestämbakgrundsfärg(self):

# --- bakgrundsfärg måste  (?) bestämmas före setupUi i Personblad.py

        self.f_option = ""
        self.färgschema = str(self.options.färgschema)
        if self.färgschema == "None":
            self.färgschema = '0'
            self.f_option = ""
            self.färgschemabakgrund = QColor(0,0,0,0) # färgschema Standard
#            self.setupFärgschema0()
        elif self.färgschema == '1':
            self.f_option = " -f 1 "
            self.färgschemabakgrund = QColor(0,255,0,16) # färgschema Master (ljusgrönt)
#            self.setupFärgschema1()
        elif self.färgschema == '2':
            self.f_option = " -f 2 "
            self.färgschemabakgrund = QColor(255,255,0,32) # färgschema Compare  (ljusgult)
#            self.setupFärgschema2()
        return
###################################################################################################




########################################################################################
# en del av grafiska gränsytan kodas här
    def mera_ui_connections(self):

        QtCore.QObject.connect(self.pushButton_Starta,QtCore.SIGNAL("clicked()"), self.startaknapp)
########################################################################################




########################################################################################
    def startaknapp(self):

        idag = datetime.datetime.today()
        self.datumtillägg = str(idag.year) + str(idag.month).zfill(2) + str(idag.day).zfill(2) + "_" + str(idag.hour).zfill(2) + str(idag.minute).zfill(2) + str(idag.second).zfill(2)

        self.databas = self.lineEdit_Databas.text()
        self.startakontroll()

########################################################################################




########################################################################################
    def ritaom(self):
        self.sijlayout()
        return
########################################################################################




########################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        if len(self.args) != 1 : # Jag förväntar mig exakt ett argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt ett argument i anropet: Databasadress. Jag avbryter här. \n")
            self.avsluta(1)


        self.lineEdit_Databas.setText(self.args[0])
        self.databas = self.lineEdit_Databas.text()

        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)

#        idag = datetime.datetime.today()
#        self.datumtillägg = str(idag.year) + str(idag.month).zfill(2) + str(idag.day).zfill(2) + "_" + str(idag.hour).zfill(2) + str(idag.minute).zfill(2) + str(idag.second).zfill(2)

        self.primärpersonlista = []
        self.primärparlista = []
        self.datakataloglista = []
        self.parlista = []
        self.personlista = []

        self.fontsizeset()

###################################################################################################




###################################################################################################
#    def validpathname(self, s)    def validfilename(self, s)
#
#       De första 32 tecknen i ASCII tabellen är ej skrivbara.
#       DEC 	HEX 	Symbol 	HTML  	Beskrivning
#       0	00	NUL		Null char.
#       1	01	SOH		Start of Header
#       2	02	STX		Start of Text
#       3	03	ETX		End of Text
#       4	04	EOT		End of Transmission
#       5	05	ENQ		Enquiry
#       6	06	ACK		Acknowledgment
#       7	07	BEL		Bell
#       8	08	BS		Backspace
#       9	09	HT		Horizontal Tab
#       10	0A	LF		Line Feed
#       11	0B	VT		Vertical Tab
#       12	0C	FF		Form Feed
#       13	0D	CR		Carriage Return
#       14	0E	SO		Shift Out
#       15	0F	SI		Shift In
#       16	10	DLE 		Data Link Escape
#       17	11	Dcl 		XON Device Control 1
#       18	12	DC2 		Device Control 2
#       19	13	DC3 		XOFFDevice Control 3
#       20	14	DC4 		Device Control 4
#       21	15	NAK 		Negative Acknowledgement
#       22	16	SYN 		Synchronous Idle
#       23	17	ETB 		End of Trans. Block
#       24	18	CAN 		Cancel
#       25	19	EM		End of Medium
#       26	1A	SUB 		Substitute
#       27	1B	ESC 		Escape
#       28	1C	FS		File Separator
#       29	1D	GS		Group Separator
#       30	1E	RS		Record Separator
#       31	1F	US		Unit Separator
#
#       Tecknen 32-127 är gemensam för alla varianter av ASCII-tabeller,
#       de kallas även för de skrivbara tecknen i ASCII.
#
#       32	20	 	 	Mellanslag
#       33	21	!	 	Utropstecken
#       34	22	"	&quot;	Citationstecken (Citattecken)
#       35	23	#	 	Nummertecken (staket)
#       36	24	$	 	Dollartecken
#       37	25	%	 	Procenttecken
#       38	26	&	&amp;	Ochtecken
#       39	27	'	 	Apostrof
#       40	28	(	 	Vänster parentes
#       41	29	)	 	Höger parentes
#       42	2A	*	 	Asterisk
#       43	2B	+	 	Plus
#       44	2C	,	 	Komma
#       45	2D	-	 	Minus
#       46	2E	.	 	Punkt
#       47	2F	/	 	Divisionstecken (Slash)
#       48	30	0	 	Siffran 0
#       |
#       57	39	9	 	Siffran 9
#       58	3A	:	 	Kolon
#       59	3B	;	 	Semikolon
#       60	3C	<	&lt;	Mindre än
#       61	3D	=	 	Lika med
#       62	3E	>	&gt;	Större än
#       63	3F	?	 	Frågetecken
#       64	40	@	 	Snabel-A (At)
#       65	41	A	 	Versalt A
#       |
#       90	5A	Z	 	Versalt Z
#       91	5B	[	 	Vänster hakparentes
#       92	5C	\	 	Backslash
#       93	5D	]	 	Höger hakparentes
#       94	5E	^	 	Utelämningstecken (Caret)
#       95	5F	_	 	Horisontell linje
#       96	60	`	 	Grav ( Acute accent )
#       97	61	a	 	Gement a
#       |
#       122	7A	z	 	Gement z
#       123	7B	{	 	Vänster krullparentes
#       124	7C	|	 	Vertikal linje
#       125	7D	}	 	Höger krullparentes
#       126	7E	~	 	Tilde
#       127	7F		 	Delete

    def validpathname(self, s):
        for i in range(0,len(s)):
            try:
                j= ord(s[i])
            except:
                return False, i
            if j>=123:
                return False, i
            if j<=44:
                return False, i
            if j>=58 and j<=64:
                return False, i
            if j == 91:
                return False, i
            if j == 93:
                return False, i
            if j == 94:
                return False, i
            if j == 96:
                return False, i

        return True, i

    def validfilename(self, s):
        for i in range(0,len(s)):
            try:
                j= ord(s[i])
            except:
                return False, i
            if j>=123:
                return False, i
            if j<=44:
                return False, i
            if j==47:
                return False, i
            if j>=58 and j<=64:
                return False, i
            if j>=91 and j<=94:
                return False, i
            if j == 96:
                return False, i

        return True, i
###################################################################################################




###################################################################################################

    def startakontroll(self):

        self.databas = str(self.lineEdit_Databas.text())

        validpath, teckenposition = self.validpathname(self.databas)
        if not validpath:
            self.logga ("VARNING! Sökvägen till databasen innehåller olämpligt tecken. Detta kan medföra problem i en del miljöer.\n")
            self.logga ("   Sökväg:    " + str(self.databas) + "\n")
            self.logga ("   position:  " + str(teckenposition) + "\n")

        if not  os.path.exists(self.databas):
            self.logga ("Jag hittar inte databasen     " + self.databas + "\nAVBRYTER!\n")

        elif not os.path.exists(os.path.join(self.databas, "data")):
            self.logga ("Jag känner inte igen databasen     " + self.databas + "\nAVBRYTER!\n")

        elif not os.path.exists( os.path.join(self.databas, "senaste", "senasteperson.txt")):
            self.logga ("Jag känner inte igen databasen     " + self.databas + "\nAVBRYTER!\n")

        elif os.path.exists(os.path.join(self.databas, "data")):
            self.logga ("Startar kontroll av " + self.databas + "\n" )


            if self.checkBox_Fas0.isChecked() == True:
                self.Fas0()  # skapa primära listor med person- och parnummer,
            if self.checkBox_Fas1.isChecked() == True:
                self.Fas1()  # koll av filstruktur
            if self.checkBox_Fas2.isChecked() == True:
                self.Fas2()  # koll av länkar mellan filer
            if self.checkBox_Fas3.isChecked() == True:
                self.Fas3()  # koll av taggar
            if self.checkBox_Fas4.isChecked() == True:
                self.Fas4()  # genererar kategorilistor
            if self.checkBox_Fas5.isChecked() == True:
                self.Fas5()  # kontrollerar församlingsnamn
            if self.checkBox_Fas6.isChecked() == True:
                self.Fas6()  # kompletterar person- och parkataloger med namntext
            if self.checkBox_Fas7.isChecked() == True:
                self.Fas7()  # kompletterar person- och parkataloger med namntext

            self.logga ("\nValda kontroller genomförda\n")

        return
###################################################################################################




###################################################################################################
    def checknumeric (self, st):
        numbers = ["0","1","2","3","4","5","6","7","8","9"]
        for s in st[0:len(st)]:
            if numbers.count(s) != 1:
                return False
        return True
###################################################################################################




###################################################################################################
    def Fas0(self):
# skapa primärlistor, alla personer och alla par i hela databasen

        self.logga ("\nFAS 0: Skapar primärlistor på person- och parfiler\n")

# läs sistapersonnummer-fil
        senastepersonfilnamn = os.path.join( self.databas, "senaste", "senasteperson.txt")
        senastepersonfil = open( senastepersonfilnamn, "r", encoding="utf-8" )
        self.senasteperson=senastepersonfil.readline().strip()# tag bort ev newline och annan whitespace
        senastepersonfil.close()
        self.primärpersonlista[:] = []
        for i in range (1, int(self.senasteperson) + 1 ):
            aktuelltpersonnummer =  str(i).zfill(8)
            filnamn = os.path.join(self.databas, "data", aktuelltpersonnummer[:5], aktuelltpersonnummer + ".xml")
            if os.path.exists(filnamn):
                self.primärpersonlista.append(aktuelltpersonnummer)

        self.primärpersonlista.sort()
        self.logga ("Antal personer i databasen:        " + str(len(self.primärpersonlista)) + "\n" )


# läs sistaparnummer-fil
# läs sistanummer-fil
        senasteparfilnamn = os.path.join(self.databas, "senaste", "senastepar.txt")
        senasteparfil = open( senasteparfilnamn, "r", encoding="utf-8" )
        self.senastepar=senasteparfil.readline().strip()# tag bort ev newline och annan whitespace
        senasteparfil.close()
        self.primärparlista[:] = []
        for i in range (1, int(self.senastepar[3:11]) + 1 ):
            aktuelltparnummer = "par" + str(i).zfill(8)
            filnamn = os.path.join(self.databas, "data", aktuelltparnummer[:8], aktuelltparnummer + ".xml")
            if os.path.exists(filnamn):
                self.primärparlista.append(aktuelltparnummer)

        self.primärparlista.sort()
        self.logga ("Antal par i databasen:        " + str(len(self.primärparlista)) + "\n" )

        self.logga ("\nFAS 0: Skapade primärlistor på person- och parfiler\n")


###################################################################################################
    def Fas1(self):
# Kontroll av länkar
# Indata till fas 1 är globala primärlistor innehållande alla personer i databasen respektive alla par i databasen

        self.datakataloglista[:] = []
        self.parlista[:] = []
        self.personlista[:] = []

        self.logga ("\nFAS 1: kontroll av filstruktur\n")

# analysera katalogstrukturen
        folderinh =  os.listdir(os.path.join(self.databas, "data"))
        folderinh.sort()
        for f1 in folderinh:
            if os.path.isdir(os.path.join(self.databas, "data", f1)):

                validpath, teckenposition = self.validpathname(f1)
                if not validpath:
                    self.logga ("VARNING! Sökvägen till databasen innehåller olämpligt tecken. Detta kan medföra problem i en del miljöer.\n")
                    self.logga ("   Sökväg:    " + self.databas + "/data/" + f1 + "\n")
                    self.logga ("   Position:  " + str( len(self.databas + "/data/") + teckenposition ) + "\n")

                NumberOK = False

                if len(f1) == 8:
                    NumberOK = self.checknumeric (f1 [3:8] ) and f1[0:3]== "par"
                    if NumberOK == True:
                        self.logga ("hittade pardatakatalog " + self.databas + "/data/" + f1 + "\n")
                elif len (f1) == 5:
                    NumberOK = self.checknumeric (f1 [0:5] )
                    if NumberOK == True:
                        self.logga ("hittade persondatakatalog " + self.databas + "/data/" + f1 + "\n")

                if NumberOK == True:  # således en katalog med persondatafiler eller pardatafiler i
                    self.datakataloglista.append(f1)

        for f2 in self.datakataloglista:
            f2inh = os.listdir(os.path.join(self.databas, "data", f2))
            for f3 in f2inh:
                if os.path.isfile(os.path.join(self.databas, "data", f2, f3)):
                    if f3[-4:] == ".xml":
                        if len(f3) == 15:  # par00000000.xml
                            NumberOK = self.checknumeric (f3 [3:11] ) and f3[0:3]== "par"
                            if NumberOK == True:
                                self.parlista.append(f3)
                                if int(f3 [3:11]) > int(self.senastepar[3:11]):

                                    self.logga("VARNING! Jag hittade parfil "+ self.databas + "/data/" + f2 + "/" + f3 + " med högre nummer än senaste par-nummer (" + self.senastepar + ")\n" )

                        elif len (f3) == 12: # 00000000.xml
                            NumberOK = self.checknumeric (f3 [0:8] )
                            if NumberOK == True:
                                self.personlista.append(f3)
                                if int(f3 [0:8]) > int(self.senasteperson):
                                    self.logga("VARNING! Jag hittade personfil "+ self.databas + "/data/" + f2 + "/" + f3 + " med högre nummer än senaste person-nummer (" + self.senasteperson + ")\n" )

                        if f2 != f3[0:len(f2)]:
                            self.logga ("VARNING! Det finns en fil " +  f3 + " på katalogen " + self.databas + "/data/" + f2 + "\noåtkomlig för normala Johan-funktioner\n")

  #                  else:
  #                      print # ny rad if not ".xml"
  #              else:
  #                  print # ny rad if not isfile

        self.parlista.sort()
        self.personlista.sort()

        if len(self.personlista) != len(self.primärpersonlista):
            self.logga ("VARNING!  Bristande överensstämmelse för antalet personfiler\n")
            self.logga ("len(self.personlista)=  " + str(len(self.personlista) ) + "\n" )
            self.logga ("len(self.primärpersonlista)=  " + str(len(self.primärpersonlista) ) + "\n" )

        if len(self.parlista) != len(self.primärparlista):
            self.logga ("VARNING!  Bristande överensstämmelse för antalet parfiler\n")
            self.logga ("len(self.parlista)=  " + str(len(self.parlista) ) + "\n" )
            self.logga ("len(self.primärparlista)=  " + str(len(self.primärparlista) ) + "\n" )

        self.logga ("FAS 1: kontroll av filstruktur klar\n")

        return
###################################################################################################




###################################################################################################
    def Fas2(self):
# Kontroll av länkar
# Indata till fas 2 är globala primärlistor innehållande alla personer i databasen respektive alla par i databasen

        self.logga ("\nFAS 2: kontroll av länkar (tar en stund)\n")

        Person1 = johanpersonfil()
        Person2 = johanpersonfil()
        Par1 = johanparfil()
        Par2 = johanparfil()
        Par3 = johanparfil()


        for pers in self.primärpersonlista:
            persfilnamn = os.path.join(self.databas, "data", pers[0:5], pers + ".xml")
            allmänt.hämtapersonfil(allmänt(), persfilnamn, Person1)

# koll av överensstämmelse mellan filnamn och personens ID i filen
            if Person1.person_ID != pers:
                self.logga ("VARNING!  Filnamn " + pers + ".xml överensstämmer inte med personens ID i filen: " + Person1.person_ID + '\n')

            if Person1.bonusrelation_ID != "":
                self.logga ("Person " + pers + " har bonusrelation(er): " + Person1.bonusrelation_ID  + '\n' )



# om föräldrapar angives så läs parfilen och kontrollera att det finns en barn-länk tillbaka
            if Person1.föräldrapar_ID != "":
                föräldraparfilnamn = os.path.join(self.databas, "data",  Person1.föräldrapar_ID[0:8],  Person1.föräldrapar_ID + ".xml")
                allmänt.hämtaparfil(allmänt(), föräldraparfilnamn, Par1)

                egnabarn = Par1.barn_ID.split("\n")
                if egnabarn.count(pers) != 1 :
                    self.logga ("VARNING!  länkfel mellan person " + pers + " och föräldrapar " + Person1.föräldrapar_ID + '\n' )

# om för personen finns en eller flera bonuslänkar (som kan vara antingen till personer eller till par)
# så läs aktuella parfiler eller personfiler och kontrollera befintligheten av en länk tillbaka.

            if Person1.bonusrelation_ID != "":
                bonuslista = Person1.bonusrelation_ID.split("\n")
                for bonus in bonuslista:
                    if len(bonus) == 8:  # personfil
                        pers2filnamn = os.path.join(self.databas, "data", bonus[0:5], bonus + ".xml")
                        allmänt.hämtapersonfil(allmänt(), pers2filnamn, Person2)

                        bonuslista2 = Person2.bonusrelation_ID.split("\n")
                        if bonuslista2.count(pers) != 1 :
                            self.logga ("VARNING!  länkfel mellan person " + pers + " och bonus-person " + bonus + '\n')

                    elif len(bonus) == 11:   # parfil
                        par2filnamn = os.path.join(self.databas, "data", bonus[0:8], bonus + ".xml")
                        allmänt.hämtaparfil(allmänt(), par2filnamn, Par2)

                        bonuslista2 = Par2.bonusrelation_ID.split("\n")
                        if bonuslista2.count(pers) != 1 :
                            self.logga ("VARNING!  länkfel mellan person " + pers + " och bonus-par " + bonus + '\n')

# om för personen anges egna par så kontrollera för varje par befintligheten av en länk tillbaka

            if Person1.egna_par_ID != "":
                egnapar = Person1.egna_par_ID.split("\n")
                for egna in egnapar:
                    par2filnamn = os.path.join(self.databas, "data", egna[0:8], egna + ".xml")

                    if not os.path.exists(par2filnamn):
                        self.logga ("VARNING!  länkfel mellan person ;" + pers + "; och eget par ;" + egna + "; parfilen finns inte"   + '\n' )
                    else:
                        allmänt.hämtaparfil(allmänt(), par2filnamn, Par2)
                        if (Par2.person1_ID != pers) and (Par2.person2_ID != pers) :
                            self.logga ("VARNING!  länkfel mellan person ;" + pers + "; och eget par ;" + egna + "; person1= ;" + Par2.person1_ID   + "; person2= ;" + Par2.person2_ID  + '\n')




        for par in self.primärparlista:
            parfilnamn = os.path.join(self.databas, "data", par[0:8], par + ".xml")
            allmänt.hämtaparfil(allmänt(), parfilnamn, Par1)


# koll av överensstämmelse mellan filnamn och parets ID i filen
            if Par1.par_ID != par[0:11]:
                self.logga ("VARNING!  Filnamn " + par[0:11] + ".xml överensstämmer inte med parets ID i filen: " + Par1.par_ID + '\n')

            if Par1.bonusrelation_ID != "":
                self.logga ("Par " + par[0:11] + " har bonusrelation(er): " + Par1.bonusrelation_ID  + '\n' )

            if Par1.barn_ID == "":
                if  Par1.person1_ID == "" and Par1.person2_ID == "" :
                    self.logga ("VARNING! ;" + par + "; saknar länk till både Person 1, Person2 och barn !!!; Korrigera eller tag bort parfilen!\n")


                elif  Par1.person1_ID != "" and Par1.person2_ID == "" :
                    self.logga ("OBS! ;" + par + "; har länk enbart till Person1, men varken till Person2 eller barn.\n")
                    if Par1.bonusrelation_ID != "":
                        self.logga ("Kolla bonuslänkar!\n")

                elif  Par1.person1_ID == "" and Par1.person2_ID != "" :
                    self.logga ("OBS! ;" + par + "; har länk enbart till Person2, men varken till Person1 eller barn. \n ")
                    if Par1.bonusrelation_ID != "":
                        self.logga ("Kolla bonuslänkar!\n")




            else: # if Par1.barn_ID != ""
                if Par1.person1_ID == "" and Par1.person2_ID == "" :
                    self.logga ("OBS! ;" + par + "; saknar länk till både Person 1 och Person2 men har länk till barn. ;" + Par1.barn_ID.replace("\n",", ")  + '\n')

                else:
                    if Par1.person1_ID == "":
                        self.logga ("OBS! ;" + par + "; har länk till barn men inte till fader.\n")
                    else:    # Par1.person1_ID != ""  # Person1 finns.
                        persfilnamn = os.path.join(self.databas, "data", Par1.person1_ID[0:5], Par1.person1_ID + ".xml")
                        allmänt.hämtapersonfil(allmänt(), persfilnamn, Person1)
                        # kolla att han är man.
                        if  Person1.person_kön != "m":
                            self.logga ('\nVARNING! Par nr. ' + Par1.par_ID + '. Kön för Person1 (' + Par1.person1_ID + ') anges till "' + Person1.person_kön + '". Förväntat: "m" (man).\n')


                    if Par1.person2_ID == "":
                        self.logga ("OBS! ;" + par + "; har länk till barn men inte till moder.\n")
                    else:    # Par1.person2_ID != ""  # Person2 finns. kolla att hon är kvinna.
                        persfilnamn = os.path.join(self.databas, "data", Par1.person2_ID[0:5], Par1.person2_ID + ".xml")
                        allmänt.hämtapersonfil(allmänt(), persfilnamn, Person2)
                        if  Person2.person_kön != "k":
                            self.logga ('\nVARNING! Par nr. ' + Par1.par_ID + '. Kön för Person2 (' + Par1.person2_ID + ') anges till "' + Person2.person_kön + '". Förväntat: "k" (kvinna).\n')

            if Par1.person1_ID != "":

                persfilnamn = os.path.join(self.databas, "data", Par1.person1_ID[0:5], Par1.person1_ID + ".xml")
                allmänt.hämtapersonfil(allmänt(), persfilnamn, Person1)

                # kolla att Person1 har länk tillbaka till paret
                egnapar=Person1.egna_par_ID.split("\n")
                if egnapar.count(par) != 1:
                    self.logga ("VARNING!  länkfel mellan par " + par + " och parets ingående Person1: " + Par1.person1_ID + " med länkar till egna par " + Person1.egna_par_ID.replace("\n"," ") + '\n')


            if Par1.person2_ID != "":

                persfilnamn = os.path.join(self.databas, "data" , Par1.person2_ID[0:5] , Par1.person2_ID + ".xml")
                allmänt.hämtapersonfil(allmänt(), persfilnamn, Person2)

                # kolla att Person2 har länk tillbaka till paret
                egnapar=Person2.egna_par_ID.split("\n")
                if egnapar.count(par) != 1:
                    self.logga ("VARNING!  länkfel mellan par " + par + " och parets ingående Person2: " + Par1.person2_ID + " med länkar till egna par " + Person2.egna_par_ID.replace("\n"," ")   + '\n')


# kolla att parets barn har länk tillbaka till paret
            if Par1.barn_ID != "":
                barnlista = Par1.barn_ID.split("\n")
                for barn in barnlista:
                    barnfilnamn = os.path.join(self.databas, "data", barn[0:5], barn + ".xml")
                    allmänt.hämtapersonfil(allmänt(), barnfilnamn, Person1)
                    if Person1.föräldrapar_ID != par:
                        self.logga ("VARNING!  länkfel mellan par ;" + par + "; och barn ;" + barn + '\n')


# om för paret finns en eller flera bonuslänkar (som kan vara antingen till personer eller till par)
# så läs aktuella parfiler eller personfiler och kontrollera befintligheten av en länk tillbaka.

            if Par1.bonusrelation_ID != "":
                bonuslista = Par1.bonusrelation_ID.split("\n")
                for bonus in bonuslista:
                    if len(bonus) == 8:  # personfil
                        pers2filnamn = os.path.join(self.databas, "data", bonus[0:5], bonus + ".xml")
                        allmänt.hämtapersonfil(allmänt(), pers2filnamn, Person2)

                        bonuslista2 = Person2.bonusrelation_ID.split("\n")
                        if bonuslista2.count(par) != 1 :
                            self.logga ("VARNING!  länkfel mellan person " + pers + " och bonus-person " + bonus + '\n')

                    elif len(bonus) == 11:   # parfil
                        par2filnamn = os.path.join(self.databas, "data", bonus[0:8], bonus + ".xml")
                        allmänt.hämtaparfil(allmänt(), par2filnamn, Par2)

                        bonuslista2 = Par2.bonusrelation_ID.split("\n")
                        if bonuslista2.count(par) != 1 :
                            self.logga ("VARNING!  länkfel mellan person " + pers + " och bonus-par " + bonus + '\n')

        self.logga ("\nFAS 2: kontroll av länkar klar\n")

###################################################################################################




###################################################################################################
    def Fas3(self):
# Kontroll av taggar (så att inte xml-fil innehåller okänd tagg
# Indata till fas 3 är globala primärlistor innehållande alla personer i databasen respektive alla par i databasen
#  OBS: Taggar i andra filer än person- och parfiler ingår inte i kontrollen: T.ex. INI-filer

        self.logga ("\nFAS 3: kontroll av taggar\n")

        persontaggar = [ "?xml","ant","anteckning","bonusrelation_ID","by","dag","datum","disbytförsamling","död","efternamn","egetpar_ID","egnapar","födelse","förnamn","församling","föräldrapar_ID","gata","härad","kategori","kvarter","källa","källor","kön","län","månad","nam","namn","person","person_ID","plats","socken","sparat","stad","tilltal","utrikesplats","år" ]
        partaggar = [ "?xml","anteckning","barn","barn_ID","bonusrelation_ID","by","dag","datum","disbytförsamling","församling","gata","härad","inledning","kvarter","källa","källor","län","månad","par","par_ID","person1_ID","person2_ID","plats","socken","sparat","stad","typ","upplösning","utrikesplats","år" ]

        for pers in self.primärpersonlista:

            personfilnamn =  os.path.join(self.databas,  "data", pers[0:5], pers + ".xml")

            infile = open( personfilnamn, "r", encoding='utf-8' )
            helafilen=infile.read()
            infile.close()
            maxlen = len(helafilen)

            startpos = 0

            while startpos < maxlen:
                tagg, startpos = self.nastatagg( helafilen, startpos, maxlen )
                if tagg != "" :
                    if persontaggar.count (tagg) != 1:
                        self.logga ("VARNING! Personfil "+ pers + " innehåller okänd tagg: \n" )
                        try:
                            self.logga ( tagg  + '\n' )
                        except:
                            pass






        for par in self.primärparlista:

            parfilnamn =  os.path.join(self.databas, "data", par[0:8], par + ".xml")

            infile = open( parfilnamn, "r", encoding='utf-8' )
            helafilen=infile.read()
            infile.close()
            maxlen = len(helafilen)

            startpos = 0

            while startpos < maxlen:
                tagg, startpos = self.nastatagg( helafilen, startpos, maxlen )
                if tagg != "" :
                    if partaggar.count (tagg) != 1:
                        self.logga ("VARNING! Parfil " + par + " innehåller okänd tagg: \n")
                        try:
                            self.logga ( tagg  + '\n' )
                        except:
                            pass


        self.logga ("\nFAS 3: kontroll av taggar klar\n")


###################################################################################################




###################################################################################################
    def nastatagg(self, strang, start, end):

        vansterpos = strang.find ( "<", start, end )
        if vansterpos < 0:
            return "", end+1
        hogerpos = strang.find ( ">", start + 1, end)
        if hogerpos <= 0:
            return "", end+1

        tagg = strang[vansterpos+1:hogerpos]
        if tagg[0] == "/" :
            tagg = tagg [1: len(tagg)]
        if tagg[len(tagg) -1] == "/" :
            tagg = tagg [0: len(tagg) -1]
        if tagg[0] == "?" :
            tagg = tagg [0:4]

        tagga = tagg.split(" ")
        tagg = tagga[0]

        return tagg, hogerpos +1


###################################################################################################




###################################################################################################
    def Fas4(self):

# Indata till fas 4 är global primärlista innehållande alla personer i databasen

        self.logga ("\nFAS 4: Genererar kategorilistor\n")

        allmänt.räknamarkeringar(allmänt(), self.databas, self.primärpersonlista, self.datumtillägg)

        self.logga ("\nFAS 4: Skrev kategorilistor\n")
###################################################################################################




###################################################################################################
    def Fas5(self):

# Indata till fas 5 är global primärlista innehållande alla personer i databasen

        sökväg = os.path.split(self.databas)           # t.ex : "/home/FILSERVERN/slkt", "IOB"

        kyrkoarkiv = os.path.join(sökväg[0],"kyrkoarkiv") # t.ex : "/home/FILSERVERN/slkt/kyrkoarkiv"
        if not os.path.exists (kyrkoarkiv):
            os.mkdir(kyrkoarkiv)

        self.logga ("\nFAS 5: Kontrollerar församlingsnamn\n")

#################################################################
#  sverigesallaförsamlingarförjohan.txt         Samtliga 4369 gamla och aktuella namn på  församlingar
#  sverigesförsamlingarförjohan.txt             Aktuella 2508 församlingsnamn, identiskt skrivna i RSV:s och DIS:s tabeller
#  sverigestidigareförsamlingarförjohan.txt     1800 namn i RSV:s lista som DIS inte vill veta av.
#  sverigesunikdisförsamlingarförjohan.txt      79 namn i DIS:s lista, 4 helt nya, några felstavade, andra förkortade ur RSV:s lista
#################################################################


        self.sverigesförsamlingar = os.path.join(kyrkoarkiv, "sverigesallaförsamlingarförjohan.txt")
        if not os.path.exists(self.sverigesförsamlingar):
            self.logga ("jag hittar inte " + self.sverigesförsamlingar + "\n Ingen kontroll av församlingsnamnen för DISBYT\n") #
            DISBYTkoll = False
            sverigesförstext = ""
        else:
            DISBYTkoll = True
            sverigesförs = open(self.sverigesförsamlingar, "r", encoding='utf-8')
            sverigesförstext = sverigesförs.read() # Hela texten med alla församlingsnamnen
            sverigesförs.close()

        sverigesförsrader = sverigesförstext.split("\n")
        minaförsrader = []



        Person = johanpersonfil()
        Par    = johanparfil()

        for pers in self.primärpersonlista:
            persfilnamn = os.path.join(self.databas, "data", pers[0:5], pers + ".xml")
            allmänt.hämtapersonfil(allmänt(), persfilnamn, Person)

            if DISBYTkoll == True:
                self.kollaDISBYTförsamling ( pers, Person.född_disbytförsamling, sverigesförsrader)
                self.kollaDISBYTförsamling ( pers,  Person.död_disbytförsamling, sverigesförsrader)

            nyrad = Person.född_församling + ";" + Person.född_län
            if self.kollaminförsamling (nyrad, minaförsrader):
                minaförsrader.append(nyrad)

            nyrad = Person.död_församling + ";" +  Person.död_län
            if self.kollaminförsamling (nyrad, minaförsrader):
                minaförsrader.append(nyrad)


        for par in self.primärparlista:
            parfilnamn = os.path.join(self.databas, "data", par[0:8], par + ".xml")
            allmänt.hämtaparfil(allmänt(), parfilnamn, Par)

            if DISBYTkoll == True:
                self.kollaDISBYTförsamling ( par,  Par.inledn_disbytförsamling, sverigesförsrader)
                self.kollaDISBYTförsamling ( par, Par.upplösn_disbytförsamling, sverigesförsrader)

            nyrad = Par.inledn_församling + ";" +  Par.inledn_län
            if self.kollaminförsamling (nyrad, minaförsrader):
                minaförsrader.append(nyrad)

            nyrad = Par.upplösn_församling + ";" + Par.upplösn_län
            if self.kollaminförsamling (nyrad, minaförsrader):
                minaförsrader.append(nyrad)

        minaförsrader.sort()

        dt = datetime.datetime.today()
        self.minaförsamlingar = os.path.join(kyrkoarkiv, "minaförsamlingar" + dt.strftime('%Y%m%d_%H%M%S') + ".txt")

        utfil = open(self.minaförsamlingar, 'w')
        for rad in minaförsrader:
            utfil.write(rad + '\n')
        utfil.close()

        self.logga ("\nFAS 5: Kontrollerade församlingsnamn\n")

        return
####################################################################################################




###################################################################################################
    def kollaDISBYTförsamling(self, ID,  DISBYTförsamling,  sverigesförsrader):

        if DISBYTförsamling == "":
            return

        for rad in sverigesförsrader:
            if rad.find(DISBYTförsamling) == 0: # hittade DISBYTförsamling i sverigesförsrader
                return

        self.logga ('OBS!;ID;' + ID + ';' + DISBYTförsamling + ';;ej i;' + self.sverigesförsamlingar + '\n')
        # Använder semikolon som avgränsare i stället för tab. så att utskrift kan tas upp via editor till kalkylark

        return
####################################################################################################




###################################################################################################
    def kollaminförsamling(self, minförsamling,  minaförsrader):

        if minförsamling == ";" :
            return False # Ingen församling plus län. Vi ska inte addera rad till rader

        for rad in minaförsrader:
            if rad.find(minförsamling) == 0:
                return False # Hittade församling plus län i listan. Vi ska inte addera rad till rader

        return True # Hittade INTE församling plus län i listan. Nu ska vi addera rad till rader
####################################################################################################




###################################################################################################
    def Fas6(self):

# Indata till fas 6 är global primärlista innehållande alla personer i databasen

        self.logga ("\nFAS 6: Kompletterar person- och parkataloger med namnfil\n")

        Person  = johanpersonfil()
        Par     = johanparfil()
        Person1 = johanpersonfil()
        Person2 = johanpersonfil()

        for pers in self.primärpersonlista:
            persdirnamn = os.path.join(self.databas, "data", pers[0:5], pers)
            if os.path.exists(persdirnamn):
                if os.path.isdir(persdirnamn):
                    persfilnamn = os.path.join(self.databas, "data", pers[0:5], pers + ".xml")
                    allmänt.hämtapersonfil(allmänt(), persfilnamn, Person)
                    personnamn = Person.kortnamn
                    #self.logga ( persdirnamn + ': ' + personnamn + "\n")
                    namnfilnamn = os.path.join(self.databas, "data", pers[0:5], pers, personnamn)


                    # ------------------------------------------------------
                    finnsinnehåll = False
                    fillista = os.listdir(persdirnamn)
                    for fil in fillista:
#                        print (fil)
                        checkfil = os.path.join(persdirnamn,fil)
                        if os.path.getsize(checkfil) > 0  or os.path.isdir(checkfil):
                            finnsinnehåll = True
                        else:
                            if fil != personnamn:
                                self.logga ('Finns redan: ' + fil + '. Förväntad namnfil: ' + personnamn + '\n')

                    if finnsinnehåll == False:
                        self.logga ('Katalog ' + persdirnamn + ' saknar innehåll' + '\n')
                    # ------------------------------------------------------


                    if not os.path.exists( namnfilnamn ):
                        self.logga ('Skriver namnfil ' + personnamn + ' i katalog, längd = 0' + '\n')
                        namnfil = open( namnfilnamn , "a", encoding='utf-8' )
                        namnfil.close()


        for par in self.primärparlista:
            pardirnamn = os.path.join(self.databas, "data", par[0:8], par )
            if os.path.exists(pardirnamn):
                if os.path.isdir(pardirnamn):
                    parfilnamn = os.path.join(self.databas, "data", par[0:8], par + ".xml")
                    allmänt.hämtaparfil(allmänt(), parfilnamn, Par)
                    pers1 = Par.person1_ID
                    pers2 = Par.person2_ID
                    pers1filnamn = os.path.join(self.databas, "data", pers1[0:5], pers1 + ".xml")
                    allmänt.hämtapersonfil(allmänt(), pers1filnamn, Person1)
                    pers2filnamn = os.path.join(self.databas, "data", pers2[0:5], pers2 + ".xml")
                    allmänt.hämtapersonfil(allmänt(), pers2filnamn, Person2)
                    parnamn = Person1.kortnamn + " och " + Person2.kortnamn
                    #self.logga ( pardirnamn + ': ' + parnamn + "\n")
                    namnfilnamn = os.path.join(self.databas, "data", par[0:8], par,  parnamn)


                    # ------------------------------------------------------
                    finnsinnehåll = False
                    fillista = os.listdir(pardirnamn)
                    for fil in fillista:
#                        print (fil)
                        checkfil = os.path.join(pardirnamn,fil)
                        if os.path.getsize(checkfil) > 0  or os.path.isdir(checkfil) :
                            finnsinnehåll = True
                        else:
                            if fil != parnamn:
                                self.logga ('Finns redan: ' + fil + '. Förväntad namnfil: ' + parnamn + '\n')

                    if finnsinnehåll == False:
                        self.logga ('Katalog ' + pardirnamn + ' saknar innehåll' + '\n')
                    # ------------------------------------------------------


                    if not os.path.exists( namnfilnamn ):
                        self.logga ('Skriver namnfil ' + parnamn + ' i katalog, längd = 0' + '\n')
                        namnfil = open( namnfilnamn , "a", encoding='utf-8' )
                        namnfil.close()

        self.logga ("\nFAS 6: Kompletterade person- och parkataloger med namnfiler \n")

        return
###################################################################################################




###################################################################################################
    def Fas7(self):

# Indata till fas 7 är global primärlista innehållande alla par i databasen

# borde lägga till kontroll att inga parblad sedan tidigare är öppna för uppdatering


        self.logga ("\nFAS 7: Kontrollerar upplösning av par\n")
        Par1  = johanparfil()
        Person1 = johanpersonfil()
        Person2 = johanpersonfil()

        for par in self.primärparlista:  # behandla varje par inom listan av par00000000

            # Hämta parfilen och tillhörande personfiler
            parfilnamn = os.path.join(self.databas, "data", par[0:8], par + ".xml")
            allmänt.hämtaparfil(allmänt(), parfilnamn, Par1)

            person1filnamn = os.path.join(self.databas, "data", Par1.person1_ID[0:5], Par1.person1_ID + ".xml")
            person2filnamn = os.path.join(self.databas, "data", Par1.person2_ID[0:5], Par1.person2_ID + ".xml")
            allmänt.hämtapersonfil(allmänt(), person1filnamn, Person1)
            allmänt.hämtapersonfil(allmänt(), person2filnamn, Person2)

            # Hämta upplösning_typ ur parfilen
            upplösntyp = Par1.upplösn_typ.lower()
            uppgifterfinns = Par1.upplösn_år != "" or Par1.upplösn_månad != "" or Par1.upplösn_dag != "" \
                or Par1.upplösn_gata != "" or Par1.upplösn_by != "" or Par1.upplösn_kvarter != "" \
                or Par1.upplösn_socken != "" or Par1.upplösn_församling != "" or Par1.upplösn_disbytförsamling != "" \
                or Par1.upplösn_stad != "" or Par1.upplösn_härad != "" or Par1.upplösn_län != "" \
                or Par1.upplösn_utrikesplats != "" or Par1.upplösn_källa != ""


            # Om båda personerna är döda är det dödsåret för den först avlidne som vanligen är slutåret för paret
            # Jämförelse görs om dödsåren angivits med fyra siffror och ingenting annat samt om årtalen är mindre än 2100
            implicittyp = ""
            if Person1.död_år.isdigit() and Person2.död_år.isdigit() and 2100 >int( Person1.död_år) > 1000 and  2100 > int(Person2.död_år) > 1000:
                if Person1.person_kön.lower() == "m" and    Person2.person_kön.lower() == "k" :
                    if Person1.död_år <= Person2.död_år:
                        implicittyp = "mannens död"
                    else:
                        implicittyp = "kvinnans död"
                elif Person2.person_kön.lower() == "m" and    Person1.person_kön.lower() == "k" :
                    if Person2.död_år <= Person1.död_år:
                        implicittyp = "mannens död"
                    else:
                        implicittyp = "kvinnans död"

                # Om parbladet inte redan har angivelse för upplösning_typ så skriv "(mannens död)" resp. "(kvinnans död)"
                # Om parbladet redan har angivelse  "mannens död" eller "kvinnans död" för upplösning_typ så skriv "(mannens död)" resp. "(kvinnans död)"
                if implicittyp != "":
                    if upplösntyp == "" or upplösntyp == implicittyp :
                        Par1.upplösn_typ = "(" + implicittyp + ")"
                        upplösntyp = Par1.upplösn_typ
                        allmänt.sparaparfil(allmänt(),  parfilnamn, Par1)
                # Denna komplettering är i förekommande fall bara kosmetisk och informativ; I  "ättlingar.py" görs samma jämförelse som ovan för
                # utskriften i listan av årtalen för parets inledning och upplösning.

            # om implicit "mannens död" eller "kvinnans död" inte kan bestämmas så kan fortfarande dessa angivelser finnas p.g.a. annan kunskap,
            # t.ex. att änkan eller enkemannen fortfarande lever eller att dennas/dennes dödsår inte är exakt känt.


            upplösntyp = upplösntyp.strip('()')
            if upplösntyp == "mannens död" or  upplösntyp == "kvinnans död":   # Antingen med eller utan parenteser omkring, dvs implicit eller explicit angivet
                if uppgifterfinns == True: # Man ska inte ha ytterligare uppgifter i parblade utan hämta från resp. personblad.
                    self.logga( Par1.par_ID + ': ' + upplösntyp + '. Uppgifter finns ändå. Kontrollera och ta bort !   '  + '\n')

            elif upplösntyp !=  "":
                self.logga( Par1.par_ID + ': ' + upplösntyp + '\n')  # t.ex. frånskilda, boskillnad

            elif upplösntyp ==  "":
                if uppgifterfinns == True:
                    self.logga( Par1.par_ID + ': Ingen upplösn_typ angiven men ändå andra uppgifter. Kontrollera och komplettera !' + '\n')


        self.logga ("\nFAS 7: Kontrollerade upplösning av par\n")
###################################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn, 'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Kontrollera_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

# logga till textruta i programfönster
        self.textEdit_logg.insertPlainText(txt )
        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)

        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Kontrollera_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winKontrollera = Kontrollera()
winKontrollera.show()
sys.exit(app.exec_())

################################################################################

### Slut på programmet ########################################################################
