#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# nydatabas.py
# PYTHON 3 # http://pyright.blogspot.com/2009/11/unicode-normalization-python-3x-unicode.html
# Senast ändrad: 2011-02-06  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




########################################################################################
import sys
import os
import stat
import datetime
import shutil
import unicodedata
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from optparse import OptionParser
from gui_nydatabas import gui_Nydatabas

from johangemensamt import allmänt
from johanklasser import *
import importera_gedcom_tråd
########################################################################################




########################################################################################
class Nydatabas(QtGui.QMainWindow, gui_Nydatabas):

    SenastÄndrad = '2011-02-06 14:30:35'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'nydatabas_py3_'
    loggfilopen = False

    fontsize = 9
    förstagången = True

    importfil = ''
    nydatabas = ''
    inifilnamn = ''

    gedcomfil = ''
    rader = []
    EndOfFile = False

    redanlästrad = ''

    senastenivå = -1

    inifilnamn = ''
    inifiltext = ''
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    options = {}
    args = []

########################################################################################

    dictAnselTillUnicode = {    # För Python 3
###################################################################################################################################################################
#   Ansel :   Unicode , #chr#    Beskrivning                                                                 #    ingår i ...                   # ---- Ansel ---- #
#    dec  :      dec  , #   #                                                                                #                                  #  dec  #   hex   #
#-------------------------------------------------------------------------------------------------------------------------------------------------------#---------#
        0 : chr(    0), #   #                                                                                #                                  #    0  # b'\x00' #
        1 : chr(    1), #   #                                                                                #                                  #    1  # b'\x01' #
        2 : chr(    2), #   #                                                                                #                                  #    2  # b'\x02' #
        3 : chr(    3), #   #                                                                                #                                  #    3  # b'\x03' #
        4 : chr(    4), #   #                                                                                #                                  #    4  # b'\x04' #
        5 : chr(    5), #   #                                                                                #                                  #    5  # b'\x05' #
        6 : chr(    6), #   #                                                                                #                                  #    6  # b'\x06' #
        7 : chr(    7), #   #                                                                                #                                  #    7  # b'\x07' #
        8 : chr(    8), #   #                                                                                #                                  #    8  # b'\x08' #
        9 : chr(    9), #   #                                                                                #                                  #    9  # b'\x09' #
       10 : chr(   10), #   #                                                                                #                                  #   10  # b'\x0A' #
       11 : chr(   11), #   #                                                                                #                                  #   11  # b'\x0B' #
       12 : chr(   12), #   #                                                                                #                                  #   12  # b'\x0C' #
       13 : chr(   13), #   #                                                                                #                                  #   13  # b'\x0D' #
       14 : chr(   14), #   #                                                                                #                                  #   14  # b'\x0E' #
       15 : chr(   15), #   #                                                                                #                                  #   15  # b'\x0F' #
       16 : chr(   16), #   #                                                                                #                                  #   16  # b'\x10' #
       17 : chr(   17), #   #                                                                                #                                  #   17  # b'\x11' #
       18 : chr(   18), #   #                                                                                #                                  #   18  # b'\x12' #
       19 : chr(   19), #   #                                                                                #                                  #   19  # b'\x13' #
       20 : chr(   20), #   #                                                                                #                                  #   20  # b'\x14' #
       21 : chr(   21), #   #                                                                                #                                  #   21  # b'\x15' #
       22 : chr(   22), #   #                                                                                #                                  #   22  # b'\x16' #
       23 : chr(   23), #   #                                                                                #                                  #   23  # b'\x17' #
       24 : chr(   24), #   #                                                                                #                                  #   24  # b'\x18' #
       25 : chr(   25), #   #                                                                                #                                  #   25  # b'\x19' #
       26 : chr(   26), #   #                                                                                #                                  #   26  # b'\x1A' #
       27 : chr(   27), #   #                                                                                #                                  #   27  # b'\x1B' #
       28 : chr(   28), #   #                                                                                #                                  #   28  # b'\x1C' #
       29 : chr(   29), #   #                                                                                #                                  #   29  # b'\x1D' #
       30 : chr(   30), #   #                                                                                #                                  #   30  # b'\x1E' #
       31 : chr(   31), #   #                                                                                #                                  #   31  # b'\x1F' #
       32 : chr(   32), #   #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   32  # b'\x20' #
       33 : chr(   33), # ! #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   33  # b'\x21' #
       34 : chr(   34), # " #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   34  # b'\x22' #
       35 : chr(   35), # # #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   35  # b'\x23' #
       36 : chr(   36), # $ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   36  # b'\x24' #
       37 : chr(   37), # % #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   37  # b'\x25' #
       38 : chr(   38), # & #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   38  # b'\x26' #
       39 : chr(   39), # ' #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   39  # b'\x27' #
       40 : chr(   40), # ( #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   40  # b'\x28' #
       41 : chr(   41), # ) #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   41  # b'\x29' #
       42 : chr(   42), # * #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   42  # b'\x2A' #
       43 : chr(   43), # + #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   43  # b'\x2B' #
       44 : chr(   44), # , #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   44  # b'\x2C' #
       45 : chr(   45), # - #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   45  # b'\x2D' #
       46 : chr(   46), # . #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   46  # b'\x2E' #
       47 : chr(   47), # / #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   47  # b'\x2F' #
       48 : chr(   48), # 0 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   48  # b'\x30' #
       49 : chr(   49), # 1 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   49  # b'\x31' #
       50 : chr(   50), # 2 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   50  # b'\x32' #
       51 : chr(   51), # 3 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   51  # b'\x33' #
       52 : chr(   52), # 4 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   52  # b'\x34' #
       53 : chr(   53), # 5 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   53  # b'\x35' #
       54 : chr(   54), # 6 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   54  # b'\x36' #
       55 : chr(   55), # 7 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   55  # b'\x37' #
       56 : chr(   56), # 8 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   56  # b'\x38' #
       57 : chr(   57), # 9 #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   57  # b'\x39' #
       58 : chr(   58), # : #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   58  # b'\x3A' #
       59 : chr(   59), # ; #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   59  # b'\x3B' #
       60 : chr(   60), # < #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   60  # b'\x3C' #
       61 : chr(   61), # = #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   61  # b'\x3D' #
       62 : chr(   62), # > #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   62  # b'\x3E' #
       63 : chr(   63), # ? #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   63  # b'\x3F' #
       64 : chr(   64), # @ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   64  # b'\x40' #
       65 : chr(   65), # A #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   65  # b'\x41' #
       66 : chr(   66), # B #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   66  # b'\x42' #
       67 : chr(   67), # C #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   67  # b'\x43' #
       68 : chr(   68), # D #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   68  # b'\x44' #
       69 : chr(   69), # E #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   69  # b'\x45' #
       70 : chr(   70), # F #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   70  # b'\x46' #
       71 : chr(   71), # G #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   71  # b'\x47' #
       72 : chr(   72), # H #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   72  # b'\x48' #
       73 : chr(   73), # I #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   73  # b'\x49' #
       74 : chr(   74), # J #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   74  # b'\x4A' #
       75 : chr(   75), # K #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   75  # b'\x4B' #
       76 : chr(   76), # L #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   76  # b'\x4C' #
       77 : chr(   77), # M #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   77  # b'\x4D' #
       78 : chr(   78), # N #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   78  # b'\x4E' #
       79 : chr(   79), # O #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   79  # b'\x4F' #
       80 : chr(   80), # P #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   80  # b'\x50' #
       81 : chr(   81), # Q #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   81  # b'\x51' #
       82 : chr(   82), # R #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   82  # b'\x52' #
       83 : chr(   83), # S #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   83  # b'\x53' #
       84 : chr(   84), # T #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   84  # b'\x54' #
       85 : chr(   85), # U #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   85  # b'\x55' #
       86 : chr(   86), # V #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   86  # b'\x56' #
       87 : chr(   87), # W #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   87  # b'\x57' #
       88 : chr(   88), # X #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   88  # b'\x58' #
       89 : chr(   89), # Y #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   89  # b'\x59' #
       90 : chr(   90), # Z #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   90  # b'\x5A' #
       91 : chr(   91), # [ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   91  # b'\x5B' #
       92 : chr(   92), # \ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   92  # b'\x5C' #
       93 : chr(   93), # ] #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   93  # b'\x5D' #
       94 : chr(   94), # ^ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   94  # b'\x5E' #
       95 : chr(   95), # _ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   95  # b'\x5F' #
       96 : chr(   96), # ` #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   96  # b'\x60' #
       97 : chr(   97), # a #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   97  # b'\x61' #
       98 : chr(   98), # b #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   98  # b'\x62' #
       99 : chr(   99), # c #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #   99  # b'\x63' #
      100 : chr(  100), # d #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  100  # b'\x64' #
      101 : chr(  101), # e #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  101  # b'\x65' #
      102 : chr(  102), # f #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  102  # b'\x66' #
      103 : chr(  103), # g #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  103  # b'\x67' #
      104 : chr(  104), # h #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  104  # b'\x68' #
      105 : chr(  105), # i #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  105  # b'\x69' #
      106 : chr(  106), # j #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  106  # b'\x6A' #
      107 : chr(  107), # k #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  107  # b'\x6B' #
      108 : chr(  108), # l #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  108  # b'\x6C' #
      109 : chr(  109), # m #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  109  # b'\x6D' #
      110 : chr(  110), # n #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  110  # b'\x6E' #
      111 : chr(  111), # o #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  111  # b'\x6F' #
      112 : chr(  112), # p #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  112  # b'\x70' #
      113 : chr(  113), # q #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  113  # b'\x71' #
      114 : chr(  114), # r #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  114  # b'\x72' #
      115 : chr(  115), # s #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  115  # b'\x73' #
      116 : chr(  116), # t #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  116  # b'\x74' #
      117 : chr(  117), # u #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  117  # b'\x75' #
      118 : chr(  118), # v #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  118  # b'\x76' #
      119 : chr(  119), # w #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  119  # b'\x77' #
      120 : chr(  120), # x #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  120  # b'\x78' #
      121 : chr(  121), # y #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  121  # b'\x79' #
      122 : chr(  122), # z #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  122  # b'\x7A' #
      123 : chr(  123), # { #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  123  # b'\x7B' #
      124 : chr(  124), # | #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  124  # b'\x7C' #
      125 : chr(  125), # } #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  125  # b'\x7D' #
      126 : chr(  126), # ~ #                                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  126  # b'\x7E' #
      127 : chr(  127), #   #                                                                                #                                  #  127  # b'\x7F' #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      161 : chr(  321), # Ł #  uppercase polish l / Latin CAPITAL letter l with stroke                       # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  161  # b'\xA1' #
      162 : chr(  216), # Ø #  uppercase scandinavian o / Latin CAPITAL letter o with stroke                 # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  162  # b'\xA2' #
      163 : chr(  272), # Đ #  uppercase d with crossbar / Latin CAPITAL letter d with stroke                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  163  # b'\xA3' #
      164 : chr(  222), # Þ #  uppercase icelandic thorn / Latin CAPITAL letter thorn (icelandic)            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  164  # b'\xA4' #
      165 : chr(  198), # Æ #  uppercase digraph ae / Latin CAPITAL ligature ae                              # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  165  # b'\xA5' #
      166 : chr(  338), # Œ #  uppercase digraph oe / Latin CAPITAL ligature oe                              # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  166  # b'\xA6' #
      167 : chr(  697), # ʹ #  soft sign, prime / modifier letter prime                                      # Gedcom 5.5,               MARC-8 #  167  # b'\xA7' #
      168 : chr(  183), # · #  middle dot                                                                    # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  168  # b'\xA8' #
      169 : chr( 9837), # ♭ #  music flat sign                                                               #             Gedcom 5.5.1, MARC-8 #  169  # b'\xA9' #
      170 : chr(  174), # ® #  patent mark / registered sign                                                 #             Gedcom 5.5.1, MARC-8 #  170  # b'\xAA' #
      171 : chr(  177), # ± #  plus or minus / plus-minus sign                                               #             Gedcom 5.5.1, MARC-8 #  171  # b'\xAB' #
      172 : chr(  416), # Ơ #  uppercase o-hook / Latin CAPITAL letter o with horn                           #                           MARC-8 #  172  # b'\xAC' #
      173 : chr(  431), # Ư #  uppercase u-hook / Latin CAPITAL letter u with horn                           #                           MARC-8 #  173  # b'\xAD' #
      174 : chr(  700), # ʼ #  alif / modifier letter apostrophe                                             # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  174  # b'\xAE' #
      175 : chr(65533), # � #  ()                                                                            #                                  #  175  # b'\xAF' #
      176 : chr(  699), # ʻ #  ayn / modifier letter turned comma                                            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  176  # b'\xB0' #
      177 : chr(  322), # ł #  lowercase polish l / Latin small letter l with stroke                         # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  177  # b'\xB1' #
      178 : chr(  248), # ø #  lowercase scandinavian o / Latin small letter o with stroke                   # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  178  # b'\xB2' #
      179 : chr(  273), # đ #  lowercase d with crossbar / Latin small letter d with stroke                  # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  179  # b'\xB3' #
      180 : chr(  254), # þ #  lowercase icelandic thorn / Latin small letter thorn (icelandic)              # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  180  # b'\xB4' #
      181 : chr(  230), # æ #  lowercase digraph ae / Latin small ligature ae                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  181  # b'\xB5' #
      182 : chr(  339), # œ #  lowercase digraph oe / Latin small ligature oe                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  182  # b'\xB6' #
      183 : chr(  698), # ʺ #  hard sign, double prime / modifier letter double prime                        #                           MARC-8 #  183  # b'\xB7' #
      184 : chr(  305), # ı #  lowercase turkish i / Latin small letter dotless i                            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  184  # b'\xB8' #
      185 : chr(  163), # £ #  british pound / pound sign                                                    # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  185  # b'\xB9' #
      186 : chr(  240), # ð #  lowercase eth / Latin small letter eth (icelandic)                            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  186  # b'\xBA' #
      187 : chr(65533), # � #  ()                                                                            #                                  #  187  # b'\xBB' #
      188 : chr(  417), # ơ #  lowercase o-hook / Latin small letter o with horn                             #                           MARC-8 #  188  # b'\xBC' #
      189 : chr(  432), # ư #  lowercase u-hook / Latin small letter u with horn                             #                           MARC-8 #  189  # b'\xBD' #
      190 : chr(65533), # � #  ()                                                                            #                                  #  190  # b'\xBE' #
      191 : chr(65533), # � #  ()                                                                            #                                  #  191  # b'\xBF' #
      192 : chr(  176), # ° #  degree sign                                                                   #                           MARC-8 #  192  # b'\xC0' #
      193 : chr( 8467), # ℓ #  script small l                                                                #                           MARC-8 #  193  # b'\xC1' #
      194 : chr( 8471), # ℗ #  sound recording copyright                                                     #                           MARC-8 #  194  # b'\xC2' #
      195 : chr(  169), # © #  copyright sign                                                                # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  195  # b'\xC3' #
      196 : chr( 9839), # ♯ #  music sharp sign                                                              #                           MARC-8 #  196  # b'\xC4' #
      197 : chr(  191), # ¿ #  inverted question mark                                                        # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  197  # b'\xC5' #
      198 : chr(  161), # ¡ #  inverted exclamation mark                                                     # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  198  # b'\xC6' #
      199 : chr(  223), # ß #  eszett symbol (Marc-8)                                                        #                           MARC-8 #  199  # b'\xC7' #
      200 : chr( 8364), # € #  euro sign                                                                     #                           MARC-8 #  200  # b'\xC8' #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      207 : chr(  223), # ß #  eszett symbol (Ansel/Gedcom)                                                  # Gedcom 5.5, Gedcom 5.5.1,        #  207  # b'\xCF' #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      224 : chr(  777), #   #  pseudo question mark / combining hook above                                   #                           MARC-8 #  224  # b'\xE0' #
      225 : chr(  768), #   #  grave / combining grave accent (varia)                                        # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  225  # b'\xE1' #
      226 : chr(  769), #   #  acute / combining acute accent (oxia)                                         # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  226  # b'\xE2' #
      227 : chr(  770), #   #  circumflex / combining circumflex accent                                      # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  227  # b'\xE3' #
      228 : chr(  771), #   #  tilde / combining tilde                                                       # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  228  # b'\xE4' #
      229 : chr(  772), #   #  macron / combining macron                                                     # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  229  # b'\xE5' #
      230 : chr(  774), #   #  breve / combining breve (vrachy)                                              # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  230  # b'\xE6' #
      231 : chr(  775), #   #  superior dot / combining dot above                                            # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  231  # b'\xE7' #
      232 : chr(  776), #   #  umlaut, diaeresis / combining diaeresis (dialytika)                           # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  232  # b'\xE8' #
      233 : chr(  780), #   #  hacek / combining caron                                                       # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  233  # b'\xE9' #
      234 : chr(  778), #   #  circle above, angstrom / combining ring above                                 # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  234  # b'\xEA' #
      235 : chr(65533), # � #  (ligature, first half / combining double inverted breve  FE20  EFB8A0)        #                           MARC-8 #  235  # b'\xEB' #
      236 : chr(65533), # � #  (ligature, second half / combining ligature right half   FE21  EFB8A1 Note 1) #                           MARC-8 #  236  # b'\xEC' #
      237 : chr(  789), #   #  high comma, off center / combining comma above right                          # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  237  # b'\xED' #
      238 : chr(  779), #   #  double acute / combining double acute accent                                  # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  238  # b'\xEE' #
      239 : chr(  784), #   #  candrabindu / combining candrabindu                                           #                           MARC-8 #  239  # b'\xEF' #
      240 : chr(  807), #   #  cedilla / combining cedilla                                                   # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  240  # b'\xF0' #
      241 : chr(  808), #   #  right hook, ogonek / combining ogonek                                         # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  241  # b'\xF1' #
      242 : chr(  803), #   #  dot below / combining dot below                                               #                           MARC-8 #  242  # b'\xF2' #
      243 : chr(  804), #   #  double dot below / combining diaeresis below                                  #                           MARC-8 #  243  # b'\xF3' #
      244 : chr(  805), #   #  circle below / combining ring below                                           #                           MARC-8 #  244  # b'\xF4' #
      245 : chr(  819), #   #  double underscore / combining double low line                                 #                           MARC-8 #  245  # b'\xF5' #
      246 : chr(  818), #   #  underscore / combining low line                                               # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  246  # b'\xF6' #
      247 : chr(  806), #   #  left hook (comma below) / combining comma below                               # Gedcom 5.5,               MARC-8 #  247  # b'\xF7' #
      248 : chr(  796), #   #  right cedilla / combining left half ring below                                #                           MARC-8 #  248  # b'\xF8' #
      249 : chr(  814), #   #  upadhmaniya / combining breve below                                           #                           MARC-8 #  249  # b'\xF9' #
      250 : chr(65533), # � #  (double tilde, first half / combining double tilde              FE22  EFB8A2) #                           MARC-8 #  250  # b'\xFA' #
      251 : chr(65533), # � #  (double tilde, second half / combining double tilde right half  FE23  EFB8A3  Note 2) #                   MARC-8 #  251  # b'\xFB' #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      254 : chr(  787)  #   #  high comma, centered / combining comma above (Psili)                          # Gedcom 5.5, Gedcom 5.5.1, MARC-8 #  254  # b'\xFE' #
        }
######################################################################################################################################################################




########################################################################################
    def __init__(self, parent=None):
        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options] ",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-g", "--Gedcomfil", dest="Gedcomfil", help="Gedcomfil att importera")
        parser.add_option("-n", "--nydatabas", dest="Nydatabas", help="Namn för exporterad databas")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder =  os.path.join( os.environ['APPDATA'] , 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass


# Anropa inte self.logga förrän efter self.setupUi !!
        self.setupUi(self)
        self.inledning()

        self.fontsizeset()

        self.ui_connections()      # signaler i gui till slots i gui_nydatabas.py
        self.mera_ui_connections() # signaler i gui till slots i nydatabas.py

        self.enableUi()

########################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Nydatabas_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




#########################################################################################
# en del av grafiska gränsytan kodas här
    def mera_ui_connections(self):

        self.connect(self.pushButton_Importfil,     SIGNAL('clicked()'), self.showDialogImportfil   )
        self.connect(self.pushButton_Sökväg,        SIGNAL('clicked()'), self.showDialogSökväg      )
        self.connect(self.pushButton_Fortsätt,      SIGNAL('clicked()'), self.skapadatabaskatalog   )
        self.connect(self.pushButton_Startaimport,  SIGNAL("clicked()"), self.startaimportknapp     )

        QtCore.QObject.connect(self.radioButton_TomDatabas,   QtCore.SIGNAL('clicked()'), self.ritaom)
        QtCore.QObject.connect(self.radioButton_GedcomImport, QtCore.SIGNAL('clicked()'), self.ritaom)

        self.lock = QReadWriteLock()
        self.importera_gedcom_tråd = importera_gedcom_tråd.Importera_Gedcom_Tråd(self.lock, self)

        self.connect(self.importera_gedcom_tråd, SIGNAL("indexed(QString)"), self.uppdateraläget)
        self.connect(self.importera_gedcom_tråd, SIGNAL("finished(bool)"), self.finished)
        return
########################################################################################




#######################################################################################
    def uppdateraläget(self, sträng):
        self.lineEdit_Pågår.setText(sträng)
        self.logga("TRÅD: " + sträng + '\n')
        return
###################################################################################################




###################################################################################################
    def showDialogSökväg(self):

        sijDialog = QtGui.QFileDialog()
        sökväg = sijDialog.getExistingDirectory(self, "Välj eller skapa sökväg till ny johan-databas", "/home")
        sökväg = str(sökväg).rstrip('/')
        self.lineEdit_Sökväg.setText(sökväg)


        return
###################################################################################################




###################################################################################################
    def showDialogImportfil(self):

        sijDialog = QtGui.QFileDialog()
        databas = sijDialog.getOpenFileName(self, "Välj Gedcomfil att importera", "/home", "GEDCOM-filer (*.ged);;UTF-8-konverterat (*.ged.utf8)")

        if databas !=  "" :
            self.lineEdit_Importfil.setText(databas)
        return
###################################################################################################




########################################################################################
    def ritaom(self):
        self.sijlayout()
        self.windowlayout()
        return
########################################################################################




########################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        idag = datetime.datetime.today()
        datumtillagg = str(idag.year) + str(idag.month).zfill(2) + str(idag.day).zfill(2) + "_" + str(idag.hour).zfill(2) + str(idag.minute).zfill(2) + str(idag.second).zfill(2)

        if len(self.args) > 1 : # Jag förväntar mig högst ett argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig högst ett argument i anropet (sökvägen till databas). Jag avbryter här. \n")
            self.avsluta(1)

        if len(self.args) == 1:
            self.lineEdit_Sökväg.setText(self.args[0])
        else:
            self.lineEdit_Sökväg.setText("")


        self.importfil = str(self.options.Gedcomfil)
        if self.importfil == "None":
            self.importfil = ''
            self.importfil = '/home/ingemar/PIGAN/slkt/program/GedcomTest/disbytutdrag.ged'    # Adress passar i Ingemars linuxmiljö för programinkörning
        self.lineEdit_Importfil.setText(self.importfil)



        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)

        return
###################################################################################################




#########################################################################################
    def skapadatabaskatalog(self):

        sökväg = self.lineEdit_Sökväg.text()

        if sökväg == "":
            self.lineEdit_Sökväg.setFocus()
            msg = "Ange sökväg till databasen"
            QtGui.QMessageBox.information(self,'Johan: Sökväg till ny databas', msg, 'OK')
            return

        if not os.path.exists ( sökväg ):
            self.lineEdit_Sökväg.setFocus()
            msg = 'Jag hittar inte angiven sökväg till databas\n'
            msg = msg + 'Skapa vid behov och ange sökväg'
            QtGui.QMessageBox.information(self,'Johan: Sökväg till ny databas', msg, 'OK')
            return

        if not os.path.isdir ( sökväg ):
            self.lineEdit_Sökväg.setFocus()
            msg = 'Sökvägen ska vara en giltig katalogadress (folderadress)\n'
            msg = msg + 'där databasen, i sig själv en katalog, ska sparas'
            QtGui.QMessageBox.information(self,'Johan: Sökväg till ny databas', msg, 'OK')
            return

# sökvägen finns och är godkänd.

        if self.lineEdit_NyttDBNamn.text() == "":
            self.lineEdit_Sökväg.setFocus()
            msg = "Ange databasens namn"
            QtGui.QMessageBox.information(self,'Johan: Sökväg till ny databas', msg, 'OK')
            return

        databasnamn = os.path.join(sökväg, self.lineEdit_NyttDBNamn.text())

        if not os.path.exists (databasnamn):
            os.mkdir(databasnamn)
        
        if not os.path.exists (databasnamn):
            self.logga ('Kunde inte skapa databasens huvudkatalog. Avbryter\n')
            msg = ('Jag kunde inte skapa databasens huvudkatalog.\nAvbryter')
            QtGui.QMessageBox.information(self,'Johan: Sökväg till ny databas', msg, 'Avbryt')
            self.avsluta (1)

# databasnamnet tillåts finnas sedan tidigare som katalognamn om denna katalog är tom
        if len(os.listdir( databasnamn)) != 0:
            msg = 'Den tänkta huvudkatalogen för den nya databasen finns redan och\n'
            msg = msg + 'innehåller en eller flera filer av något slag.\nAvbryter här'
            QtGui.QMessageBox.information(self,'Johan: Sökväg till ny databas', msg, 'Avbryt')
            self.avsluta (1)

        if self.radioButton_TomDatabas.isChecked():
            self.tomdatabas(databasnamn)
        elif self.radioButton_GedcomImport.isChecked():
            self.import_widget.setVisible(True)
            self.nydatabas = databasnamn 

# Här väntat programmet på att någon klickar på "Starta"-knappen
        return
########################################################################################




###################################################################################################
    def tomdatabas(self, databasnamn):
        
#       ('Katalogen "' + databasnamn + '" är godkänd att kopiera databasmall till \n')
        allmänt.skapanydatabas(allmänt(), databasnamn )     # kopierar mallen

        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + '   "' + databasnamn  + '"   ' + '00000001'
        QtCore.QProcess().startDetached(kommando )

        self.logga('Nya databasen: "' + databasnamn + '" \n')
        self.logga('är klar att användas. Personbladet för första personen har öppnats.\n')
        self.logga('Fyll i tillgängliga uppgifter för första personen, åtminstone kön ("k" eller "m").\n')
        self.logga('Spara personbladet.\n')
        self.logga('STÄNG personbladet!\n')
        self.logga("Öppna därefter 'anor' eller 'ättlingar' för att tillfoga fler personer.\n")
        self.logga('TIPS: Notera databasen i aktuell johan_ini.xml så blir databasen lättare tillgänglig.\n')

        return
###################################################################################################




###################################################################################################
    def startaimportknapp(self):

# Sökväg och namn för den nya databasen har just bestämts och godkänts och sparats i globala variabeln self.nydatabas
# (Knappen "Starta Import" blir inte synlig förrän detta har utförts)
# Databasens toppkatalog har skapats men är ännu helt tom och ska inte behöva kollas igen.

        self.importfil = self.lineEdit_Importfil.text()

        if not os.path.exists (self.importfil):
            msg = "Jag hittar inte gedcomfil att importera: " + self.importfil
            QtGui.QMessageBox.information(self, 'importera gedcom', msg, 'OK')
            return

        self.logga ("Avser starta import från GEDCOM-fil\n")
        self.logga ("Från:   " + self.importfil + "\nTill:   " + self.nydatabas + '\n' )

# *** Bestäm kodning *******************************************************************

        self.EndOfFile = False

        kodning = self.bestämkodning()
        kodning_upper = kodning.upper()

        if self.EndOfFile == True:
            msg = "För kort fil: " + self.importfil
            QtGui.QMessageBox.information(self, 'importera gedcom', msg, 'AVBRYTER')
            return False

        self.logga ( "Gedcomfilens kodning: " + kodning + '\n')



# *** Konvertera från fil enligt kodning till UTF-8 ************************************
# Se även kommentar i Johans program exportera.py. (Sök "comboBox_Kodning.addItems")
# OBS! Fil att importera är normalt skriven av annat program än Johans exportera.
        self.EndOfFile = False

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Importfilen är redan kodad UTF-8
        if kodning_upper == "UTF-8" or kodning_upper == "UTF8":  # ingen kodningskonvertering alls
            utf8fil = self.importfil

        else:
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Importfilen är kodad ANSEL och ska konverteras här och nu av Johan till UTF-8
            if kodning_upper == "ANSEL" or kodning_upper == "ASCII":
                utf8fil = self.importfil + ".utf8"

                infil = open( self.importfil, "rb" )
                utfil = open(utf8fil, "w", encoding='utf-8')

                while True:
                    ImportRad = infil.readline()
                    if ImportRad == b'':  # end of file (visar sig vara här vi bryter)
                        break
                    if len(ImportRad) == 0:  # end of file
                        break

                    utf8rad = (self.ANSEL_till_utf8(ImportRad))
                    if utf8rad[0:7] == "1 CHAR ":
                        utf8rad = "1 CHAR UTF-8\n"

                    utfil.write(utf8rad)

                utfil.close()
                infil.close()

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        # Importfilens kodning är inte identifierad. Försöker här med pythons batteri av omkodare.
        # annan kodning som ska skrivas med små eller stora bokstäver enligt
        # http://docs.python.org/py3k/library/codecs.html?highlight=codec#standard-encodings
            else:
                utf8fil = self.importfil + ".utf8"

                try:
                    infil = open( self.importfil, 'r', encoding=kodning )
                except:
                    # Kunde inte öppna importfil med kodning=kodning. AVBRYT
                    msg = 'Jag kan inte översätta från kodning = ' + kodning + ' till Unicode/UTF-8.'
                    msg = msg + '\nKorrekta gedcom-kodningar är:'
                    msg = msg + '\n      ASCII, OBS! inte en enda bokstav med prickar eller accenter!'
                    msg = msg + '\n      ANSEL, exempel: svenskt Ä = hex E8 41'
                    msg = msg + '\nDessutom klarar jag:'
                    msg = msg + '\n      IBM850,  exempel: svenskt Ä = hex 8E'
                    msg = msg + '\n      8859-1, exempel: svenskt Ä = hex C4'
                    msg = msg + '\n      UTF-8,  exempel: svenskt Ä = hex C3 84'
                    msg = msg + '\nsamt alla ytterligare kodningar som anges i'
                    msg = msg + '\nhttp://docs.python.org/py3k/library/codecs.html?highlight=codec#standard-encodings'
                    msg = msg + '\nstavade med stora och små bokstäver exakt så som anges där.'

                    QtGui.QMessageBox.critical(self, 'importera gedcom', msg, 'AVBRYT NU')
                    return False

                utfil = open(utf8fil, 'w', encoding='utf-8')

                while True:
                    KodadRad = infil.readline()          # encoding=kodning
                    if KodadRad == '':
                        break

                    if KodadRad[0:7] == "1 CHAR ":
                        KodadRad = "1 CHAR UTF-8\n"
                    utfil.write(KodadRad)
                utfil.close()
                infil.close()

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

            msg = 'Översättning från kodning =  ' + kodning + ' till Unicode/UTF-8 är klar.'
            msg = msg + '\nResultatfilen, ' + utf8fil + '\n   kan raderas när importen är färdig.'

            QtGui.QMessageBox.information(self, 'importera gedcom', msg, 'Fortsätt')


# **************************************************************************************

        self.logga ("nydatabas.py: Startar import från GEDCOM-fil\n")
        self.logga ("Från:   " + self.importfil + "\nTill:   " + self.nydatabas + '\n' )

# Nu är indatafilen konverterad
# Här startar översättningen från Gedcom till Johan
        self.importera_gedcom_tråd.initialize(utf8fil, self.nydatabas, self.importfil)
        self.importera_gedcom_tråd.start()

        self.logga ("nydatabas.py: Import av gedcomfil pågår\n")

        return True
########################################################################################




########################################################################################
    def finished(self):

        self.logga ("Importen är klar" + '\n')

        self.kontrolleranydatabas()
# kommentera bort ovanstående rad för att slippa fortsätta automatiskt
# med kontroll och innehållsförteckning för den nu importerade databasen.

        return
###################################################################################################




###################################################################################################
    def kontrolleranydatabas(self):

        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"    -s F    ' + self.i_option + '   "' + self.nydatabas + '"'  # skapa innehållsförteckning sorterad på förnamn (ett eller flera per person)
        QtCore.QProcess().startDetached(kommando)
        self.logga ("nydatabas.py: Startade förnamnssorterad förteckning\n")

        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"    -s E    ' + self.i_option + '   "' + self.nydatabas + '"'  # skapa innehållsförteckning sorterad på efternamn (ett eller flera per person)
        QtCore.QProcess().startDetached(kommando)
        self.logga ("nydatabas.py: Startade efternamnssorterad förteckning\n")

        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'inh.py') + '"    ' + self.i_option + '   "' + self.nydatabas + '"'  # skapa övriga innehållsförteckningar
        QtCore.QProcess().startDetached(kommando)
        self.logga ("nydatabas.py: Startade övriga förteckningar\n")

        self.logga ('Öppnar program för kontroll av databas till nytt fönster.\nSTARTA SJÄLV kontrollen där. Kan ta tid.\n')
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'kontrollera.py') + '"   ' + self.i_option + '   "' + self.nydatabas + '"'
        QtCore.QProcess().startDetached(kommando)  # bara starta men vänta inte.

        return
###################################################################################################




###################################################################################################
    def bestämkodning(self):
        self.gedcomfil = open( self.importfil, "rb" )

# Man skulle inte behöva använda globala variabler här
#   def bestämkodning(self, imprtfil):
#       gedfil = open( imprtfil, "rb" )

# gedcomfilen öppnas som binärfil eftersom Python3 kräks åt ANSEL-filer)
# stängs igen innan kodningen levereras.

        self.rader=[] # Låt vara globalt tills vidare
        for i in range(0,20): # Borde väl överskrida antalet förekommande nivåer i någon gedcomfil
            self.rader.append("*")

        kodning = "okänd"
        self.senastenivå = -1
        self.redanlästrad = "*"              # rensar inför första anropet till self.gemignästa_bin()
        self.gemignästa_bin()                # levererar i globala "self.rader[]" !

        if self.EndOfFile:
            self.gedcomfil.close()
            return kodning

        rad0delar = self.rader[0].strip(b' \n').split(b' ')
        rad1delar = self.rader[1].strip(b' \n').split(b' ')

        while rad0delar[1] == b"HEAD":

            if rad1delar[1] == b"CHAR":
                self.gedcomfil.close()
                kodning = rad1delar[2].strip().decode('ASCII')  # Översättning från bytesträng till teckensträng.
                                                                # Förutsätts att denna rad kan tolkas som ASCII oberoende av filens kodning

#                try:
#                    kodning = rad1delar[2].decode('utf-8').strip()
#                except:
#                    pass

                return kodning   # utf-8

            else:
                self.gemignästa_bin()
                if self.EndOfFile:
                    self.gedcomfil.close()
                    return kodning

                rad0delar = self.rader[0].strip(b' \n').split(b' ')
                rad1delar = self.rader[1].strip(b' \n').split(b' ')

        self.gedcomfil.close()
        return  kodning
###################################################################################################




###################################################################################################
    def gemignästa_bin(self):   # - Ge mig nästa (rad) '
#
# Förutsättning: filen som läses har okänd kodning.
# Den ska vara öppnad som binärfil med globala namnet gedcomfil
#
# Alla leveranser till anropande kod sker i utf-8 i listan self.rader[]
#
# det finns två anrop hit: i rutinen "bestämkodning" ovan

        andrad = False
        if  self.redanlästrad != "*"  :
            rad = self.redanlästrad
            self.redanlästrad = "*"
#            self.logga('Hämtade fram redan läst rad: "' + repr(rad) + '"\n')
        else:
            rårad = self.gedcomfil.readline()
#            self.logga('Läste rad från fil: "' + repr(rårad) + '"\n')

            if rårad == b'':
                self.EndOfFile = True
                return
            rad = rårad.strip()

        delar = rad.split(b' ')

        if len(delar) > 1:
            if delar[0].isdigit():

                nivå = int(delar[0])
                self.rader[nivå] = rad               # utf-8
                self.rader[nivå+1] = "*"             # utf-8
                self.senastenivå = nivå
                andrad = True

        while True:
            rårad = self.gedcomfil.readline()        # utf-8
            if rad == '':
                self.EndOfFile = True
                return
            rad = rårad.strip()
            delar = rad.split(b' ')


            if len(delar) > 1:
                if delar[0].isdigit():
                    nivå = int(delar[0])
                    if (self.senastenivå +1 - nivå != 0  ):
                        self.redanlästrad = rad      # utf-8  # spara till nästa gång
                        return

                    else:
                        self.rader[nivå] = rad       # utf-8
                        self.senastenivå = nivå
                        if nivå+3 >= len(self.rader):
                            self.rader.append("*")
                        self.rader[nivå+1] = "*"     # utf-8

        return
###################################################################################################




########################################################################################
# Ansel till Unicode
#===================
#
# Enkeltecken 0 - 127,  kopieras,
# Förekommande enkeltecken i området 160 - 223 översätts till unicode-enkeltecken.
#
# Enkla eller multipla kombineratecken hanteras och översätts till
# motsvarande enkla eller multipla unicode-kombineratecken.
# Tillhörande grundtecken översätts som enkeltecken.
#
# Ingen översättning görs av Anselkombinerade tecken till färdiga unicode-enkeltecken även då sådana finns.
#
    def ANSEL_till_utf8(self, anselrad):

        utf8_rad=""
        anselpos=0
        ansellen=len(anselrad)

        while anselpos < ansellen:
            anselchar = anselrad[anselpos]
#            print (type(anselchar))  ## <class 'int'>


            UnicodeCombiner = ''
            while 224 < anselchar < 255 :  # kombinationsprefix, komplett lista - inklusive "�" för de nummer som är odefinierade
                UnicodeCombiner  = UnicodeCombiner + self.AnselTillUnicode(anselchar)


                anselpos = anselpos + 1
                anselchar = anselrad[anselpos]

            UnicodeTecken = self.AnselTillUnicode(anselchar) # Obs. funktionen AnselTillUnicode nedan

            try:
                U_sträng = unicodedata.normalize('NFC', UnicodeTecken + UnicodeCombiner)
            except:
                self.logga ('kunde inte normalisera(NFC) ' + UnicodeTecken + UnicodeCombiner + '\n')
                U_sträng = "���"

            utf8_rad = utf8_rad + U_sträng
            anselpos = anselpos + 1







        return utf8_rad
###################################################################################################




########################################################################################
    def AnselTillUnicode (self, anselchr):
        try:
            U_char = self.dictAnselTillUnicode [anselchr]
        except:
            U_char = '�'
        return U_char
###################################################################################################




#############################################################################################
    def logga(self, txt):
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn,'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Nydatabas_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print(ptxt)

# logga tilltextruta i johanfönstret
        self.textEdit_logg.insertPlainText(txt )
        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)

        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

## gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

## gör detta någon nytta?
#        self.repaint()

## gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Nydatabas_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winNydatabas = Nydatabas()
winNydatabas.show()
sys.exit(app.exec_())

################################################################################
