#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# parblad.py

# Senast ändrad: 2011-02-09  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
import datetime
import shutil
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from optparse import OptionParser
from gui_parblad import *

from johangemensamt import allmänt
from johanklasser import *
###################################################################################################




###################################################################################################
class Parblad(QtGui.QMainWindow, gui_Parblad):

    SenastÄndrad = '2011-02-06 14:30:35'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'parblad_py3_'
    loggfilopen = False

    lockedfilename = ""
    fnstrstr = ""
    infilnamn = ""
    databas = ""

    aktuelltparnummer = ""
    aktuelltbarnnummer = ""
    aktuelltbarnnamn   = ""

    aktuelltmakenummer = ""
    aktuelltmakenamn   = ""
    aktuelltmakanummer = ""
    aktuelltmakanamn   = ""

    palette_ytteryta_normal   = QtGui.QPalette()
    palette_ytteryta_spara    = QtGui.QPalette()
    palette_inneryta          = QtGui.QPalette()
    palette_sparaknapp_spara  = QtGui.QPalette()
    palette_sparaknapp_normal = QtGui.QPalette()

    fontsize = 9
    förstagången = True

    options = {}
    args = []

    färgschema = '0'     # '0' = Standard, '1' = Master, '2' = Compare
    färgschemabakgrund = QColor()

    inifilnamn = ''
    inifiltext = ''
    uprogramkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    f_option = ""
    i_option = ""

    Par1 = johanparfil()  #strukt ParXML() i 'strukturer' # måste vara global så att knapptryckning "Spara" kan fånga upp
###################################################################################################




###################################################################################################
    def __init__(self, parent = None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas  par_nummer",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-f", "--färg", dest="färgschema", help="färgschema vid databasjämförelser")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize
        self.bestämbakgrundsfärg()

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder =  os.path.join( unicode(os.environ['APPDATA']) , 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( unicode(os.environ['HOME']), 'johanloggar' )
            except:
                pass

        self.setupUi(self)  # definiera alla objekten men inte storlekar och placeringar

        self.createActions()

        self.inledning()  # först hämta data så tabellernas utsträckning kan bestämmas

        self.ui_connections()
        self.mera_ui_connections()

# Öppna inte avbrotten för ändringar i inmatningsfälten förrän de fyllts första gången!
        self.enableUi()

        self.lineEdit_Parnummer.setFocus()
        return
###################################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Parblad_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




###################################################################################################
    def bestämbakgrundsfärg(self):

# --- bakgrundsfärg måste (?) bestämmas före setupUi i Personblad.py

        self.f_option = ""
        self.färgschema = str(self.options.färgschema)
        if self.färgschema == "None":
            self.färgschema = '0'
            self.f_option = ""
            self.färgschemabakgrund = QColor(0,0,0,0) # färgschema Standard
#            self.setupFärgschema0()
        elif self.färgschema == '1':
            self.f_option = " -f 1 "
            self.färgschemabakgrund = QColor(0,255,0,16) # färgschema Master (ljusgrönt)
#            self.setupFärgschema1()
        elif self.färgschema == '2':
            self.f_option = " -f 2 "
            self.färgschemabakgrund = QColor(255,255,0,32) # färgschema Compare  (ljusgult)
#            self.setupFärgschema2()
        return
###########################################################################




######################################################################################
# kopplingar till knappar i grafiska gränsytan
    def mera_ui_connections(self):

#       Kopplingar, signaler i gui till slots i parblad.py
#       Ytterligare kopplingar, signaler i gui till slots i gui_par.py, finns i gui_par.py/ui_connections(self)


        self.connect(self.pushButton_Databas,         SIGNAL('clicked()'),       self.showDialogDatabas)
######################################################################################




###################################################################################################
    def closeEvent(self, event):
# Om man passerar här på väg ut utan att ha öppnat någon fil
# ska man inte göra något alls mer än låta programmet sluta
#
        if self.lockedfilename == "":
            event.accept()

# Om fil lästs, dvs "öppnats", så har den låsts.
#   om filen inte har ändrats sedan sista "spara" så ska man släppa låset och låta programmet sluta
#
        if self.pushButton_Spara.isEnabled() == False:   #  dirtybit

            try:
                os.remove(self.lockedfilename)
            except OSError as e:
                self.raderingsfel(e)
            self.lockedfilename = ""
            event.accept()

        else:
            Message = "Ändringar i parbladet har inte sparats. Ska jag stänga ändå"
            reply = QtGui.QMessageBox.question(self, "OBS!", Message ,  "Spara ändringar\noch stäng",  "Avbryt\nstängning", "Släng ändringar\nStäng direkt!")

            if reply == 0:  # spara ändringar och stäng
                self.sparaknapp()

                try:
                    os.remove(self.lockedfilename)
                except OSError as e:
                    self.raderingsfel(e)
                    self.lockedfilename = ""
                    event.accept()

            elif reply == 1:   # avbryt stängning
                event.ignore()

            else:              # if reply == 2  # Släng ändringar och stäng
                os.remove(self.lockedfilename)
                self.lockedfilename = ""
                event.accept()
###################################################################################################




######################################################################################
    def raderingsfel(self, e):
        self.logga ("FEL vid radering av låsfil:  " + str(e) + '\n')
#        self.logga ("FEL vid radering av låsfil:  errno=" + str(e.errno) + " filename=" + str(e.filename) + " strerror=" + e.strerror + '\n')
        return
######################################################################################




###################################################################################################
# kopplingar till högerklicksmenyer. Statiska rubriker lämnas tomma. Anpassade rubriker skrivs vid avbrottet
    def createActions(self):

        self.makebladAct =  QtGui.QAction("", self)
        self.connect(self.makebladAct, QtCore.SIGNAL("triggered()"), self.makeblad)

        self.makabladAct =  QtGui.QAction("", self)
        self.connect(self.makabladAct, QtCore.SIGNAL("triggered()"), self.makablad)

        self.barnbladAct =  QtGui.QAction("", self)
        self.connect(self.barnbladAct, QtCore.SIGNAL("triggered()"), self.barnblad)
###################################################################################################




###################################################################################################
    def ritaomknapp(self):

        if self.pushButton_Spara.isEnabled() == False:   #  dirtybit
            self.ritaom()
        else:
            Message = "Ändringar i parbladet har inte sparats. Ska jag ladda om ändå?"
            reply = QtGui.QMessageBox.question(self, "OBS!", Message , "Avbryt\nhämtning", "Släng ändringar\nHämta igen!")
            if reply != 0:
                self.ritaom()
###################################################################################################




###################################################################################################
    def dirtybit_set(self):

        idag = datetime.datetime.today()
        senastsparat = str(idag.year) + '-' +  str(idag.month).zfill(2) + '-' +  str(idag.day).zfill(2) + "  " + str(idag.hour).zfill(2) + ':' +  str(idag.minute).zfill(2) + ':' +  str(idag.second).zfill(2)
        self.lineEdit_SenastSparat.setText(senastsparat)

        self.pushButton_Spara.setEnabled(True)
        self.setWindowTitle(self.fnstrstr + "  [ändrad]  ")
        self.ytteryta.setPalette(self.palette_ytteryta_spara)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_spara)
######################################################################################




######################################################################################
    def dirtybit_reset(self):

        self.pushButton_Spara.setEnabled(False)
        self.setWindowTitle(self.fnstrstr)
        self.ytteryta.setPalette(self.palette_ytteryta_spara)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_spara)
###################################################################################################




###################################################################################################
    def sparaknapp(self):

        self.sparaGui(self.Par1)
        allmänt.sparaparfil(allmänt(), self.infilnamn, self.Par1)
        self.dirtybit_reset()
        self.ytteryta.setPalette(self.palette_ytteryta_normal)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_normal)
###################################################################################################




###################################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        if len(self.args) != 2 : # Jag förväntar mig två argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt två argument i anropet: Databasadress, Personnummer. Jag avbryter här.\n ")
            self.avsluta(1)

        self.lineEdit_Databas.setText(self.args[0])
        self.lineEdit_Parnummer.setText(self.args[1])
        self.databas = self.lineEdit_Databas.text()


# lås den aktuella parfilen.
#--------------------------------------------------------------------------------------------
        if self.lockedfilename == "":
            lockfilepar = os.path.join (self.lineEdit_Databas.text(), "locks", self.lineEdit_Parnummer.text() + ".lock")
            lockresponsepar = allmänt.johanlock(allmänt(),lockfilepar)

            if lockresponsepar == "":     # så har vi nu låst den aktuella parfilen åt oss
                self.lockedfilename = lockfilepar
            else:
                msg = 'Parbladet för par ' + self.lineEdit_Parnummer.text() + ' är LÅST\n\n'
                msg = msg + lockresponsepar
                QtGui.QMessageBox.information(self, "Johan - Parblad" , msg , QtGui.QMessageBox.Ok)

                self.avsluta(1)
#--------------------------------------------------------------------------------------------

        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)

        self.fontsizeset()
        self.ritaom()

        return
###################################################################################################




###################################################################################################
    def showDialogDatabas(self):

        if self.pushButton_Spara.isEnabled() == True:

            Message = "Ändringar i parbladet har inte sparats. Ska jag ladda om ändå?"
            reply = QtGui.QMessageBox.question(self, "OBS!", Message , "Avbryt\nhämtning", "Släng ändringar\nHämta igen!")
            if reply == 0:
                return

        self.pushButton_Spara.setEnabled( False)

        svar = str(QtGui.QFileDialog.getExistingDirectory(self, "Databas att exportera från", "/home", QFileDialog.ShowDirsOnly))

        fp = allmänt.förstapar (allmänt(), svar.rstrip('/'))

        if fp != "":
            self.databas = svar
            self.lineEdit_Databas.setText(self.databas)
            self.lineEdit_Parnummer.setText(fp)
            self.ritaom()

        return
###################################################################################################




###################################################################################################
    def ritaom(self):

        self.databas = self.lineEdit_Databas.text()
        parnummer=self.lineEdit_Parnummer.text()

#####  bestäm filnamn och kontrollera att filen finns
        self.infilnamn = os.path.join( self.databas, "data", parnummer[0:8], parnummer + ".xml")
        if os.path.exists(self.infilnamn) == False:
            msg = "Jag hittar inte filen " + self.infilnamn + "\nAvbryter."
            reply = QtGui.QMessageBox.information(self, "Johan - Parblad" , msg , QtGui.QMessageBox.Ok)
            return

######  hämta parfil och fyll det grafiska fönstret ----------------------------------------
        allmänt.hämtaparfil(allmänt(), self.infilnamn, self.Par1)
        self.fyllGui(self.Par1)
        self.dirtybit_reset()
        self.ytteryta.setPalette(self.palette_ytteryta_normal)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_normal)

#        self.pushButton_Spara.setEnabled(False)   #  dirtybit

######  skapa fönstrets titel, sätt på plats och spara globalt ----------------------------------------
        self.fnstrstr = parnummer + " - parblad"
        self.setWindowTitle(self.fnstrstr)

######  skapa meny i tabell för andra dokument
        self.andradokument( parnummer)

        self.sijlayout()
        self.windowlayout()

        return
###################################################################################################




###################################################################################################
    def andradokument(self, parnummer):

        infilkatalog =  os.path.join(self.databas, "data", parnummer[0:8] )
        folderinh = os.listdir(infilkatalog)

        OOo_dokumentfunnet = False
        txt_dokumentfunnet = False
        folder_funnen = False

# Rensa tabellen för att visa filer och länkar
        self.tableWidget_länkar.clearContents()
        self.tableWidget_länkar.setRowCount(0)

        for f in folderinh[:]:

            if parnummer == f[0:11] : # så finns någonting för paren i fråga

                if os.path.isfile(os.path.join(infilkatalog , f)):
                    if len(f) == 15 and  f[11:15] == ".odt" :
                        self.tableWidget_länkar.insertRow(0)
                        OOo_dokumentfunnet = True
                        self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem("O"))
                        self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Öppna odt-dokument"))
                        self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(f))
                    elif len(f) == 15 and  f[11:15] == ".txt" :
                        self.tableWidget_länkar.insertRow(0)
                        txt_dokumentfunnet = True
                        self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem("T"))
                        self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Öppna textdokument"))
                        self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(f))
                    elif ( f[11:15] != ".xml" ) :
                        self.tableWidget_länkar.insertRow(0)
                        self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem("A"))
                        self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Öppna annat-dokument"))
                        self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(f))

                elif os.path.isdir(os.path.join(infilkatalog , f[0:11])):  # koll att katalognamnet är just 11 tecken
                    self.tableWidget_länkar.insertRow(0)
                    self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem("K"))
                    self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Öppna katalog"))
                    self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(f))
                    folder_funnen =  True

# samma par kan ha flera filer redan i infilkatalog.
# först sedan katalogen genomlöpts vet vi om txt- eller odt-filer saknas för paret
# och menyrader för skapade av demsamma ska erbjudas

        if txt_dokumentfunnet == False:
            self.tableWidget_länkar.insertRow(0)
            self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem(""))
            self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Skapa textdokument"))
            self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(parnummer+".txt"))

        if OOo_dokumentfunnet == False:
            self.tableWidget_länkar.insertRow(0)
            self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem(""))
            self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Skapa odt-dokument"))
            self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(parnummer+".odt"))

        if folder_funnen == False:
            self.tableWidget_länkar.insertRow(0)
            self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem(""))
            self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Skapa katalog"))
            self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(parnummer))

###################################################################################################




###################################################################################################
    def lankarknapp(self, r, c):
#        print "I lankarknapprutinen: r =", r, ",   c=", c
        self.tableWidget_länkar.setCurrentCell(r, 2)
        valtnamn = self.tableWidget_länkar.currentItem().text()
        foldernamn0  = os.path.join(self.databas, "data", valtnamn[0:8]) #  + "/"


# Öppna befintlig katalog med filhanterare
        if  os.path.lexists(os.path.join(foldernamn0 , valtnamn)):
            if os.path.isdir(os.path.join(foldernamn0 , valtnamn)):
                foldernamn1 =os.path.join(foldernamn0 , valtnamn)
                kommando = allmänt.FILHANTERARE
                if kommando[-8:] == 'krusader':
                    krusaderheader = '"' +  self.Par1.kortnamn  + ' - fler filer' + '"'
                    kommando = kommando + '  -caption ' + krusaderheader + '   --left ' + foldernamn0 + ' --right ' + foldernamn1
                else:
                    kommando = kommando + '   ' + foldernamn0
                QtCore.QProcess().startDetached(kommando)

# Öppna befintlig odt-fil
            if os.path.isfile(os.path.join(foldernamn0 , valtnamn)):
                if (len(valtnamn) == 15) and (valtnamn[11:15] ) == ".odt" :
                    filnamn = os.path.join(foldernamn0 , valtnamn)
                    kommando = allmänt.ORDBEHANDLARE + " " + filnamn
                    QtCore.QProcess().startDetached(kommando)

# Öppna befintlig textfil
                elif  (len(valtnamn) == 15) and (valtnamn[11:15] ) == ".txt" :
                    filnamn = os.path.join(foldernamn0 , valtnamn)
                    kommando = allmänt.EDITOR + filnamn
                    QtCore.QProcess().startDetached(kommando)

# Försök öppna fil av okänd filtyp
# Hur ska jag anropa för att systemet ska välja associerat program att öppna med?
                else:
#                    filnamn = os.path.join(foldernamn0 , valtnamn)
#                    kommando =  " " + filnamn
#                    QtCore.QProcess().startDetached(kommando


# Öppna i stället katalogen med filhanterare
                    kommando = allmänt.FILHANTERARE
                    if kommando[-8:] == 'krusader':
                        krusaderheader = '"' +  self.Par1.kortnamn  + ' - fler filer' + '"'
                        kommando = kommando  + '  -caption ' + krusaderheader + '   --left ' + foldernamn0 + ' --right ' + foldernamn0
                    else:
                        kommando = kommando + '   ' + foldernamn0
                    QtCore.QProcess().startDetached(kommando)


            if os.path.islink(os.path.join(foldernamn0 , valtnamn)):
                print(" jag har inte lärt mig att hantera länkar")

        else: # if not os.path.exists ...

# Om katalog, skapa den
            if (len( valtnamn) == 11 ) :
                foldernamn1 =os.path.join(foldernamn0 , valtnamn)
                os.mkdir ( foldernamn1 )
# och sedan starta filhanterare

                kommando = allmänt.FILHANTERARE
                if kommando[-8:] == 'krusader':
                    krusaderheader = '"' +  self.Par1.kortnamn + ' - fler filer' + '"'
                    kommando = kommando + '  -caption ' + krusaderheader + '   --left ' + foldernamn0 + ' --right ' + foldernamn1
                else:
                    kommando = kommando + '   ' + foldernamn0
                QtCore.QProcess().startDetached(kommando)

# Om odt-fil, kopiera in mall till dokumentnamnet
            elif (len(valtnamn) == 15) and (valtnamn[11:15] ) == ".odt" :
                filnamn = os.path.join(foldernamn0 , valtnamn)
                shutil.copy2 ( os.path.join(self.databas, "data", "mallar", "par00000000.odt"), filnamn)
# och öppna det nya dokumentet
                kommando = allmänt.ORDBEHANDLARE + " " + filnamn
                QtCore.QProcess().startDetached(kommando)

# Om textfil: öppna nytt, skriv en första rad, stäng.
            elif (len(valtnamn) == 15) and (valtnamn[11:15] ) == ".txt" :
                filnamn = os.path.join(foldernamn0 , valtnamn)
                utfil=open(filnamn, 'w', encoding='utf-8')
                utfil.write(  self.Par1.kortnamn  + "\n\n" )
                utfil.close()
# Öppna därefter med vald editor
                kommando = allmänt.EDITOR + filnamn
                QtCore.QProcess().startDetached(kommando)

###################################################################################################




###################################################################################################
    def fyllGui(self, par):

        self.lineEdit_Par_ID.setText( par.par_ID)
        self.lineEdit_Person1_ID.setText( par.person1_ID)
        self.lineEdit_Person2_ID.setText( par.person2_ID)
        self.textEdit_Anteckningar.setText( par.anteckning)
#        self.textEdit_Barn.setText( par.barn)

        self.Händelse_inledning.lineEdit_typ.setText( par.inledn_typ)
        self.Händelse_inledning.lineEdit_år.setText( par.inledn_år)
        self.Händelse_inledning.lineEdit_månad.setText( par.inledn_månad)
        self.Händelse_inledning.lineEdit_dag.setText(  par.inledn_dag)

        self.Händelse_inledning.lineEdit_gata.setText(  par.inledn_gata)
        self.Händelse_inledning.lineEdit_by.setText( par.inledn_by)
        self.Händelse_inledning.lineEdit_kvarter.setText( par.inledn_kvarter)
        self.Händelse_inledning.lineEdit_socken.setText( par.inledn_socken)
        self.Händelse_inledning.lineEdit_församling.setText( par.inledn_församling)
        self.Händelse_inledning.lineEdit_disbytförsamling.setText( par.inledn_disbytförsamling)
        self.Händelse_inledning.lineEdit_stad.setText( par.inledn_stad)
        self.Händelse_inledning.lineEdit_härad.setText( par.inledn_härad)
        self.Händelse_inledning.lineEdit_län.setText( par.inledn_län)
        self.Händelse_inledning.lineEdit_utrikesplats.setText( par.inledn_utrikesplats)
        self.Händelse_inledning.textEdit_källa.setText( par.inledn_källa)

        self.Händelse_upplösning.lineEdit_typ.setText( par.upplösn_typ.lower())
        self.Händelse_upplösning.lineEdit_typ.setToolTip(' "mannens död" | "kvinnans död" | annat ')


#        self.Händelse_upplösning.groupBox_typ.setTitle('Typ ("mannens död", "kvinnans död", annat)')
#        if par.upplösn_typ.lower() == "mannens död" or par.upplösn_typ.lower() == "kvinnans död":
#            self.Händelse_upplösning.lineEdit_år.setText('')
#            self.Händelse_upplösning.lineEdit_månad.setText('')
#            self.Händelse_upplösning.lineEdit_dag.setText('')

#            self.Händelse_upplösning.lineEdit_gata.setText('')
#            self.Händelse_upplösning.lineEdit_by.setText('')
#            self.Händelse_upplösning.lineEdit_kvarter.setText('')
#            self.Händelse_upplösning.lineEdit_socken.setText('')
#            self.Händelse_upplösning.lineEdit_församling.setText('')
#            self.Händelse_upplösning.lineEdit_disbytförsamling.setText('')
#            self.Händelse_upplösning.lineEdit_stad.setText('')
#            self.Händelse_upplösning.lineEdit_härad.setText('')
#            self.Händelse_upplösning.lineEdit_län.setText('')
#            self.Händelse_upplösning.lineEdit_utrikesplats.setText('')
#            self.Händelse_upplösning.textEdit_källa.setText('')
#        else:


        self.Händelse_upplösning.lineEdit_år.setText( par.upplösn_år)
        self.Händelse_upplösning.lineEdit_månad.setText( par.upplösn_månad)
        self.Händelse_upplösning.lineEdit_dag.setText( par.upplösn_dag)

        self.Händelse_upplösning.lineEdit_gata.setText( par.upplösn_gata)
        self.Händelse_upplösning.lineEdit_by.setText( par.upplösn_by)
        self.Händelse_upplösning.lineEdit_kvarter.setText( par.upplösn_kvarter)
        self.Händelse_upplösning.lineEdit_socken.setText( par.upplösn_socken)
        self.Händelse_upplösning.lineEdit_församling.setText( par.upplösn_församling)
        self.Händelse_upplösning.lineEdit_disbytförsamling.setText( par.upplösn_disbytförsamling)
        self.Händelse_upplösning.lineEdit_stad.setText( par.upplösn_stad)
        self.Händelse_upplösning.lineEdit_härad.setText( par.upplösn_härad)
        self.Händelse_upplösning.lineEdit_län.setText( par.upplösn_län)
        self.Händelse_upplösning.lineEdit_utrikesplats.setText( par.upplösn_utrikesplats)
        self.Händelse_upplösning.textEdit_källa.setText( par.upplösn_källa)

        self.textEdit_Fler_Källor.setText( par.fler_källor)

        self.lineEdit_SenastSparat.setText( par.senastsparat)

# De två personerna i paret

        person1filnamn = os.path.join(self.databas, "data", par.person1_ID[0:5], par.person1_ID + ".xml")
        person2filnamn = os.path.join(self.databas, "data", par.person2_ID[0:5], par.person2_ID + ".xml")

        Person1 = johanpersonfil()
        Person2 = johanpersonfil()

        if os.path.exists(person1filnamn):
            allmänt.hämtapersonfil(allmänt(), person1filnamn, Person1)
            self.lineEdit_Person1_namn.setText( Person1.kortnamn )
        else:   # Jag kan inte hitta personfilen ", person1filnamn
            self.lineEdit_Person1_namn.setText( "" )

        if os.path.exists(person2filnamn):
            allmänt.hämtapersonfil(allmänt(), person2filnamn, Person2)
            self.lineEdit_Person2_namn.setText( Person2.kortnamn )
        else:   # Jag kan inte hitta personfilen ", person2filnamn
            self.lineEdit_Person2_namn.setText( "")


# Rensa tabell för att visa barn i
        self.tableWidget_Barn.clearContents()
        self.tableWidget_Barn.setRowCount(0)

# fyll i tabell från början
        if par.barn_ID != "":
            barnen = par.barn_ID.split("\n")
            for b in barnen:
                row=self.tableWidget_Barn.rowCount()
                self.tableWidget_Barn.insertRow(row)

# --- Kolumn 0: Barnets personnummer

                self.tableWidget_Barn.setItem(row, 0, QtGui.QTableWidgetItem(b ))

                Barn1 = johanpersonfil()
                barnfilnamn =  os.path.join(self.databas, "data", b[0:5], b + ".xml")

#####  läs hela filen till strukturen 'Barn1'
                if os.path.exists(barnfilnamn):
                    allmänt.hämtapersonfil(allmänt(), barnfilnamn, Barn1)

# --- Kolumn 1: Barnets födelseår

                    self.tableWidget_Barn.setItem(row, 1, QtGui.QTableWidgetItem(Barn1.född_år))

# --- Kolumn 2: Barnets namn,

                    self.tableWidget_Barn.setItem(row, 2, QtGui.QTableWidgetItem( Barn1.kortnamn ))

                else:
                    print("(parblad.py) Jag hittar inte personfilen", barnfilnamn)

###########################################################333############




###########################################################333############
    def sparaGui(self, par):

        par.par_ID = str(self.lineEdit_Par_ID.text())
        par.person1_ID = str(self.lineEdit_Person1_ID.text())
        par.person2_ID = str(self.lineEdit_Person2_ID.text())
        par.anteckning = str(self.textEdit_Anteckningar.toPlainText())

        par.inledn_typ = str(self.Händelse_inledning.lineEdit_typ.text())
        par.inledn_år = str(self.Händelse_inledning.lineEdit_år.text())
        par.inledn_månad = str(self.Händelse_inledning.lineEdit_månad.text())
        par.inledn_dag = str(self.Händelse_inledning.lineEdit_dag.text())

        par.inledn_gata = str(self.Händelse_inledning.lineEdit_gata.text())
        par.inledn_by = str(self.Händelse_inledning.lineEdit_by.text())
        par.inledn_kvarter = str(self.Händelse_inledning.lineEdit_kvarter.text())
        par.inledn_socken = str(self.Händelse_inledning.lineEdit_socken.text())
        par.inledn_församling = str(self.Händelse_inledning.lineEdit_församling.text())
        par.inledn_disbytförsamling = str(self.Händelse_inledning.lineEdit_disbytförsamling.text())
        par.inledn_stad = str(self.Händelse_inledning.lineEdit_stad.text())
        par.inledn_härad = str(self.Händelse_inledning.lineEdit_härad.text())
        par.inledn_län = str(self.Händelse_inledning.lineEdit_län.text())
        par.inledn_utrikesplats = str(self.Händelse_inledning.lineEdit_utrikesplats.text())
        par.inledn_källa = str(self.Händelse_inledning.textEdit_källa.toPlainText())

        par.upplösn_typ = str(self.Händelse_upplösning.lineEdit_typ.text())
        par.upplösn_år = str(self.Händelse_upplösning.lineEdit_år.text())
        par.upplösn_månad = str(self.Händelse_upplösning.lineEdit_månad.text())
        par.upplösn_dag = str(self.Händelse_upplösning.lineEdit_dag.text())

        par.upplösn_gata = str(self.Händelse_upplösning.lineEdit_gata.text())
        par.upplösn_by = str(self.Händelse_upplösning.lineEdit_by.text())
        par.upplösn_kvarter = str(self.Händelse_upplösning.lineEdit_kvarter.text())
        par.upplösn_socken = str(self.Händelse_upplösning.lineEdit_socken.text())
        par.upplösn_församling = str(self.Händelse_upplösning.lineEdit_församling.text())
        par.upplösn_disbytförsamling = str(self.Händelse_upplösning.lineEdit_disbytförsamling.text())
        par.upplösn_stad = str(self.Händelse_upplösning.lineEdit_stad.text())
        par.upplösn_härad = str(self.Händelse_upplösning.lineEdit_härad.text())
        par.upplösn_län = str(self.Händelse_upplösning.lineEdit_län.text())
        par.upplösn_utrikesplats = str(self.Händelse_upplösning.lineEdit_utrikesplats.text())
        par.upplösn_källa = str(self.Händelse_upplösning.textEdit_källa.toPlainText())

        par.fler_källor = str(self.textEdit_Fler_Källor.toPlainText())

        idag = datetime.datetime.today()
        senastsparat = str(str(idag.year) + '-' +  str(idag.month).zfill(2) + '-' +  str(idag.day).zfill(2) + "  " + str(idag.hour).zfill(2) + ':' +  str(idag.minute).zfill(2) + ':' +  str(idag.second).zfill(2))

        par.senastsparat = senastsparat
        self.lineEdit_SenastSparat.setText(senastsparat)


        if self.tableWidget_Barn.rowCount() == 0:
            par.barn_ID = ""
        else:
            self.tableWidget_Barn.selectColumn(0)
            self.tableWidget_Barn.selectRow(0)
            par.barn_ID = str(self.tableWidget_Barn.currentItem().text())
            rc=1
            while rc < self.tableWidget_Barn.rowCount():
                self.tableWidget_Barn.selectRow(rc)
                par.barn_ID = par.barn_ID + "\n" + str(self.tableWidget_Barn.currentItem().text())
                rc = rc + 1
###################################################################################################




###################################################################################################
    def uppknapp(self):

        aktuellrad = self.tableWidget_Barn.currentRow()
        antalrader = self.tableWidget_Barn.rowCount()
        if antalrader < 2:
            return
        if aktuellrad <= 0:
            return
        if aktuellrad > antalrader - 1:
            return

        FlyttaUppIDtext   = str(self.tableWidget_Barn.item(aktuellrad, 0).text())
        FlyttaUppArtext   = str(self.tableWidget_Barn.item(aktuellrad, 1).text())
        FlyttaUppNamntext = str(self.tableWidget_Barn.item(aktuellrad, 2).text())

        FlyttaNerIDtext   = str(self.tableWidget_Barn.item(aktuellrad-1, 0).text())
        FlyttaNerArtext   = str(self.tableWidget_Barn.item(aktuellrad-1, 1).text())
        FlyttaNerNamntext = str(self.tableWidget_Barn.item(aktuellrad-1, 2).text())

        self.tableWidget_Barn.setItem(aktuellrad, 0, QtGui.QTableWidgetItem(FlyttaNerIDtext)  )
        self.tableWidget_Barn.setItem(aktuellrad, 1, QtGui.QTableWidgetItem(FlyttaNerArtext)  )
        self.tableWidget_Barn.setItem(aktuellrad, 2, QtGui.QTableWidgetItem(FlyttaNerNamntext))

        self.tableWidget_Barn.setItem(aktuellrad-1, 0, QtGui.QTableWidgetItem(FlyttaUppIDtext)  )
        self.tableWidget_Barn.setItem(aktuellrad-1, 1, QtGui.QTableWidgetItem(FlyttaUppArtext)  )
        self.tableWidget_Barn.setItem(aktuellrad-1, 2, QtGui.QTableWidgetItem(FlyttaUppNamntext))

        self.tableWidget_Barn.selectRow(aktuellrad-1)
        self.dirtybit_set()
        self.ytteryta.setPalette(self.palette_ytteryta_spara)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_spara)

        return
###################################################################################################




###################################################################################################
    def nedknapp(self):

        aktuellrad = self.tableWidget_Barn.currentRow()
        antalrader = self.tableWidget_Barn.rowCount()
        if antalrader < 2:
            return
        if aktuellrad < 0:
            return
        if aktuellrad >= antalrader - 1:
            return

        FlyttaUppIDtext   = str(self.tableWidget_Barn.item(aktuellrad+1, 0).text())
        FlyttaUppArtext   = str(self.tableWidget_Barn.item(aktuellrad+1, 1).text())
        FlyttaUppNamntext = str(self.tableWidget_Barn.item(aktuellrad+1, 2).text())

        FlyttaNerIDtext   = str(self.tableWidget_Barn.item(aktuellrad, 0).text())
        FlyttaNerArtext   = str(self.tableWidget_Barn.item(aktuellrad, 1).text())
        FlyttaNerNamntext = str(self.tableWidget_Barn.item(aktuellrad, 2).text())

        self.tableWidget_Barn.setItem(aktuellrad+1, 0, QtGui.QTableWidgetItem(FlyttaNerIDtext)  )
        self.tableWidget_Barn.setItem(aktuellrad+1, 1, QtGui.QTableWidgetItem(FlyttaNerArtext)  )
        self.tableWidget_Barn.setItem(aktuellrad+1, 2, QtGui.QTableWidgetItem(FlyttaNerNamntext))

        self.tableWidget_Barn.setItem(aktuellrad, 0, QtGui.QTableWidgetItem(FlyttaUppIDtext)  )
        self.tableWidget_Barn.setItem(aktuellrad, 1, QtGui.QTableWidgetItem(FlyttaUppArtext)  )
        self.tableWidget_Barn.setItem(aktuellrad, 2, QtGui.QTableWidgetItem(FlyttaUppNamntext))

        self.tableWidget_Barn.selectRow(aktuellrad+1)
        self.dirtybit_set()
        self.ytteryta.setPalette(self.palette_ytteryta_spara)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_spara)

        return
###################################################################################################




###################################################################################################
# Hit kommer man magiskt vid högerklick
    def contextMenuEvent(self, event):

        if      self.groupBox_Par.geometry().top()    < event.y() \
            and self.groupBox_Par.geometry().bottom() > event.y() \
            and self.groupBox_Par.geometry().left()   < event.x() \
            and self.groupBox_Par.geometry().right()  > event.x():
            self.skapaMenyPar(event)

        elif    self.groupBox_Egna_Barn.geometry().top()    < event.y() \
            and self.groupBox_Egna_Barn.geometry().bottom() > event.y() \
            and self.groupBox_Egna_Barn.geometry().left()   < event.x() \
            and self.groupBox_Egna_Barn.geometry().right()  > event.x():
            self.skapaMenyEgna_Barn(event)


####  slut på själva klickhanteringen #############################################################
###################################################################################################



###################################################################################################
    def skapaMenyPar( self,event):

        self.aktuelltmakenummer = self.lineEdit_Person1_ID.text()
        self.aktuelltmakenamn = self.lineEdit_Person1_namn.text()
        self.aktuelltmakanummer = self.lineEdit_Person2_ID.text()
        self.aktuelltmakanamn = self.lineEdit_Person2_namn.text()

        meny = QtGui.QMenu(self)

        if self.aktuelltmakenummer != "":
            meny.addAction(self.makebladAct)
            rubriktext = "PERSONBLAD för " + self.aktuelltmakenamn
            self.makebladAct.setText(rubriktext)

        if self.aktuelltmakanummer != "":
            meny.addAction(self.makabladAct)
            rubriktext = "PERSONBLAD för " + self.aktuelltmakanamn
            self.makabladAct.setText(rubriktext)

        meny.exec_(event.globalPos())
###################################################################################################




###################################################################################################
    def skapaMenyEgna_Barn( self,event):

        aktuellrad = self.tableWidget_Barn.currentRow()
        self.tableWidget_Barn.setCurrentCell(aktuellrad,0)

        try:
            self.aktuelltbarnnummer = self.tableWidget_Barn.currentItem().text().strip()
        except:
            self.aktuelltbarnnummer = ""


        self.tableWidget_Barn.setCurrentCell(aktuellrad,2)

        try:
            self.aktuelltbarnnamn = self.tableWidget_Barn.currentItem().text().strip()
        except:
            self.aktuelltbarnnamn = ""


        meny = QtGui.QMenu(self)

        if self.aktuelltbarnnummer != "":
            meny.addAction(self.barnbladAct)
            rubriktext = "PERSONBLAD för " + self.aktuelltbarnnamn
            self.barnbladAct.setText(rubriktext)

        meny.exec_(event.globalPos())
###################################################################################################




###################################################################################################
##### Stöd för olika val i menyn efter högerklick  ################################################


# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def makeanlista(self):
        kommando = allmänt.PYTON+ '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltmakenummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def makaanlista(self):
        kommando = allmänt.PYTON+ '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltmakanummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def makeblad(self):
        kommando = allmänt.PYTON+ '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltmakenummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def makablad(self):
        kommando = allmänt.PYTON+ '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltmakanummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def barnblad(self):
        kommando = allmänt.PYTON+ '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltbarnnummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def ättlinglista(self):
        kommando = allmänt.PYTON+ '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltmakenummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def ättlinglista(self):
        kommando = allmänt.PYTON+ '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltmakanummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

##### slut för stöd för olika val i valrutan ######################################################
###################################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn, 'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Parblad_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

## logga till textruta i programfönster
#        self.textEdit_logg.insertPlainText(txt )
#        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)
#
#        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Parblad_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




###################################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winParblad = Parblad()
winParblad.show()
sys.exit(app.exec_())
################################################################################
