#!/usr/local/bin/python3
# -*- coding: utf-8 -*-


# parlista.py

# Senast ändrad: 2011-03-02  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




###########################################################################
import sys
import os
import datetime
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from optparse import OptionParser
from gui_parlista import *

from johangemensamt import allmänt
from johanklasser import *
###########################################################################




###########################################################################
class Parlista(QtGui.QMainWindow, gui_Parlista):

    SenastÄndrad = '2011-03-01 20:05:48'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'parlista_py3_'
    loggfilopen = False

    databas = ""
    aktuelltparnummer = ""

    Person1 = johanpersonfil()

    loggwidth = 0     #  =0 ger ingen logg
#    loggwidth = 20    #  =n ger loggruta med bredden ca n tecken eller något fler. Föreslår =20 (20 - 30 tecken)
#    loggwidth = 40

    startpar = ""   #  strängar!
    slutpar = ""    #  strängar!

    fontsize = 9
    loggnr = 0










    options = {}
    args = []

    färgschema = '0'     # '0' = Standard, '1' = Master, '2' = Compare
    färgschemabakgrund = QColor()

    inifilnamn = ''
    inifiltext = ''
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    f_option = ""
    i_option = ""

    EditeraTillstånd = False

###########################################################################




#############################################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-f", "--färg", dest="färgschema", help="färgschema vid databasjämförelser")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize
        self.bestämbakgrundsfärg()

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder =  os.path.join( os.environ['APPDATA'], 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass


        self.setupUi(self)
        self.ui_connections()

        self.inledning()

        self.connect(self.pushButton_starta,  SIGNAL("clicked()"), self.startalista)

        return
#   Väntar sedan på att någon klickar på "starta lista"
############################################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Parlista_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




###################################################################################################
    def bestämbakgrundsfärg(self):

        self.f_option = ""
        self.färgschema = str(self.options.färgschema)
        if self.färgschema == "None":
            self.färgschema = '0'
            self.f_option = ""
            self.färgschemabakgrund = QColor(0,0,0,0) # färgschema Standard
#            self.setupFärgschema0()
        elif self.färgschema == '1':
            self.f_option = " -f 1 "
            self.färgschemabakgrund = QColor(0,255,0,16) # färgschema Master (ljusgrönt)
#            self.setupFärgschema1()
        elif self.färgschema == '2':
            self.f_option = " -f 2 "
            self.färgschemabakgrund = QColor(255,255,0,32) # färgschema Compare  (ljusgult)
#            self.setupFärgschema2()
        return
###################################################################################################




#############################################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        if len(self.args) != 1 : # Jag förväntar mig exakt ett argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt ett argument i anropet: Databasadress ???. Jag avbryter här.\n ")
            self.avsluta(1)

        self.lineEdit_Databas.setText(self.args[0])
        self.databas = self.lineEdit_Databas.text()

        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)

        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()

# läs sistanummer-filen
        senasteparfil = open( os.path.join(self.databas, "senaste", "senastepar.txt") , "r", encoding='utf-8')
        senastepar = senasteparfil.readline().strip()    # tag bort ev newline och annan whitespace
        senasteparfil.close()
        self.lineEdit_Senastepar.setText(senastepar)
        self.lineEdit_stoppnr.setText(senastepar)
        self.lineEdit_startnr.setText("par00000001")

        self.frame_top.setVisible(False)
        self.frame_top2.setVisible(True)
        self.tableWidget_Parlista.setVisible(False)

        return
#############################################################################################################




#############################################################################################################
    def startalista(self):

        self.startpar = self.lineEdit_startnr.text()   # strängar!  typ "par01234567"
        self.slutpar  = self.lineEdit_stoppnr.text()   # strängar!

        self.frame_top2.setVisible(False)
        self.frame_top.setVisible(True)
        self.tableWidget_Parlista.setVisible(True)
        self.tableWidget_Parlista.setAlternatingRowColors(True)

        self.ritaom() # fyller tabellen med pardata

        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()

        self.createActions() # skapa för högerklicksmeny

        self.checkBox_TillåtUppdatering.setEnabled(False)
        self.connect(self.checkBox_TillåtUppdatering, SIGNAL("stateChanged(int)"), self.ÄndraEditTillstånd)
        self.checkBox_TillåtUppdatering.setEnabled(True)

        self.connect(self.tableWidget_Parlista, SIGNAL("cellChanged(int,int)"), self.tabellrutaändrad)
        self.connect(self.tableWidget_Parlista, SIGNAL("cellClicked(int,int)"), self.tabellrutaklick)
        self.tableWidget_Parlista.setEnabled(True)

        return
# Väntar på någon av händelser:
#       1) växling av "Tillåt Uppdatering"
#       2) vänsterklick i tabellen
#           - om Tillåt Uppdatering: för vissa av cellerna i tabellen kan vald cell sättas i edit-tillstånd
#           - om ej Tillåt Uppdatering: vald rad i tabell markeras
#       3) högerklick i tabellen
#           - om Tillåt Uppdatering: - inget ska hända
#           - om ej Tillåt Uppdatering: rullmeny ska fram
#       4) innehåll i cell ändrat
#############################################################################################################




#############################################################################################################
    def createActions(self):

# kopplingar till högerklicksmeny. Statiska rubriker lämnas tomma. Anpassade rubriker skrivs vid avbrottet
        self.ättling1listaAct = QtGui.QAction("", self)
        self.connect(self.ättling1listaAct, QtCore.SIGNAL("triggered()"), self.ättling1lista)

        self.an1listaAct =  QtGui.QAction("", self)
        self.connect(self.an1listaAct, QtCore.SIGNAL("triggered()"), self.an1lista)

        self.person1bladAct =  QtGui.QAction("", self)
        self.connect(self.person1bladAct, QtCore.SIGNAL("triggered()"), self.person1blad)


        self.ättling2listaAct = QtGui.QAction("", self)
        self.connect(self.ättling2listaAct, QtCore.SIGNAL("triggered()"), self.ättling2lista)

        self.an2listaAct =  QtGui.QAction("", self)
        self.connect(self.an2listaAct, QtCore.SIGNAL("triggered()"), self.an2lista)

        self.person2bladAct =  QtGui.QAction("", self)
        self.connect(self.person2bladAct, QtCore.SIGNAL("triggered()"), self.person2blad)

        return
#############################################################################################################




#############################################################################################################
    def ritaom (self):

        self.databas = self.lineEdit_Databas.text()

        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allmänt.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allmänt.Vertikalfaktor * metrics.height()












# --- Tömmer och nollställer eventuell gammal tabell ---
        self.tableWidget_Parlista.clearContents()
        self.tableWidget_Parlista.setRowCount(0)

        self.tableWidget_Parlista.setSortingEnabled(False)

        Par1 = johanparfil()

        antalpar = 0
        loopparnummer = int(self.startpar[3:11])

        while loopparnummer >= int(self.startpar[3:11]) and loopparnummer <= int(self.slutpar[3:11]) :
            aktuellpar_ID = "par" + str(loopparnummer ).zfill(8)

            filnamn = os.path.join(self.databas, "data", aktuellpar_ID[:8], aktuellpar_ID + ".xml")
            if os.path.exists(filnamn):
                allmänt.hämtaparfil ( allmänt(), filnamn, Par1 )  # Läs alla par - ett i taget
                self.fyllnästarad ( Par1, fh )
                antalpar = antalpar + 1

            loopparnummer = loopparnummer + 1

#        self.logga ("Listade " + str(antalpar) + " par med par_ID mellan " + str(self.startpar).zfill(8) + " och " + str(self.slutpar).zfill(8)  + (".\n"))










        self.tableWidget_Parlista.setSortingEnabled(True)
        self.tableWidget_Parlista.sortItems(0,Qt.AscendingOrder)
        self.lineEdit_Antalpar.setText(str(antalpar))

        availablescreen_Rect = QtGui.QDesktopWidget().availableGeometry()
        self.ytteryta.setGeometry (0,0, 0.95 * availablescreen_Rect.width(),  0.95 * availablescreen_Rect.height() )

        return
#### end def ritaom #########################################################################################




# Constant              Value   Description
# Qt.NoItemFlags          0   It does not have any properties set.
# Qt.ItemIsSelectable     1   It can be selected.
# Qt.ItemIsEditable       2   It can be edited.
# Qt.ItemIsDragEnabled    4   It can be dragged.
# Qt.ItemIsDropEnabled    8   It can be used as a drop target.
# Qt.ItemIsUserCheckable 16   It can be checked or unchecked by the user.
# Qt.ItemIsEnabled       32   The user can interact with the item.
# Qt.ItemIsTristate      64   The item is checkable with three separate states.

#############################################################################################################
    def fyllnästarad(self, par, radhöjd):

        noeditflaggor = Qt.ItemIsSelectable | Qt.ItemIsEnabled

        if self.checkBox_TillåtUppdatering.isChecked():
            editflaggor = Qt.ItemIsSelectable | Qt.ItemIsEditable | Qt.ItemIsEnabled
        else:
            editflaggor = Qt.ItemIsSelectable | Qt.ItemIsEnabled

        row = self.tableWidget_Parlista.rowCount()
        self.tableWidget_Parlista.insertRow(row)

        self.FylliParItem( row,  0, par.par_ID                    , noeditflaggor)
        self.FylliParItem( row,  1, par.person1_ID                , noeditflaggor)
        self.FylliParItem( row,  2, par.person2_ID                , noeditflaggor)

        self.FylliParItem( row,  5, par.bonusrelation_ID          , noeditflaggor)
        self.FylliParItem( row,  6, par.inledn_typ                , editflaggor)
        self.FylliParItem( row,  7, par.inledn_år                 , editflaggor)
        self.FylliParItem( row,  8, par.inledn_månad              , editflaggor)
        self.FylliParItem( row,  9, par.inledn_dag                , editflaggor)
        self.FylliParItem( row, 10, par.inledn_gata               , editflaggor)
        self.FylliParItem( row, 11, par.inledn_by                 , editflaggor)
        self.FylliParItem( row, 12, par.inledn_kvarter            , editflaggor)
        self.FylliParItem( row, 13, par.inledn_socken             , editflaggor)
        self.FylliParItem( row, 14, par.inledn_församling         , editflaggor)
        self.FylliParItem( row, 15, par.inledn_disbytförsamling   , editflaggor)
        self.FylliParItem( row, 16, par.inledn_stad               , editflaggor)
        self.FylliParItem( row, 17, par.inledn_härad              , editflaggor)
        self.FylliParItem( row, 18, par.inledn_län                , editflaggor)
        self.FylliParItem( row, 19, par.inledn_utrikesplats       , editflaggor)
        self.FylliParItem( row, 20, par.inledn_källa              , editflaggor)
        self.FylliParItem( row, 21, par.upplösn_typ               , editflaggor)
        self.FylliParItem( row, 22, par.upplösn_år                , editflaggor)
        self.FylliParItem( row, 23, par.upplösn_månad             , editflaggor)
        self.FylliParItem( row, 24, par.upplösn_dag               , editflaggor)
        self.FylliParItem( row, 25, par.upplösn_gata              , editflaggor)
        self.FylliParItem( row, 26, par.upplösn_by                , editflaggor)
        self.FylliParItem( row, 27, par.upplösn_kvarter           , editflaggor)
        self.FylliParItem( row, 28, par.upplösn_socken            , editflaggor)
        self.FylliParItem( row, 29, par.upplösn_församling        , editflaggor)
        self.FylliParItem( row, 30, par.upplösn_disbytförsamling  , editflaggor)
        self.FylliParItem( row, 31, par.upplösn_stad              , editflaggor)
        self.FylliParItem( row, 32, par.upplösn_härad             , editflaggor)
        self.FylliParItem( row, 33, par.upplösn_län               , editflaggor)
        self.FylliParItem( row, 34, par.upplösn_utrikesplats      , editflaggor)
        self.FylliParItem( row, 35, par.upplösn_källa             , editflaggor)
        self.FylliParItem( row, 36, par.barn_ID                   , editflaggor)
        self.FylliParItem( row, 37, par.fler_källor               , editflaggor)
        self.FylliParItem( row, 38, par.anteckning                , editflaggor)
        self.FylliParItem( row, 39, par.senastsparat              , noeditflaggor)

        filnamn = os.path.join(self.databas, "data", par.person1_ID[:5], par.person1_ID + ".xml")
        if os.path.exists(filnamn):
            allmänt.hämtapersonfil ( allmänt(), filnamn, self.Person1 )  #
            self.FylliParItem( row,  3, self.Person1.långtnamn                   , noeditflaggor)

        filnamn = os.path.join(self.databas, "data", par.person2_ID[:5], par.person2_ID + ".xml")
        if os.path.exists(filnamn):
            allmänt.hämtapersonfil ( allmänt(), filnamn, self.Person1 )  #
            self.FylliParItem( row,  4, self.Person1.långtnamn                   , noeditflaggor)

        self.tableWidget_Parlista.setRowHeight(row, radhöjd)

        for kolumn in [0,1,2,3,4,5,39]:
            try:
                self.tableWidget_Parlista.item(row, kolumn).setForeground(QtGui.QBrush(QtGui.QColor(0,0,0)))
            except:
                pass

            try:
                self.tableWidget_Parlista.item(row, kolumn).setBackground( QtGui.QBrush(QtGui.QColor(255,255,255)))
            except:
                pass

        return
#############################################################################################################




#############################################################################################################
    def FylliParItem(self, rad, kolumn, paruppgift, flaggor):
        self.tableWidget_Parlista.setItem(rad, kolumn, QtGui.QTableWidgetItem())
        self.tableWidget_Parlista.item   (rad, kolumn).setText(paruppgift)
        self.tableWidget_Parlista.item   (rad, kolumn).setFlags(flaggor)
        self.tableWidget_Parlista.item   (rad, kolumn).setToolTip(paruppgift)
#############################################################################################################




#############################################################################################################
    def ÄndraEditTillstånd(self): # Hit vid ändring av self.checkBox_TillåtUppdatering
#        self.logga ("enter ÄndraEditTillstånd\n")
#        self.logga ("Aktuellt Tillstånd: " + str(self.EditeraTillstånd) + '\n' )
#        self.logga ("checkBox1: " + str(self.checkBox_TillåtUppdatering.isChecked())  + '\n' )


        if self.checkBox_TillåtUppdatering.isChecked():
            Msg = """VARNING - Du vill tillåta Parlista.py att ändra i databasen

Varje ändring införes omedelbart i databasen.
Du måste själv vara noga med att inget annat program har
åtkomst till databasen, varken i denna dator eller i någon
annan dator som kan ha åtkomst via nätverk.
"""
            svar = QtGui.QMessageBox.warning(self, "OBS!", Msg, "Återgå till\nenbart läsning", "OK - jag är ensam i databasen\nTillåt ändringar")
#           self.logga ("Svar: " + str(svar) + '\n' )  # svar = 0: återgå; = 1: tillåt
            if str(svar) == "0":
                self.checkBox_TillåtUppdatering.setChecked(False)
#                self.logga ("checkBox2: " + str(self.checkBox_TillåtUppdatering.isChecked())  + '\n' )
                self.ÄndraEditTillstånd()

                return

        if self.checkBox_TillåtUppdatering.isChecked() != self.EditeraTillstånd:
            self.TillämpaEditTillstånd(self.checkBox_TillåtUppdatering.isChecked())

        return
#############################################################################################################




#############################################################################################################
    def TillämpaEditTillstånd(self, Tillstånd = False):

###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###

        self.checkBox_TillåtUppdatering.setEnabled(False)
        self.tableWidget_Parlista.setEnabled(False)
        self.disconnect(self.tableWidget_Parlista, SIGNAL("cellChanged(int,int)"), self.tabellrutaändrad)

###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###

        musmarkör = QCursor()
        musmarkör.setShape(Qt.WaitCursor)
        QApplication.setOverrideCursor(musmarkör)

        if self.checkBox_TillåtUppdatering.isChecked():
            editflaggor = Qt.ItemIsSelectable | Qt.ItemIsEditable | Qt.ItemIsEnabled
            brushForeGnd = QtGui.QBrush(QtGui.QColor(128,0,0))
            brushBackGnd = QtGui.QBrush(QtGui.QColor(255,253,253))
            self.tableWidget_Parlista.setSelectionBehavior(QtGui.QAbstractItemView.SelectItems)

        else:
            editflaggor = Qt.ItemIsSelectable | Qt.ItemIsEnabled
            brushForeGnd = QtGui.QBrush(QtGui.QColor(0,0,0))
            brushBackGnd = QtGui.QBrush(QtGui.QColor(255,255,255))
            self.tableWidget_Parlista.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)

        for rad in range (0,self.tableWidget_Parlista.rowCount()):
            for kolumn in range (6, 39):
                self.tableWidget_Parlista.item(rad, kolumn).setFlags(editflaggor)
                self.tableWidget_Parlista.item(rad, kolumn).setBackground(brushBackGnd)
                self.tableWidget_Parlista.item(rad, kolumn).setForeground(brushForeGnd)

        self.EditeraTillstånd = Tillstånd
        musmarkör.setShape(Qt.ArrowCursor)
        QApplication.setOverrideCursor(musmarkör)

###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###

        self.connect(self.tableWidget_Parlista, SIGNAL("cellChanged(int,int)"), self.tabellrutaändrad)
        self.tableWidget_Parlista.setEnabled(True)
        self.checkBox_TillåtUppdatering.setEnabled(True)

###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###

        return
#############################################################################################################




##### Stöd för tänkta olika val i menyrutan  ################################################################
    def tabellrutaklick(self, r, c):
#        self.logga ("Enkelklick, row/col: " + str(r) + ' / ' + str(c) + '\n' )
#        self.logga ("Editmod1: " + str(self.EditeraTillstånd) + '\n' )

        if not self.EditeraTillstånd:
            return

        if r>=0 and c >=0:
            self.tableWidget_Parlista.setCurrentCell(r, c)
#            self.logga ( ' Cell i tabell, row/col: ' + str(self.tableWidget_Parlista.currentRow()) + ' / ' +  str(self.tableWidget_Parlista.currentColumn()) + '\n')

            try:    # försök att editera
                self.tableWidget_Parlista.editItem(self.tableWidget_Parlista.item(r,c))
#                self.logga (' Editerar, row/col: ' + str(r) + ' / ' + str(c) + '\n' )
            except:
                pass
#                self.logga ('Kunde inte editera, row/col: ' + str(r) + ' / ' + str(c) + '\n' )
        return

#############################################################################################################




#############################################################################################################
# Hit kommer man magiskt vid högerklick2
    def contextMenuEvent(self, event):

#        self.logga ("Högerklick\n")
# bestäm rad i tabellen vid högerklickan; hämta namn och nummer
# Vad händer om man högerklickar någon annanstans än i tabellen?
#        self.logga ('type(event) = ' + str(type(event))  + '\n')
#        self.logga ("event.reason = " + str(event.reason())  + '\n')
#        self.logga ("event.globalX = " + str(event.globalX())  + '\n')
#        self.logga ("event.globalY = " + str(event.globalY())  + '\n')
#        self.logga ("event.x = " + str(event.x())  + '\n')
#        self.logga ("event.y = " + str(event.y())  + '\n')

#        self.logga ("SelectionMode: " + str(self.tableWidget_Parlista.selectionMode())  + '\n')
#        self.logga ("SelectionBehavior: " + str(self.tableWidget_Parlista.selectionBehavior())  + '\n')
#        self.logga ("Editmod2: " + str(self.EditeraTillstånd)  + '\n')

        if self.EditeraTillstånd == True:
            return

#        self.logga ("Personlista left/right/top/bottom: " \
#          +  str(self.tableWidget_Parlista.geometry().left())   + ' / ' \
#          +  str(self.tableWidget_Parlista.geometry().right() ) + ' / ' \
#          +  str(self.tableWidget_Parlista.geometry().top())    + ' / ' \
#          +  str(self.tableWidget_Parlista.geometry().bottom()) + '\n')

        if self.tableWidget_Parlista.geometry().left()   > event.x()\
        or self.tableWidget_Parlista.geometry().right()  < event.x()\
        or self.tableWidget_Parlista.geometry().top()    > event.y()\
        or self.tableWidget_Parlista.geometry().bottom() < event.y():
            return

#        ScrollMode:
#        QAbstractItemView.ScrollPerItem    0   The view will scroll the contents one item at a time.
#        QAbstractItemView.ScrollPerPixel   1   The view will scroll the contents one pixel at a time.
#
#        SelectionBehavior:
#        QAbstractItemView.SelectItems    0   Selecting single items.
#        QAbstractItemView.SelectRows     1   Selecting only rows.
#        QAbstractItemView.SelectColumns  2   Selecting only columns.
#
#        SelectionMode:
#        QAbstractItemView.SingleSelection      1   When the user selects an item, any already-selected item becomes unselected, and the user cannot unselect the selected item by clicking on it.
#        QAbstractItemView.ContiguousSelection  4   When the user selects an item in the usual way, the selection is cleared and the new item selected. However, if the user presses the Shift key while clicking on an item, all items between the current item and the clicked item are selected or unselected, depending on the state of the clicked item.
#        QAbstractItemView.ExtendedSelection    3   When the user selects an item in the usual way, the selection is cleared and the new item selected. However, if the user presses the Ctrl key when clicking on an item, the clicked item gets toggled and all other items are left untouched. If the user presses the Shift key while clicking on an item, all items between the current item and the clicked item are selected or unselected, depending on the state of the clicked item. Multiple items can be selected by dragging the mouse over them.
#        QAbstractItemView.MultiSelection       2   When the user selects an item in the usual way, the selection status of that item is toggled and the other items are left alone. Multiple items can be toggled by dragging the mouse over them.
#        QAbstractItemView.NoSelection          0   Items cannot be selected.

        aktuellrad = self.tableWidget_Parlista.currentRow()
#        self.logga (" Högerklick, aktuellrad: " + str(aktuellrad)  + '\n' )
        if aktuellrad < 0:
            return

        self.tableWidget_Parlista.setCurrentCell(aktuellrad,1)
        self.aktuelltperson1nummer = self.tableWidget_Parlista.currentItem().text()

        self.tableWidget_Parlista.setCurrentCell(aktuellrad,3)
        aktuelltperson1namn = self.tableWidget_Parlista.currentItem().text().strip()

        self.tableWidget_Parlista.setCurrentCell(aktuellrad,2)
        self.aktuelltperson2nummer = self.tableWidget_Parlista.currentItem().text()

        self.tableWidget_Parlista.setCurrentCell(aktuellrad,4)
        aktuelltperson2namn = self.tableWidget_Parlista.currentItem().text().strip()

        aktuellperson1rubrik = self.aktuelltperson1nummer + ": " + aktuelltperson1namn
        aktuellperson2rubrik = self.aktuelltperson2nummer + ": " + aktuelltperson2namn

# Låt hela raden för musklicket synas markerad
        self.tableWidget_Parlista.selectRow(aktuellrad)

# Skapa meny, anpassad till förutsättningar och med anpassade texter
        meny = QtGui.QMenu(self)

        meny.addAction(self.ättling1listaAct)
        rubrik = "ÄTTLINGAR till "+ aktuellperson1rubrik
        self.ättling1listaAct.setText(rubrik  )

        meny.addAction(self.an1listaAct)
        rubrik = "ANOR till " + aktuellperson1rubrik
        self.an1listaAct.setText(rubrik)

        meny.addAction(self.person1bladAct)
        rubrik = "PERSONBLAD för " + aktuellperson1rubrik
        self.person1bladAct.setText(rubrik)


        meny.addAction(self.ättling2listaAct)
        rubrik = "ÄTTLINGAR till "+ aktuellperson2rubrik
        self.ättling2listaAct.setText(rubrik  )

        meny.addAction(self.an2listaAct)
        rubrik = "ANOR till " + aktuellperson2rubrik
        self.an2listaAct.setText(rubrik)

        meny.addAction(self.person2bladAct)
        rubrik = "PERSONBLAD för " + aktuellperson2rubrik
        self.person2bladAct.setText(rubrik)

        meny.exec_(event.globalPos())
####  slut på själva klickhanteringen ########################################################################




##### Stöd för olika val i menyn efter högerklick  ##########################################################
    def ättling1lista(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltperson1nummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def an1lista(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltperson1nummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def person1blad(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltperson1nummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def ättling2lista(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltperson2nummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def an2lista(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltperson2nummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def person2blad(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltperson2nummer
        QtCore.QProcess().startDetached(kommando )

##### slut för stöd för olika val i menyn efter högerklick  #################################################




























































#############################################################################################################
    def tabellrutaändrad(self,r,c):

        ändraditem =    self.tableWidget_Parlista.item(r,c).text()
        ändradpar = self.tableWidget_Parlista.item(r,0).text()
        ändradparfilnamn = os.path.join(self.databas, "data", ändradpar[:8], ändradpar + ".xml")

        if os.path.exists(ändradparfilnamn):
            Par2 = johanparfil()
            allmänt.hämtaparfil ( allmänt(), ändradparfilnamn, Par2 )  # Läs paret

            if c == 6:
                FöreÄndring = Par2.inledn_typ
                Par2.inledn_typ                 = ändraditem
            elif c == 7:
                FöreÄndring = Par2.inledn_år
                Par2.inledn_år                  = ändraditem
            elif c == 8:
                FöreÄndring = Par2.inledn_månad
                Par2.inledn_månad               = ändraditem
            elif c == 9:
                FöreÄndring = Par2.inledn_dag
                Par2.inledn_dag                 = ändraditem
            elif c == 10:
                FöreÄndring =Par2.inledn_gata
                Par2.inledn_gata                = ändraditem
            elif c == 11:
                FöreÄndring = Par2.inledn_by
                Par2.inledn_by                  = ändraditem
            elif c == 12:
                FöreÄndring = Par2.inledn_kvarter
                Par2.inledn_kvarter             = ändraditem
            elif c == 13:
                FöreÄndring = Par2.inledn_socken
                Par2.inledn_socken              = ändraditem
            elif c == 14:
                FöreÄndring = Par2.inledn_församling
                Par2.inledn_församling          = ändraditem
            elif c == 15:
                FöreÄndring = Par2.inledn_disbytförsamling
                Par2.inledn_disbytförsamling    = ändraditem
            elif c == 16:
                FöreÄndring = Par2.inledn_stad
                Par2.inledn_stad                = ändraditem
            elif c == 17:
                FöreÄndring = Par2.inledn_härad
                Par2.inledn_härad               = ändraditem
            elif c == 18:
                FöreÄndring = Par2.inledn_län
                Par2.inledn_län                 = ändraditem
            elif c == 19:
                FöreÄndring = Par2.inledn_utrikesplats
                Par2.inledn_utrikesplats        = ändraditem
            elif c == 20:
                FöreÄndring = Par2.inledn_källa
                Par2.inledn_källa               = ändraditem
            elif c == 21:
                FöreÄndring = Par2.upplösn_typ
                Par2.upplösn_typ                = ändraditem
            elif c == 22:
                FöreÄndring = Par2.upplösn_år
                Par2.upplösn_år                 = ändraditem
            elif c == 23:
                FöreÄndring = Par2.upplösn_månad
                Par2.upplösn_månad              = ändraditem
            elif c == 24:
                FöreÄndring = Par2.upplösn_dag
                Par2.upplösn_dag                = ändraditem
            elif c == 25:
                FöreÄndring = Par2.upplösn_gata
                Par2.upplösn_gata               = ändraditem
            elif c == 26:
                FöreÄndring = Par2.upplösn_by
                Par2.upplösn_by                 = ändraditem
            elif c == 27:
                FöreÄndring = Par2.upplösn_kvarter
                Par2.upplösn_kvarter            = ändraditem
            elif c == 28:
                FöreÄndring = Par2.upplösn_socken
                Par2.upplösn_socken             = ändraditem
            elif c == 29:
                FöreÄndring = Par2.upplösn_församling
                Par2.upplösn_församling         = ändraditem
            elif c == 30:
                FöreÄndring = Par2.upplösn_disbytförsamling
                Par2.upplösn_disbytförsamling   = ändraditem
            elif c == 31:
                FöreÄndring = Par2.upplösn_stad
                Par2.upplösn_stad               = ändraditem
            elif c == 32:
                FöreÄndring = Par2.upplösn_härad
                Par2.upplösn_härad              = ändraditem
            elif c == 33:
                FöreÄndring = Par2.upplösn_län
                Par2.upplösn_län                = ändraditem
            elif c == 34:
                FöreÄndring = Par2.upplösn_utrikesplats
                Par2.upplösn_utrikesplats       = ändraditem
            elif c == 35:
                FöreÄndring =Par2.upplösn_källa
                Par2.upplösn_källa              = ändraditem
            elif c == 36:
                FöreÄndring = Par2.barn_ID
                Par2.barn_ID                    = ändraditem
            elif c == 37:
                FöreÄndring = Par2.fler_källor
                Par2.fler_källor                = ändraditem
            elif c == 38:
                FöreÄndring = Par2.anteckning
                Par2.anteckning                 = ändraditem
            else:
                return
            self.logga ('Ändring för par =  nr ' + ändradpar + '. Rad=' + str(r) + ', kolumn=' + str(c)\
            + '. FÖRE: "' +  FöreÄndring + '"  EFTER: "' + ändraditem  + '"\n')
            allmänt.sparaparfil ( allmänt(), ändradparfilnamn, Par2)  # Spara paret efter ändring

        return
#############################################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn,'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Parlista_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

# logga till textruta i programfönster
        if self.loggwidth != 0:
            self.textEdit_logg.insertPlainText(txt )
            self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)

            textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def printwhereami(self, msg=""):
        text = str(self.loggnr).zfill(4) + 'Här är jag: '  + inspect.stack()[1][3]
        for n in range (2, len(inspect.stack()) ):
          text = text + '  <-- ' + inspect.stack()[n][3]
        if msg!="":
            self.logga (msg + '\n')
        self.logga (text + '\n')
        self.loggnr = self.loggnr + 1
        return
###################################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Parlista_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




#############################################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winParlista = Parlista()
winParlista.show()
sys.exit(app.exec_())
#############################################################################################################
