#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# personblad.py

# Senast ändrad: 2011-02-09  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
import datetime
import shutil
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from optparse import OptionParser
from gui_personblad import *

from johangemensamt import allmänt
from johanklasser import *
###################################################################################################




###################################################################################################
class Personblad(QtGui.QMainWindow, gui_Personblad):

    SenastÄndrad = '2011-02-06 14:30:35'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'personblad_py3_'
    loggfilopen = False

    infilnamn = ""
    lockedfilename = ""
    databas = ""
    fnstrstr = ""

    aktuelltpersonnummer = ""
    aktuelltpersonnamn = ""

    aktuelltföräldranummer1 = ""
    aktuelltföräldranummer2 = ""
    aktuelltföräldraparnummer = ""
    aktuelltegetparnummer = ""
    aktuelltmakemakanummer = ""


    palette_ytteryta_normal   = QtGui.QPalette()
    palette_ytteryta_spara    = QtGui.QPalette()
    palette_inneryta          = QtGui.QPalette()
    palette_sparaknapp_spara  = QtGui.QPalette()
    palette_sparaknapp_normal = QtGui.QPalette()
    palette_Upplysning        = QtGui.QPalette()

    fontsize = 9
    förstagången = True

    options = {}
    args = []

    färgschema = '0'     # '0' = Standard, '1' = Master, '2' = Compare
    färgschemabakgrund = QColor()

    inifilnamn = ''
    inifiltext = ''
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    f_option = ""
    i_option = ""

    Person1 = johanpersonfil()  #strukt PersonXML() i 'strukturer' # måste vara global så att knapptryckning "Spara" kan fånga upp
###################################################################################################




###################################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas  person_nummer",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-f", "--färg", dest="färgschema", help="färgschema vid databasjämförelser")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize
        self.bestämbakgrundsfärg()

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder =  os.path.join( os.environ['APPDATA'], 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass

        self.setupUi(self)

        self.createActions()

        self.inledning()

        self.ui_connections()
        self.mera_ui_connections()

# Öppna inte avbrotten för ändringar i inmatningsfälten förrän de fyllts första gången!
        self.enableUi()

        self.lineEdit_Personnummer.setFocus()

        return
######################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Personblad_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




###################################################################################################
    def bestämbakgrundsfärg(self):

# --- bakgrundsfärg måste (?) bestämmas före setupUi i Personblad.py

        self.f_option = ""
        self.färgschema = str(self.options.färgschema)
        if self.färgschema == "None":
            self.färgschema = '0'
            self.f_option = ""
            self.färgschemabakgrund = QColor(0,0,0,0) # färgschema Standard
#            self.setupFärgschema0()
        elif self.färgschema == '1':
            self.f_option = " -f 1 "
            self.färgschemabakgrund = QColor(0,255,0,16) # färgschema Master (ljusgrönt)
#            self.setupFärgschema1()
        elif self.färgschema == '2':
            self.f_option = " -f 2 "
            self.färgschemabakgrund = QColor(255,255,0,32) # färgschema Compare  (ljusgult)
#            self.setupFärgschema2()
        return
###########################################################################




######################################################################################
# kopplingar till knappar i grafiska gränsytan
    def mera_ui_connections(self):

#       Kopplingar, signaler i gui till slots i personblad.py
#       Ytterligare kopplingar, signaler i gui till slots i gui_personblad.py, finns i gui_personblad.py/ui_connections(self)


        self.connect(self.pushButton_Databas,         SIGNAL('clicked()'),       self.showDialogDatabas)
######################################################################################




######################################################################################
    def closeEvent(self, event):
# Om man passerar här på väg ut utan att ha öppnat någon fil
# ska man inte göra något alls mer än låta programmet sluta
#

        if self.lockedfilename == "":
            event.accept()

# Om fil lästs, dvs "öppnats", så har den låsts.
#   om filen inte har ändrats sedan sista "spara" så ska man släppa låset och låta programmet sluta
#
        if self.pushButton_Spara.isEnabled() == False:

            try:
                os.remove(self.lockedfilename)
            except OSError as e:
                self.raderingsfel(e)
            self.lockedfilename = ""
            event.accept()

        else:
            Message = "Ändringar i personbladet har inte sparats. Ska jag stänga ändå"
            reply = QtGui.QMessageBox.question(self, "OBS!", Message ,  "Spara ändringar\noch stäng",  "Avbryt\nstängning", "Släng ändringar\nStäng direkt!")

            if reply == 0:    # spara ändringar och stäng
                self.sparaknapp()
                try:
                    os.remove(self.lockedfilename)
                except OSError as e:
                    self.raderingsfel(e)
                self.lockedfilename = ""
                event.accept()

            elif reply == 1:   # avbryt stängning
                event.ignore()

            else:              # if reply == 2  # Släng ändringar och stäng
                os.remove(self.lockedfilename)
                self.lockedfilename = ""
                event.accept()
######################################################################################




######################################################################################
    def raderingsfel(self, e):
        self.logga ("FEL vid radering av låsfil:  " + str(e) + '\n')
#        self.logga ("FEL vid radering av låsfil:  errno=" + str(e.errno) + " filename=" + str(e.filename) + " strerror=" + e.strerror + '\n')
        return
######################################################################################




###################################################################################################
# kopplingar till högerklicksmenyer. Statiska rubriker lämnas tomma. Anpassade rubriker skrivs vid avbrottet
    def createActions(self):

        self.ättlinglistabladAct = QtGui.QAction("", self)
        self.connect(self.ättlinglistabladAct, QtCore.SIGNAL("triggered()"), self.ättlinglista)

        self.anlistaAct =  QtGui.QAction("", self)
        self.connect(self.anlistaAct, QtCore.SIGNAL("triggered()"), self.anlista)

        self.föräldraparbladAct = QtGui.QAction("", self)
        self.connect(self.föräldraparbladAct , QtCore.SIGNAL("triggered()"), self.föräldraparblad)

        self.egetparbladAct = QtGui.QAction("", self)
        self.connect(self.egetparbladAct, QtCore.SIGNAL("triggered()"), self.egetparblad)

        self.makemakabladAct =  QtGui.QAction("", self)
        self.connect(self.makemakabladAct, QtCore.SIGNAL("triggered()"), self.makemakablad)
###################################################################################################




######################################################################################
    def ritaomknapp(self):

        if self.pushButton_Spara.isEnabled() == False:
            self.ritaom()
        else:
            Message = "Ändringar i personbladet har inte sparats. Ska jag ladda om ändå?"
            reply = QtGui.QMessageBox.question(self, "OBS!", Message , "Avbryt\nhämtning", "Släng ändringar\nHämta igen!")
            if reply != 0:

                self.ritaom()
######################################################################################




######################################################################################
    def dirtybit_set(self):

        idag = datetime.datetime.today()
        senastsparat = str(idag.year) + '-' +  str(idag.month).zfill(2) + '-' +  str(idag.day).zfill(2) + "  " + str(idag.hour).zfill(2) + ':' +  str(idag.minute).zfill(2) + ':' +  str(idag.second).zfill(2)
        self.lineEdit_SenastSparat.setText(senastsparat)

        self.pushButton_Spara.setEnabled(True)
        self.setWindowTitle(self.fnstrstr + "  [ändrad]  ")
        self.ytteryta.setPalette(self.palette_ytteryta_spara)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_spara)
######################################################################################




######################################################################################
    def dirtybit_reset(self):

        self.pushButton_Spara.setEnabled(False)
        self.setWindowTitle(self.fnstrstr)
        self.ytteryta.setPalette(self.palette_ytteryta_spara)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_spara)
######################################################################################




######################################################################################
    def sparaknapp(self):

        self.sparaGui(self.Person1)
        allmänt.sparapersonfil(allmänt(),self.infilnamn, self.Person1)
        self.dirtybit_reset()
        self.ytteryta.setPalette(self.palette_ytteryta_normal)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_normal)
###################################################################################################
########################




###################################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        if len(self.args) != 2 : # Jag förväntar mig två argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt två argument i anropet: Databasadress, Personnummer. Jag avbryter här.\n ")
            self.avsluta(1)

        self.lineEdit_Databas.setText(self.args[0])
        self.lineEdit_Personnummer.setText(self.args[1])
        self.databas = self.lineEdit_Databas.text()

        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext )

# lås den aktuella personfilen.
#--------------------------------------------------------------------------------------------
        if self.lockedfilename == "":
            lockfileperson = os.path.join(self.databas, "locks", self.lineEdit_Personnummer.text() + ".lock")
            lockresponseperson = allmänt.johanlock(allmänt(),lockfileperson)

            if lockresponseperson == "": # så har vi nu låst den aktuella personfilen åt oss
                self.lockedfilename = lockfileperson
            else:
                msg = 'Personbladet för person ' + self.lineEdit_Personnummer.text() + ' är LÅST\n\n'
                msg = msg + lockresponseperson
                QtGui.QMessageBox.information(self, "Johan - Personblad" , msg , QtGui.QMessageBox.Ok)

                self.avsluta(1)
#--------------------------------------------------------------------------------------------

        self.fontsizeset()
        self.ritaom()

        return
###################################################################################################




###################################################################################################
    def showDialogDatabas(self):

        if self.pushButton_Spara.isEnabled() == True:

            Message = "Ändringar i personbladet har inte sparats. Ska jag ladda om ändå?"
            reply = QtGui.QMessageBox.question(self, "OBS!", Message , "Avbryt\nhämtning", "Släng ändringar\nHämta igen!")
            if reply == 0:
                return

        self.pushButton_Spara.setEnabled( False)

        svar = QtGui.QFileDialog.getExistingDirectory(self, "Databas att exportera från", "/home", QFileDialog.ShowDirsOnly)
        fp = allmänt.förstaperson (allmänt(), str(svar).rstrip('/'))

        if fp != "":
            self.databas = svar
            self.lineEdit_Databas.setText(self.databas)
            self.lineEdit_Personnummer.setText(fp)
            self.ritaom()

        return
###################################################################################################




###################################################################################################
    def ritaom(self):

        self.databas = self.lineEdit_Databas.text()
        personnummer=self.lineEdit_Personnummer.text()


#####  bestäm filnamn och kontrollera att filen finns
        self.infilnamn = os.path.join( self.databas, "data", str( personnummer[0:5]), str( personnummer) + ".xml")
        if os.path.exists(self.infilnamn) == False:
            msg = "Jag hittar inte filen " + self.infilnamn + "\nAvbryter."
            reply = QtGui.QMessageBox.information(self, "Johan - Personblad" , msg , QtGui.QMessageBox.Ok)
            self.avsluta(1)
            return



######  hämta personfil och fyll det grafiska fönstret  --------------------------------
        allmänt.hämtapersonfil(allmänt(), self.infilnamn, self.Person1)
        self.fyllGui(self.Person1)
        self.dirtybit_reset()
        self.ytteryta.setPalette(self.palette_ytteryta_normal)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_normal)

######  skapa och sätt fönstrets titel, spara den globalt ---------------------------------------
        self.fnstrstr = self.Person1.kortnamn  + " - personblad"
        self.setWindowTitle(self.fnstrstr)

######  skapa meny i tabell för andra dokument
        self.andradokument( personnummer)

        self.sijlayout()
        self.windowlayout()

        return
###################################################################################################




###################################################################################################
    def andradokument(self, personnummer):

        infilkatalog = os.path.join(self.databas, "data", str(personnummer[0:5]))
        folderinh = os.listdir(infilkatalog)

        OOo_dokumentfunnet = False
        txt_dokumentfunnet = False
        folder_funnen = False

# Rensa tabellen för att visa filer och länkar
        self.tableWidget_länkar.clearContents()
        self.tableWidget_länkar.setRowCount(0)

        for f in folderinh[:]:

            if personnummer == f[0:8] : # så finns någonting för personen i fråga

                if os.path.isfile(os.path.join(infilkatalog , f)):
                    if len(f) == 12 and  f[8:12] == ".odt" :
                        self.tableWidget_länkar.insertRow(0)
                        OOo_dokumentfunnet = True
                        self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem("O"))
                        self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Öppna odt-dokument"))
                        self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(f))
                    elif len(f) == 12 and  f[8:12] == ".txt" :
                        self.tableWidget_länkar.insertRow(0)
                        txt_dokumentfunnet = True
                        self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem("T"))
                        self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Öppna textdokument"))
                        self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(f))
                    elif ( f[8:12] != ".xml" ) :
                        self.tableWidget_länkar.insertRow(0)
                        self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem("A"))
                        self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Öppna annat-dokument"))
                        self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(f))

                elif os.path.isdir(os.path.join(infilkatalog , f[0:8])):  # koll att katalognamnet är just 8 tecken
                    self.tableWidget_länkar.insertRow(0)
                    self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem("K"))
                    self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Öppna katalog"))
                    self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(f))
                    folder_funnen =  True

# samma person kan ha flera filer redan i infilkatalog.
# först sedan katalogen genomlöpts vet vi om txt- eller odt-filer saknas för personen
# och menyrader för skapade av demsamma ska erbjudas

        if txt_dokumentfunnet == False:
            self.tableWidget_länkar.insertRow(0)
            self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem(""))
            self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Skapa textdokument"))
            self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(personnummer+".txt"))

        if OOo_dokumentfunnet == False:
            self.tableWidget_länkar.insertRow(0)
            self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem(""))
            self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Skapa odt-dokument"))
            self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(personnummer+".odt"))

        if folder_funnen == False:
            self.tableWidget_länkar.insertRow(0)
            self.tableWidget_länkar.setItem(0, 0, QtGui.QTableWidgetItem(""))
            self.tableWidget_länkar.setItem(0, 1, QtGui.QTableWidgetItem("Skapa katalog"))
            self.tableWidget_länkar.setItem(0, 2, QtGui.QTableWidgetItem(personnummer))

##################################################################################################




###################################################################################################
    def lankarknapp(self, r, c):
#        print "I lankarknapprutinen: r =", r, ",   c=", c
        self.tableWidget_länkar.setCurrentCell(r, 2)
        valtnamn =  self.tableWidget_länkar.currentItem().text()
        foldernamn0  = os.path.join(self.databas, "data", str(valtnamn[0:5])) # + "/"
        namn1 = os.path.join(foldernamn0, str(valtnamn))
#        mallfolder =  self.databas + "/data/mallar/"

#        print "valtnamn =", valtnamn

# Öppna befintlig katalog med filhanterare krusader

        if  os.path.lexists(namn1):
            if os.path.isdir(namn1):
                kommando = allmänt.FILHANTERARE
                if kommando[-8:] == 'krusader':
                    krusaderheader = '"' +  self.Person1.kortnamn  + ' - fler filer' + '"'
                    kommando = kommando  + '  -caption ' + krusaderheader + '   --left ' + foldernamn0 + ' --right ' + namn1
                else:
                    kommando = kommando + '   ' + foldernamn0
                QtCore.QProcess().startDetached(kommando)

# Öppna befintlig odt-fil
            if os.path.isfile(namn1):
                if (len(valtnamn) == 12) and (valtnamn[8:12] ) == ".odt" :
                    kommando = allmänt.ORDBEHANDLARE + " " + namn1
                    QtCore.QProcess().startDetached((kommando))

# Öppna befintlig textfil med vald editor
                elif  (len(valtnamn) == 12) and (valtnamn[8:12] ) == ".txt" :
                    kommando = allmänt.EDITOR + namn1
                    QtCore.QProcess().startDetached(kommando)

# Försök öppna fil av okänd filtyp
# Hur ska jag anropa för att systemet ska välja associerat program att öppna med?
                else:
#                    kommando =  " " + filnamn1
#                    oppna_okand = QtCore.QProcess()
#                    oppna_okand.startDetached(kommando)

# Öppna i stället katalogen med krusader
                    kommando = allmänt.FILHANTERARE
                    if kommando[-8:] == 'krusader':
                        krusaderheader = '"' +  self.Person1.kortnamn  + ' - fler filer' + '"'
                        kommando = kommando  + '  -caption ' + krusaderheader + '   --left ' + foldernamn0 + ' --right ' + foldernamn0
                    else:
                        kommando = kommando + '   ' + foldernamn0
                    QtCore.QProcess().startDetached(kommando)


            if os.path.islink(namn1):
                print(" jag har inte lärt mig att hantera länkar")

        else: # if not os.path.exists ...

# Om katalog, skapa den
            if (len( valtnamn) == 8 ) :
                os.mkdir ( namn1 )
# och sedan starta krusader

                kommando = allmänt.FILHANTERARE
                if kommando[-8:] == 'krusader':
                    krusaderheader = '"' +  self.Person1.kortnamn + ' - fler filer' + '"'
                    kommando = kommando  + '  -caption ' + krusaderheader + '   --left ' + foldernamn0 + ' --right ' + namn1
                else:
                    kommando = kommando + '   ' + foldernamn0
                QtCore.QProcess().startDetached(kommando)

# Om odt-fil, kopiera in mall till dokumentnamnet
            elif (len(valtnamn) == 12) and (valtnamn[8:12] ) == ".odt" :
                shutil.copy2 ( os.path.join(self.databas, "data", "mallar", "00000000.odt"), namn1)
# och öppna det nya dokumentet
                kommando = allmänt.ORDBEHANDLARE + " " + namn1
                QtCore.QProcess().startDetached(kommando)

# Om textfil: öppna nytt, skriv en första rad, stäng.
            elif (len(valtnamn) == 12) and (valtnamn[8:12] ) == ".txt" :
                utfil=open(namn1, 'w', encoding='utf-8')
                utfil.write(  self.Person1.kortnamn  + "\n\n" )
                utfil.close()
# Öppna därefter med vald editor
                kommando = allmänt.EDITOR  + namn1
                QtCore.QProcess().startDetached(kommando)
###################################################################################################




###################################################################################################
    def fyllGui(self,pers):

        self.lineEdit_Person_ID.setText(pers.person_ID)
        self.lineEdit_Föräldrapar_ID.setText(pers.föräldrapar_ID)
        self.textEdit_Bonusrelation_ID.setText(pers.bonusrelation_ID)

        self.textEdit_Förnamn.setText( pers.förnamn) # född_härad
        self.textEdit_Tilltal.setText( pers.tilltal)
        self.textEdit_Efternamn.setText( pers.efternamn)
        self.lineEdit_Person_Kön.setText(pers.person_kön)
        self.lineEdit_Person_Kategori.setText( pers.person_kategori)

        self.Händelse_född.lineEdit_år.setText( pers.född_år)
        self.Händelse_född.lineEdit_månad.setText( pers.född_månad)
        self.Händelse_född.lineEdit_dag.setText( pers.född_dag)

        self.Händelse_född.lineEdit_gata.setText( pers.född_gata)
        self.Händelse_född.lineEdit_by.setText( pers.född_by)
        self.Händelse_född.lineEdit_kvarter.setText( pers.född_kvarter)
        self.Händelse_född.lineEdit_socken.setText( pers.född_socken)
        self.Händelse_född.lineEdit_församling.setText( pers.född_församling)
        self.Händelse_född.lineEdit_disbytförsamling.setText( pers.född_disbytförsamling)

        self.Händelse_född.lineEdit_stad.setText( pers.född_stad)
        self.Händelse_född.lineEdit_härad.setText( pers.född_härad)
        self.Händelse_född.lineEdit_län.setText( pers.född_län)
        self.Händelse_född.lineEdit_utrikesplats.setText( pers.född_utrikesplats)
        self.Händelse_född.textEdit_källa.setText( pers.född_källa)

        self.Händelse_död.lineEdit_år.setText( pers.död_år)
        self.Händelse_död.lineEdit_månad.setText( pers.död_månad)
        self.Händelse_död.lineEdit_dag.setText( pers.död_dag)

        self.Händelse_död.lineEdit_gata.setText( pers.död_gata)
        self.Händelse_död.lineEdit_by.setText( pers.död_by)
        self.Händelse_död.lineEdit_kvarter.setText( pers.död_kvarter)
        self.Händelse_död.lineEdit_socken.setText( pers.död_socken)
        self.Händelse_död.lineEdit_församling.setText( pers.död_församling)
        self.Händelse_död.lineEdit_disbytförsamling.setText( pers.död_disbytförsamling)
        self.Händelse_död.lineEdit_stad.setText( pers.död_stad)
        self.Händelse_död.lineEdit_härad.setText( pers.död_härad)
        self.Händelse_död.lineEdit_län.setText( pers.död_län)
        self.Händelse_död.lineEdit_utrikesplats.setText( pers.död_utrikesplats)
        self.Händelse_död.textEdit_källa.setText( pers.död_källa)

        self.textEdit_Fler_Källor.setText( pers.fler_källor)
        self.textEdit_Anteckningar.setText( pers.anteckning)

        self.lineEdit_SenastSparat.setText( pers.senastsparat)
# hämta länkade filer och sätt in enstaka rader här:


#### läs föräldraparets parfil, hämta de två personID, läs respektives  personfil och ta vara på personnamnen
        self.aktuelltpersonnummer = pers.person_ID
        self.aktuelltpersonnamn = pers.kortnamn
        self.aktuelltföräldraparnummer = pers.föräldrapar_ID

        fparfilnamn = os.path.join(self.databas, "data", str( self.aktuelltföräldraparnummer[0:8]), str(self.aktuelltföräldraparnummer) + ".xml")
        FPar1 = johanparfil()
        FPerson = johanpersonfil()

        self.textEdit_Föräldrapar_Namn.setText("")
        if os.path.exists(fparfilnamn):
            allmänt.hämtaparfil( allmänt(), fparfilnamn, FPar1)

            self.aktuelltföräldranummer1 = FPar1.person1_ID
            self.aktuelltföräldranummer2 = FPar1.person2_ID

            persfilnamn = os.path.join(self.databas, "data", str( self.aktuelltföräldranummer1 [0:5]), str( self.aktuelltföräldranummer1) + ".xml")
            allmänt.hämtapersonfil(allmänt(), persfilnamn, FPerson)
            föräldranamn1 = FPerson.kortnamn

            persfilnamn = os.path.join(self.databas, "data", str( self.aktuelltföräldranummer2 [0:5]), str( self.aktuelltföräldranummer2) + ".xml")
            allmänt.hämtapersonfil(allmänt(), persfilnamn, FPerson)
            föräldranamn2 = FPerson.kortnamn

            if föräldranamn1 !="" and föräldranamn2!= "":
                self.textEdit_Föräldrapar_Namn.setText(föräldranamn1 + "\n" + föräldranamn2)
            elif föräldranamn1 !="" :
                self.textEdit_Föräldrapar_Namn.setText(föräldranamn1)
            elif föräldranamn2 !="" :
                self.textEdit_Föräldrapar_Namn.setText(föräldranamn2)


# Rensa tabell för att visa egna par i
        self.tableWidget_Egna_Par.clearContents()
        self.tableWidget_Egna_Par.setRowCount(0)

#  Dela upp 'egna par', för varje gör:
# läs person1_id och person2_id, känn igen eget ID och välj det andra att skriva i rutan för egna par.


# nya modellen

        egnaparnamn = ""
        if pers.egna_par_ID != "":
            egnapar = pers.egna_par_ID.split("\n")
            for egetpar in egnapar:

                row=self.tableWidget_Egna_Par.rowCount()
                self.tableWidget_Egna_Par.insertRow(row)
# --- Kolumn 0: parets ID
                self.tableWidget_Egna_Par.setItem(row, 0, QtGui.QTableWidgetItem(egetpar ))

                egetparfilnamn = os.path.join(self.databas, "data", str(egetpar [0:8]), str(egetpar) + ".xml")
                if  os.path.exists(egetparfilnamn):
                    allmänt.hämtaparfil(allmänt(), egetparfilnamn, FPar1)

                    if pers.person_ID == FPar1.person1_ID:
                        makemaka_ID =  FPar1.person2_ID
                    elif pers.person_ID == FPar1.person2_ID:
                        makemaka_ID =  FPar1.person1_ID
                    else:
                        pass

# --- Kolumn 1: make/maka ID
                    self.tableWidget_Egna_Par.setItem(row, 1, QtGui.QTableWidgetItem( makemaka_ID ))

# --- Kolumn 3: par från år eller under åren
                    self.tableWidget_Egna_Par.setItem(row, 3, QtGui.QTableWidgetItem(FPar1.inledn_år + " - " + FPar1.upplösn_år))

# --- Kolumn 2: make/maka namn
                    makemakafilnamn = os.path.join(self.databas, "data", str(makemaka_ID [0:5]), str(makemaka_ID) + ".xml")
                    if  os.path.exists(makemakafilnamn):
                        allmänt.hämtapersonfil( allmänt(), makemakafilnamn,  FPerson)
                        self.tableWidget_Egna_Par.setItem(row, 2, QtGui.QTableWidgetItem( FPerson.kortnamn ))
                    else:
                        print("(personblad.py) Jag kan inte hitta personfilen ", makemakafilnamn)

                else:
                    print("(personblad.py) Jag kan inte hitta parfilen ", egetparfilnamn)

###################################################################################################




###################################################################################################
    def sparaGui(self, pers):

        pers.person_ID = str(self.lineEdit_Person_ID.text())
        pers.föräldrapar_ID = str(self.lineEdit_Föräldrapar_ID.text())
        pers.bonusrelation_ID = str(self.textEdit_Bonusrelation_ID.toPlainText())

        pers.förnamn = str(self.textEdit_Förnamn.toPlainText())
        pers.tilltal = str(self.textEdit_Tilltal.toPlainText())
        pers.efternamn = str(self.textEdit_Efternamn.toPlainText())
        pers.person_kön = str(self.lineEdit_Person_Kön.text())
        pers.person_kategori = str(self.lineEdit_Person_Kategori.text())

        pers.född_år = str(self.Händelse_född.lineEdit_år.text())
        pers.född_månad = str(self.Händelse_född.lineEdit_månad.text())
        pers.född_dag = str(self.Händelse_född.lineEdit_dag.text())

        pers.född_gata = str(self.Händelse_född.lineEdit_gata.text())
        pers.född_by = str(self.Händelse_född.lineEdit_by.text())
        pers.född_kvarter = str(self.Händelse_född.lineEdit_kvarter.text())
        pers.född_socken = str(self.Händelse_född.lineEdit_socken.text())


        pers.född_församling = str(self.Händelse_född.lineEdit_församling.text())
        pers.född_disbytförsamling = str(self.Händelse_född.lineEdit_disbytförsamling.text())
        pers.född_stad = str(self.Händelse_född.lineEdit_stad.text())
        pers.född_härad = str(self.Händelse_född.lineEdit_härad.text())
        pers.född_län = str(self.Händelse_född.lineEdit_län.text())
        pers.född_utrikesplats = str(self.Händelse_född.lineEdit_utrikesplats.text())
        pers.född_källa = str(self.Händelse_född.textEdit_källa.toPlainText())

        pers.död_år = str(self.Händelse_död.lineEdit_år.text())
        pers.död_månad = str(self.Händelse_död.lineEdit_månad.text())
        pers.död_dag = str(self.Händelse_död.lineEdit_dag.text())

        pers.död_gata = str(self.Händelse_död.lineEdit_gata.text())
        pers.död_by = str(self.Händelse_död.lineEdit_by.text())
        pers.död_kvarter = str(self.Händelse_död.lineEdit_kvarter.text())
        pers.död_socken = str(self.Händelse_död.lineEdit_socken.text())

        pers.död_församling = str(self.Händelse_död.lineEdit_församling.text())
        pers.död_disbytförsamling = str(self.Händelse_död.lineEdit_disbytförsamling.text())
        pers.död_stad = str(self.Händelse_död.lineEdit_stad.text())
        pers.död_härad = str(self.Händelse_död.lineEdit_härad.text())
        pers.död_län = str(self.Händelse_död.lineEdit_län.text())
        pers.död_utrikesplats = str(self.Händelse_död.lineEdit_utrikesplats.text())
        pers.död_källa = str(self.Händelse_död.textEdit_källa.toPlainText())


        pers.fler_källor = str(self.textEdit_Fler_Källor.toPlainText())
        pers.anteckning = str(self.textEdit_Anteckningar.toPlainText())

        idag = datetime.datetime.today()
        senastsparat = str(str(idag.year) + '-' +  str(idag.month).zfill(2) + '-' +  str(idag.day).zfill(2) + "  " + str(idag.hour).zfill(2) + ':' +  str(idag.minute).zfill(2) + ':' +  str(idag.second).zfill(2))

        pers.senastsparat = senastsparat
        self.lineEdit_SenastSparat.setText(senastsparat)


        if self.tableWidget_Egna_Par.rowCount() == 0:
            pers.egna_par_ID = ""
        else:
            self.tableWidget_Egna_Par.selectColumn(0)
            self.tableWidget_Egna_Par.selectRow(0)
            pers.egna_par_ID = str(self.tableWidget_Egna_Par.currentItem().text())
            rc=1
            while rc < self.tableWidget_Egna_Par.rowCount():
                self.tableWidget_Egna_Par.selectRow(rc)
                pers.egna_par_ID = pers.egna_par_ID+ "\n" + str(self.tableWidget_Egna_Par.currentItem().text())
                rc = rc + 1
###################################################################################################




###################################################################################################
    def uppknapp(self):

        aktuellrad = self.tableWidget_Egna_Par.currentRow()
        antalrader = self.tableWidget_Egna_Par.rowCount()
        if antalrader < 2:
            return
        if aktuellrad <= 0:
            return
        if aktuellrad > antalrader - 1:
            return

        FlyttaUppParIDtext      = str(self.tableWidget_Egna_Par.item(aktuellrad  , 0).text())
        FlyttaUppMakeMakaIDtext = str(self.tableWidget_Egna_Par.item(aktuellrad  , 1).text())
        FlyttaUppNamntext       = str(self.tableWidget_Egna_Par.item(aktuellrad  , 2).text())
        FlyttaUppArtext         = str(self.tableWidget_Egna_Par.item(aktuellrad  , 3).text())

        FlyttaNerParIDtext      = str(self.tableWidget_Egna_Par.item(aktuellrad-1, 0).text())
        FlyttaNerMakeMakaIDtext = str(self.tableWidget_Egna_Par.item(aktuellrad-1, 1).text())
        FlyttaNerNamntext       = str(self.tableWidget_Egna_Par.item(aktuellrad-1, 2).text())
        FlyttaNerArtext         = str(self.tableWidget_Egna_Par.item(aktuellrad-1, 3).text())

        self.tableWidget_Egna_Par.setItem(aktuellrad  , 0, QtGui.QTableWidgetItem(FlyttaNerParIDtext     ))
        self.tableWidget_Egna_Par.setItem(aktuellrad  , 1, QtGui.QTableWidgetItem(FlyttaNerMakeMakaIDtext))
        self.tableWidget_Egna_Par.setItem(aktuellrad  , 2, QtGui.QTableWidgetItem(FlyttaNerNamntext      ))
        self.tableWidget_Egna_Par.setItem(aktuellrad  , 3, QtGui.QTableWidgetItem(FlyttaNerArtext        ))

        self.tableWidget_Egna_Par.setItem(aktuellrad-1, 0, QtGui.QTableWidgetItem(FlyttaUppParIDtext     ))
        self.tableWidget_Egna_Par.setItem(aktuellrad-1, 1, QtGui.QTableWidgetItem(FlyttaUppMakeMakaIDtext))
        self.tableWidget_Egna_Par.setItem(aktuellrad-1, 2, QtGui.QTableWidgetItem(FlyttaUppNamntext      ))
        self.tableWidget_Egna_Par.setItem(aktuellrad-1, 3, QtGui.QTableWidgetItem(FlyttaUppArtext        ))

        self.tableWidget_Egna_Par.selectRow(aktuellrad-1)
        self.dirtybit_set()
        self.ytteryta.setPalette(self.palette_ytteryta_spara)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_spara)

        return
###################################################################################################




###################################################################################################
    def nedknapp(self):

        aktuellrad = self.tableWidget_Egna_Par.currentRow()
        antalrader = self.tableWidget_Egna_Par.rowCount()
        if antalrader < 2:
            return
        if aktuellrad < 0:
            return
        if aktuellrad >= antalrader - 1:
            return

        FlyttaUppParIDtext      = str(self.tableWidget_Egna_Par.item(aktuellrad+1, 0).text())
        FlyttaUppMakeMakaIDtext = str(self.tableWidget_Egna_Par.item(aktuellrad+1, 1).text())
        FlyttaUppNamntext       = str(self.tableWidget_Egna_Par.item(aktuellrad+1, 2).text())
        FlyttaUppArtext         = str(self.tableWidget_Egna_Par.item(aktuellrad+1, 3).text())

        FlyttaNerParIDtext      = str(self.tableWidget_Egna_Par.item(aktuellrad  , 0).text())
        FlyttaNerMakeMakaIDtext = str(self.tableWidget_Egna_Par.item(aktuellrad  , 1).text())
        FlyttaNerNamntext       = str(self.tableWidget_Egna_Par.item(aktuellrad  , 2).text())
        FlyttaNerArtext         = str(self.tableWidget_Egna_Par.item(aktuellrad  , 3).text())

        self.tableWidget_Egna_Par.setItem(aktuellrad+1, 0, QtGui.QTableWidgetItem(FlyttaNerParIDtext     ))
        self.tableWidget_Egna_Par.setItem(aktuellrad+1, 1, QtGui.QTableWidgetItem(FlyttaNerMakeMakaIDtext))
        self.tableWidget_Egna_Par.setItem(aktuellrad+1, 2, QtGui.QTableWidgetItem(FlyttaNerNamntext      ))
        self.tableWidget_Egna_Par.setItem(aktuellrad+1, 3, QtGui.QTableWidgetItem(FlyttaNerArtext        ))

        self.tableWidget_Egna_Par.setItem(aktuellrad  , 0, QtGui.QTableWidgetItem(FlyttaUppParIDtext     ))
        self.tableWidget_Egna_Par.setItem(aktuellrad  , 1, QtGui.QTableWidgetItem(FlyttaUppMakeMakaIDtext))
        self.tableWidget_Egna_Par.setItem(aktuellrad  , 2, QtGui.QTableWidgetItem(FlyttaUppNamntext      ))
        self.tableWidget_Egna_Par.setItem(aktuellrad  , 3, QtGui.QTableWidgetItem(FlyttaUppArtext        ))

        self.tableWidget_Egna_Par.selectRow(aktuellrad+1)
        self.dirtybit_set()
        self.ytteryta.setPalette(self.palette_ytteryta_spara)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_spara)

        return
###################################################################################################




###################################################################################################
# Hit kommer man magiskt vid högerklick
    def contextMenuEvent(self, event):

        if      self.groupBox_Person.geometry().top()    < event.y() \
            and self.groupBox_Person.geometry().bottom() > event.y() \
            and self.groupBox_Person.geometry().left()   < event.x() \
            and self.groupBox_Person.geometry().right()  > event.x():
            self.skapaMenyPerson(event)

        elif    self.groupBox_Föräldrapar.geometry().top()    < event.y() \
            and self.groupBox_Föräldrapar.geometry().bottom() > event.y() \
            and self.groupBox_Föräldrapar.geometry().left()   < event.x() \
            and self.groupBox_Föräldrapar.geometry().right()  > event.x():
            self.skapaMenyFöräldrapar(event)

        elif    self.groupBox_Egna_Par.geometry().top()    < event.y() \
            and self.groupBox_Egna_Par.geometry().bottom() > event.y() \
            and self.groupBox_Egna_Par.geometry().left()   < event.x() \
            and self.groupBox_Egna_Par.geometry().right()  > event.x():
            self.skapaMenyEgnapar(event)

####  slut på själva klickhanteringen #############################################################
###################################################################################################




###################################################################################################
    def skapaMenyPerson(self, event):

        meny = QtGui.QMenu(self)

        meny.addAction(self.ättlinglistabladAct)
        rubrik = "ÄTTLINGAR till "
        self.ättlinglistabladAct.setText(rubrik + self.aktuelltpersonnamn)

        meny.addAction(self.anlistaAct)
        rubrik = "ANOR till "
        self.anlistaAct.setText(rubrik + self.aktuelltpersonnamn)

        meny.exec_(event.globalPos())
###################################################################################################




###################################################################################################

    def skapaMenyFöräldrapar(self, event):

        meny = QtGui.QMenu(self)

        if self.aktuelltföräldraparnummer != "":
            meny.addAction(self.föräldraparbladAct)
            rubriktext = "PARBLAD " + self.aktuelltföräldraparnummer +  " för "  +  str(self.textEdit_Föräldrapar_Namn.toPlainText().replace("\n"," och "))
            self.föräldraparbladAct.setText(rubriktext)

        meny.exec_(event.globalPos())
###################################################################################################




###################################################################################################
    def skapaMenyEgnapar(self, event):

        aktuellrad = self.tableWidget_Egna_Par.currentRow()
        self.tableWidget_Egna_Par.setCurrentCell(aktuellrad,0)

        try:
            self.aktuelltegetparnummer = self.tableWidget_Egna_Par.currentItem().text().strip()
        except:
            self.aktuelltegetparnummer = ""

        self.tableWidget_Egna_Par.setCurrentCell(aktuellrad,1)
        try:
            self.aktuelltmakemakanummer = self.tableWidget_Egna_Par.currentItem().text().strip()
        except:
            self.aktuelltmakemakanummer = ""

        self.tableWidget_Egna_Par.setCurrentCell(aktuellrad,2)
        try:
            aktuelltmakemakanamn = self.tableWidget_Egna_Par.currentItem().text().strip()
        except:
            aktuelltmakemakanamn = ""



        meny = QtGui.QMenu(self)

        if self.aktuelltegetparnummer != "":
            meny.addAction(self.egetparbladAct)
            rubriktext = "PARBLAD för " + self.aktuelltpersonnamn + " och " + aktuelltmakemakanamn
            self.egetparbladAct.setText(rubriktext)

        if self.aktuelltmakemakanummer != "":
            meny.addAction(self.makemakabladAct)
            rubriktext = "PERSONBLAD för " + aktuelltmakemakanamn
            self.makemakabladAct.setText(rubriktext)

        meny.exec_(event.globalPos())
###################################################################################################






###################################################################################################
##### Stöd för olika val i menyn efter högerklick  ################################################

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def ättlinglista(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando)

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def anlista(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando)

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def föräldraparblad(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'parblad.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltföräldraparnummer
        QtCore.QProcess().startDetached(kommando)

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def egetparblad(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'parblad.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltegetparnummer
        QtCore.QProcess().startDetached(kommando)

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def makemakablad(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltmakemakanummer
        QtCore.QProcess().startDetached(kommando)

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

##### slut för stöd för olika val i valrutan ######################################################
###################################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn,'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Personblad_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

## logga till textruta i programfönster
#        self.textEdit_logg.insertPlainText(txt )
#        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)
#
#        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Personblad_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




###################################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winPersonblad = Personblad()
winPersonblad.show()
sys.exit(app.exec_())
###################################################################################################
