#!/usr/local/bin/python3
# -*- coding: utf-8 -*-


# personlista.py

# Senast ändrad: 2011-03-02  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




###########################################################################
import sys
import os
import datetime
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from optparse import OptionParser
from gui_personlista import *

from johangemensamt import allmänt
from johanklasser import *
###########################################################################




###########################################################################
class Personlista(QtGui.QMainWindow, gui_Personlista):

    SenastÄndrad = '2011-02-15 09:11:55'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'personlista_py3_'
    loggfilopen = False

    databas = ""
    aktuelltpersonnummer = ""

    Par1 = johanparfil()

    loggwidth = 0    #  = 0 ger ingen logg
#    loggwidth = 20   #  = n ger loggruta med bredden ca n tecken eller något fler. Föreslår =20 (20 - 30 tecken)
#    loggwidth = 40

    startperson = ""   #  strängar!
    slutperson = ""    #  strängar!

    fontsize = 9
    loggnr = 0

    KatA_antal = 0
    KatB_antal = 0
    KatC_antal = 0
    Kat1_antal = 0
    KatPgodk_antal = 0
    KatPspärr_antal = 0
    KatObest_antal = 0
    KatÖvriga_antal = 0

    options = {}
    args = []

    färgschema = '0'     # '0' = Standard, '1' = Master, '2' = Compare
    färgschemabakgrund = QColor()

    inifilnamn = ''
    inifiltext = ''
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    f_option = ""
    i_option = ""

    EditeraTillstånd = False

###########################################################################




#############################################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)
        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-f", "--färg", dest="färgschema", help="färgschema vid databasjämförelser")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize
        self.bestämbakgrundsfärg()

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder = os.path.join((os.environ['APPDATA']) , 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass


        self.setupUi(self)
        self.ui_connections()

        self.inledning()

        self.connect(self.pushButton_starta,  SIGNAL("clicked()"), self.startalista)

        return
#   Väntar sedan på att någon klickar på "starta lista"
############################################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Personlista_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




###################################################################################################
    def bestämbakgrundsfärg(self):

        self.f_option = ""
        self.färgschema = str(self.options.färgschema)
        if self.färgschema == "None":
            self.färgschema = '0'
            self.f_option = ""
            self.färgschemabakgrund = QColor(0,0,0,0) # färgschema Standard
#            self.setupFärgschema0()
        elif self.färgschema == '1':
            self.f_option = " -f 1 "
            self.färgschemabakgrund = QColor(0,255,0,16) # färgschema Master (ljusgrönt)
#            self.setupFärgschema1()
        elif self.färgschema == '2':
            self.f_option = " -f 2 "
            self.färgschemabakgrund = QColor(255,255,0,32) # färgschema Compare  (ljusgult)
#            self.setupFärgschema2()
        return
###################################################################################################




#############################################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        if len(self.args) != 1 : # Jag förväntar mig ett argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt ett argument i anropet: Databasadress. Jag avbryter här. \n")
            self.avsluta(1)

        self.lineEdit_Databas.setText(self.args[0])
        self.databas = self.lineEdit_Databas.text()

        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)

        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()

# läs sistanummer-filen
        senastepersonfil = open( os.path.join(self.databas, "senaste", "senasteperson.txt") , "r", encoding='utf-8')
        senasteperson = senastepersonfil.readline().strip()    # tag bort ev newline och annan whitespace
        senastepersonfil.close()
        self.lineEdit_Senasteperson.setText(senasteperson)
        self.lineEdit_startnr.setText("00000001")
        self.lineEdit_stoppnr.setText(senasteperson)

        self.frame_top.setVisible(False)
        self.frame_top2.setVisible(True)
        self.tableWidget_Personlista.setVisible(False)

        return
#############################################################################################################




#############################################################################################################
    def startalista(self):

        self.startperson = self.lineEdit_startnr.text()   # strängar!    typ "01234567"
        self.slutperson  = self.lineEdit_stoppnr.text()   # strängar!

        self.frame_top2.setVisible(False)
        self.frame_top.setVisible(True)
        self.tableWidget_Personlista.setVisible(True)
        self.tableWidget_Personlista.setAlternatingRowColors(True) # måste ligga före ritaom() ???

        self.ritaom() # fyller tabellen med persondata

        self.fontsizeset()
        self.sijlayout()
        self.tablelayout()
        self.windowlayout()

        self.createActions() # skapa för högerklicksmeny

        self.checkBox_TillåtUppdatering.setChecked(False)
        self.connect(self.checkBox_TillåtUppdatering, SIGNAL("stateChanged(int)"), self.ÄndraEditTillstånd)
        self.checkBox_TillåtUppdatering.setEnabled(True)

        self.connect(self.tableWidget_Personlista, SIGNAL("cellChanged(int,int)"), self.tabellrutaändrad)
        self.connect(self.tableWidget_Personlista, SIGNAL("cellClicked(int,int)"), self.tabellrutaklick)
        self.tableWidget_Personlista.setEnabled(True)

        return
# Väntar på någon av händelser:
#       1) växling av "Tillåt Uppdatering"
#       2) vänsterklick i tabellen
#           - om Tillåt Uppdatering: för vissa av cellerna i tabellen kan vald cell sättas i edit-tillstånd
#           - om ej Tillåt Uppdatering: vald rad i tabell markeras
#       3) högerklick i tabellen
#           - om Tillåt Uppdatering: - inget ska hända
#           - om ej Tillåt Uppdatering: rullmeny ska fram
#       4) innehåll i cell ändrat
#############################################################################################################




#############################################################################################################
    def createActions(self):

# kopplingar till högerklicksmeny. Statiska rubriker lämnas tomma. Anpassade rubriker skrivs vid avbrottet
        self.ättlinglistaAct = QtGui.QAction("", self)
        self.connect(self.ättlinglistaAct, QtCore.SIGNAL("triggered()"), self.ättlinglista)

        self.anlistaAct =  QtGui.QAction("", self)
        self.connect(self.anlistaAct, QtCore.SIGNAL("triggered()"), self.anlista)

        self.personbladAct =  QtGui.QAction("", self)
        self.connect(self.personbladAct, QtCore.SIGNAL("triggered()"), self.personblad)











        return
#############################################################################################################




#############################################################################################################
    def ritaom (self):

        self.databas = self.lineEdit_Databas.text()

        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allmänt.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allmänt.Vertikalfaktor * metrics.height()

# --- Preparerar tabell ---
        self.KatA_antal = 0
        self.KatB_antal = 0
        self.KatC_antal = 0
        self.Kat1_antal = 0
        self.KatPgodk_antal = 0
        self.KatPspärr_antal = 0
        self.KatÖvriga_antal = 0
        self.KatObest_antal = 0


# --- Tömmer och nollställer eventuell gammal tabell ---
        self.tableWidget_Personlista.clearContents()
        self.tableWidget_Personlista.setRowCount(0)

        self.tableWidget_Personlista.setSortingEnabled(False)

        Person1 = johanpersonfil()

        antalpersoner = 0
        looppersonnummer = int(self.startperson)

        while looppersonnummer >= int(self.startperson) and looppersonnummer <= int(self.slutperson) :
            aktuellperson_ID = str(looppersonnummer ).zfill(8)

            filnamn = os.path.join(self.databas, "data", aktuellperson_ID[:5], aktuellperson_ID + ".xml")
            if os.path.exists(filnamn):
                allmänt.hämtapersonfil ( allmänt(), filnamn, Person1 )  # Läs alla personer - en i taget
                self.fyllnästarad ( Person1, fh )
                antalpersoner = antalpersoner + 1

            looppersonnummer  = looppersonnummer  + 1

        self.lineEdit_KatA.setText(str(self.KatA_antal))
        self.lineEdit_KatB.setText(str(self.KatB_antal))
        self.lineEdit_KatC.setText(str(self.KatC_antal))
        self.lineEdit_Kat1.setText(str(self.Kat1_antal))
        self.lineEdit_KatPgodk.setText(str(self.KatPgodk_antal))
        self.lineEdit_KatPspärr.setText(str(self.KatPspärr_antal))
        self.lineEdit_KatÖvriga.setText(str(self.KatÖvriga_antal))
        self.lineEdit_KatObest.setText(str(self.KatObest_antal))

        self.tableWidget_Personlista.setSortingEnabled(True)
        self.tableWidget_Personlista.sortItems(0,Qt.AscendingOrder)
        self.lineEdit_Antalpersoner.setText(str(antalpersoner))

        availablescreen_Rect = QtGui.QDesktopWidget().availableGeometry()
        self.ytteryta.setGeometry (0,0, 0.95 * availablescreen_Rect.width(),  0.95 * availablescreen_Rect.height() )

        return
#### end def ritaom #########################################################################################




# Constant              Value   Description
# Qt.NoItemFlags          0   It does not have any properties set.
# Qt.ItemIsSelectable     1   It can be selected.
# Qt.ItemIsEditable       2   It can be edited.
# Qt.ItemIsDragEnabled    4   It can be dragged.
# Qt.ItemIsDropEnabled    8   It can be used as a drop target.
# Qt.ItemIsUserCheckable 16   It can be checked or unchecked by the user.
# Qt.ItemIsEnabled       32   The user can interact with the item.
# Qt.ItemIsTristate      64   The item is checkable with three separate states.

#############################################################################################################
    def fyllnästarad(self, person, radhöjd):

        noeditflaggor = Qt.ItemIsSelectable | Qt.ItemIsEnabled

        if self.checkBox_TillåtUppdatering.isChecked():
            editflaggor = Qt.ItemIsSelectable | Qt.ItemIsEditable | Qt.ItemIsEnabled
        else:
            editflaggor = Qt.ItemIsSelectable | Qt.ItemIsEnabled

        row = self.tableWidget_Personlista.rowCount()
        self.tableWidget_Personlista.insertRow(row)

        self.FylliPersonItem( row,  0, person.person_ID               , noeditflaggor)
        self.FylliPersonItem( row,  1, person.föräldrapar_ID          , noeditflaggor)
        self.FylliPersonItem( row,  2, person.egna_par_ID             , noeditflaggor)
        self.FylliPersonItem( row,  3, self.egnaparitemtext( person ) , noeditflaggor)
        self.FylliPersonItem( row,  4, person.bonusrelation_ID        , noeditflaggor)
        self.FylliPersonItem( row,  5, person.allaförnamn             , noeditflaggor)
        self.FylliPersonItem( row,  6, person.allatilltal             , noeditflaggor)
        self.FylliPersonItem( row,  7, person.allaefternamn           , noeditflaggor)
        self.FylliPersonItem( row,  8, person.person_kön              , noeditflaggor)

        self.FylliPersonItem( row, 10, person.född_år                 , editflaggor)
        self.FylliPersonItem( row, 11, person.född_månad              , editflaggor)
        self.FylliPersonItem( row, 12, person.född_dag                , editflaggor)
        self.FylliPersonItem( row, 13, person.född_gata               , editflaggor)
        self.FylliPersonItem( row, 14, person.född_by                 , editflaggor)
        self.FylliPersonItem( row, 15, person.född_kvarter            , editflaggor)
        self.FylliPersonItem( row, 16, person.född_socken             , editflaggor)
        self.FylliPersonItem( row, 17, person.född_församling         , editflaggor)
        self.FylliPersonItem( row, 18, person.född_disbytförsamling   , editflaggor)
        self.FylliPersonItem( row, 19, person.född_stad               , editflaggor)
        self.FylliPersonItem( row, 20, person.född_härad              , editflaggor)
        self.FylliPersonItem( row, 21, person.född_län                , editflaggor)
        self.FylliPersonItem( row, 22, person.född_utrikesplats       , editflaggor)
        self.FylliPersonItem( row, 23, person.född_källa              , editflaggor)
        self.FylliPersonItem( row, 24, person.död_år                  , editflaggor)
        self.FylliPersonItem( row, 25, person.död_månad               , editflaggor)
        self.FylliPersonItem( row, 26, person.död_dag                 , editflaggor)
        self.FylliPersonItem( row, 27, person.död_gata                , editflaggor)
        self.FylliPersonItem( row, 28, person.död_by                  , editflaggor)
        self.FylliPersonItem( row, 29, person.död_kvarter             , editflaggor)
        self.FylliPersonItem( row, 30, person.död_socken              , editflaggor)
        self.FylliPersonItem( row, 31, person.död_församling          , editflaggor)
        self.FylliPersonItem( row, 32, person.död_disbytförsamling    , editflaggor)
        self.FylliPersonItem( row, 33, person.död_stad                , editflaggor)
        self.FylliPersonItem( row, 34, person.död_härad               , editflaggor)
        self.FylliPersonItem( row, 35, person.död_län                 , editflaggor)
        self.FylliPersonItem( row, 36, person.död_utrikesplats        , editflaggor)
        self.FylliPersonItem( row, 37, person.död_källa               , editflaggor)
        self.FylliPersonItem( row, 38, person.fler_källor             , editflaggor)
        self.FylliPersonItem( row, 39, person.anteckning              , editflaggor)
        self.FylliPersonItem( row, 40, person.senastsparat            , noeditflaggor)

        self.tableWidget_Personlista.setItem(row,  9, self.personkategoriitem( person ))
        self.tableWidget_Personlista.item   (row,  9).setToolTip( person.person_kategori       )
        self.tableWidget_Personlista.item   (row,  9).setFlags(editflaggor)

        self.tableWidget_Personlista.setRowHeight(row, len(person.egna_par_ID.split("\n")) * radhöjd)

        for kolumn in [0,1,2,3,4,5,6,7,8,40]:
            try:
                self.tableWidget_Personlista.item(row, kolumn).setForeground(QtGui.QBrush(QtGui.QColor(0,0,0)))
            except:
                pass

            try:
                self.tableWidget_Personlista.item(row, kolumn).setBackground( QtGui.QBrush(QtGui.QColor(255,255,255)))
            except:
                pass

        return
#############################################################################################################




#############################################################################################################
    def FylliPersonItem(self, rad, kolumn, personuppgift, flaggor):
        self.tableWidget_Personlista.setItem(rad, kolumn, QtGui.QTableWidgetItem())
        self.tableWidget_Personlista.item   (rad, kolumn).setText(personuppgift)
        self.tableWidget_Personlista.item   (rad, kolumn).setFlags(flaggor)
        self.tableWidget_Personlista.item   (rad, kolumn).setToolTip(personuppgift)
#############################################################################################################




#############################################################################################################
    def ÄndraEditTillstånd(self): # Hit vid ändring av self.checkBox_TillåtUppdatering
#        self.logga ("enter ÄndraEditTillstånd\n")
#        self.logga ("Aktuellt Tillstånd: " + str(self.EditeraTillstånd) + '\n' )
#        self.logga ("checkBox1: " + str(self.checkBox_TillåtUppdatering.isChecked())  + '\n' )


        if self.checkBox_TillåtUppdatering.isChecked():
            Msg = """VARNING - Du vill tillåta Personlista.py att ändra i databasen

Varje ändring införes omedelbart i databasen.
Du måste själv vara noga med att inget annat program har
åtkomst till databasen, varken i denna dator eller i någon
annan dator som kan ha åtkomst via nätverk.
"""
            svar = QtGui.QMessageBox.warning(self, "OBS!", Msg, "Återgå till\nenbart läsning", "OK - jag är ensam i databasen\nTillåt ändringar")
#           self.logga ("Svar: " + str(svar) + '\n' )  # svar = 0: återgå; = 1: tillåt
            if str(svar) == "0":
                self.checkBox_TillåtUppdatering.setChecked(False)
#                self.logga ("checkBox2: " + str(self.checkBox_TillåtUppdatering.isChecked())  + '\n' )
                self.ÄndraEditTillstånd()

                return

        if self.checkBox_TillåtUppdatering.isChecked() != self.EditeraTillstånd:
            self.TillämpaEditTillstånd(self.checkBox_TillåtUppdatering.isChecked())

        return
#############################################################################################################




#############################################################################################################
    def TillämpaEditTillstånd(self, Tillstånd = False):

###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###

        self.checkBox_TillåtUppdatering.setEnabled(False)
        self.tableWidget_Personlista.setEnabled(False)
        self.disconnect(self.tableWidget_Personlista, SIGNAL("cellChanged(int,int)"), self.tabellrutaändrad)

###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###

        musmarkör = QCursor()
        musmarkör.setShape(Qt.WaitCursor)
        QApplication.setOverrideCursor(musmarkör)

        if Tillstånd == True:
            editflaggor = Qt.ItemIsSelectable | Qt.ItemIsEditable | Qt.ItemIsEnabled
            brushForeGnd = QtGui.QBrush(QtGui.QColor(128,0,0))
            brushBackGnd = QtGui.QBrush(QtGui.QColor(255,253,253))
            self.tableWidget_Personlista.setSelectionBehavior(QtGui.QAbstractItemView.SelectItems)

        else:   # if Tillstånd == False
            editflaggor = Qt.ItemIsSelectable | Qt.ItemIsEnabled
            brushForeGnd = QtGui.QBrush(QtGui.QColor(0,0,0))
            brushBackGnd = QtGui.QBrush(QtGui.QColor(255,255,255))
            self.tableWidget_Personlista.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)

        for rad in range (0,self.tableWidget_Personlista.rowCount()):
            for kolumn in range (9, 40):
                self.tableWidget_Personlista.item(rad, kolumn).setFlags(editflaggor)
                self.tableWidget_Personlista.item(rad, kolumn).setBackground(brushBackGnd)
                self.tableWidget_Personlista.item(rad, kolumn).setForeground(brushForeGnd)

        self.EditeraTillstånd = Tillstånd
        musmarkör.setShape(Qt.ArrowCursor)
        QApplication.setOverrideCursor(musmarkör)

###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###

        self.connect(self.tableWidget_Personlista, SIGNAL("cellChanged(int,int)"), self.tabellrutaändrad)
        self.tableWidget_Personlista.setEnabled(True)
        self.checkBox_TillåtUppdatering.setEnabled(True)

###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###-###

        return
#############################################################################################################




##### Stöd för tänkta olika val i menyrutan  ################################################################
    def tabellrutaklick(self, r, c):
#        self.logga ("Enkelklick, row/col: " + str(r) + ' / ' + str(c) + '\n' )
#        self.logga ("Editmod1: " + str(self.EditeraTillstånd) + '\n' )

        if not self.EditeraTillstånd:
            return

        if r>=0 and c >=0:
            self.tableWidget_Personlista.setCurrentCell(r, c)
#            self.logga ( ' Cell i tabell, row/col: ' + str(self.tableWidget_Personlista.currentRow()) + ' / ' +  str(self.tableWidget_Personlista.currentColumn()) + '\n')

            try:    # försök att editera
                self.tableWidget_Personlista.editItem(self.tableWidget_Personlista.item(r,c))
#                self.logga (' Editerar, row/col: ' + str(r) + ' / ' + str(c) + '\n' )
            except:
                pass
#                self.logga ('Kunde inte editera, row/col: ' + str(r) + ' / ' + str(c) + '\n' )
        return

#############################################################################################################




#############################################################################################################
# Hit kommer man magiskt vid högerklick2
    def contextMenuEvent(self, event):

#        self.logga ("Högerklick\n")
#        self.logga ('type(event) = ' + str(type(event))  + '\n')
#        self.logga ("event.reason = " + str(event.reason())  + '\n')
#        self.logga ("event.globalX = " + str(event.globalX())  + '\n')
#        self.logga ("event.globalY = " + str(event.globalY())  + '\n')
#        self.logga ("event.x = " + str(event.x())  + '\n')
#        self.logga ("event.y = " + str(event.y())  + '\n')

#        self.logga ("SelectionMode: " + str(self.tableWidget_Personlista.selectionMode())  + '\n')
#        self.logga ("SelectionBehavior: " + str(self.tableWidget_Personlista.selectionBehavior())  + '\n')
#        self.logga ("Editmod2: " + str(self.EditeraTillstånd)  + '\n')

        if self.EditeraTillstånd == True: # När vi kan editera vill vi inte tillåta högerklickande
            return

#        self.logga ("Personlista left/right/top/bottom: " \
#          +  str(self.tableWidget_Personlista.geometry().left())   + ' / ' \
#          +  str(self.tableWidget_Personlista.geometry().right() ) + ' / ' \
#          +  str(self.tableWidget_Personlista.geometry().top())    + ' / ' \
#          +  str(self.tableWidget_Personlista.geometry().bottom()) + '\n')

#   Kolla att högerklicken sitter inom tabellen
        if self.tableWidget_Personlista.geometry().left()   > event.x()\
        or self.tableWidget_Personlista.geometry().right()  < event.x()\
        or self.tableWidget_Personlista.geometry().top()    > event.y()\
        or self.tableWidget_Personlista.geometry().bottom() < event.y():
            return

#        ScrollMode:
#        QAbstractItemView.ScrollPerItem    0   The view will scroll the contents one item at a time.
#        QAbstractItemView.ScrollPerPixel   1   The view will scroll the contents one pixel at a time.
#
#        SelectionBehavior:
#        QAbstractItemView.SelectItems    0   Selecting single items.
#        QAbstractItemView.SelectRows     1   Selecting only rows.
#        QAbstractItemView.SelectColumns  2   Selecting only columns.
#
#        SelectionMode:
#        QAbstractItemView.SingleSelection      1   When the user selects an item, any already-selected item becomes unselected, and the user cannot unselect the selected item by clicking on it.
#        QAbstractItemView.ContiguousSelection  4   When the user selects an item in the usual way, the selection is cleared and the new item selected. However, if the user presses the Shift key while clicking on an item, all items between the current item and the clicked item are selected or unselected, depending on the state of the clicked item.
#        QAbstractItemView.ExtendedSelection    3   When the user selects an item in the usual way, the selection is cleared and the new item selected. However, if the user presses the Ctrl key when clicking on an item, the clicked item gets toggled and all other items are left untouched. If the user presses the Shift key while clicking on an item, all items between the current item and the clicked item are selected or unselected, depending on the state of the clicked item. Multiple items can be selected by dragging the mouse over them.
#        QAbstractItemView.MultiSelection       2   When the user selects an item in the usual way, the selection status of that item is toggled and the other items are left alone. Multiple items can be toggled by dragging the mouse over them.
#        QAbstractItemView.NoSelection          0   Items cannot be selected.

        aktuellrad = self.tableWidget_Personlista.currentRow()
#        self.logga (" Högerklick, aktuellrad: " + str(aktuellrad)  + '\n' )
        if aktuellrad < 0:
            return

        self.tableWidget_Personlista.setCurrentCell(aktuellrad,0)
        self.aktuelltpersonnummer = self.tableWidget_Personlista.currentItem().text()

        self.tableWidget_Personlista.setCurrentCell(aktuellrad,5)
        aktuelltpersonförnamn = self.tableWidget_Personlista.currentItem().text().strip()

        self.tableWidget_Personlista.setCurrentCell(aktuellrad,7)
        aktuelltpersonefternamn = self.tableWidget_Personlista.currentItem().text().strip()

        aktuellpersonrubrik = self.aktuelltpersonnummer + ": " + aktuelltpersonförnamn + " " + aktuelltpersonefternamn

# Låt hela raden för musklicket synas markerad
        self.tableWidget_Personlista.selectRow(aktuellrad)

# Skapa meny, anpassad till förutsättningar och med anpassade texter
        meny = QtGui.QMenu(self)

        meny.addAction(self.ättlinglistaAct)
        rubrik = "ÄTTLINGAR till "+ aktuellpersonrubrik
        self.ättlinglistaAct.setText(rubrik  )

        meny.addAction(self.anlistaAct)
        rubrik = "ANOR till " + aktuellpersonrubrik
        self.anlistaAct.setText(rubrik)

        meny.addAction(self.personbladAct)
        rubrik = "PERSONBLAD för " + aktuellpersonrubrik
        self.personbladAct.setText(rubrik)















        meny.exec_(event.globalPos())
####  slut på själva klickhanteringen #######################################################################




##### Stöd för olika val i menyn efter högerklick  ##########################################################
    def ättlinglista(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def anlista(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando )

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def personblad(self):
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' + self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando )

##### slut för stöd för olika val i menyn efter högerklick  #################################################




#############################################################################################################
    def egnaparitemtext( self, person ):

        egnapartext = ""

        egnapar =  person.egna_par_ID.split("\n")
        for p in egnapar:

            parfilnamn = os.path.join(self.databas,  "data", p[:8], p + ".xml")

            if os.path.exists(parfilnamn):
                allmänt.hämtaparfil(allmänt(), parfilnamn, self.Par1)
            else:
                allmänt.initparfil(allmänt(), self.Par1)

            partext = ""

            if (self.Par1.inledn_år != "") or (self.Par1.upplösn_år != ""):
                partext = self.Par1.inledn_år + "-" + self.Par1.upplösn_år
            else:
                partext = " "

            if egnapartext == "":
                egnapartext = partext
            else:
                egnapartext = egnapartext + "\n" + partext

        return  egnapartext
#############################################################################################################




#############################################################################################################
    def personkategoriitem( self, person ):

        person_ID = person.person_ID
        kategori = person.person_kategori
        kategoriitem = QtGui.QTableWidgetItem( kategori )
        kategoriitem.setTextAlignment(Qt.Alignment(Qt.AlignHCenter))
        född_år = person.född_år
        död_år = person.död_år

        if kategori == "A":                                     # explicit spärrade
            kategoriitem.setBackground(QColor(255,192,255,255)) # KatA magenta
            self.KatA_antal = self.KatA_antal + 1
        elif kategori == "1":                                   # EXPLICIT GODKÄNDA
            kategoriitem.setBackground(QColor(224,255,224,255)) # Kat1 ljusgrön
            self.Kat1_antal = self.Kat1_antal + 1
        elif (kategori == "") and (född_år == "") and (död_år == ""):

            if (person.allaförnamn == "") and (person.allaefternamn == ""): # automatiskt spärrade
                kategoriitem.setBackground(QColor(255,240,255,255)) # KatPspärr  ljus magenta
                self.KatPspärr_antal = self.KatPspärr_antal + 1
            else:                                                   # automatiskt spärrade, kandidater till manuell godkännandemärkning
                kategoriitem.setBackground(QColor(255,255,255,255)) # KatObest  vit
                self.KatObest_antal = self.KatObest_antal +1

        elif allmänt.KategoriPgodk( allmänt(), person):
            if kategori == "":                                      # AUTOMATISKT GODKÄNDA
                kategoriitem.setBackground(QColor(240,255,240,255)) # KatPgodk  grön
                self.KatPgodk_antal = self.KatPgodk_antal + 1
            elif kategori == "B":                                   # spärras tills vidare
                kategoriitem.setBackground(QColor(255,255,224,255)) # KatB  gul
                self.KatB_antal = self.KatB_antal + 1
            elif kategori == "C":                                   # spärras tills vidare
                kategoriitem.setBackground(QColor(240,240,240,255)) # KatC grå
                self.KatC_antal = self.KatC_antal + 1
            else:  # om okänd/felstavad kategori                    # spärras tills vidare
                kategoriitem.setBackground(QColor(255,240,255,255)) # KatPspärr  ljus magenta
                self.KatÖvriga_antal = self.KatÖvriga_antal + 1
        else:  # om ej KatPgodkänd.                                 # spärras tills vidare
            kategoriitem.setBackground(QColor(255,240,255,255))     # KatPspärr  ljus magenta
            self.KatPspärr_antal = self.KatPspärr_antal + 1
        return kategoriitem
###################################################################################################




#############################################################################################################
    def tabellrutaändrad(self,r,c):

        ändraditem =    self.tableWidget_Personlista.item(r,c).text()
        ändradperson = self.tableWidget_Personlista.item(r,0).text()
        ändradpersonfilnamn = os.path.join(self.databas, "data", ändradperson[:5], ändradperson + ".xml")

        if os.path.exists(ändradpersonfilnamn):
            Person2 = johanpersonfil()
            allmänt.hämtapersonfil ( allmänt(), ändradpersonfilnamn, Person2 )  # Läs personen

            if c == 10:
                FöreÄndring = Person2.född_år
                Person2.född_år                              = ändraditem
            elif c == 11:
                FöreÄndring = Person2.född_månad
                Person2.född_månad                           = ändraditem
            elif c == 12:
                FöreÄndring = Person2.född_dag
                Person2.född_dag                             = ändraditem
            elif c == 13:
                FöreÄndring = Person2.född_gata
                Person2.född_gata                            = ändraditem
            elif c == 14:
                FöreÄndring = Person2.född_by
                Person2.född_by                              = ändraditem
            elif c == 15:
                FöreÄndring = Person2.född_kvarter
                Person2.född_kvarter                         = ändraditem
            elif c == 16:
                FöreÄndring = Person2.född_socken
                Person2.född_socken                          = ändraditem
            elif c == 17:
                FöreÄndring = Person2.född_församling
                Person2.född_församling                      = ändraditem
            elif c == 18:
                FöreÄndring = Person2.född_disbytförsamling
                Person2.född_disbytförsamling                = ändraditem
            elif c == 19:
                FöreÄndring = Person2.född_stad
                Person2.född_stad                            = ändraditem
            elif c == 20:
                FöreÄndring = Person2.född_härad
                Person2.född_härad                           = ändraditem
            elif c == 21:
                FöreÄndring =  Person2.född_län
                Person2.född_län                             = ändraditem
            elif c == 22:
                FöreÄndring = Person2.född_utrikesplats
                Person2.född_utrikesplats                    = ändraditem
            elif c == 23:
                FöreÄndring = Person2.född_källa
                Person2.född_källa                           = ändraditem
            elif c == 24:
                FöreÄndring = Person2.död_år
                Person2.död_år                               = ändraditem
            elif c == 25:
                FöreÄndring = Person2.död_månad
                Person2.död_månad                            = ändraditem
            elif c == 26:
                FöreÄndring = Person2.död_dag
                Person2.död_dag                              = ändraditem
            elif c == 27:
                FöreÄndring = Person2.död_gata
                Person2.död_gata                             = ändraditem
            elif c == 28:
                FöreÄndring = Person2.död_by
                Person2.död_by                               = ändraditem
            elif c == 29:
                FöreÄndring = Person2.död_kvarter
                Person2.död_kvarter                          = ändraditem
            elif c == 30:
                FöreÄndring = Person2.död_socken
                Person2.död_socken                           = ändraditem
            elif c == 31:
                FöreÄndring = Person2.död_församling
                Person2.död_församling                       = ändraditem
            elif c == 32:
                FöreÄndring = Person2.död_disbytförsamling
                Person2.död_disbytförsamling                 = ändraditem
            elif c == 33:
                FöreÄndring = Person2.död_stad
                Person2.död_stad                             = ändraditem
            elif c == 34:
                FöreÄndring = Person2.död_härad
                Person2.död_härad                            = ändraditem
            elif c == 35:
                FöreÄndring = Person2.död_län
                Person2.död_län                              = ändraditem
            elif c == 36:
                FöreÄndring = Person2.död_utrikesplats
                Person2.död_utrikesplats                     = ändraditem
            elif c == 37:
                FöreÄndring = Person2.död_källa
                Person2.död_källa                            = ändraditem
            elif c == 38:
                FöreÄndring = Person2.fler_källor
                Person2.fler_källor                          = ändraditem
            elif c == 39:
                FöreÄndring = Person2.anteckning
                Person2.anteckning                           = ändraditem
            else:
                return
            self.logga ('Ändring för person =  nr ' + ändradperson + '. Rad=' + str(r) + ', kolumn=' + str(c)\
            + '. FÖRE: "' +  FöreÄndring + '"  EFTER: "' + ändraditem  + '"\n')
            allmänt.sparapersonfil ( allmänt(), ändradpersonfilnamn, Person2)  # Spara personen efter ändring

        return
#############################################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter ska vara unicode, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn,'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Personlista_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

# logga till textruta i programfönster
        if self.loggwidth != 0:
            self.textEdit_logg.insertPlainText(txt )
            self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)

            textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def printwhereami(self, msg=""):
        text = str(self.loggnr).zfill(4) + 'Här är jag: '  + inspect.stack()[1][3]
        for n in range (2, len(inspect.stack()) ):
          text = text + '  <-- ' + inspect.stack()[n][3]
        if msg!="":
            self.logga (msg + '\n')
        self.logga (text + '\n')
        self.loggnr = self.loggnr +1
        return
###################################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Personlista_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




#############################################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winPersonlista = Personlista()
winPersonlista.show()
sys.exit(app.exec_())
#############################################################################################################
