#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# ättlingar.py

# Senast ändrad: 2011-02-22  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
import datetime
import shutil

from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from optparse import OptionParser
from gui_attlingar import gui_Ättlingar
# Filnamnet i johan_py3 ändrat från gui_ättlingar.py till gui_attlingar.py för att
# komma förbi bug som syns vid Windowskörning och förväntas vara fixad till Python 3.2

from johangemensamt import allmänt
from johanklasser import johanpersonfil, johanparfil
###################################################################################################




###################################################################################################
class Ättlingar(QtGui.QMainWindow, gui_Ättlingar):

    SenastÄndrad = '2011-02-06 14:30:35'  # Uppdateras automatiskt. Ändra inte manuellt.

    loggfilfolder = ""
    loggfilgrundnamn = 'ättlingar_py3_'
    loggfilopen = False

    fontsize = 9
    förstagången = True

    maxnivå = 0

    databas = ''
    personnr = ''
    aktuelltpersonnummer = ''
    aktuelltpersonnamn = ''
    aktuelltparnummer = ''

    antalegnapar = 0
    antalmakespar = 0

    antalgenerationer = 3
    maximumgenerationer = 19
    minimumgenerationer = 1
    förvalantalgenerationer = 3

    options = {}
    args = []

    färgschema = '0'     # '0' = Standard, '1' = Master, '2' = Compare
    färgschemabakgrund = QColor()

    inifilnamn = ""
    inifiltext = ""
    programkatalog = ''
#        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

    f_option = ""
    i_option = ""

###################################################################################################




###################################################################################################
    def __init__(self, parent=None):

        QtGui.QMainWindow.__init__(self)

        parser = OptionParser(usage = "Usage:   %prog   [options]  databas  person_nummer",\
        version = "%prog   Version: "+self.SenastÄndrad)   # OptionParser(usage, version)

        parser.add_option("-i", "--INIfil", dest="INIfilnamn", help="Läs INI-data från INIfilnamn")
        parser.add_option("-f", "--färg", dest="färgschema", help="färgschema vid databasjämförelser")
        (self.options, self.args) = parser.parse_args()

        self.inifilnamn, self.inifiltext = allmänt.bestäminifil(allmänt(), self, str(self.options.INIfilnamn))
        self.i_option = ' -i "' + self.inifilnamn + '" '
        allmänt.hämtavertikalfaktor (allmänt(), self.inifiltext)
        allmänt.hämtastartfontsize  (allmänt(), self.inifiltext)
        self.fontsize = allmänt.Startfontsize
        self.bestämbakgrundsfärg()

        sysplatform = sys.platform
        if sysplatform == "win32":
            try:
                self.loggfilfolder =  os.path.join( os.environ['APPDATA'], 'sij', 'johanloggar' )
            except:
                pass
        if sysplatform == "linux2":
            try:
                self.loggfilfolder = os.path.join( os.environ['HOME'], 'johanloggar' )
            except:
                pass

        self.setupUi(self)

        self.createActions()
        self.inledning()

        self.fontsizeset()

        self.ui_connections()      # signaler i gui till slots i gui_ättlingar.py
        self.mera_ui_connections() # signaler i gui till slots i ättlingar.py
        self.enableUi()

###################################################################################################




###################################################################################################
    def __del__(self):

        if self.loggfilopen == True:
            self.logga ('Stänger logg för Ättlingar_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        return
###################################################################################################




###################################################################################################
    def bestämbakgrundsfärg(self):

# --- bakgrundsfärg måste  (?) bestämmas före setupUi i Personblad.py

        self.f_option = ""
        self.färgschema = str(self.options.färgschema)
        if self.färgschema == "None":
            self.färgschema = '0'
            self.f_option = ""
            self.färgschemabakgrund = QColor(0,0,0,0) # färgschema Standard
#            self.setupFärgschema0()
        elif self.färgschema == '1':
            self.f_option = " -f 1 "
            self.färgschemabakgrund = QColor(0,255,0,16) # färgschema Master (ljusgrönt)
#            self.setupFärgschema1()
        elif self.färgschema == '2':
            self.f_option = " -f 2 "
            self.färgschemabakgrund = QColor(255,255,0,32) # färgschema Compare  (ljusgult)
#            self.setupFärgschema2()
        return
###################################################################################################




######################################################################################
# kopplingar, signaler i gui till slots i ättlingar.py
    def mera_ui_connections(self):

#       Kopplingar, signaler i gui till slots i ättlingar.py
#       Ytterligare kopplingar, signaler i gui till slots i gui_ättlingar.py, finns i gui_ättlingar.py/ui_connections(self)

        self.connect ( self.pushButton_SparaSomText,    SIGNAL("clicked()"),       self.sparaknapp)
        self.connect ( self.pushButton_RitaOm,          SIGNAL("clicked()"),       self.ritaom)
        self.connect ( self.lineEdit_Personnummer,      SIGNAL("returnPressed()"), self.ritaom)
        self.connect ( self.checkBox_VisaAllaNamn,      SIGNAL("clicked()"),       self.ritaom)
        self.connect ( self.lineEdit_AntalGenerationer, SIGNAL("returnPressed()"), self.bestämantal)

        self.connect ( self.pushButton_Databas,         SIGNAL('clicked()'),       self.showDialogDatabas)

######################################################################################




###################################################################################################
# kopplingar till högerklicksmeny. Statiska rubriker lämnas tomma. Anpassade rubriker skrivs vid avbrottet
    def createActions(self):
        self.nymakemakaAct =  QtGui.QAction("", self)
        self.connect(self.nymakemakaAct, QtCore.SIGNAL("triggered()"), self.nymakemaka)

        self.nysonAct =  QtGui.QAction("", self)
        self.connect(self.nysonAct, QtCore.SIGNAL("triggered()"), self.nyson)

        self.nydotterAct =  QtGui.QAction("", self)
        self.connect(self.nydotterAct, QtCore.SIGNAL("triggered()"), self.nydotter)

        self.personbladAct =  QtGui.QAction("", self)
        self.connect(self.personbladAct, QtCore.SIGNAL("triggered()"), self.personblad)

        self.parbladAct = QtGui.QAction("", self)
        self.connect(self.parbladAct, QtCore.SIGNAL("triggered()"), self.parblad)

        self.ättlinglistabladAct = QtGui.QAction("", self)
        self.connect(self.ättlinglistabladAct, QtCore.SIGNAL("triggered()"), self.ättlinglista)

        self.anlistaAct =  QtGui.QAction("", self)
        self.connect(self.anlistaAct, QtCore.SIGNAL("triggered()"), self.anlista)

        self.odtdokAct =  QtGui.QAction("", self)
        self.connect(self.odtdokAct, QtCore.SIGNAL("triggered()"), self.odtdok)

        self.merafolderAct =  QtGui.QAction("", self)
        self.connect(self.merafolderAct, QtCore.SIGNAL("triggered()"), self.visamerafolder)

        self.odtdokparAct =  QtGui.QAction("", self)
        self.connect(self.odtdokparAct, QtCore.SIGNAL("triggered()"), self.odtpardok)

        self.meraparfolderAct =  QtGui.QAction("", self)
        self.connect(self.meraparfolderAct, QtCore.SIGNAL("triggered()"), self.visameraparfolder)
###################################################################################################




###################################################################################################
    def inledning(self):

        self.programkatalog = os.path.split( os.path.abspath(    sys.argv[0] ) )[0]

        if len(self.args) != 2 : # Jag förväntar mig exakt två argument, förutom optionerna
            self.logga ("Optioner: " + str(self.options) + '\n')
            self.logga ("Argument: " + str(self.args) + '\n')
            self.logga ("Förutom eventuella optioner förväntade jag mig exakt två argument i anropet: Databasadress, Personnummer. Jag avbryter här.\n ")
            self.avsluta(1)

        self.lineEdit_Databas.setText(self.args[0])
        self.lineEdit_Personnummer.setText(self.args[1])
        self.databas = self.lineEdit_Databas.text()

        allmänt.hämtaprogramsökvägar (allmänt(), self.inifiltext)

        self.lineEdit_AntalGenerationer.setText(str(self.antalgenerationer))

        self.checkBox_VisaDatabasNummer.setEnabled(True)
        self.checkBox_VisaFörsamling.setEnabled(True)
        self.checkBox_VisaUppnåddÅlder.setEnabled(True)
        self.checkBox_VisaDatabasFlaggor.setEnabled(True)
        self.checkBox_VisaAllaNamn.setEnabled(True)
        self.pushButton_SparaSomText.setEnabled(True)


        self.fontsizeset()

        return
###################################################################################################




###################################################################################################
    def showDialogDatabas(self):

        databas = QtGui.QFileDialog.getExistingDirectory(self, "Databas att visa", "/home", QFileDialog.ShowDirsOnly)
        self.lineEdit_Databas.setText(str(databas))

        return
###################################################################################################




###################################################################################################
    def ritaom (self):

# spara databas och personnummer som tabellen ritas för att kunna förbise ev. ändringar på gång i inmatningsfälten
        self.databas = self.lineEdit_Databas.text()
        self.personnr = self.lineEdit_Personnummer.text()
        self.antalgenerationer = int( self.lineEdit_AntalGenerationer.text())

        Person1 = johanpersonfil()

######  skapa fönstrets titel ----------------------------------------
        infilnamn = os.path.join(self.databas,  'data', self.personnr[0:5], self.personnr + '.xml')
        if os.path.exists(infilnamn):
            allmänt.hämtapersonfil(allmänt(), infilnamn, Person1)
            self.setWindowTitle( Person1.kortnamn + " - ättlingar")

# --- Tömmer och nollställer eventuell gammal tabell ---
            self.tableWidget_Ättlingar.clearContents()
            self.tableWidget_Ättlingar.setRowCount(0)
#            self.tableWidget_Ättlingar.setColumnCount(len(self.Ättlingkolumnhuvud))

# --- Rekursiv generering av tabellens innehåll ---
            istartnivå = 0  # blir generationsnumret på huvudpersonen
            self.maxnivå = istartnivå + self.antalgenerationer
            self.hämtaperson(self.databas, self.personnr, istartnivå, self.maxnivå)
# ( Efter rekursionen har tabellen vuxit till en rad för varje person )

# --- formaterar ---
            self.sijlayout()
            self.tablelayout()
            self.windowlayout()

        return
###################################################################################################




###################################################################################################
    def bestämantal(self):

        meddela = False
        try:
            self.antalgenerationer = int(self.lineEdit_AntalGenerationer.text())
            if self.antalgenerationer < self.minimumgenerationer:
                meddela = True
                self.antalgenerationer = self.minimumgenerationer
            if self.antalgenerationer > self.maximumgenerationer:
                meddela = True
                self.antalgenerationer = self.maximumgenerationer
        except:
            meddela = True
            self.antalgenerationer = self.förvalantalgenerationer

        if meddela:
            msg = "Jag måste ha ett heltal mellan " + str(self.minimumgenerationer) + " och " + str(self.maximumgenerationer) + " som antal generationer ättlingar utöver probanden själv"
            QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)

        self.lineEdit_AntalGenerationer.setText(str(self.antalgenerationer))
        self.ritaom()

        return
###################################################################################################




###################################################################################################
    def sparaknapp(self):
        self.sparatext()

        return
###################################################################################################




###################################################################################################
    def sparatext (self):

# här finns databas och personnummer som tabellen ritades för: self.databas, self.personnr

        idag =  datetime.datetime.today()
        tidpunkt = str(idag.year) + str(idag.month).zfill(2) + str(idag.day).zfill(2)   #   + "_" + str(idag.hour).zfill(2) + str(idag.minute).zfill(2) + str(idag.second).zfill(2)

        textfilnamn = os.path.join(self.databas, 'text', self.personnr + '_ättlingar_' + str(self.antalgenerationer) + '_nivåer_' + str(tidpunkt) + '.txt')

        sparafil = open(textfilnamn, 'w', encoding='utf-8')
        for n in range(0, self.tableWidget_Ättlingar.columnCount()):
            headertext = self.tableWidget_Ättlingar.horizontalHeaderItem(n).text().strip()

            sparafil.write( headertext)
            sparafil.write("\t")

        sparafil.write("\n")

        for r in range(0, self.tableWidget_Ättlingar.rowCount()):
            for c in range (0, self.tableWidget_Ättlingar.columnCount()):
                self.tableWidget_Ättlingar.setCurrentCell(r,c)
                try:
                    celltext = self.tableWidget_Ättlingar.currentItem().text()    # misslyckas med tomma fält.  FORTFARANDE i Python3 ??
                except:
                    celltext = ""


                sparafil.write(celltext)
                sparafil.write("\t")
            sparafil.write("\n")
        sparafil.close()

        return
###################################################################################################




###################################################################################################
# Hit kommer man magiskt vid högerklick
    def contextMenuEvent(self, event):

        try:
            aktuellrad = self.tableWidget_Ättlingar.currentRow()
            self.tableWidget_Ättlingar.setCurrentCell(aktuellrad,1)
            aktuellperson =  self.tableWidget_Ättlingar.currentItem().text().split(":")
            self.aktuelltpersonnamn = aktuellperson[1].strip()
        except:
            return


        self.tableWidget_Ättlingar.setCurrentCell(aktuellrad,10)
        try:
            self.aktuelltpersonnummer =  self.tableWidget_Ättlingar.currentItem().text().strip()
        except:
            self.aktuelltpersonnummer = ""


        self.tableWidget_Ättlingar.setCurrentCell(aktuellrad,11)
        try:
            self.aktuelltparnummer = self.tableWidget_Ättlingar.currentItem().text().strip()
        except:
            self.aktuelltparnummer = ""

        merafolder = os.path.join(self.databas, 'data', self.aktuelltpersonnummer[0:5], self.aktuelltpersonnummer)
        odtdokfilnamn = merafolder + ".odt"

        meraparfolder = os.path.join(self.databas, 'data', self.aktuelltparnummer[0:8], self.aktuelltparnummer)
        odtdokparfilnamn = meraparfolder + ".odt"

        aktuelltparfilnamn = os.path.join(self.databas, 'data', self.aktuelltparnummer[0:8], self.aktuelltparnummer + '.xml')
        aktuelltfadernamn = ""
        aktuelltmodernamn = ""

#       Försöker hämta parfil, aktuelltparfilnamn
        if os.path.exists(aktuelltparfilnamn):
            Par2 = johanparfil()
            allmänt.hämtaparfil(allmänt(), aktuelltparfilnamn, Par2)
            aktuellperson1ID = Par2.person1_ID
            aktuellperson2ID = Par2.person2_ID
            Person1 = johanpersonfil()
            Person2 = johanpersonfil()
            aktuelltperson1filnamn = os.path.join(self.databas,  'data', aktuellperson1ID[0:5], aktuellperson1ID + '.xml')
            aktuelltperson2filnamn = os.path.join(self.databas,  'data', aktuellperson2ID[0:5], aktuellperson2ID + '.xml')

#           Försöker hämta faderfil, aktuelltperson1filnamn
            if os.path.exists(aktuelltperson1filnamn):
                allmänt.hämtapersonfil(allmänt(), aktuelltperson1filnamn, Person1)
            else:
                msg = "I ättlingar.py: Jag kunde inte hitta personfilen " + aktuelltperson1filnamn + "\nKör databaskontrollen"
                QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)


#           Försöker hämta moderfil, aktuelltperson2filnamn
            if os.path.exists(aktuelltperson2filnamn):
                allmänt.hämtapersonfil(allmänt(), aktuelltperson2filnamn, Person2)
            else:
                msg = "I ättlingar.py: Jag kunde inte hitta personfilen " + aktuelltperson2filnamn + "\nKör databaskontrollen"
                QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)

            aktuelltmakenamn = aktuelltfadernamn = Person1.kortnamn
            aktuelltmakanamn = aktuelltmodernamn = Person2.kortnamn

        if aktuelltfadernamn == "":
            aktuelltfadernamn = "okänd fader"
            aktuelltmakenamn = "okänd make"
        if aktuelltmodernamn == "":
            aktuelltmodernamn = "okänd moder"
            aktuelltmakanamn = "okänd maka"

# Låt hela raden för musklicket synas markerad
        self.tableWidget_Ättlingar.selectRow(aktuellrad)

# Skapa meny, anpassad till förutsättningar och med anpassade texter
        meny = QtGui.QMenu(self)

        meny.addAction(self.ättlinglistabladAct)
        rubriktext = "ÄTTLINGAR till " + self.aktuelltpersonnamn
        self.ättlinglistabladAct.setText(rubriktext)

        meny.addAction(self.anlistaAct)
        rubriktext = "ANOR till " + self.aktuelltpersonnamn
        self.anlistaAct.setText(rubriktext)
        self.anlistaAct.enabled = False

        meny.addAction(self.personbladAct)
        rubriktext = "PERSONBLAD för " + self.aktuelltpersonnamn
        self.personbladAct.setText(rubriktext)

        if self.aktuelltparnummer != "":
            meny.addAction(self.parbladAct)
            rubriktext = "PARBLAD för "  + aktuelltmakenamn + " och " + aktuelltmakanamn
            self.parbladAct.setText(rubriktext)


        if os.path.exists(odtdokfilnamn):
            meny.addAction(self.odtdokAct)
            rubriktext = "Öppna ODF-dokument för " + self.aktuelltpersonnamn
            self.odtdokAct.setText(rubriktext)
        else:
            meny.addAction(self.odtdokAct)
            rubriktext = "Skapa ODF-dokument för " +  self.aktuelltpersonnamn
            self.odtdokAct.setText(rubriktext)



        if os.path.exists(merafolder):
            meny.addAction(self.merafolderAct)
            rubriktext = "Öppna FOLDER med fler filer för " +  self.aktuelltpersonnamn
            self.merafolderAct.setText(rubriktext)
        else:
            meny.addAction(self.merafolderAct)
            rubriktext = "Skapa FOLDER för fler filer för " +  self.aktuelltpersonnamn
            self.merafolderAct.setText(rubriktext)



        if self.aktuelltparnummer != "":
            if os.path.exists(odtdokparfilnamn):
                meny.addAction(self.odtdokparAct)
                rubriktext = "Öppna ODF-dokument för paret " + aktuelltmakenamn + " och " + aktuelltmakanamn
                self.odtdokparAct.setText(rubriktext)
            else:
                meny.addAction(self.odtdokparAct)
                rubriktext = "Skapa ODF-dokument för paret " + aktuelltmakenamn + " och " + aktuelltmakanamn
                self.odtdokparAct.setText(rubriktext)

            if os.path.exists(meraparfolder):
                meny.addAction(self.meraparfolderAct)
                rubriktext = "Öppna FOLDER med fler filer för paret " + aktuelltmakenamn + " och " + aktuelltmakanamn
                self.meraparfolderAct.setText(rubriktext)
            else:
                meny.addAction(self.meraparfolderAct)
                rubriktext = "Skapa FOLDER för fler filer för paret " + aktuelltmakenamn + " och " + aktuelltmakanamn
                self.meraparfolderAct.setText(rubriktext)

        if aktuellperson[0].strip() == "+":
            meny.addAction(self.nysonAct)
            rubriktext = "Skapa fil för NY SON till  "+ aktuelltfadernamn + " och " + aktuelltmodernamn
            self.nysonAct.setText(rubriktext )

            meny.addAction(self.nydotterAct)
            rubriktext = "Skapa fil för NY DOTTER till " + aktuelltfadernamn + " och " + aktuelltmodernamn
            self.nydotterAct.setText(rubriktext)

        elif int(aktuellperson[0].strip()) < self.maxnivå:
            meny.addAction(self.nymakemakaAct)
            rubriktext = "Skapa filer för NY MAKE/MAKA till " + self.aktuelltpersonnamn
            self.nymakemakaAct.setText(rubriktext)

        meny.exec_(event.globalPos())

####  slut på själva klickhanteringen #############################################################
###################################################################################################




###################################################################################################
##### Stöd för olika val i menyn efter högerklick  ################################################

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def visamerafolder(self):
    # Skapa vid behov, visa med filhanterare katalog för personens ytterligare filer
        foldernamnvänster = os.path.join(self.databas,  'data', self.aktuelltpersonnummer[0:5])
        foldernamnhöger   = os.path.join(foldernamnvänster , self.aktuelltpersonnummer)

        if not os.path.exists( foldernamnhöger ):
            os.mkdir ( foldernamnhöger )

        kommando = allmänt.FILHANTERARE

        # ingemarspecifikt, linuxspecifikt anrop till filhanteraren krusader
        if kommando[-8:] == 'krusader':
            krusaderheader = '"' + self.aktuelltpersonnamn + ' - fler filer' + '"'
            kommando = kommando + ' -caption ' + krusaderheader + '   --left ' + foldernamnvänster + ' --right ' + foldernamnhöger
        else:
            kommando = kommando + '  ' + foldernamnhöger
        QtCore.QProcess().startDetached((kommando))
        return

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def visameraparfolder(self):
    # Skapa vid behov, visa med filhanterare katalog för parets ytterligare filer
        foldernamnvänster =os.path.join(self.databas,  'data', self.aktuelltparnummer[0:8])
        foldernamnhöger = os.path.join(foldernamnvänster , self.aktuelltparnummer)

        if not os.path.exists( foldernamnhöger ):
            os.mkdir ( foldernamnhöger )

        kommando = allmänt.FILHANTERARE

        # ingemarspecifikt, linuxspecifikt anrop till filhanteraren krusader
        if kommando[-8:] == 'krusader':
            krusaderheader = '"' + self.aktuelltpersonnamn + ' - fler filer' + '"'
            kommando = kommando  + ' -caption ' + krusaderheader + '   --left ' + foldernamnvänster + ' --right ' + foldernamnhöger
        else:
            kommando = kommando + '  ' + foldernamnhöger
        QtCore.QProcess().startDetached((kommando))
        return

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def odtdok(self):
        mallfilnamn = os.path.join ( self.databas, "data", "mallar", "00000000.odt")
        filnamn = os.path.join(self.databas,  'data', self.aktuelltpersonnummer[0:5], self.aktuelltpersonnummer + ".odt")

        if not os.path.exists(filnamn):
            shutil.copy2 ( mallfilnamn , filnamn)

        kommando = allmänt.ORDBEHANDLARE + '  ' + filnamn
        QtCore.QProcess().startDetached((kommando))
        return

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def odtpardok(self):    # Öppna odf-dokument för par med OOo writer för editering eller läsning
        mallfilnamn = os.path.join ( self.databas, "data", "mallar", "par00000000.odt")
        filnamn     = os.path.join ( self.databas, 'data', self.aktuelltparnummer[0:8], self.aktuelltparnummer + ".odt")

        if not os.path.exists(filnamn):
            shutil.copy2 (mallfilnamn, filnamn)

        kommando = allmänt.ORDBEHANDLARE + '  ' + filnamn
        QtCore.QProcess().startDetached((kommando))
        return

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def ättlinglista(self):    # Visa ättlingar med Johan
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'ättlingar.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' +self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando)
        return

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def anlista(self):     # Visa anor med Johan
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'anor.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' +self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando)
        return

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def personblad(self):    # Editera personblad med Johan
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' +self.aktuelltpersonnummer
        QtCore.QProcess().startDetached(kommando)
        return

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def parblad(self):    # Editera parblad med Johan
        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'parblad.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + self.databas + '"   ' +self.aktuelltparnummer
        QtCore.QProcess().startDetached(kommando)
        return

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def nymakemaka(self):

        nyttparnummer=""
        nyttpersonnummer=""

# Två nya filer som ska länkas till varandra och till en befintlig personfil
#       Kod för att skapa parblad och personblad för ny make eller maka"
        success = False
        aktuellrad = self.tableWidget_Ättlingar.currentRow()
        self.tableWidget_Ättlingar.setCurrentCell(aktuellrad,1)
        aktuellpersonruta =   self.tableWidget_Ättlingar.currentItem().text().split(":")
        aktuellpersonnivå = aktuellpersonruta[0].strip()  # ...[0] är siffra eller plustecken, ...[1] är namnet (alla förnamn plus alla efternamn)
        aktuellpersonnamn = aktuellpersonruta[1].strip()  # ...[0] är siffra eller plustecken, ...[1] är namnet (alla förnamn plus alla efternamn)

        self.tableWidget_Ättlingar.setCurrentCell(aktuellrad,10)

        self.aktuelltpersonnummer = self.tableWidget_Ättlingar.currentItem().text().strip()

        aktuelltpersonfilnamn =  os.path.join(self.databas,  'data', self.aktuelltpersonnummer[0:5], self.aktuelltpersonnummer + '.xml')

        if os.path.exists(aktuelltpersonfilnamn):

# behövs inte kontrolleras igen att vi inte hamnat på lägsta nivån i ättlinglistan. hänsyn till detta är tagen redan vid konstuktionen av menyn.

            lockfilesenaste = os.path.join(self.databas, 'locks', "senaste.lock")
            lockresponsesenaste = allmänt.johanlock(allmänt(),lockfilesenaste)
# lås sistanummer-filerna (samma lås för båda filerna: senastepar, senasteperson)
            if lockresponsesenaste == "":       # så har vi låst båda filerna med senaste nummer
# lås dessutom den aktuella personfilen.
                lockfileperson = os.path.join(self.databas,  'locks', self.aktuelltpersonnummer + '.lock')
                lockresponseperson = allmänt.johanlock(allmänt(),lockfileperson)

                if lockresponseperson == "":     # så har vi också låst den aktuella personfilen

# läs sistanummer-filerna
                    senastepersonfilnamn = os.path.join(self.databas, "senaste", "senasteperson.txt")
                    senastepersonfil = open( senastepersonfilnamn, "r", encoding="utf-8" )
                    senasteperson=senastepersonfil.readline().strip(' \n\t')    # tag bort ev newline och annan whitespace
                    senastepersonfil.close()

                    senasteparfilnamn = os.path.join(self.databas, "senaste", "senastepar.txt")
                    senasteparfil = open( senasteparfilnamn, "r", encoding="utf-8" )
                    senastepar=senasteparfil.readline().strip(' \n\t')    # tag bort ev newline och annan whitespace
                    senasteparfil.close()

###+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# gör ett nytt sistanummer för person; kolla att inte filer redan finns
                    filnummer = int(senasteperson)
                    nummer =  str(filnummer).zfill(8)
                    filnamn = os.path.join(self.databas,  'data', nummer[:5], nummer + '.xml')
                    while os.path.exists(filnamn):
                        filnummer = filnummer + 1
                        nummer =  str(filnummer).zfill(8)
                        filnamn = os.path.join(self.databas,  'data', nummer[:5], nummer + '.xml')
                    nyttpersonnummer = nummer

# skapa ny underkatalog vid behov
                    underkatalog = os.path.join(self.databas,  'data', nummer[:5])
                    if not os.path.exists(underkatalog):
                        os.mkdir (underkatalog)

###+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# gör ett nytt sistanummer för par; kolla att inte filer redan finns
                    filnummer = int(senastepar[3:12])
                    nummer = str(filnummer).zfill(8)
                    filnamn = os.path.join(self.databas,  'data',  'par' + nummer[:5], 'par' + nummer + '.xml')
                    while os.path.exists(filnamn):
                        filnummer = filnummer + 1
                        nummer = str(filnummer).zfill(8)
                        filnamn = os.path.join(self.databas,  'data',  'par' + nummer[:5], 'par' + nummer + '.xml')
                    nyttparnummer ="par" + nummer

# skapa ny underkatalog vid behov
                    underkatalog = os.path.join(self.databas,  'data',  'par' + nummer[:5])
                    if not os.path.exists(underkatalog):
                        os.mkdir( underkatalog)
###+++++++++++++++++++++++++++++++++++++++++++++++++++++++++


# lås de båda nya filerna som ännu inte skrivits  (par och person)

                    lockfilenyperson = os.path.join(self.databas, 'locks', nyttpersonnummer + '.lock')
                    lockresponsenyperson = allmänt.johanlock(allmänt(),lockfilenyperson)

                    if lockresponsenyperson == "":

                        lockfilenyttpar = os.path.join(self.databas, 'locks', nyttparnummer + '.lock')
                        lockresponsenyttpar = allmänt.johanlock(allmänt(),lockfilenyttpar)

                        if lockresponsenyttpar == "":

# Skapa tomma strukturer för de båda nya filerna
                            NyttPar = johanparfil()
                            allmänt.initparfil(allmänt(), NyttPar)

                            NyPerson =  johanpersonfil(allmänt())
                            allmänt.initpersonfil(allmänt(), NyPerson)


# och en ifylld för den aktuella personen i ättlinglistan
                            TidigarePerson = johanpersonfil()
                            allmänt.hämtapersonfil(allmänt(), aktuelltpersonfilnamn , TidigarePerson)


# koppla ihop den tidigare och de två nya filerna - - - - - - - - - - - - - - - - - - - -
#       (förutsätt normalt, tvåkönat par)
                            NyttPar.par_ID = nyttparnummer
                            if TidigarePerson.person_kön == "m":
                                NyttPar.person1_ID = self.aktuelltpersonnummer
                                NyttPar.person2_ID = nyttpersonnummer
                                NyPerson.person_kön = "k"
                            else:   #if TidigarePerson.person_kön == "k":
                                NyttPar.person2_ID = self.aktuelltpersonnummer
                                NyttPar.person1_ID = nyttpersonnummer
                                NyPerson.person_kön = "m"

                            NyPerson.person_ID = nyttpersonnummer
                            NyPerson.egna_par_ID = nyttparnummer
                            if TidigarePerson.egna_par_ID == "":
                                TidigarePerson.egna_par_ID = nyttparnummer
                            else:
                                TidigarePerson.egna_par_ID = TidigarePerson.egna_par_ID + "\n" + nyttparnummer
# har kopplat ihop den tidigare och de två nya filerna - - - - - - - - - - - - - - - - - - - -


                            allmänt.sparapersonfil(allmänt(), aktuelltpersonfilnamn, TidigarePerson)


                            NyttPersonfilnamn = os.path.join(self.databas, 'data', nyttpersonnummer[0:5], nyttpersonnummer + '.xml')
                            allmänt.sparapersonfil(allmänt(), NyttPersonfilnamn, NyPerson)


                            NyttParfilnamn =  os.path.join(self.databas, 'data', nyttparnummer[0:8], nyttparnummer + '.xml')
                            allmänt.sparaparfil(allmänt(), NyttParfilnamn, NyttPar)


                            success = True

# uppdatera senaste par&person och skriv ut

                            senastepersonfilnamn = os.path.join(self.databas,  "senaste", "senasteperson.txt")
                            senasteparfilnamn =  os.path.join(self.databas,  "senaste", "senastepar.txt")

                            senastepersonfil = open( senastepersonfilnamn, "w", encoding="utf-8" )
                            senastepersonfil.write(nyttpersonnummer)
                            senastepersonfil.close()

                            senasteparfil = open( senasteparfilnamn, "w", encoding="utf-8" )
                            senasteparfil.write(nyttparnummer)
                            senasteparfil.close()

                            # avsluta ned normal radering av låsfilen  lockfilenyttpar
                            os.remove(lockfilenyttpar)





                        else:    #  if lockresponsenyttpar != ""
                            msg = 'Parbladet för nytt par, ' + nyttparnummer + ', är LÅST\n'
                            msg = msg + 'DETTA SKA INTE KUNNA INTRÄFFA!\n\n'
                            msg = msg + lockresponsenyttpar
                            QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)
                            success = False

                        # avsluta ned normal radering av låsfilen  lockfilenyperson
                        os.remove(lockfilenyperson)





                    else:   # if lockresponsenyperson != ""
                        msg = 'Personbladet för ny person, ' + nyttpersonnummer + ', är LÅST\n'
                        msg = msg + 'DETTA SKA INTE KUNNA INTRÄFFA!\n\n'
                        msg = msg + lockresponsenyperson
                        QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)
                        success = False

                    # avsluta ned normal radering av låsfilen  lockfileperson
                    os.remove(lockfileperson)





                else:  # lockresponseperson !=  '':
                    msg = 'Personbladet för person ' + self.aktuelltpersonnummer + ' är LÅST\n\n'
                    msg = msg + lockresponseperson
                    QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)
                    success = False

                # avsluta ned normal radering av låsfilen lockfilesenaste
                os.remove(lockfilesenaste)





            else: # lockresponsesenaste != '':
                msg = 'Filerna för allokering av nya person- och parnummer är LÅSTA\n\n'
                msg = msg + lockresponsesenaste
                QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)
                success = False





        else:
            msg = "Jag kunde inte hitta personfilen " + aktuelltpersonfilnamn
            msg = msg + "\nKör databaskontrollen"
            QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)
            success = False





        if success == True:
            # rita om hela ättlinglistan
            self.ritaom()

            # öppna nya parbladet för editering
            if nyttparnummer != "":
                self.aktuelltparnummer = nyttparnummer
                self.parblad()

            # öppna nya personbladet för editering
            if nyttpersonnummer != "":
                self.aktuelltpersonnummer = nyttpersonnummer
                self.personblad()

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def nyson(self):
        self.nyttbarn("m")

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def nydotter(self):
        self.nyttbarn("k")

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
    def nyttbarn(self, barnetskön):

        success = False

        aktuellrad = self.tableWidget_Ättlingar.currentRow()
        self.tableWidget_Ättlingar.setCurrentCell(aktuellrad,11)
        self.aktuelltparnummer =  self.tableWidget_Ättlingar.currentItem().text().strip()

        aktuelltparfilnamn =  os.path.join(self.databas,   'data',  self.aktuelltparnummer[0:8], self.aktuelltparnummer + '.xml')
        if os.path.exists(aktuelltparfilnamn):



# har vi väl hittat avsett par är det nu att forstätta med låsteknikaliteterna:
            lockfilesenaste =  os.path.join(self.databas, 'locks', "senaste.lock")
            lockresponsesenaste = allmänt.johanlock(allmänt(),lockfilesenaste)
            # lås sistanummer-filerna,
            if lockresponsesenaste == "":     # så har vi låst båda filerna med senaste nummer

                # lås dessutom den aktuella parfilen. för befintligt par, ska kompletteras med nummer till nytt barn
                lockfilepar =   os.path.join(self.databas, 'locks', self.aktuelltparnummer + '.lock')
                lockresponsepar = allmänt.johanlock(allmänt(),lockfilepar)

                if lockresponsepar == "":     # så har vi också låst den aktuella parfilen

# läs sistanummer-filen för personnummer
                    senastepersonfilnamn =   os.path.join(self.databas, "senaste", "senasteperson.txt")
                    senastepersonfil = open( senastepersonfilnamn, "r", encoding="utf-8" )
                    senasteperson=senastepersonfil.readline().strip()    # tag bort ev newline och annan whitespace
                    senastepersonfil.close()

# gör nytt sistanummer, kolla att inte filer redan finns
                    filnummer = int(senasteperson)
                    nummer =  str(filnummer).zfill(8)
                    filnamn =  os.path.join(self.databas,   'data', nummer[:5], nummer + '.xml')
                    while os.path.exists(filnamn):
                        filnummer = filnummer + 1
                        nummer =  str(filnummer).zfill(8)
                        filnamn =  os.path.join(self.databas,   'data', nummer[:5], nummer + '.xml')
                    nyttpersonnummer = nummer

# skapa ny underkatalog vid behov
                    underkatalog =  os.path.join(self.databas,   'data', nummer[:5])
                    if not os.path.exists(underkatalog):
                        os.mkdir( underkatalog)


# lås den nya personfilen som ännu inte skrivits, den är avsedd för det nya barnet
                    lockfilenyperson =   os.path.join(self.databas, 'locks', nyttpersonnummer + '.lock')
                    lockresponsenyperson = allmänt.johanlock(allmänt(),lockfilenyperson)

                    if lockresponsenyperson == "":

# Skapa en tom struktur för den nya filen
                        NyPerson =  johanpersonfil(allmänt())
                        allmänt.initpersonfil(allmänt(), NyPerson)
#  och en ifylld struktur för det aktuella paret
                        TidigarePar = johanparfil()
                        allmänt.hämtaparfil(allmänt(), aktuelltparfilnamn , TidigarePar)

# koppla ihop den tidigare och den nya filen - - - - - - - - - - - - - - - - - - - -

                        NyPerson.person_ID = nyttpersonnummer
                        NyPerson.föräldrapar_ID =self.aktuelltparnummer
                        NyPerson.person_kön = barnetskön

                        if TidigarePar.barn_ID == "":
                            TidigarePar.barn_ID = nyttpersonnummer
                        else:
                            TidigarePar.barn_ID = TidigarePar.barn_ID + "\n" + nyttpersonnummer


# har kopplat ihop den tidigare och den nya filen - - - - - - - - - - - - - - - - - - - -
                        allmänt.sparaparfil(allmänt(),   aktuelltparfilnamn , TidigarePar)
                        NyttPersonfilnamn =  os.path.join(self.databas,   'data',  nyttpersonnummer[0:5], nyttpersonnummer + '.xml')
                        allmänt.sparapersonfil(allmänt(),    NyttPersonfilnamn   , NyPerson)


# uppdatera senaste par&person och skriv ut
                        senastepersonfilnamn =  os.path.join(self.databas, "senaste", "senasteperson.txt")
                        senastepersonfil = open( senastepersonfilnamn, "w", encoding="utf-8" )
                        senastepersonfil.write(nyttpersonnummer)
                        senastepersonfil.close()

# avsluta ned normal radering av låsfilen  lockfilenyperson
                        os.remove(lockfilenyperson)
                        success = True





                    else:  # lockresponsenyperson != ''
                        msg = 'Personbladet för ny person, ' + nyttpersonnummer + ', är LÅST\n'
                        msg = msg + 'DETTA SKA INTE KUNNA INTRÄFFA!\n\n'
                        msg = msg + lockresponsenyperson
                        QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)
                        success = False

# avsluta ned normal radering av låsfilen  lockfileperson
                    os.remove(lockfilepar)





                else:   # lockresponsepar !=  '':
                    msg = 'Parbladet för par ' + self.aktuelltparnummer + ' är LÅST\n\n'
                    msg = msg + lockresponsepar
                    QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)
                    success = False

                # avsluta ned normal radering av låsfilen lockfilesenaste
                os.remove(lockfilesenaste)





            else: # lockresponsesenaste != '':
                msg = 'Filerna för allokering av nya person- och parnummer är LÅSTA\n\n'
                msg = msg + lockresponsesenaste
                QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)

                success = False





        else:
            msg = "Jag kunde inte hitta parfilen " + aktuelltparfilnamn
            msg = msg + "\nKör databaskontrollen"
            QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)
            success = False





        if success == True:
            # rita om hela ättlinglistan
            self.ritaom()

            # öppna nya personbladet för editering
            if nyttpersonnummer != "":
                self.aktuelltpersonnummer = nyttpersonnummer
                self.personblad()

##### slut för stöd för olika val i menyn efter högerklick  #######################################
###################################################################################################




###################################################################################################
    def summatext(self, t1, t2):
        if t1 == "":
            return t2
        elif t2 == "":
            return t1
        else:
            return t1 + ", " + t2
###################################################################################################




###################################################################################################
#####  Hämta person och skriv rad #################################################################
# Här är inhoppet för rekursionen
    def hämtaperson(self, db, pnr, inivå, imax_nivå ):

        row = self.tableWidget_Ättlingar.rowCount()
        self.tableWidget_Ättlingar.insertRow(row)
        indent = "          "*inivå
        indent2 = " "
        Person1 = johanpersonfil()
# --- bestäm filnamn
        merafolder =  os.path.join(db, 'data', pnr[0:5], pnr)
        infilnamn = merafolder + '.xml'
        odtdokfilnamn = merafolder + ".odt"

# --- skapa struktur och läs filens innehåll till denna struktur
        if os.path.exists(infilnamn):
            allmänt.hämtapersonfil(allmänt(),infilnamn, Person1)

            for kol in range (1,16): # Sätt först tomt innehåll # Annars kan man inte sätta bakgrundsfärg
                self.tableWidget_Ättlingar.setItem(row, kol,  QtGui.QTableWidgetItem( ""))
            for kol in range (1,10): # Sätt först tomt innehåll # Annars kan man inte sätta bakgrundsfärg
                self.tableWidget_Ättlingar.item(row, kol).setBackground(self.färgschemabakgrund)


# --- Skriv innehåll för respektive kolumn på raden

# --- Kolumn 1: Namn med generationsnummer och make/maka-indikering
            if  self.checkBox_VisaAllaNamn.checkState() == 0:
                self.tableWidget_Ättlingar.setItem(row, 1, QtGui.QTableWidgetItem(indent + str(inivå) + ":  " + Person1.kortnamn))
            else:
                self.tableWidget_Ättlingar.setItem(row, 1, QtGui.QTableWidgetItem(indent + str(inivå) + ":  " + Person1.allaförnamn + " " +  Person1.allaefternamn))
            self.tableWidget_Ättlingar.item(row, 1).setToolTip( Person1.allaförnamn + " " +  Person1.allaefternamnmedant)

# --- Kolumn 2: Flerpar-indikering för make/maka
            self.tableWidget_Ättlingar.setItem(row, 2, QtGui.QTableWidgetItem( ""))

# --- Kolumn 3: Född datum
            if Person1.född_år + Person1.född_månad + Person1.född_dag != "":
                self.tableWidget_Ättlingar.setItem(row, 3, QtGui.QTableWidgetItem( self.födddatum(Person1)))

# --- Kolumn 4: Födelseförsamling
            if Person1.född_utrikesplats != "":
                föddplats = self.summatext(Person1.född_församling, Person1.född_utrikesplats)
            else:
                föddplats =  self.summatext(Person1.född_by , Person1.född_församling)
            self.tableWidget_Ättlingar.setItem(row, 4, QtGui.QTableWidgetItem(föddplats))
            self.tableWidget_Ättlingar.item(row, 4).setToolTip( Person1.född_gata + ", " + Person1.född_by + ", " + Person1.född_kvarter + ", " + Person1.född_socken + ", " + Person1.född_församling + ", " + Person1.född_stad + ", " + Person1.född_härad + ", " + Person1.född_län + ", " + Person1.född_utrikesplats)

# --- Kolumn 5: Född, källreferens
            if Person1.född_källa != "":
                self.tableWidget_Ättlingar.setItem(row, 5, QtGui.QTableWidgetItem( "ref" ))
                self.tableWidget_Ättlingar.item(row, 5).setToolTip( Person1.född_källa )
            else:
                self.tableWidget_Ättlingar.setItem(row, 5, QtGui.QTableWidgetItem( "" ))
                self.tableWidget_Ättlingar.item(row, 5).setToolTip("")

# --- Kolumn 6: Död datum
            if Person1.död_år + Person1.död_månad + Person1.död_dag != "":
                self.tableWidget_Ättlingar.setItem(row, 6, QtGui.QTableWidgetItem( self.döddatum(Person1)))
            else:
                self.tableWidget_Ättlingar.setItem(row, 6, QtGui.QTableWidgetItem( "" ))
                self.tableWidget_Ättlingar.item(row, 6).setToolTip("")

# --- Kolumn 7: Dödförsamling
            if Person1.död_utrikesplats != "":
                dödplats = self.summatext(Person1.död_församling, Person1.död_utrikesplats)
            else:
                dödplats = self.summatext(Person1.död_by , Person1.död_församling)
            self.tableWidget_Ättlingar.setItem(row, 7, QtGui.QTableWidgetItem(dödplats))
            self.tableWidget_Ättlingar.item(row, 7).setToolTip( Person1.död_gata + ", " + Person1.död_by + ", " + Person1.död_kvarter + ", " + Person1.död_socken + ", " + Person1.död_församling + ", " + Person1.död_stad + ", " + Person1.död_härad + ", " + Person1.död_län + ", " + Person1.död_utrikesplats)

# --- Kolumn 8: Död, källreferens
            if Person1.död_källa != "":
                self.tableWidget_Ättlingar.setItem(row, 8, QtGui.QTableWidgetItem( "ref" ))
                self.tableWidget_Ättlingar.item(row, 8).setToolTip( Person1.död_källa )
            else:
                self.tableWidget_Ättlingar.setItem(row, 8, QtGui.QTableWidgetItem( "" ))
                self.tableWidget_Ättlingar.item(row, 8).setToolTip("")

# --- Kolumn 9:  Uppnådd ålder
            ålder_år, ålder_dagar= allmänt.personålder(allmänt(), Person1)
            ålderitem = QtGui.QTableWidgetItem(ålder_år)
            ålderitem.setTextAlignment(Qt.Alignment(Qt.AlignHCenter))
            self.tableWidget_Ättlingar.setItem(row, 9, ålderitem)

# --- Kolumn 10: Personnummer
            person_ID_item =  QtGui.QTableWidgetItem( Person1.person_ID)
            person_ID_item.setTextAlignment(Qt.Alignment(Qt.AlignCenter))
            person_ID_item.setBackground(self.färgschemabakgrund)
            self.tableWidget_Ättlingar.setItem(row, 10, person_ID_item)

# --- Kolumn 11: Parnummer, inte relevant i denna rutin, gråmärkes
            paritem = QtGui.QTableWidgetItem("")
            paritem.setBackground(QColor(0,0,0,16))
            self.tableWidget_Ättlingar.setItem(row, 11, paritem)

# --- Kolumn 12: Par år, inte relevant i denna rutin, gråmärkes
            paritem = QtGui.QTableWidgetItem("")
            paritem.setBackground(QColor(0,0,0,16))
            self.tableWidget_Ättlingar.setItem(row, 12, paritem)
            self.antalegnapar = len(Person1.egna_par_ID.split("\n")) # ska användas för att gissa pars varaktighet

# --- Kolumn 13: kön
            kön_item = QtGui.QTableWidgetItem( Person1.person_kön )
            kön_item.setTextAlignment(Qt.Alignment(Qt.AlignHCenter))
            self.tableWidget_Ättlingar.setItem(row, 13, kön_item)

            if Person1.person_kön == "":

                Message = "Person " + Person1.person_ID + ", " + Person1.kortnamn + " saknar könsmarkering\nKorrigera personbladet?"
                reply = QtGui.QMessageBox.question(self, "OBS!",   Message , "Korrigera\nnu", "Låt vara")

# QtGui.QMessageBox.Yes: reply = 16384
# QtGui.QMessageBox.No:  reply = 65536
# "Korrigera\nnu":       reply = 0
# "Låt vara":            reply = 1

                if reply == 0:
                    kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog,   'personblad.py') + '"   ' + self.i_option +  '   ' + self.f_option + '   "' + db + '"   ' + pnr
                    QtCore.QProcess().startDetached((kommando ))

# --- Kolumn 14: Kategori
            self.tableWidget_Ättlingar.setItem(row, 14, self.personkategoriitem(Person1))

# --- Kolumn 15: "mer"-flagga

            if os.path.exists(odtdokfilnamn) or  os.path.exists(merafolder):
                meraitem=QtGui.QTableWidgetItem( "mer" )
                meraitem.setTextAlignment(Qt.Alignment(Qt.AlignHCenter))
                self.tableWidget_Ättlingar.setItem(row, 15, meraitem)

            for kol in range (1,10): # Sätt först tomt innehåll # Annars kan man inte sätta bakgrundsfärg
                self.tableWidget_Ättlingar.item(row, kol).setBackground(self.färgschemabakgrund)


##### visa make/maka men inte på sista nivån --------------------------------------------
            if inivå < imax_nivå:
                for par in Person1.egna_par_ID.split("\n"):
                    if par != "":
                        row = self.tableWidget_Ättlingar.rowCount()
                        self.tableWidget_Ättlingar.insertRow(row)

                        parunderkatalog = os.path.join( 'data', par[0:8])
                        parfilnamn = os.path.join(str(db), parunderkatalog, par + '.xml')
                        Par1 = johanparfil()
                        if os.path.exists(parfilnamn):
                            allmänt.hämtaparfil(allmänt(),parfilnamn, Par1)

                            makemaka = ""
                            if Person1.person_kön  == "m":  #  Person1.person_kön, se Kolumn 8 ovan
                                makemaka = Par1.person2_ID
                                mannensdödsår = Person1.död_år
                                makemakakön = "k"

                            if Person1.person_kön  == "k":  #  Person1.person_kön, se Kolumn 8 ovan
                                makemaka = Par1.person1_ID
                                kvinnansdödsår = Person1.död_år
                                makemakakön = "m"

                            makemakafilnamn =  os.path.join(str(db),   'data', makemaka[0:5], makemaka + '.xml')
                            makemakaodtdokfilnamn =  os.path.join(str(db),   'data', makemaka[0:5], makemaka + ".odt")
                            makemakamerafolder =  os.path.join(str(db),   'data', makemaka[0:5], makemaka)
                            MakeMaka1 = johanpersonfil()
                            if os.path.exists(makemakafilnamn):
                                allmänt.hämtapersonfil(allmänt(),makemakafilnamn, MakeMaka1)


                                for kol in range (1,16): # Sätt först tomt innehåll  # Annars kan man inte sätta bakgrundsfärg
                                    self.tableWidget_Ättlingar.setItem(row, kol,  QtGui.QTableWidgetItem( ""))
                                for kol in range (1,10): # Sätt först tomt innehåll  # Annars kan man inte sätta bakgrundsfärg
                                    self.tableWidget_Ättlingar.item(row, kol).setBackground(self.färgschemabakgrund)

# --- Skriv innehåll för respektive kolumn på raden
# --- Kolumn 1: Namn med generationsnummer och make/maka-indikering
                                if  self.checkBox_VisaAllaNamn.checkState() == 0:
                                    self.tableWidget_Ättlingar.setItem(row, 1, QtGui.QTableWidgetItem(indent + indent2 + "+"  + ":  " + MakeMaka1.kortnamn ))
                                else:
                                    self.tableWidget_Ättlingar.setItem(row, 1, QtGui.QTableWidgetItem(indent + indent2 + "+"  + ":  " + MakeMaka1.allaförnamn +" " +  MakeMaka1.allaefternamn ))
                                self.tableWidget_Ättlingar.item(row, 1).setToolTip( MakeMaka1.allaförnamn +" " +  MakeMaka1.allaefternamnmedant )

# --- Kolumn 2: Flerpar-indikering för make/maka

                                if len(MakeMaka1.egna_par_ID.split("\n")) >1:
                                    self.tableWidget_Ättlingar.setItem(row, 2, QtGui.QTableWidgetItem( "#"))
                                else:
                                    self.tableWidget_Ättlingar.setItem(row, 2, QtGui.QTableWidgetItem( ""))

# --- Kolumn 3: Född datum
                                if MakeMaka1.född_år + MakeMaka1.född_månad + MakeMaka1.född_dag != "":
                                    self.tableWidget_Ättlingar.setItem(row, 3, QtGui.QTableWidgetItem( self.födddatum(MakeMaka1)))

# --- Kolumn 4: Födelseförsamling
                                if MakeMaka1.född_utrikesplats != "":
                                    föddplats = self.summatext(MakeMaka1.född_församling, MakeMaka1.född_utrikesplats)
                                else:
                                    föddplats =  self.summatext(MakeMaka1.född_by , MakeMaka1.född_församling)
                                self.tableWidget_Ättlingar.setItem(row, 4, QtGui.QTableWidgetItem(föddplats))
                                self.tableWidget_Ättlingar.item(row, 4).setToolTip( MakeMaka1.född_gata + ", " + MakeMaka1.född_by + ", " + MakeMaka1.född_kvarter + ", " + MakeMaka1.född_socken + ", " + MakeMaka1.född_församling + ", " + MakeMaka1.född_stad + ", " + MakeMaka1.född_härad + ", " + MakeMaka1.född_län + ", " + MakeMaka1.född_utrikesplats)

# --- Kolumn 5: Född, källreferens
                                if MakeMaka1.född_källa != "":
                                    self.tableWidget_Ättlingar.setItem(row, 5, QtGui.QTableWidgetItem( "ref" ))
                                    self.tableWidget_Ättlingar.item(row, 5).setToolTip( MakeMaka1.född_källa )
                                else:
                                    self.tableWidget_Ättlingar.setItem(row, 5, QtGui.QTableWidgetItem( "" ))
                                    self.tableWidget_Ättlingar.item(row, 5).setToolTip("")

# --- Kolumn 6: Död datum
                                if MakeMaka1.död_år + MakeMaka1.död_månad + MakeMaka1.död_dag != "":
                                    self.tableWidget_Ättlingar.setItem(row, 6, QtGui.QTableWidgetItem( self.döddatum(MakeMaka1)))
                                else:
                                    self.tableWidget_Ättlingar.setItem(row, 6, QtGui.QTableWidgetItem( "" ))
                                    self.tableWidget_Ättlingar.item(row, 6).setToolTip("")
                                if makemakakön == "k":
                                    kvinnansdödsår = MakeMaka1.död_år
                                if makemakakön == "m":
                                    mannensdödsår = MakeMaka1.död_år

# --- Kolumn 7: Dödförsamling
                                if MakeMaka1.död_utrikesplats != "":
                                    dödplats = self.summatext(MakeMaka1.död_församling, MakeMaka1.död_utrikesplats)
                                else:
                                    dödplats =  self.summatext(MakeMaka1.död_by , MakeMaka1.död_församling)
                                self.tableWidget_Ättlingar.setItem(row, 7, QtGui.QTableWidgetItem(dödplats))
                                self.tableWidget_Ättlingar.item(row, 7).setToolTip( MakeMaka1.död_gata + ", " + MakeMaka1.död_by + ", " + MakeMaka1.död_kvarter + ", " + MakeMaka1.död_socken + ", " + MakeMaka1.död_församling + ", " + MakeMaka1.död_stad + ", " + MakeMaka1.död_härad + ", " + MakeMaka1.död_län + ", " + MakeMaka1.död_utrikesplats)

# --- Kolumn 8: Död, källreferens
                                if MakeMaka1.död_källa != "":
                                    self.tableWidget_Ättlingar.setItem(row, 8, QtGui.QTableWidgetItem( "ref" ))
                                    self.tableWidget_Ättlingar.item(row, 8).setToolTip( MakeMaka1.död_källa )
                                else:
                                    self.tableWidget_Ättlingar.setItem(row, 8, QtGui.QTableWidgetItem( "" ))
                                    self.tableWidget_Ättlingar.item(row, 8).setToolTip("")


# --- Kolumn 9:  Uppnådd ålder
                                ålder_år, ålder_dagar= allmänt.personålder(allmänt(), MakeMaka1)
                                ålderitem = QtGui.QTableWidgetItem(ålder_år)
                                ålderitem.setTextAlignment(Qt.Alignment(Qt.AlignCenter))
                                self.tableWidget_Ättlingar.setItem(row, 9, ålderitem)

# --- Kolumn 10: Personnummer
                                person_ID_item =  QtGui.QTableWidgetItem( MakeMaka1.person_ID)
                                person_ID_item.setTextAlignment(Qt.Alignment(Qt.AlignCenter))
                                self.tableWidget_Ättlingar.setItem(row, 10, person_ID_item)

# --- Kolumn 11: Parnummer
                                self.tableWidget_Ättlingar.setItem(row, 11, QtGui.QTableWidgetItem( Par1.par_ID))
                                self.antalmakepar = len(MakeMaka1.egna_par_ID.split("\n")) # ska användas för att gissa pars varaktighet

# --- Kolumn 12: Par år
                        # Om både make och maka ingår i endast ett par så kan man gissa att äktenskapet
                        # troligen inte upplöstes förrän vid den enes död. Ange detta årtal plus (?)
                                upplösningsår = ""

                        # 1) om explicit årtal för parets upplösning anges så gäller detta (förmodligen ej pga död).
                                if Par1.upplösn_år != "":
                                    upplösningsår = Par1.upplösn_år  # behöver inte vara heltal/årtal

                                else:

                        # 2) annars, om explicit anges ena kontrahentens död så gäller detta
                                    if Par1.upplösn_typ.find("mannens död") >= 0:   #  explicit angivelse
                                        upplösningsår = mannensdödsår               # behöver inte vara heltal/årtal

                                    elif Par1.upplösn_typ.find("kvinnans död") >= 0:    # explicit angivelse
                                        upplösningsår = kvinnansdödsår                  # behöver inte vara heltal/årtal


                        # 3) om explicit orsak inte anges så gissa att upplösningen var en följd av den ena kontrahentens död
                        #    Då krävs kännedom om bådas respektive dödsår, uttryckta som korrekta heltal

                                    elif Par1.upplösn_typ == "": 
                                        if mannensdödsår.isdigit() and kvinnansdödsår.isdigit():
                                            if 1000 < int( mannensdödsår) < 2100 and  1000 < int(kvinnansdödsår) < 2100:
                                                if mannensdödsår <= kvinnansdödsår:
                                                    upplösningsår = mannensdödsår + ' ?'    # Gissat årtal, komplettera parbladet manuellt
                                                else:
                                                    upplösningsår = kvinnansdödsår + ' ?'   # Gissat årtal, komplettera parbladet manuellt

                        # 4) Om explicit anges annan orsak än någons död så avstå från att gissa, explicit årtal torde finnas, hit bara om det inte finns
                                    elif Par1.upplösn_typ != "":
                                        pass    # upplösningsår = ""

                        # 5) Om någon eller båda av makarna ingick i flera par så avstå tills vidare från att gissa
                                    elif self.antalegnapar > 1 or self.antalmakespar > 1:
                                        upplösningsår = "??"    # Inte ens gissning, komplettera parbladet manuellt


                                if upplösningsår != "" or  Par1.inledn_år != "" :
                                    self.tableWidget_Ättlingar.setItem(row,12, QtGui.QTableWidgetItem(Par1.inledn_år + " - " + upplösningsår))


# --- Kolumn 13: kön
                                kön_item = QtGui.QTableWidgetItem( MakeMaka1.person_kön )
                                kön_item.setTextAlignment(Qt.Alignment(Qt.AlignCenter))
                                self.tableWidget_Ättlingar.setItem(row, 13, kön_item)

                                if MakeMaka1.person_kön == "":
                                    msg = "Person " +  MakeMaka1.person_ID + ", " + MakeMaka1.kortnamn + " saknar könsmarkering\nKorrigera personbladet?"
                                    reply = QtGui.QMessageBox.question(self, "OBS!", msg, "Korrigera\nnu", "Låt vara")

# QtGui.QMessageBox.Yes: reply = 16384
# QtGui.QMessageBox.No:  reply = 65536
# "Korrigera\nnu":       reply = 0
# "Låt vara":            reply = 1
                                    if reply == 0:
                                        kommando = allmänt.PYTON + '   "' +  os.path.join(self.programkatalog, 'personblad.py') + '"   ' + self.i_option + '   ' + self.f_option + '   "' + db + '"   ' + makemaka
                                        QtCore.QProcess().startDetached(kommando )

# --- Kolumn 14: Kategori
                                self.tableWidget_Ättlingar.setItem(row, 14, self.personkategoriitem(MakeMaka1))

# --- Kolumn 15: "mer"-flagga
                                if os.path.exists(makemakaodtdokfilnamn) or  os.path.exists(makemakamerafolder):
                                    meraitem=QtGui.QTableWidgetItem( "mer" )
                                    meraitem.setTextAlignment(Qt.Alignment(Qt.AlignCenter))
                                    self.tableWidget_Ättlingar.setItem(row, 15, meraitem)

                                for kol in range (1,10): # Sätt först tomt innehåll  # Annars kan man inte sätta bakgrundsfärg
                                    self.tableWidget_Ättlingar.item(row, kol).setBackground(self.färgschemabakgrund)


                            else:   # if not os.path.exists(makemakafilnamn). I johandatabaser
                                    # som skapas genom hämtning/översättning från andra databas-
                                    # format kan saknas personblad för make/maka
                                # Sätt in par-ID från huvudpersonens personblad.
                                # det kan förekomma flera par-ID, som då kan ses via ToolTip.
                                paritem = QtGui.QTableWidgetItem (Par1.par_ID)  # ( Person1.egna_par_ID)
                                self.tableWidget_Ättlingar.setItem(row, 11, paritem )
                                self.tableWidget_Ättlingar.item(row, 11).setToolTip(( Person1.egna_par_ID).replace('\n',','))

##### # # # # #    rekursion:    # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
                            allabarn = Par1.barn_ID
                            for barn in allabarn.split("\n"):
                                if barn != "":
                                    self.hämtaperson ( db, barn, inivå+1, imax_nivå )


        else:
            msg = "I ättlingar.py: Jag kunde inte hitta personfilen " + infilnamn
            QtGui.QMessageBox.information(self, "Johan - Ättlingar" , msg , QtGui.QMessageBox.Ok)

#### end hämtaperson ##############################################################################
###################################################################################################




###################################################################################################
    def födddatum(self, person):
        föddtext= ''
        if person.född_år != "":
            föddtext = föddtext +person.född_år
        else:
            föddtext = föddtext + "    "

        if  person.född_månad != "":
            föddtext = föddtext + '-' +  person.född_månad
            if  person.född_dag != "":
                föddtext = föddtext + '-' +  person.född_dag
        else:
            if  person.född_dag != "":
                föddtext = föddtext + '-  -' +  person.född_dag
        return föddtext
###################################################################################################




###################################################################################################
    def döddatum(self, person):
        dödtext= ''
        if person.död_år != "":
            dödtext = dödtext +person.död_år
        else:
            dödtext = dödtext + "    "

        if  person.död_månad != "":
            dödtext = dödtext + '-' +  person.död_månad
            if  person.död_dag != "":
                dödtext = dödtext + '-' +  person.död_dag
        else:
            if  person.död_dag != "":
                dödtext = dödtext + '-  -' +  person.död_dag
        return dödtext
###################################################################################################




###################################################################################################
    def personkategoriitem(self, person):
        kategori = person.person_kategori
        kategoriitem = QtGui.QTableWidgetItem( kategori )
        kategoriitem.setTextAlignment(Qt.Alignment(Qt.AlignHCenter))

        if kategori == "A":
            kategoriitem.setBackground(QColor(255,192,255,127)) # KatA - magenta
        elif kategori == "1":
            kategoriitem.setBackground(QColor(160,255,160,127)) # Kat1 - grön
        elif allmänt.KategoriPgodk( allmänt(), person):
            if kategori == "":
                kategoriitem.setBackground(QColor(207,255,207,127)) # KatPgodk - ljus grön
            elif kategori == "B":
                kategoriitem.setBackground(QColor(255,255,224,127)) # KatB - ljus gul
            elif kategori == "C":
                kategoriitem.setBackground(QColor(240,240,240,127)) # KatC - ljus grå
            else:
                kategoriitem.setBackground(QColor(255,207,255,127)) # KatPspärr - ljus magenta
        else:
            kategoriitem.setBackground(QColor(255,207,255,127)) # KatPspärr - ljus magenta
        return kategoriitem
###################################################################################################




#############################################################################################
    def logga(self, txt):   # inkommande parameter, ska normalt avslutas ned NyRad
        import datetime     # behöver importeras här också för att rutinen ska fungera under stängning, anropad från __del__
# logga till loggfil
        if self.loggfilfolder != "":

            if not os.path.exists(self.loggfilfolder):
                os.mkdir(self.loggfilfolder)

            if os.path.exists(self.loggfilfolder):

                if self.loggfilopen == False:
                    dt = datetime.datetime.today()
                    self.loggfilnamn = os.path.join(self.loggfilfolder, self.loggfilgrundnamn + "_" + dt.strftime('%Y%m%d_%H%M%S') +'.log')
                    self.loggfil = open(self.loggfilnamn,'w', encoding='utf-8')
                    self.loggfilopen = True

                    self.logga ('Startar logg för Ättlingar_py3\n')

                dt = datetime.datetime.today()
                msg =  str(dt.strftime("%Y-%m-%d_%H:%M:%S")) + '.' + str(int(dt.microsecond/1000)).zfill(3) + '   ' + txt
                self.loggfil.write (msg)

# logga till konsolfönstret
        if txt[-1:] == '\n':
            ptxt=txt[:-1]
        else:
            ptxt = txt + ','
        print (ptxt)

## logga till textruta i programfönster
#        self.textEdit_logg.insertPlainText(txt )
#        self.textEdit_logg.moveCursor(QtGui.QTextCursor.End, QtGui.QTextCursor.MoveAnchor)
#
#        textEdit_logg_Rect = self.textEdit_logg.geometry()   # QtCore.QRect ( )

# gör detta någon nytta?
#        self.textEdit_logg.repaint( textEdit_logg_Rect )

# gör detta någon nytta?
#        self.repaint()

# gör detta någon nytta?
#        app.processEvents()

#############################################################################################




###################################################################################################
    def avsluta(self, exitcode=0):

        if self.loggfilopen == True:
            self.logga ('Avslutar Ättlingar_py3\n')
            self.loggfilopen = False
            self.loggfil.close()

        sys.exit(exitcode)
###################################################################################################




###################################################################################################
# Här  startar  programmet

app = QtGui.QApplication(sys.argv)
winÄttlingar = Ättlingar()
winÄttlingar.show()
sys.exit(app.exec_())
###################################################################################################
